// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/browser/performance_monitor/events.json
// DO NOT EDIT.

#include "tools/json_schema_compiler/util.h"
#include "chrome/browser/performance_monitor/events.h"

using base::Value;
using base::DictionaryValue;
using base::ListValue;
using base::BinaryValue;
using json_schema_compiler::any::Any;

namespace performance_monitor {
namespace events {

//
// Types
//

UncleanShutdown::UncleanShutdown()
  : event_type(0), time(0.0) {}
UncleanShutdown::~UncleanShutdown() {}

// static
bool UncleanShutdown::Populate(const Value& value, UncleanShutdown* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* event_type_value = NULL;
  if (!dict->GetWithoutPathExpansion("eventType", &event_type_value))
    return false;
  {
    if (!event_type_value->GetAsInteger(&out->event_type))
      return false;
  }

  Value* time_value = NULL;
  if (!dict->GetWithoutPathExpansion("time", &time_value))
    return false;
  {
    if (!time_value->GetAsDouble(&out->time))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> UncleanShutdown::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("eventType", Value::CreateIntegerValue(this->event_type));
  value->SetWithoutPathExpansion("time", Value::CreateDoubleValue(this->time));

  return value.Pass();
}


ExtensionUninstall::ExtensionUninstall()
  : event_type(0), extension_location(0), time(0.0) {}
ExtensionUninstall::~ExtensionUninstall() {}

// static
bool ExtensionUninstall::Populate(const Value& value, ExtensionUninstall* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* extension_id_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionId", &extension_id_value))
    return false;
  {
    if (!extension_id_value->GetAsString(&out->extension_id))
      return false;
  }

  Value* extension_version_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionVersion", &extension_version_value))
    return false;
  {
    if (!extension_version_value->GetAsString(&out->extension_version))
      return false;
  }

  Value* event_type_value = NULL;
  if (!dict->GetWithoutPathExpansion("eventType", &event_type_value))
    return false;
  {
    if (!event_type_value->GetAsInteger(&out->event_type))
      return false;
  }

  Value* extension_location_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionLocation", &extension_location_value))
    return false;
  {
    if (!extension_location_value->GetAsInteger(&out->extension_location))
      return false;
  }

  Value* extension_url_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionUrl", &extension_url_value))
    return false;
  {
    if (!extension_url_value->GetAsString(&out->extension_url))
      return false;
  }

  Value* extension_description_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionDescription", &extension_description_value))
    return false;
  {
    if (!extension_description_value->GetAsString(&out->extension_description))
      return false;
  }

  Value* time_value = NULL;
  if (!dict->GetWithoutPathExpansion("time", &time_value))
    return false;
  {
    if (!time_value->GetAsDouble(&out->time))
      return false;
  }

  Value* extension_name_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionName", &extension_name_value))
    return false;
  {
    if (!extension_name_value->GetAsString(&out->extension_name))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> ExtensionUninstall::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("extensionId", Value::CreateStringValue(this->extension_id));
  value->SetWithoutPathExpansion("extensionVersion", Value::CreateStringValue(this->extension_version));
  value->SetWithoutPathExpansion("eventType", Value::CreateIntegerValue(this->event_type));
  value->SetWithoutPathExpansion("extensionLocation", Value::CreateIntegerValue(this->extension_location));
  value->SetWithoutPathExpansion("extensionUrl", Value::CreateStringValue(this->extension_url));
  value->SetWithoutPathExpansion("extensionDescription", Value::CreateStringValue(this->extension_description));
  value->SetWithoutPathExpansion("time", Value::CreateDoubleValue(this->time));
  value->SetWithoutPathExpansion("extensionName", Value::CreateStringValue(this->extension_name));

  return value.Pass();
}


RendererFreeze::RendererFreeze()
  : event_type(0), time(0.0) {}
RendererFreeze::~RendererFreeze() {}

// static
bool RendererFreeze::Populate(const Value& value, RendererFreeze* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* url_value = NULL;
  if (!dict->GetWithoutPathExpansion("url", &url_value))
    return false;
  {
    if (!url_value->GetAsString(&out->url))
      return false;
  }

  Value* event_type_value = NULL;
  if (!dict->GetWithoutPathExpansion("eventType", &event_type_value))
    return false;
  {
    if (!event_type_value->GetAsInteger(&out->event_type))
      return false;
  }

  Value* time_value = NULL;
  if (!dict->GetWithoutPathExpansion("time", &time_value))
    return false;
  {
    if (!time_value->GetAsDouble(&out->time))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> RendererFreeze::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("url", Value::CreateStringValue(this->url));
  value->SetWithoutPathExpansion("eventType", Value::CreateIntegerValue(this->event_type));
  value->SetWithoutPathExpansion("time", Value::CreateDoubleValue(this->time));

  return value.Pass();
}


ChromeUpdate::ChromeUpdate()
  : event_type(0), time(0.0) {}
ChromeUpdate::~ChromeUpdate() {}

// static
bool ChromeUpdate::Populate(const Value& value, ChromeUpdate* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* event_type_value = NULL;
  if (!dict->GetWithoutPathExpansion("eventType", &event_type_value))
    return false;
  {
    if (!event_type_value->GetAsInteger(&out->event_type))
      return false;
  }

  Value* previous_version_value = NULL;
  if (!dict->GetWithoutPathExpansion("previousVersion", &previous_version_value))
    return false;
  {
    if (!previous_version_value->GetAsString(&out->previous_version))
      return false;
  }

  Value* current_version_value = NULL;
  if (!dict->GetWithoutPathExpansion("currentVersion", &current_version_value))
    return false;
  {
    if (!current_version_value->GetAsString(&out->current_version))
      return false;
  }

  Value* time_value = NULL;
  if (!dict->GetWithoutPathExpansion("time", &time_value))
    return false;
  {
    if (!time_value->GetAsDouble(&out->time))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> ChromeUpdate::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("eventType", Value::CreateIntegerValue(this->event_type));
  value->SetWithoutPathExpansion("previousVersion", Value::CreateStringValue(this->previous_version));
  value->SetWithoutPathExpansion("currentVersion", Value::CreateStringValue(this->current_version));
  value->SetWithoutPathExpansion("time", Value::CreateDoubleValue(this->time));

  return value.Pass();
}


ExtensionUnload::ExtensionUnload()
  : unload_reason(0), event_type(0), extension_location(0), time(0.0) {}
ExtensionUnload::~ExtensionUnload() {}

// static
bool ExtensionUnload::Populate(const Value& value, ExtensionUnload* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* unload_reason_value = NULL;
  if (!dict->GetWithoutPathExpansion("unloadReason", &unload_reason_value))
    return false;
  {
    if (!unload_reason_value->GetAsInteger(&out->unload_reason))
      return false;
  }

  Value* extension_id_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionId", &extension_id_value))
    return false;
  {
    if (!extension_id_value->GetAsString(&out->extension_id))
      return false;
  }

  Value* extension_version_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionVersion", &extension_version_value))
    return false;
  {
    if (!extension_version_value->GetAsString(&out->extension_version))
      return false;
  }

  Value* event_type_value = NULL;
  if (!dict->GetWithoutPathExpansion("eventType", &event_type_value))
    return false;
  {
    if (!event_type_value->GetAsInteger(&out->event_type))
      return false;
  }

  Value* extension_location_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionLocation", &extension_location_value))
    return false;
  {
    if (!extension_location_value->GetAsInteger(&out->extension_location))
      return false;
  }

  Value* extension_url_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionUrl", &extension_url_value))
    return false;
  {
    if (!extension_url_value->GetAsString(&out->extension_url))
      return false;
  }

  Value* extension_description_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionDescription", &extension_description_value))
    return false;
  {
    if (!extension_description_value->GetAsString(&out->extension_description))
      return false;
  }

  Value* time_value = NULL;
  if (!dict->GetWithoutPathExpansion("time", &time_value))
    return false;
  {
    if (!time_value->GetAsDouble(&out->time))
      return false;
  }

  Value* extension_name_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionName", &extension_name_value))
    return false;
  {
    if (!extension_name_value->GetAsString(&out->extension_name))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> ExtensionUnload::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("unloadReason", Value::CreateIntegerValue(this->unload_reason));
  value->SetWithoutPathExpansion("extensionId", Value::CreateStringValue(this->extension_id));
  value->SetWithoutPathExpansion("extensionVersion", Value::CreateStringValue(this->extension_version));
  value->SetWithoutPathExpansion("eventType", Value::CreateIntegerValue(this->event_type));
  value->SetWithoutPathExpansion("extensionLocation", Value::CreateIntegerValue(this->extension_location));
  value->SetWithoutPathExpansion("extensionUrl", Value::CreateStringValue(this->extension_url));
  value->SetWithoutPathExpansion("extensionDescription", Value::CreateStringValue(this->extension_description));
  value->SetWithoutPathExpansion("time", Value::CreateDoubleValue(this->time));
  value->SetWithoutPathExpansion("extensionName", Value::CreateStringValue(this->extension_name));

  return value.Pass();
}


RendererCrash::RendererCrash()
  : event_type(0), time(0.0) {}
RendererCrash::~RendererCrash() {}

// static
bool RendererCrash::Populate(const Value& value, RendererCrash* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* url_value = NULL;
  if (!dict->GetWithoutPathExpansion("url", &url_value))
    return false;
  {
    if (!url_value->GetAsString(&out->url))
      return false;
  }

  Value* event_type_value = NULL;
  if (!dict->GetWithoutPathExpansion("eventType", &event_type_value))
    return false;
  {
    if (!event_type_value->GetAsInteger(&out->event_type))
      return false;
  }

  Value* time_value = NULL;
  if (!dict->GetWithoutPathExpansion("time", &time_value))
    return false;
  {
    if (!time_value->GetAsDouble(&out->time))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> RendererCrash::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("url", Value::CreateStringValue(this->url));
  value->SetWithoutPathExpansion("eventType", Value::CreateIntegerValue(this->event_type));
  value->SetWithoutPathExpansion("time", Value::CreateDoubleValue(this->time));

  return value.Pass();
}


ExtensionInstall::ExtensionInstall()
  : event_type(0), extension_location(0), time(0.0) {}
ExtensionInstall::~ExtensionInstall() {}

// static
bool ExtensionInstall::Populate(const Value& value, ExtensionInstall* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* extension_id_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionId", &extension_id_value))
    return false;
  {
    if (!extension_id_value->GetAsString(&out->extension_id))
      return false;
  }

  Value* extension_version_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionVersion", &extension_version_value))
    return false;
  {
    if (!extension_version_value->GetAsString(&out->extension_version))
      return false;
  }

  Value* event_type_value = NULL;
  if (!dict->GetWithoutPathExpansion("eventType", &event_type_value))
    return false;
  {
    if (!event_type_value->GetAsInteger(&out->event_type))
      return false;
  }

  Value* extension_location_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionLocation", &extension_location_value))
    return false;
  {
    if (!extension_location_value->GetAsInteger(&out->extension_location))
      return false;
  }

  Value* extension_url_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionUrl", &extension_url_value))
    return false;
  {
    if (!extension_url_value->GetAsString(&out->extension_url))
      return false;
  }

  Value* extension_description_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionDescription", &extension_description_value))
    return false;
  {
    if (!extension_description_value->GetAsString(&out->extension_description))
      return false;
  }

  Value* time_value = NULL;
  if (!dict->GetWithoutPathExpansion("time", &time_value))
    return false;
  {
    if (!time_value->GetAsDouble(&out->time))
      return false;
  }

  Value* extension_name_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionName", &extension_name_value))
    return false;
  {
    if (!extension_name_value->GetAsString(&out->extension_name))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> ExtensionInstall::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("extensionId", Value::CreateStringValue(this->extension_id));
  value->SetWithoutPathExpansion("extensionVersion", Value::CreateStringValue(this->extension_version));
  value->SetWithoutPathExpansion("eventType", Value::CreateIntegerValue(this->event_type));
  value->SetWithoutPathExpansion("extensionLocation", Value::CreateIntegerValue(this->extension_location));
  value->SetWithoutPathExpansion("extensionUrl", Value::CreateStringValue(this->extension_url));
  value->SetWithoutPathExpansion("extensionDescription", Value::CreateStringValue(this->extension_description));
  value->SetWithoutPathExpansion("time", Value::CreateDoubleValue(this->time));
  value->SetWithoutPathExpansion("extensionName", Value::CreateStringValue(this->extension_name));

  return value.Pass();
}


ExtensionEnable::ExtensionEnable()
  : event_type(0), extension_location(0), time(0.0) {}
ExtensionEnable::~ExtensionEnable() {}

// static
bool ExtensionEnable::Populate(const Value& value, ExtensionEnable* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* extension_id_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionId", &extension_id_value))
    return false;
  {
    if (!extension_id_value->GetAsString(&out->extension_id))
      return false;
  }

  Value* extension_version_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionVersion", &extension_version_value))
    return false;
  {
    if (!extension_version_value->GetAsString(&out->extension_version))
      return false;
  }

  Value* event_type_value = NULL;
  if (!dict->GetWithoutPathExpansion("eventType", &event_type_value))
    return false;
  {
    if (!event_type_value->GetAsInteger(&out->event_type))
      return false;
  }

  Value* extension_location_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionLocation", &extension_location_value))
    return false;
  {
    if (!extension_location_value->GetAsInteger(&out->extension_location))
      return false;
  }

  Value* extension_url_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionUrl", &extension_url_value))
    return false;
  {
    if (!extension_url_value->GetAsString(&out->extension_url))
      return false;
  }

  Value* extension_description_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionDescription", &extension_description_value))
    return false;
  {
    if (!extension_description_value->GetAsString(&out->extension_description))
      return false;
  }

  Value* time_value = NULL;
  if (!dict->GetWithoutPathExpansion("time", &time_value))
    return false;
  {
    if (!time_value->GetAsDouble(&out->time))
      return false;
  }

  Value* extension_name_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionName", &extension_name_value))
    return false;
  {
    if (!extension_name_value->GetAsString(&out->extension_name))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> ExtensionEnable::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("extensionId", Value::CreateStringValue(this->extension_id));
  value->SetWithoutPathExpansion("extensionVersion", Value::CreateStringValue(this->extension_version));
  value->SetWithoutPathExpansion("eventType", Value::CreateIntegerValue(this->event_type));
  value->SetWithoutPathExpansion("extensionLocation", Value::CreateIntegerValue(this->extension_location));
  value->SetWithoutPathExpansion("extensionUrl", Value::CreateStringValue(this->extension_url));
  value->SetWithoutPathExpansion("extensionDescription", Value::CreateStringValue(this->extension_description));
  value->SetWithoutPathExpansion("time", Value::CreateDoubleValue(this->time));
  value->SetWithoutPathExpansion("extensionName", Value::CreateStringValue(this->extension_name));

  return value.Pass();
}


ExtensionUpdate::ExtensionUpdate()
  : event_type(0), extension_location(0), time(0.0) {}
ExtensionUpdate::~ExtensionUpdate() {}

// static
bool ExtensionUpdate::Populate(const Value& value, ExtensionUpdate* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* extension_id_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionId", &extension_id_value))
    return false;
  {
    if (!extension_id_value->GetAsString(&out->extension_id))
      return false;
  }

  Value* extension_version_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionVersion", &extension_version_value))
    return false;
  {
    if (!extension_version_value->GetAsString(&out->extension_version))
      return false;
  }

  Value* event_type_value = NULL;
  if (!dict->GetWithoutPathExpansion("eventType", &event_type_value))
    return false;
  {
    if (!event_type_value->GetAsInteger(&out->event_type))
      return false;
  }

  Value* extension_location_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionLocation", &extension_location_value))
    return false;
  {
    if (!extension_location_value->GetAsInteger(&out->extension_location))
      return false;
  }

  Value* extension_url_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionUrl", &extension_url_value))
    return false;
  {
    if (!extension_url_value->GetAsString(&out->extension_url))
      return false;
  }

  Value* extension_description_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionDescription", &extension_description_value))
    return false;
  {
    if (!extension_description_value->GetAsString(&out->extension_description))
      return false;
  }

  Value* time_value = NULL;
  if (!dict->GetWithoutPathExpansion("time", &time_value))
    return false;
  {
    if (!time_value->GetAsDouble(&out->time))
      return false;
  }

  Value* extension_name_value = NULL;
  if (!dict->GetWithoutPathExpansion("extensionName", &extension_name_value))
    return false;
  {
    if (!extension_name_value->GetAsString(&out->extension_name))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> ExtensionUpdate::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("extensionId", Value::CreateStringValue(this->extension_id));
  value->SetWithoutPathExpansion("extensionVersion", Value::CreateStringValue(this->extension_version));
  value->SetWithoutPathExpansion("eventType", Value::CreateIntegerValue(this->event_type));
  value->SetWithoutPathExpansion("extensionLocation", Value::CreateIntegerValue(this->extension_location));
  value->SetWithoutPathExpansion("extensionUrl", Value::CreateStringValue(this->extension_url));
  value->SetWithoutPathExpansion("extensionDescription", Value::CreateStringValue(this->extension_description));
  value->SetWithoutPathExpansion("time", Value::CreateDoubleValue(this->time));
  value->SetWithoutPathExpansion("extensionName", Value::CreateStringValue(this->extension_name));

  return value.Pass();
}


}  // events
}  // performance_monitor
