// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/app_window.idl
// DO NOT EDIT.

#include "tools/json_schema_compiler/util.h"
#include "chrome/common/extensions/api/app_window.h"

using base::Value;
using base::DictionaryValue;
using base::ListValue;
using base::BinaryValue;
using json_schema_compiler::any::Any;

namespace extensions {
namespace api {
namespace app_window {

//
// Types
//

CreateWindowOptions::CreateWindowOptions()
   {}
CreateWindowOptions::~CreateWindowOptions() {}

// static
bool CreateWindowOptions::Populate(const Value& value, CreateWindowOptions* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* max_width_value = NULL;
  if (dict->GetWithoutPathExpansion("maxWidth", &max_width_value)) {
    {
      int temp;
      if (!max_width_value->GetAsInteger(&temp))
        return false;
      out->max_width.reset(new int(temp));
    }
  }

  Value* top_value = NULL;
  if (dict->GetWithoutPathExpansion("top", &top_value)) {
    {
      int temp;
      if (!top_value->GetAsInteger(&temp))
        return false;
      out->top.reset(new int(temp));
    }
  }

  Value* min_height_value = NULL;
  if (dict->GetWithoutPathExpansion("minHeight", &min_height_value)) {
    {
      int temp;
      if (!min_height_value->GetAsInteger(&temp))
        return false;
      out->min_height.reset(new int(temp));
    }
  }

  Value* max_height_value = NULL;
  if (dict->GetWithoutPathExpansion("maxHeight", &max_height_value)) {
    {
      int temp;
      if (!max_height_value->GetAsInteger(&temp))
        return false;
      out->max_height.reset(new int(temp));
    }
  }

  Value* height_value = NULL;
  if (dict->GetWithoutPathExpansion("height", &height_value)) {
    {
      int temp;
      if (!height_value->GetAsInteger(&temp))
        return false;
      out->height.reset(new int(temp));
    }
  }

  Value* min_width_value = NULL;
  if (dict->GetWithoutPathExpansion("minWidth", &min_width_value)) {
    {
      int temp;
      if (!min_width_value->GetAsInteger(&temp))
        return false;
      out->min_width.reset(new int(temp));
    }
  }

  Value* width_value = NULL;
  if (dict->GetWithoutPathExpansion("width", &width_value)) {
    {
      int temp;
      if (!width_value->GetAsInteger(&temp))
        return false;
      out->width.reset(new int(temp));
    }
  }

  Value* type_value = NULL;
  if (dict->GetWithoutPathExpansion("type", &type_value)) {
    {
      std::string temp;
      if (!type_value->GetAsString(&temp))
        return false;
      out->type.reset(new std::string(temp));
    }
  }

  Value* frame_value = NULL;
  if (dict->GetWithoutPathExpansion("frame", &frame_value)) {
    {
      std::string temp;
      if (!frame_value->GetAsString(&temp))
        return false;
      out->frame.reset(new std::string(temp));
    }
  }

  Value* left_value = NULL;
  if (dict->GetWithoutPathExpansion("left", &left_value)) {
    {
      int temp;
      if (!left_value->GetAsInteger(&temp))
        return false;
      out->left.reset(new int(temp));
    }
  }

  return true;
}

scoped_ptr<DictionaryValue> CreateWindowOptions::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  if (max_width.get())
    value->SetWithoutPathExpansion("maxWidth", Value::CreateIntegerValue(*this->max_width));

  if (top.get())
    value->SetWithoutPathExpansion("top", Value::CreateIntegerValue(*this->top));

  if (min_height.get())
    value->SetWithoutPathExpansion("minHeight", Value::CreateIntegerValue(*this->min_height));

  if (max_height.get())
    value->SetWithoutPathExpansion("maxHeight", Value::CreateIntegerValue(*this->max_height));

  if (height.get())
    value->SetWithoutPathExpansion("height", Value::CreateIntegerValue(*this->height));

  if (min_width.get())
    value->SetWithoutPathExpansion("minWidth", Value::CreateIntegerValue(*this->min_width));

  if (width.get())
    value->SetWithoutPathExpansion("width", Value::CreateIntegerValue(*this->width));

  if (type.get())
    value->SetWithoutPathExpansion("type", Value::CreateStringValue(*this->type));

  if (frame.get())
    value->SetWithoutPathExpansion("frame", Value::CreateStringValue(*this->frame));

  if (left.get())
    value->SetWithoutPathExpansion("left", Value::CreateIntegerValue(*this->left));


  return value.Pass();
}


//
// Functions
//



Create::Params::Params() {}
Create::Params::~Params() {}

// static
scoped_ptr<Create::Params> Create::Params::Create(const ListValue& args) {
  if (args.GetSize() < 1 || args.GetSize() > 2)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* url_value = NULL;
  if (args.Get(0, &url_value) && !url_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!url_value->GetAsString(&params->url))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* options_value = NULL;
  if (args.Get(1, &options_value) && !options_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!options_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      scoped_ptr<CreateWindowOptions> temp(new CreateWindowOptions());
      if (!CreateWindowOptions::Populate(*dictionary, temp.get()))
        return scoped_ptr<Params>();
      params->options = temp.Pass();
    }
  }

  return params.Pass();
}


Value* Create::Result::Create(const int view_id) {
  return Value::CreateIntegerValue(view_id);
}



}  // app_window
}  // api
}  // extensions
