// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/app_window.idl
// DO NOT EDIT.

#ifndef CHROME_COMMON_EXTENSIONS_API_APP_WINDOW_H__
#define CHROME_COMMON_EXTENSIONS_API_APP_WINDOW_H__
#pragma once

#include <string>
#include <vector>

#include "base/basictypes.h"
#include "base/memory/linked_ptr.h"
#include "base/memory/scoped_ptr.h"
#include "base/values.h"
#include "tools/json_schema_compiler/any.h"

namespace extensions {
namespace api {

namespace app_window {
struct CreateWindowOptions;
}  // app_window

namespace app_window {

//
// Types
//

struct CreateWindowOptions {
  ~CreateWindowOptions();
  CreateWindowOptions();

  // Maximum width of the window.
  scoped_ptr<int> max_width;

  // Y coordinate of the window.
  scoped_ptr<int> top;

  // Minimum height of the window.
  scoped_ptr<int> min_height;

  // Maximum height of the window.
  scoped_ptr<int> max_height;

  // Height of the window.
  scoped_ptr<int> height;

  // Minimium width of the window.
  scoped_ptr<int> min_width;

  // Width of the window.
  scoped_ptr<int> width;

  // Window type: 'shell' (the default) is the only currently supported value.
  scoped_ptr<std::string> type;

  // Frame type: 'none' or 'chrome' (defaults to 'chrome').
  scoped_ptr<std::string> frame;

  // X coordinate of the window.
  scoped_ptr<int> left;

  // Populates a CreateWindowOptions object from a Value. Returns whether |out|
  // was successfully populated.
  static bool Populate(const Value& value, CreateWindowOptions* out);

  // Returns a new DictionaryValue representing the serialized form of this
  // CreateWindowOptions object. Passes ownership to caller.
  scoped_ptr<DictionaryValue> ToValue() const;

 private:
  DISALLOW_COPY_AND_ASSIGN(CreateWindowOptions);
};

//
// Functions
//

namespace Minimize {

};

namespace Restore {

};

namespace Create {
  struct Params {
    std::string url;

    scoped_ptr<CreateWindowOptions> options;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

  namespace Result {
    Value* Create(const int view_id);
  };

};

namespace Focus {

};

namespace Maximize {

};

}  // app_window
}  // api
}  // extensions

#endif  // CHROME_COMMON_EXTENSIONS_API_APP_WINDOW_H__
