// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/content_settings.json
// DO NOT EDIT.

#include "tools/json_schema_compiler/util.h"
#include "chrome/common/extensions/api/content_settings.h"

using base::Value;
using base::DictionaryValue;
using base::ListValue;
using base::BinaryValue;
using json_schema_compiler::any::Any;

namespace extensions {
namespace api {
namespace content_settings {

//
// Properties
//

//
// Types
//

ResourceIdentifier::ResourceIdentifier()
   {}
ResourceIdentifier::~ResourceIdentifier() {}

// static
bool ResourceIdentifier::Populate(const Value& value, ResourceIdentifier* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* id_value = NULL;
  if (!dict->GetWithoutPathExpansion("id", &id_value))
    return false;
  {
    if (!id_value->GetAsString(&out->id))
      return false;
  }

  Value* description_value = NULL;
  if (dict->GetWithoutPathExpansion("description", &description_value)) {
    {
      std::string temp;
      if (!description_value->GetAsString(&temp))
        return false;
      out->description.reset(new std::string(temp));
    }
  }

  return true;
}

scoped_ptr<DictionaryValue> ResourceIdentifier::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("id", Value::CreateStringValue(this->id));
  if (description.get())
    value->SetWithoutPathExpansion("description", Value::CreateStringValue(*this->description));


  return value.Pass();
}


// static
scoped_ptr<Value> ContentSetting::Clear::Params::Details::CreateEnumValue(Scope scope) {
  switch (scope) {
    case SCOPE_NONE: {
      return scoped_ptr<Value>();
    }
    case SCOPE_REGULAR: {
      return scoped_ptr<Value>(Value::CreateStringValue("regular"));
    }
    case SCOPE_INCOGNITO_SESSION_ONLY: {
      return scoped_ptr<Value>(Value::CreateStringValue("incognito_session_only"));
    }
    default: {
      return scoped_ptr<Value>();
    }
  }
}

ContentSetting::Clear::Params::Details::Details()
   {}
ContentSetting::Clear::Params::Details::~Details() {}

// static
bool ContentSetting::Clear::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  out->scope = SCOPE_NONE;
  Value* scope_value = NULL;
  if (dict->GetWithoutPathExpansion("scope", &scope_value)) {
    {
      {
        Scope enum_temp;
        std::string enum_as_string;
        if (!scope_value->GetAsString(&enum_as_string))
          return false;
        if(enum_as_string == "regular")
          enum_temp = SCOPE_REGULAR;
        else if(enum_as_string == "incognito_session_only")
          enum_temp = SCOPE_INCOGNITO_SESSION_ONLY;
        else
          return false;
        out->scope = enum_temp;
      }
    }
  }

  return true;
}


ContentSetting::Clear::Params::Params() {}
ContentSetting::Clear::Params::~Params() {}

// static
scoped_ptr<ContentSetting::Clear::Params> ContentSetting::Clear::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Details::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* ContentSetting::Clear::Result::Create() {
  return Value::CreateNullValue();
}

// static
scoped_ptr<Value> ContentSetting::Set::Params::Details::CreateEnumValue(Scope scope) {
  switch (scope) {
    case SCOPE_NONE: {
      return scoped_ptr<Value>();
    }
    case SCOPE_REGULAR: {
      return scoped_ptr<Value>(Value::CreateStringValue("regular"));
    }
    case SCOPE_INCOGNITO_SESSION_ONLY: {
      return scoped_ptr<Value>(Value::CreateStringValue("incognito_session_only"));
    }
    default: {
      return scoped_ptr<Value>();
    }
  }
}

ContentSetting::Set::Params::Details::Details()
   {}
ContentSetting::Set::Params::Details::~Details() {}

// static
bool ContentSetting::Set::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  out->scope = SCOPE_NONE;
  Value* resource_identifier_value = NULL;
  if (dict->GetWithoutPathExpansion("resourceIdentifier", &resource_identifier_value)) {
    {
      DictionaryValue* dictionary = NULL;
      if (!resource_identifier_value->GetAsDictionary(&dictionary))
        return false;
      scoped_ptr<ResourceIdentifier> temp(new ResourceIdentifier());
      if (!ResourceIdentifier::Populate(*dictionary, temp.get()))
        return false;
      out->resource_identifier = temp.Pass();
    }
  }

  Value* setting_value = NULL;
  if (!dict->GetWithoutPathExpansion("setting", &setting_value))
    return false;
  {
    out->setting.Init(*setting_value);
  }

  Value* secondary_pattern_value = NULL;
  if (dict->GetWithoutPathExpansion("secondaryPattern", &secondary_pattern_value)) {
    {
      std::string temp;
      if (!secondary_pattern_value->GetAsString(&temp))
        return false;
      out->secondary_pattern.reset(new std::string(temp));
    }
  }

  Value* scope_value = NULL;
  if (dict->GetWithoutPathExpansion("scope", &scope_value)) {
    {
      {
        Scope enum_temp;
        std::string enum_as_string;
        if (!scope_value->GetAsString(&enum_as_string))
          return false;
        if(enum_as_string == "regular")
          enum_temp = SCOPE_REGULAR;
        else if(enum_as_string == "incognito_session_only")
          enum_temp = SCOPE_INCOGNITO_SESSION_ONLY;
        else
          return false;
        out->scope = enum_temp;
      }
    }
  }

  Value* primary_pattern_value = NULL;
  if (!dict->GetWithoutPathExpansion("primaryPattern", &primary_pattern_value))
    return false;
  {
    if (!primary_pattern_value->GetAsString(&out->primary_pattern))
      return false;
  }

  return true;
}


ContentSetting::Set::Params::Params() {}
ContentSetting::Set::Params::~Params() {}

// static
scoped_ptr<ContentSetting::Set::Params> ContentSetting::Set::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Details::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* ContentSetting::Set::Result::Create() {
  return Value::CreateNullValue();
}

Value* ContentSetting::GetResourceIdentifiers::Result::Create(const std::vector<linked_ptr<ResourceIdentifier> >& resource_identifiers) {
  return json_schema_compiler::util::CreateValueFromArray(resource_identifiers).release();
}

ContentSetting::Get::Params::Details::Details()
   {}
ContentSetting::Get::Params::Details::~Details() {}

// static
bool ContentSetting::Get::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* secondary_url_value = NULL;
  if (dict->GetWithoutPathExpansion("secondaryUrl", &secondary_url_value)) {
    {
      std::string temp;
      if (!secondary_url_value->GetAsString(&temp))
        return false;
      out->secondary_url.reset(new std::string(temp));
    }
  }

  Value* resource_identifier_value = NULL;
  if (dict->GetWithoutPathExpansion("resourceIdentifier", &resource_identifier_value)) {
    {
      DictionaryValue* dictionary = NULL;
      if (!resource_identifier_value->GetAsDictionary(&dictionary))
        return false;
      scoped_ptr<ResourceIdentifier> temp(new ResourceIdentifier());
      if (!ResourceIdentifier::Populate(*dictionary, temp.get()))
        return false;
      out->resource_identifier = temp.Pass();
    }
  }

  Value* primary_url_value = NULL;
  if (!dict->GetWithoutPathExpansion("primaryUrl", &primary_url_value))
    return false;
  {
    if (!primary_url_value->GetAsString(&out->primary_url))
      return false;
  }

  Value* incognito_value = NULL;
  if (dict->GetWithoutPathExpansion("incognito", &incognito_value)) {
    {
      bool temp;
      if (!incognito_value->GetAsBoolean(&temp))
        return false;
      out->incognito.reset(new bool(temp));
    }
  }

  return true;
}


ContentSetting::Get::Params::Params() {}
ContentSetting::Get::Params::~Params() {}

// static
scoped_ptr<ContentSetting::Get::Params> ContentSetting::Get::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Details::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


ContentSetting::Get::Result::Details::Details()
   {}
ContentSetting::Get::Result::Details::~Details() {}

scoped_ptr<DictionaryValue> ContentSetting::Get::Result::Details::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("setting", this->setting.value().DeepCopy());

  return value.Pass();
}


Value* ContentSetting::Get::Result::Create(const Details& details) {
  return details.ToValue().release();
}


}  // content_settings
}  // api
}  // extensions
