// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/experimental_discovery.idl
// DO NOT EDIT.

#include "tools/json_schema_compiler/util.h"
#include "chrome/common/extensions/api/experimental_discovery.h"

using base::Value;
using base::DictionaryValue;
using base::ListValue;
using base::BinaryValue;
using json_schema_compiler::any::Any;

namespace extensions {
namespace api {
namespace experimental_discovery {

//
// Types
//

SuggestDetails::SuggestDetails()
   {}
SuggestDetails::~SuggestDetails() {}

// static
bool SuggestDetails::Populate(const Value& value, SuggestDetails* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* score_value = NULL;
  if (dict->GetWithoutPathExpansion("score", &score_value)) {
    {
      double temp;
      if (!score_value->GetAsDouble(&temp))
        return false;
      out->score.reset(new double(temp));
    }
  }

  Value* link_url_value = NULL;
  if (!dict->GetWithoutPathExpansion("linkUrl", &link_url_value))
    return false;
  {
    if (!link_url_value->GetAsString(&out->link_url))
      return false;
  }

  Value* link_text_value = NULL;
  if (!dict->GetWithoutPathExpansion("linkText", &link_text_value))
    return false;
  {
    if (!link_text_value->GetAsString(&out->link_text))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> SuggestDetails::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  if (score.get())
    value->SetWithoutPathExpansion("score", Value::CreateDoubleValue(*this->score));

  value->SetWithoutPathExpansion("linkUrl", Value::CreateStringValue(this->link_url));
  value->SetWithoutPathExpansion("linkText", Value::CreateStringValue(this->link_text));

  return value.Pass();
}


//
// Functions
//


Suggest::Params::Params() {}
Suggest::Params::~Params() {}

// static
scoped_ptr<Suggest::Params> Suggest::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!SuggestDetails::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}



RemoveSuggestion::Params::Params() {}
RemoveSuggestion::Params::~Params() {}

// static
scoped_ptr<RemoveSuggestion::Params> RemoveSuggestion::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* link_url_value = NULL;
  if (args.Get(0, &link_url_value) && !link_url_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!link_url_value->GetAsString(&params->link_url))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}



}  // experimental_discovery
}  // api
}  // extensions
