// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/experimental_discovery.idl
// DO NOT EDIT.

#ifndef CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_DISCOVERY_H__
#define CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_DISCOVERY_H__
#pragma once

#include <string>
#include <vector>

#include "base/basictypes.h"
#include "base/memory/linked_ptr.h"
#include "base/memory/scoped_ptr.h"
#include "base/values.h"
#include "tools/json_schema_compiler/any.h"

namespace extensions {
namespace api {

namespace experimental_discovery {
struct SuggestDetails;
}  // experimental_discovery

namespace experimental_discovery {

//
// Types
//

struct SuggestDetails {
  ~SuggestDetails();
  SuggestDetails();

  // A score indicating how interesting that suggestion is. The value must be
  // between 0 and 1. A suggestion with score 1 is twice as likely to be
  // displayed than one with a score of 0.5. Defaults to 1. TODO: need minimum=0
  // and maximum=1.
  scoped_ptr<double> score;

  // The URL to suggest and that will be displayed in the new tab page under the
  // recommended pane.
  std::string link_url;

  // The linkified text. It should be relatively short.
  std::string link_text;

  // Populates a SuggestDetails object from a Value. Returns whether |out| was
  // successfully populated.
  static bool Populate(const Value& value, SuggestDetails* out);

  // Returns a new DictionaryValue representing the serialized form of this
  // SuggestDetails object. Passes ownership to caller.
  scoped_ptr<DictionaryValue> ToValue() const;

 private:
  DISALLOW_COPY_AND_ASSIGN(SuggestDetails);
};

//
// Functions
//

namespace ClearAllSuggestions {

};

namespace Suggest {
  struct Params {
    // Detailed information on the URL to suggest.
    SuggestDetails details;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

};

namespace RemoveSuggestion {
  struct Params {
    // The URl to remove from discovery. Must be exactly the same as a linkUrl
    // previously used on a call to suggest.
    std::string link_url;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

};

}  // experimental_discovery
}  // api
}  // extensions

#endif  // CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_DISCOVERY_H__
