// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/experimental_dns.idl
// DO NOT EDIT.

#include "tools/json_schema_compiler/util.h"
#include "chrome/common/extensions/api/experimental_dns.h"

using base::Value;
using base::DictionaryValue;
using base::ListValue;
using base::BinaryValue;
using json_schema_compiler::any::Any;

namespace extensions {
namespace api {
namespace experimental_dns {

//
// Types
//

ResolveCallbackResolveInfo::ResolveCallbackResolveInfo()
  : result_code(0) {}
ResolveCallbackResolveInfo::~ResolveCallbackResolveInfo() {}

// static
bool ResolveCallbackResolveInfo::Populate(const Value& value, ResolveCallbackResolveInfo* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* result_code_value = NULL;
  if (!dict->GetWithoutPathExpansion("resultCode", &result_code_value))
    return false;
  {
    if (!result_code_value->GetAsInteger(&out->result_code))
      return false;
  }

  Value* address_value = NULL;
  if (dict->GetWithoutPathExpansion("address", &address_value)) {
    {
      std::string temp;
      if (!address_value->GetAsString(&temp))
        return false;
      out->address.reset(new std::string(temp));
    }
  }

  return true;
}

scoped_ptr<DictionaryValue> ResolveCallbackResolveInfo::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("resultCode", Value::CreateIntegerValue(this->result_code));
  if (address.get())
    value->SetWithoutPathExpansion("address", Value::CreateStringValue(*this->address));


  return value.Pass();
}


//
// Functions
//

Resolve::Params::Params() {}
Resolve::Params::~Params() {}

// static
scoped_ptr<Resolve::Params> Resolve::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* hostname_value = NULL;
  if (args.Get(0, &hostname_value) && !hostname_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!hostname_value->GetAsString(&params->hostname))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* Resolve::Result::Create(const ResolveCallbackResolveInfo& resolve_info) {
  return resolve_info.ToValue().release();
}

}  // experimental_dns
}  // api
}  // extensions
