// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/experimental_dns.idl
// DO NOT EDIT.

#ifndef CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_DNS_H__
#define CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_DNS_H__
#pragma once

#include <string>
#include <vector>

#include "base/basictypes.h"
#include "base/memory/linked_ptr.h"
#include "base/memory/scoped_ptr.h"
#include "base/values.h"
#include "tools/json_schema_compiler/any.h"

namespace extensions {
namespace api {

namespace experimental_dns {
struct ResolveCallbackResolveInfo;
}  // experimental_dns

namespace experimental_dns {

//
// Types
//

struct ResolveCallbackResolveInfo {
  ~ResolveCallbackResolveInfo();
  ResolveCallbackResolveInfo();

  // The result code. Zero indicates success.
  int result_code;

  // A string representing the IP address literal. Supplied only if resultCode
  // indicates success. Note that we presently return only IPv4 addresses.
  scoped_ptr<std::string> address;

  // Populates a ResolveCallbackResolveInfo object from a Value. Returns
  // whether |out| was successfully populated.
  static bool Populate(const Value& value, ResolveCallbackResolveInfo* out);

  // Returns a new DictionaryValue representing the serialized form of this
  // ResolveCallbackResolveInfo object. Passes ownership to caller.
  scoped_ptr<DictionaryValue> ToValue() const;

 private:
  DISALLOW_COPY_AND_ASSIGN(ResolveCallbackResolveInfo);
};

//
// Functions
//

namespace Resolve {
  struct Params {
    // The hostname to resolve.
    std::string hostname;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

  namespace Result {
    Value* Create(const ResolveCallbackResolveInfo& resolve_info);
  };

};

}  // experimental_dns
}  // api
}  // extensions

#endif  // CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_DNS_H__
