// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/experimental_font_settings.json
// DO NOT EDIT.

#include "tools/json_schema_compiler/util.h"
#include "chrome/common/extensions/api/experimental_font_settings.h"

using base::Value;
using base::DictionaryValue;
using base::ListValue;
using base::BinaryValue;
using json_schema_compiler::any::Any;

namespace extensions {
namespace api {
namespace experimental_font_settings {

//
// Types
//

FontName::FontName()
   {}
FontName::~FontName() {}

// static
bool FontName::Populate(const Value& value, FontName* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* font_name_value = NULL;
  if (!dict->GetWithoutPathExpansion("fontName", &font_name_value))
    return false;
  {
    if (!font_name_value->GetAsString(&out->font_name))
      return false;
  }

  Value* localized_name_value = NULL;
  if (!dict->GetWithoutPathExpansion("localizedName", &localized_name_value))
    return false;
  {
    if (!localized_name_value->GetAsString(&out->localized_name))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> FontName::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("fontName", Value::CreateStringValue(this->font_name));
  value->SetWithoutPathExpansion("localizedName", Value::CreateStringValue(this->localized_name));

  return value.Pass();
}





//
// Functions
//

SetDefaultFontSize::Params::Details::Details()
  : pixel_size(0) {}
SetDefaultFontSize::Params::Details::~Details() {}

// static
bool SetDefaultFontSize::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* pixel_size_value = NULL;
  if (!dict->GetWithoutPathExpansion("pixelSize", &pixel_size_value))
    return false;
  {
    if (!pixel_size_value->GetAsInteger(&out->pixel_size))
      return false;
  }

  return true;
}


SetDefaultFontSize::Params::Params() {}
SetDefaultFontSize::Params::~Params() {}

// static
scoped_ptr<SetDefaultFontSize::Params> SetDefaultFontSize::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Details::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* SetDefaultFontSize::Result::Create() {
  return Value::CreateNullValue();
}

GetFont::Params::Details::Details()
   {}
GetFont::Params::Details::~Details() {}

// static
bool GetFont::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* generic_family_value = NULL;
  if (!dict->GetWithoutPathExpansion("genericFamily", &generic_family_value))
    return false;
  {
    if (!generic_family_value->GetAsString(&out->generic_family))
      return false;
  }

  Value* script_value = NULL;
  if (dict->GetWithoutPathExpansion("script", &script_value)) {
    {
      ScriptCode temp;
      if (!script_value->GetAsString(&temp))
        return false;
      out->script.reset(new ScriptCode(temp));
    }
  }

  return true;
}


GetFont::Params::Params() {}
GetFont::Params::~Params() {}

// static
scoped_ptr<GetFont::Params> GetFont::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Details::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


GetFont::Result::Details::Details()
   {}
GetFont::Result::Details::~Details() {}

scoped_ptr<DictionaryValue> GetFont::Result::Details::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("fontName", Value::CreateStringValue(this->font_name));
  value->SetWithoutPathExpansion("levelOfControl", Value::CreateStringValue(this->level_of_control));

  return value.Pass();
}


Value* GetFont::Result::Create(const Details& details) {
  return details.ToValue().release();
}

GetDefaultFontSize::Params::Details::Details()
   {}
GetDefaultFontSize::Params::Details::~Details() {}

// static
bool GetDefaultFontSize::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  return true;
}


GetDefaultFontSize::Params::Params() {}
GetDefaultFontSize::Params::~Params() {}

// static
scoped_ptr<GetDefaultFontSize::Params> GetDefaultFontSize::Params::Create(const ListValue& args) {
  if (args.GetSize() > 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      scoped_ptr<Details> temp(new Details());
      if (!Details::Populate(*dictionary, temp.get()))
        return scoped_ptr<Params>();
      params->details = temp.Pass();
    }
  }

  return params.Pass();
}


GetDefaultFontSize::Result::Details::Details()
  : pixel_size(0) {}
GetDefaultFontSize::Result::Details::~Details() {}

scoped_ptr<DictionaryValue> GetDefaultFontSize::Result::Details::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("pixelSize", Value::CreateIntegerValue(this->pixel_size));
  value->SetWithoutPathExpansion("levelOfControl", Value::CreateStringValue(this->level_of_control));

  return value.Pass();
}


Value* GetDefaultFontSize::Result::Create(const Details& details) {
  return details.ToValue().release();
}

GetMinimumFontSize::Params::Details::Details()
   {}
GetMinimumFontSize::Params::Details::~Details() {}

// static
bool GetMinimumFontSize::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  return true;
}


GetMinimumFontSize::Params::Params() {}
GetMinimumFontSize::Params::~Params() {}

// static
scoped_ptr<GetMinimumFontSize::Params> GetMinimumFontSize::Params::Create(const ListValue& args) {
  if (args.GetSize() > 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      scoped_ptr<Details> temp(new Details());
      if (!Details::Populate(*dictionary, temp.get()))
        return scoped_ptr<Params>();
      params->details = temp.Pass();
    }
  }

  return params.Pass();
}


GetMinimumFontSize::Result::Details::Details()
  : pixel_size(0) {}
GetMinimumFontSize::Result::Details::~Details() {}

scoped_ptr<DictionaryValue> GetMinimumFontSize::Result::Details::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("pixelSize", Value::CreateIntegerValue(this->pixel_size));
  value->SetWithoutPathExpansion("levelOfControl", Value::CreateStringValue(this->level_of_control));

  return value.Pass();
}


Value* GetMinimumFontSize::Result::Create(const Details& details) {
  return details.ToValue().release();
}

SetMinimumFontSize::Params::Details::Details()
  : pixel_size(0) {}
SetMinimumFontSize::Params::Details::~Details() {}

// static
bool SetMinimumFontSize::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* pixel_size_value = NULL;
  if (!dict->GetWithoutPathExpansion("pixelSize", &pixel_size_value))
    return false;
  {
    if (!pixel_size_value->GetAsInteger(&out->pixel_size))
      return false;
  }

  return true;
}


SetMinimumFontSize::Params::Params() {}
SetMinimumFontSize::Params::~Params() {}

// static
scoped_ptr<SetMinimumFontSize::Params> SetMinimumFontSize::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Details::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* SetMinimumFontSize::Result::Create() {
  return Value::CreateNullValue();
}

GetDefaultFixedFontSize::Params::Details::Details()
   {}
GetDefaultFixedFontSize::Params::Details::~Details() {}

// static
bool GetDefaultFixedFontSize::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  return true;
}


GetDefaultFixedFontSize::Params::Params() {}
GetDefaultFixedFontSize::Params::~Params() {}

// static
scoped_ptr<GetDefaultFixedFontSize::Params> GetDefaultFixedFontSize::Params::Create(const ListValue& args) {
  if (args.GetSize() > 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      scoped_ptr<Details> temp(new Details());
      if (!Details::Populate(*dictionary, temp.get()))
        return scoped_ptr<Params>();
      params->details = temp.Pass();
    }
  }

  return params.Pass();
}


GetDefaultFixedFontSize::Result::Details::Details()
  : pixel_size(0) {}
GetDefaultFixedFontSize::Result::Details::~Details() {}

scoped_ptr<DictionaryValue> GetDefaultFixedFontSize::Result::Details::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("pixelSize", Value::CreateIntegerValue(this->pixel_size));
  value->SetWithoutPathExpansion("levelOfControl", Value::CreateStringValue(this->level_of_control));

  return value.Pass();
}


Value* GetDefaultFixedFontSize::Result::Create(const Details& details) {
  return details.ToValue().release();
}

ClearDefaultFontSize::Params::Details::Details()
   {}
ClearDefaultFontSize::Params::Details::~Details() {}

// static
bool ClearDefaultFontSize::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  return true;
}


ClearDefaultFontSize::Params::Params() {}
ClearDefaultFontSize::Params::~Params() {}

// static
scoped_ptr<ClearDefaultFontSize::Params> ClearDefaultFontSize::Params::Create(const ListValue& args) {
  if (args.GetSize() > 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      scoped_ptr<Details> temp(new Details());
      if (!Details::Populate(*dictionary, temp.get()))
        return scoped_ptr<Params>();
      params->details = temp.Pass();
    }
  }

  return params.Pass();
}


Value* ClearDefaultFontSize::Result::Create() {
  return Value::CreateNullValue();
}

SetDefaultFixedFontSize::Params::Details::Details()
  : pixel_size(0) {}
SetDefaultFixedFontSize::Params::Details::~Details() {}

// static
bool SetDefaultFixedFontSize::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* pixel_size_value = NULL;
  if (!dict->GetWithoutPathExpansion("pixelSize", &pixel_size_value))
    return false;
  {
    if (!pixel_size_value->GetAsInteger(&out->pixel_size))
      return false;
  }

  return true;
}


SetDefaultFixedFontSize::Params::Params() {}
SetDefaultFixedFontSize::Params::~Params() {}

// static
scoped_ptr<SetDefaultFixedFontSize::Params> SetDefaultFixedFontSize::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Details::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* SetDefaultFixedFontSize::Result::Create() {
  return Value::CreateNullValue();
}

ClearFont::Params::Details::Details()
   {}
ClearFont::Params::Details::~Details() {}

// static
bool ClearFont::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* generic_family_value = NULL;
  if (!dict->GetWithoutPathExpansion("genericFamily", &generic_family_value))
    return false;
  {
    if (!generic_family_value->GetAsString(&out->generic_family))
      return false;
  }

  Value* script_value = NULL;
  if (dict->GetWithoutPathExpansion("script", &script_value)) {
    {
      ScriptCode temp;
      if (!script_value->GetAsString(&temp))
        return false;
      out->script.reset(new ScriptCode(temp));
    }
  }

  return true;
}


ClearFont::Params::Params() {}
ClearFont::Params::~Params() {}

// static
scoped_ptr<ClearFont::Params> ClearFont::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Details::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* ClearFont::Result::Create() {
  return Value::CreateNullValue();
}

SetFont::Params::Details::Details()
   {}
SetFont::Params::Details::~Details() {}

// static
bool SetFont::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* font_name_value = NULL;
  if (!dict->GetWithoutPathExpansion("fontName", &font_name_value))
    return false;
  {
    if (!font_name_value->GetAsString(&out->font_name))
      return false;
  }

  Value* generic_family_value = NULL;
  if (!dict->GetWithoutPathExpansion("genericFamily", &generic_family_value))
    return false;
  {
    if (!generic_family_value->GetAsString(&out->generic_family))
      return false;
  }

  Value* script_value = NULL;
  if (dict->GetWithoutPathExpansion("script", &script_value)) {
    {
      ScriptCode temp;
      if (!script_value->GetAsString(&temp))
        return false;
      out->script.reset(new ScriptCode(temp));
    }
  }

  return true;
}


SetFont::Params::Params() {}
SetFont::Params::~Params() {}

// static
scoped_ptr<SetFont::Params> SetFont::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Details::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* SetFont::Result::Create() {
  return Value::CreateNullValue();
}

ClearMinimumFontSize::Params::Details::Details()
   {}
ClearMinimumFontSize::Params::Details::~Details() {}

// static
bool ClearMinimumFontSize::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  return true;
}


ClearMinimumFontSize::Params::Params() {}
ClearMinimumFontSize::Params::~Params() {}

// static
scoped_ptr<ClearMinimumFontSize::Params> ClearMinimumFontSize::Params::Create(const ListValue& args) {
  if (args.GetSize() > 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      scoped_ptr<Details> temp(new Details());
      if (!Details::Populate(*dictionary, temp.get()))
        return scoped_ptr<Params>();
      params->details = temp.Pass();
    }
  }

  return params.Pass();
}


Value* ClearMinimumFontSize::Result::Create() {
  return Value::CreateNullValue();
}

Value* GetFontList::Result::Create(const std::vector<linked_ptr<FontName> >& results) {
  return json_schema_compiler::util::CreateValueFromArray(results).release();
}

ClearDefaultFixedFontSize::Params::Details::Details()
   {}
ClearDefaultFixedFontSize::Params::Details::~Details() {}

// static
bool ClearDefaultFixedFontSize::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  return true;
}


ClearDefaultFixedFontSize::Params::Params() {}
ClearDefaultFixedFontSize::Params::~Params() {}

// static
scoped_ptr<ClearDefaultFixedFontSize::Params> ClearDefaultFixedFontSize::Params::Create(const ListValue& args) {
  if (args.GetSize() > 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      scoped_ptr<Details> temp(new Details());
      if (!Details::Populate(*dictionary, temp.get()))
        return scoped_ptr<Params>();
      params->details = temp.Pass();
    }
  }

  return params.Pass();
}


Value* ClearDefaultFixedFontSize::Result::Create() {
  return Value::CreateNullValue();
}

}  // experimental_font_settings
}  // api
}  // extensions
