// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/experimental_idltest.idl
// DO NOT EDIT.

#include "tools/json_schema_compiler/util.h"
#include "chrome/common/extensions/api/experimental_idltest.h"

using base::Value;
using base::DictionaryValue;
using base::ListValue;
using base::BinaryValue;
using json_schema_compiler::any::Any;

namespace extensions {
namespace api {
namespace experimental_idltest {

//
// Functions
//

SendArrayBuffer::Params::Params() {}
SendArrayBuffer::Params::~Params() {}

// static
scoped_ptr<SendArrayBuffer::Params> SendArrayBuffer::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* input_value = NULL;
  if (args.Get(0, &input_value) && !input_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!input_value->IsType(Value::TYPE_BINARY))
        return scoped_ptr<Params>();
      params->input.reset(
          static_cast<BinaryValue*>(input_value)->DeepCopy());
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* SendArrayBuffer::Result::Create(const std::vector<int>& array) {
  return json_schema_compiler::util::CreateValueFromArray(array).release();
}

SendArrayBufferView::Params::Input::Input()
   {}
SendArrayBufferView::Params::Input::~Input() {}

// static
bool SendArrayBufferView::Params::Input::Populate(const Value& value, Input* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  out->additional_properties.MergeDictionary(dict);

  return true;
}


SendArrayBufferView::Params::Params() {}
SendArrayBufferView::Params::~Params() {}

// static
scoped_ptr<SendArrayBufferView::Params> SendArrayBufferView::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* input_value = NULL;
  if (args.Get(0, &input_value) && !input_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!input_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Input::Populate(*dictionary, &params->input))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* SendArrayBufferView::Result::Create(const std::vector<int>& array) {
  return json_schema_compiler::util::CreateValueFromArray(array).release();
}

Value* GetArrayBuffer::Result::Create(const scoped_ptr<base::BinaryValue> buffer) {
  return buffer->DeepCopy();
}

}  // experimental_idltest
}  // api
}  // extensions
