// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/experimental_idltest.idl
// DO NOT EDIT.

#ifndef CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_IDLTEST_H__
#define CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_IDLTEST_H__
#pragma once

#include <string>
#include <vector>

#include "base/basictypes.h"
#include "base/memory/linked_ptr.h"
#include "base/memory/scoped_ptr.h"
#include "base/values.h"
#include "tools/json_schema_compiler/any.h"

namespace extensions {
namespace api {

namespace experimental_idltest {
}  // experimental_idltest

namespace experimental_idltest {

//
// Functions
//

namespace SendArrayBuffer {
  struct Params {
    scoped_ptr<base::BinaryValue> input;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

  namespace Result {

    Value* Create(const std::vector<int>& array);
  };

};

namespace SendArrayBufferView {
  struct Params {
    struct Input {
      ~Input();
      Input();

      base::DictionaryValue additional_properties;

      // Populates a Input object from a Value. Returns whether |out| was
      // successfully populated.
      static bool Populate(const Value& value, Input* out);


     private:
      DISALLOW_COPY_AND_ASSIGN(Input);
    };

    Input input;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

  namespace Result {

    Value* Create(const std::vector<int>& array);
  };

};

namespace GetArrayBuffer {

  namespace Result {
    Value* Create(const scoped_ptr<base::BinaryValue> buffer);
  };

};

}  // experimental_idltest
}  // api
}  // extensions

#endif  // CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_IDLTEST_H__
