// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/experimental_record.json
// DO NOT EDIT.

#ifndef CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_RECORD_H__
#define CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_RECORD_H__
#pragma once

#include <string>
#include <vector>

#include "base/basictypes.h"
#include "base/memory/linked_ptr.h"
#include "base/memory/scoped_ptr.h"
#include "base/values.h"
#include "tools/json_schema_compiler/any.h"

namespace extensions {
namespace api {

namespace experimental_record {
struct ReplayURLsResult;
struct SessionDetails;
}  // experimental_record

namespace experimental_record {

//
// Types
//

struct ReplayURLsResult {
  ~ReplayURLsResult();
  ReplayURLsResult();


  // Time in milliseconds to complete all runs.
  int run_time;

  // Full multiline dump of output stats.
  std::string stats;

  // List of errors during replay.
  std::vector<std::string> errors;

  // Populates a ReplayURLsResult object from a Value. Returns whether |out|
  // was successfully populated.
  static bool Populate(const Value& value, ReplayURLsResult* out);

  // Returns a new DictionaryValue representing the serialized form of this
  // ReplayURLsResult object. Passes ownership to caller.
  scoped_ptr<DictionaryValue> ToValue() const;

 private:
  DISALLOW_COPY_AND_ASSIGN(ReplayURLsResult);
};

struct SessionDetails {
  ~SessionDetails();
  SessionDetails();

  // A path to an extension to run in the session. Should be an unpacked
  // extension.
  scoped_ptr<std::string> extension_path;

  // Populates a SessionDetails object from a Value. Returns whether |out| was
  // successfully populated.
  static bool Populate(const Value& value, SessionDetails* out);

  // Returns a new DictionaryValue representing the serialized form of this
  // SessionDetails object. Passes ownership to caller.
  scoped_ptr<DictionaryValue> ToValue() const;

 private:
  DISALLOW_COPY_AND_ASSIGN(SessionDetails);
};

//
// Functions
//

namespace ReplayURLs {
  struct Params {

    std::vector<std::string> urls;

    std::string capture_directory_path;

    int repeat_count;

    scoped_ptr<SessionDetails> details;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

  namespace Result {
    Value* Create(const ReplayURLsResult& result);
  };

};

namespace CaptureURLs {
  struct Params {

    std::vector<std::string> urls;

    std::string cache_directory_path;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

  namespace Result {

    Value* Create(const std::vector<std::string>& errors);
  };

};

}  // experimental_record
}  // api
}  // extensions

#endif  // CHROME_COMMON_EXTENSIONS_API_EXPERIMENTAL_RECORD_H__
