// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/experimental_socket.idl
// DO NOT EDIT.

#include "tools/json_schema_compiler/util.h"
#include "chrome/common/extensions/api/experimental_socket.h"

using base::Value;
using base::DictionaryValue;
using base::ListValue;
using base::BinaryValue;
using json_schema_compiler::any::Any;

namespace extensions {
namespace api {
namespace experimental_socket {

//
// Types
//

CreateOptions::CreateOptions()
   {}
CreateOptions::~CreateOptions() {}

// static
bool CreateOptions::Populate(const Value& value, CreateOptions* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* dummy_value_value = NULL;
  if (dict->GetWithoutPathExpansion("dummyValue", &dummy_value_value)) {
    {
      int temp;
      if (!dummy_value_value->GetAsInteger(&temp))
        return false;
      out->dummy_value.reset(new int(temp));
    }
  }

  return true;
}

scoped_ptr<DictionaryValue> CreateOptions::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  if (dummy_value.get())
    value->SetWithoutPathExpansion("dummyValue", Value::CreateIntegerValue(*this->dummy_value));


  return value.Pass();
}


CreateInfo::CreateInfo()
  : socket_id(0) {}
CreateInfo::~CreateInfo() {}

// static
bool CreateInfo::Populate(const Value& value, CreateInfo* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* socket_id_value = NULL;
  if (!dict->GetWithoutPathExpansion("socketId", &socket_id_value))
    return false;
  {
    if (!socket_id_value->GetAsInteger(&out->socket_id))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> CreateInfo::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("socketId", Value::CreateIntegerValue(this->socket_id));

  return value.Pass();
}


ReadInfo::ReadInfo()
  : result_code(0), data(NULL) {}
ReadInfo::~ReadInfo() {}

// static
bool ReadInfo::Populate(const Value& value, ReadInfo* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* result_code_value = NULL;
  if (!dict->GetWithoutPathExpansion("resultCode", &result_code_value))
    return false;
  {
    if (!result_code_value->GetAsInteger(&out->result_code))
      return false;
  }

  Value* data_value = NULL;
  if (!dict->GetWithoutPathExpansion("data", &data_value))
    return false;
  {
    if (!data_value->IsType(Value::TYPE_BINARY))
      return false;
    out->data.reset(
        static_cast<BinaryValue*>(data_value)->DeepCopy());
  }

  return true;
}

scoped_ptr<DictionaryValue> ReadInfo::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("resultCode", Value::CreateIntegerValue(this->result_code));
  value->SetWithoutPathExpansion("data", this->data->DeepCopy());

  return value.Pass();
}


WriteInfo::WriteInfo()
  : bytes_written(0) {}
WriteInfo::~WriteInfo() {}

// static
bool WriteInfo::Populate(const Value& value, WriteInfo* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* bytes_written_value = NULL;
  if (!dict->GetWithoutPathExpansion("bytesWritten", &bytes_written_value))
    return false;
  {
    if (!bytes_written_value->GetAsInteger(&out->bytes_written))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> WriteInfo::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("bytesWritten", Value::CreateIntegerValue(this->bytes_written));

  return value.Pass();
}


RecvFromInfo::RecvFromInfo()
  : result_code(0), data(NULL), port(0) {}
RecvFromInfo::~RecvFromInfo() {}

// static
bool RecvFromInfo::Populate(const Value& value, RecvFromInfo* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* result_code_value = NULL;
  if (!dict->GetWithoutPathExpansion("resultCode", &result_code_value))
    return false;
  {
    if (!result_code_value->GetAsInteger(&out->result_code))
      return false;
  }

  Value* data_value = NULL;
  if (!dict->GetWithoutPathExpansion("data", &data_value))
    return false;
  {
    if (!data_value->IsType(Value::TYPE_BINARY))
      return false;
    out->data.reset(
        static_cast<BinaryValue*>(data_value)->DeepCopy());
  }

  Value* port_value = NULL;
  if (!dict->GetWithoutPathExpansion("port", &port_value))
    return false;
  {
    if (!port_value->GetAsInteger(&out->port))
      return false;
  }

  Value* address_value = NULL;
  if (!dict->GetWithoutPathExpansion("address", &address_value))
    return false;
  {
    if (!address_value->GetAsString(&out->address))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> RecvFromInfo::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("resultCode", Value::CreateIntegerValue(this->result_code));
  value->SetWithoutPathExpansion("data", this->data->DeepCopy());
  value->SetWithoutPathExpansion("port", Value::CreateIntegerValue(this->port));
  value->SetWithoutPathExpansion("address", Value::CreateStringValue(this->address));

  return value.Pass();
}



//
// Functions
//

RecvFrom::Params::Params() {}
RecvFrom::Params::~Params() {}

// static
scoped_ptr<RecvFrom::Params> RecvFrom::Params::Create(const ListValue& args) {
  if (args.GetSize() < 1 || args.GetSize() > 2)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* socket_id_value = NULL;
  if (args.Get(0, &socket_id_value) && !socket_id_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!socket_id_value->GetAsInteger(&params->socket_id))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* buffer_size_value = NULL;
  if (args.Get(1, &buffer_size_value) && !buffer_size_value->IsType(Value::TYPE_NULL))
  {
    {
      int temp;
      if (!buffer_size_value->GetAsInteger(&temp))
        return scoped_ptr<Params>();
      params->buffer_size.reset(new int(temp));
    }
  }

  return params.Pass();
}


Value* RecvFrom::Result::Create(const RecvFromInfo& recv_from_info) {
  return recv_from_info.ToValue().release();
}

Disconnect::Params::Params() {}
Disconnect::Params::~Params() {}

// static
scoped_ptr<Disconnect::Params> Disconnect::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* socket_id_value = NULL;
  if (args.Get(0, &socket_id_value) && !socket_id_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!socket_id_value->GetAsInteger(&params->socket_id))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}



Read::Params::Params() {}
Read::Params::~Params() {}

// static
scoped_ptr<Read::Params> Read::Params::Create(const ListValue& args) {
  if (args.GetSize() < 1 || args.GetSize() > 2)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* socket_id_value = NULL;
  if (args.Get(0, &socket_id_value) && !socket_id_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!socket_id_value->GetAsInteger(&params->socket_id))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* buffer_size_value = NULL;
  if (args.Get(1, &buffer_size_value) && !buffer_size_value->IsType(Value::TYPE_NULL))
  {
    {
      int temp;
      if (!buffer_size_value->GetAsInteger(&temp))
        return scoped_ptr<Params>();
      params->buffer_size.reset(new int(temp));
    }
  }

  return params.Pass();
}


Value* Read::Result::Create(const ReadInfo& read_info) {
  return read_info.ToValue().release();
}

Bind::Params::Params() {}
Bind::Params::~Params() {}

// static
scoped_ptr<Bind::Params> Bind::Params::Create(const ListValue& args) {
  if (args.GetSize() != 3)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* socket_id_value = NULL;
  if (args.Get(0, &socket_id_value) && !socket_id_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!socket_id_value->GetAsInteger(&params->socket_id))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* address_value = NULL;
  if (args.Get(1, &address_value) && !address_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!address_value->GetAsString(&params->address))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* port_value = NULL;
  if (args.Get(2, &port_value) && !port_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!port_value->GetAsInteger(&params->port))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* Bind::Result::Create(const int result) {
  return Value::CreateIntegerValue(result);
}

Create::Params::Params() {}
Create::Params::~Params() {}

// static
scoped_ptr<Create::Params> Create::Params::Create(const ListValue& args) {
  if (args.GetSize() < 1 || args.GetSize() > 2)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* type_value = NULL;
  if (args.Get(0, &type_value) && !type_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!type_value->GetAsString(&params->type))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* options_value = NULL;
  if (args.Get(1, &options_value) && !options_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!options_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      scoped_ptr<CreateOptions> temp(new CreateOptions());
      if (!CreateOptions::Populate(*dictionary, temp.get()))
        return scoped_ptr<Params>();
      params->options = temp.Pass();
    }
  }

  return params.Pass();
}


Value* Create::Result::Create(const CreateInfo& create_info) {
  return create_info.ToValue().release();
}

Write::Params::Params() {}
Write::Params::~Params() {}

// static
scoped_ptr<Write::Params> Write::Params::Create(const ListValue& args) {
  if (args.GetSize() != 2)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* socket_id_value = NULL;
  if (args.Get(0, &socket_id_value) && !socket_id_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!socket_id_value->GetAsInteger(&params->socket_id))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* data_value = NULL;
  if (args.Get(1, &data_value) && !data_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!data_value->IsType(Value::TYPE_BINARY))
        return scoped_ptr<Params>();
      params->data.reset(
          static_cast<BinaryValue*>(data_value)->DeepCopy());
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* Write::Result::Create(const WriteInfo& write_info) {
  return write_info.ToValue().release();
}

SetNoDelay::Params::Params() {}
SetNoDelay::Params::~Params() {}

// static
scoped_ptr<SetNoDelay::Params> SetNoDelay::Params::Create(const ListValue& args) {
  if (args.GetSize() != 2)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* socket_id_value = NULL;
  if (args.Get(0, &socket_id_value) && !socket_id_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!socket_id_value->GetAsInteger(&params->socket_id))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* no_delay_value = NULL;
  if (args.Get(1, &no_delay_value) && !no_delay_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!no_delay_value->GetAsBoolean(&params->no_delay))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* SetNoDelay::Result::Create(const bool result) {
  return Value::CreateBooleanValue(result);
}

Connect::Params::Params() {}
Connect::Params::~Params() {}

// static
scoped_ptr<Connect::Params> Connect::Params::Create(const ListValue& args) {
  if (args.GetSize() != 3)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* socket_id_value = NULL;
  if (args.Get(0, &socket_id_value) && !socket_id_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!socket_id_value->GetAsInteger(&params->socket_id))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* hostname_value = NULL;
  if (args.Get(1, &hostname_value) && !hostname_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!hostname_value->GetAsString(&params->hostname))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* port_value = NULL;
  if (args.Get(2, &port_value) && !port_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!port_value->GetAsInteger(&params->port))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* Connect::Result::Create(const int result) {
  return Value::CreateIntegerValue(result);
}

SendTo::Params::Params() {}
SendTo::Params::~Params() {}

// static
scoped_ptr<SendTo::Params> SendTo::Params::Create(const ListValue& args) {
  if (args.GetSize() != 4)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* socket_id_value = NULL;
  if (args.Get(0, &socket_id_value) && !socket_id_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!socket_id_value->GetAsInteger(&params->socket_id))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* data_value = NULL;
  if (args.Get(1, &data_value) && !data_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!data_value->IsType(Value::TYPE_BINARY))
        return scoped_ptr<Params>();
      params->data.reset(
          static_cast<BinaryValue*>(data_value)->DeepCopy());
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* address_value = NULL;
  if (args.Get(2, &address_value) && !address_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!address_value->GetAsString(&params->address))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* port_value = NULL;
  if (args.Get(3, &port_value) && !port_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!port_value->GetAsInteger(&params->port))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* SendTo::Result::Create(const WriteInfo& write_info) {
  return write_info.ToValue().release();
}

Destroy::Params::Params() {}
Destroy::Params::~Params() {}

// static
scoped_ptr<Destroy::Params> Destroy::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* socket_id_value = NULL;
  if (args.Get(0, &socket_id_value) && !socket_id_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!socket_id_value->GetAsInteger(&params->socket_id))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}



SetKeepAlive::Params::Params() {}
SetKeepAlive::Params::~Params() {}

// static
scoped_ptr<SetKeepAlive::Params> SetKeepAlive::Params::Create(const ListValue& args) {
  if (args.GetSize() < 2 || args.GetSize() > 3)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* socket_id_value = NULL;
  if (args.Get(0, &socket_id_value) && !socket_id_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!socket_id_value->GetAsInteger(&params->socket_id))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* enable_value = NULL;
  if (args.Get(1, &enable_value) && !enable_value->IsType(Value::TYPE_NULL))
  {
    {
      if (!enable_value->GetAsBoolean(&params->enable))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  Value* delay_value = NULL;
  if (args.Get(2, &delay_value) && !delay_value->IsType(Value::TYPE_NULL))
  {
    {
      int temp;
      if (!delay_value->GetAsInteger(&temp))
        return scoped_ptr<Params>();
      params->delay.reset(new int(temp));
    }
  }

  return params.Pass();
}


Value* SetKeepAlive::Result::Create(const bool result) {
  return Value::CreateBooleanValue(result);
}

}  // experimental_socket
}  // api
}  // extensions
