// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/file_browser_handler_internal.json
// DO NOT EDIT.

#include "tools/json_schema_compiler/util.h"
#include "chrome/common/extensions/api/file_browser_handler_internal.h"

using base::Value;
using base::DictionaryValue;
using base::ListValue;
using base::BinaryValue;
using json_schema_compiler::any::Any;

namespace extensions {
namespace api {
namespace file_browser_handler_internal {

//
// Types
//

FileEntryInfo::FileEntryInfo()
  : file_is_directory(false) {}
FileEntryInfo::~FileEntryInfo() {}

// static
bool FileEntryInfo::Populate(const Value& value, FileEntryInfo* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* file_full_path_value = NULL;
  if (!dict->GetWithoutPathExpansion("fileFullPath", &file_full_path_value))
    return false;
  {
    if (!file_full_path_value->GetAsString(&out->file_full_path))
      return false;
  }

  Value* file_system_name_value = NULL;
  if (!dict->GetWithoutPathExpansion("fileSystemName", &file_system_name_value))
    return false;
  {
    if (!file_system_name_value->GetAsString(&out->file_system_name))
      return false;
  }

  Value* file_is_directory_value = NULL;
  if (!dict->GetWithoutPathExpansion("fileIsDirectory", &file_is_directory_value))
    return false;
  {
    if (!file_is_directory_value->GetAsBoolean(&out->file_is_directory))
      return false;
  }

  Value* file_system_root_value = NULL;
  if (!dict->GetWithoutPathExpansion("fileSystemRoot", &file_system_root_value))
    return false;
  {
    if (!file_system_root_value->GetAsString(&out->file_system_root))
      return false;
  }

  return true;
}

scoped_ptr<DictionaryValue> FileEntryInfo::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("fileFullPath", Value::CreateStringValue(this->file_full_path));
  value->SetWithoutPathExpansion("fileSystemName", Value::CreateStringValue(this->file_system_name));
  value->SetWithoutPathExpansion("fileIsDirectory", Value::CreateBooleanValue(this->file_is_directory));
  value->SetWithoutPathExpansion("fileSystemRoot", Value::CreateStringValue(this->file_system_root));

  return value.Pass();
}


//
// Functions
//

SelectFile::Params::SelectionParams::SelectionParams()
   {}
SelectFile::Params::SelectionParams::~SelectionParams() {}

// static
bool SelectFile::Params::SelectionParams::Populate(const Value& value, SelectionParams* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* suggested_name_value = NULL;
  if (!dict->GetWithoutPathExpansion("suggestedName", &suggested_name_value))
    return false;
  {
    if (!suggested_name_value->GetAsString(&out->suggested_name))
      return false;
  }

  return true;
}


SelectFile::Params::Params() {}
SelectFile::Params::~Params() {}

// static
scoped_ptr<SelectFile::Params> SelectFile::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* selection_params_value = NULL;
  if (args.Get(0, &selection_params_value) && !selection_params_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!selection_params_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!SelectionParams::Populate(*dictionary, &params->selection_params))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


SelectFile::Result::Result::Result()
  : success(false) {}
SelectFile::Result::Result::~Result() {}

scoped_ptr<DictionaryValue> SelectFile::Result::Result::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  if (entry.get())
    value->SetWithoutPathExpansion("entry", this->entry->ToValue().release());

  value->SetWithoutPathExpansion("success", Value::CreateBooleanValue(this->success));

  return value.Pass();
}


Value* SelectFile::Result::Create(const Result& result) {
  return result.ToValue().release();
}

}  // file_browser_handler_internal
}  // api
}  // extensions
