// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/file_browser_handler_internal.json
// DO NOT EDIT.

#ifndef CHROME_COMMON_EXTENSIONS_API_FILE_BROWSER_HANDLER_INTERNAL_H__
#define CHROME_COMMON_EXTENSIONS_API_FILE_BROWSER_HANDLER_INTERNAL_H__
#pragma once

#include <string>
#include <vector>

#include "base/basictypes.h"
#include "base/memory/linked_ptr.h"
#include "base/memory/scoped_ptr.h"
#include "base/values.h"
#include "tools/json_schema_compiler/any.h"

namespace extensions {
namespace api {

namespace file_browser_handler_internal {
struct FileEntryInfo;
}  // file_browser_handler_internal

namespace file_browser_handler_internal {

//
// Types
//

// Information needed to build a file entry that will be returned through the
// API.
struct FileEntryInfo {
  ~FileEntryInfo();
  FileEntryInfo();

  std::string file_full_path;

  std::string file_system_name;

  bool file_is_directory;

  std::string file_system_root;

  // Populates a FileEntryInfo object from a Value. Returns whether |out| was
  // successfully populated.
  static bool Populate(const Value& value, FileEntryInfo* out);

  // Returns a new DictionaryValue representing the serialized form of this
  // FileEntryInfo object. Passes ownership to caller.
  scoped_ptr<DictionaryValue> ToValue() const;

 private:
  DISALLOW_COPY_AND_ASSIGN(FileEntryInfo);
};

//
// Functions
//

namespace SelectFile {
  struct Params {
    // Parameters that will be used to create new file.
    struct SelectionParams {
      ~SelectionParams();
      SelectionParams();

      // Suggested name for the new file.
      std::string suggested_name;

      // Populates a SelectionParams object from a Value. Returns whether |out| was
      // successfully populated.
      static bool Populate(const Value& value, SelectionParams* out);


     private:
      DISALLOW_COPY_AND_ASSIGN(SelectionParams);
    };

    // Parameters that will be used to create new file.
    SelectionParams selection_params;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

  namespace Result {
    // Result of the method.
    struct Result {
      ~Result();
      Result();

      // Selected file entry.
      scoped_ptr<FileEntryInfo> entry;

      // Has the file been selected.
      bool success;

      // Returns a new DictionaryValue representing the serialized form of this
      // Result object. Passes ownership to caller.
      scoped_ptr<DictionaryValue> ToValue() const;

     private:
      DISALLOW_COPY_AND_ASSIGN(Result);
    };

    // Result of the method.
    Value* Create(const Result& result);
  };

};

}  // file_browser_handler_internal
}  // api
}  // extensions

#endif  // CHROME_COMMON_EXTENSIONS_API_FILE_BROWSER_HANDLER_INTERNAL_H__
