// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/file_system.idl
// DO NOT EDIT.

#include "tools/json_schema_compiler/util.h"
#include "chrome/common/extensions/api/file_system.h"

using base::Value;
using base::DictionaryValue;
using base::ListValue;
using base::BinaryValue;
using json_schema_compiler::any::Any;

namespace extensions {
namespace api {
namespace file_system {

//
// Types
//

ChooseFileOptions::ChooseFileOptions()
   {}
ChooseFileOptions::~ChooseFileOptions() {}

// static
bool ChooseFileOptions::Populate(const Value& value, ChooseFileOptions* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* type_value = NULL;
  if (dict->GetWithoutPathExpansion("type", &type_value)) {
    {
      std::string temp;
      if (!type_value->GetAsString(&temp))
        return false;
      out->type.reset(new std::string(temp));
    }
  }

  return true;
}

scoped_ptr<DictionaryValue> ChooseFileOptions::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  if (type.get())
    value->SetWithoutPathExpansion("type", Value::CreateStringValue(*this->type));


  return value.Pass();
}


//
// Functions
//

GetWritableFileEntry::Params::FileEntry::FileEntry()
   {}
GetWritableFileEntry::Params::FileEntry::~FileEntry() {}

// static
bool GetWritableFileEntry::Params::FileEntry::Populate(const Value& value, FileEntry* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  out->additional_properties.MergeDictionary(dict);

  return true;
}


GetWritableFileEntry::Params::Params() {}
GetWritableFileEntry::Params::~Params() {}

// static
scoped_ptr<GetWritableFileEntry::Params> GetWritableFileEntry::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* file_entry_value = NULL;
  if (args.Get(0, &file_entry_value) && !file_entry_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!file_entry_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!FileEntry::Populate(*dictionary, &params->file_entry))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


GetWritableFileEntry::Result::FileEntry::FileEntry()
   {}
GetWritableFileEntry::Result::FileEntry::~FileEntry() {}

scoped_ptr<DictionaryValue> GetWritableFileEntry::Result::FileEntry::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->MergeDictionary(&additional_properties);

  return value.Pass();
}


Value* GetWritableFileEntry::Result::Create(const FileEntry& file_entry) {
  return file_entry.ToValue().release();
}

GetDisplayPath::Params::FileEntry::FileEntry()
   {}
GetDisplayPath::Params::FileEntry::~FileEntry() {}

// static
bool GetDisplayPath::Params::FileEntry::Populate(const Value& value, FileEntry* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  out->additional_properties.MergeDictionary(dict);

  return true;
}


GetDisplayPath::Params::Params() {}
GetDisplayPath::Params::~Params() {}

// static
scoped_ptr<GetDisplayPath::Params> GetDisplayPath::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* file_entry_value = NULL;
  if (args.Get(0, &file_entry_value) && !file_entry_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!file_entry_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!FileEntry::Populate(*dictionary, &params->file_entry))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


Value* GetDisplayPath::Result::Create(const std::string& display_path) {
  return Value::CreateStringValue(display_path);
}

ChooseFile::Params::Params() {}
ChooseFile::Params::~Params() {}

// static
scoped_ptr<ChooseFile::Params> ChooseFile::Params::Create(const ListValue& args) {
  if (args.GetSize() > 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* options_value = NULL;
  if (args.Get(0, &options_value) && !options_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!options_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      scoped_ptr<ChooseFileOptions> temp(new ChooseFileOptions());
      if (!ChooseFileOptions::Populate(*dictionary, temp.get()))
        return scoped_ptr<Params>();
      params->options = temp.Pass();
    }
  }

  return params.Pass();
}


ChooseFile::Result::FileEntry::FileEntry()
   {}
ChooseFile::Result::FileEntry::~FileEntry() {}

scoped_ptr<DictionaryValue> ChooseFile::Result::FileEntry::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->MergeDictionary(&additional_properties);

  return value.Pass();
}


Value* ChooseFile::Result::Create(const FileEntry& file_entry) {
  return file_entry.ToValue().release();
}

}  // file_system
}  // api
}  // extensions
