// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITIONS IN
//   chrome/common/extensions/api
// DO NOT EDIT.

#ifndef CHROME_COMMON_EXTENSIONS_API_GENERATED_API_H__
#define CHROME_COMMON_EXTENSIONS_API_GENERATED_API_H__
#pragma once

#include <string>

#include "base/basictypes.h"
#include "chrome/browser/extensions/api/idltest/idltest_api.h"
#include "chrome/browser/extensions/api/app_window/app_window_api.h"
#include "chrome/browser/extensions/api/socket/socket_api.h"
#include "chrome/browser/extensions/api/serial/serial_api.h"
#include "chrome/browser/extensions/api/discovery/discovery_api.h"
#include "chrome/browser/extensions/api/file_system/file_system_api.h"
#include "chrome/browser/extensions/api/alarms/alarms_api.h"
#include "chrome/browser/extensions/api/bluetooth/bluetooth_api.h"
#include "chrome/browser/extensions/api/dns/dns_api.h"
#include "chrome/browser/extensions/api/usb/usb_api.h"

class ExtensionFunctionRegistry;

namespace extensions {
namespace api {
// TODO(miket): emit code for experimental_idltest
// TODO(miket): emit code for app_window
// TODO(miket): emit code for experimental_socket
// TODO(miket): emit code for experimental_serial
// TODO(miket): emit code for experimental_discovery
// TODO(miket): emit code for file_system
// TODO(miket): emit code for alarms
// TODO(miket): emit code for experimental_bluetooth
// TODO(miket): emit code for experimental_dns
// TODO(miket): emit code for experimental_usb

class GeneratedFunctionRegistry {
  public:
  static void RegisterAll(ExtensionFunctionRegistry* registry) {
    registry->RegisterFunction<IdltestSendArrayBufferFunction>();
    registry->RegisterFunction<IdltestSendArrayBufferViewFunction>();
    registry->RegisterFunction<IdltestGetArrayBufferFunction>();
    registry->RegisterFunction<AppWindowRestoreFunction>();
    registry->RegisterFunction<AppWindowMinimizeFunction>();
    registry->RegisterFunction<AppWindowCreateFunction>();
    registry->RegisterFunction<AppWindowFocusFunction>();
    registry->RegisterFunction<AppWindowMaximizeFunction>();
    registry->RegisterFunction<SocketRecvFromFunction>();
    registry->RegisterFunction<SocketDisconnectFunction>();
    registry->RegisterFunction<SocketReadFunction>();
    registry->RegisterFunction<SocketBindFunction>();
    registry->RegisterFunction<SocketCreateFunction>();
    registry->RegisterFunction<SocketWriteFunction>();
    registry->RegisterFunction<SocketSetNoDelayFunction>();
    registry->RegisterFunction<SocketConnectFunction>();
    registry->RegisterFunction<SocketSendToFunction>();
    registry->RegisterFunction<SocketDestroyFunction>();
    registry->RegisterFunction<SocketSetKeepAliveFunction>();
    registry->RegisterFunction<SerialReadFunction>();
    registry->RegisterFunction<SerialGetPortsFunction>();
    registry->RegisterFunction<SerialWriteFunction>();
    registry->RegisterFunction<SerialFlushFunction>();
    registry->RegisterFunction<SerialCloseFunction>();
    registry->RegisterFunction<SerialOpenFunction>();
    registry->RegisterFunction<DiscoveryClearAllSuggestionsFunction>();
    registry->RegisterFunction<DiscoverySuggestFunction>();
    registry->RegisterFunction<DiscoveryRemoveSuggestionFunction>();
    registry->RegisterFunction<FileSystemGetWritableFileEntryFunction>();
    registry->RegisterFunction<FileSystemGetDisplayPathFunction>();
    registry->RegisterFunction<FileSystemChooseFileFunction>();
    registry->RegisterFunction<AlarmsCreateFunction>();
    registry->RegisterFunction<AlarmsGetAllFunction>();
    registry->RegisterFunction<AlarmsClearAllFunction>();
    registry->RegisterFunction<AlarmsClearFunction>();
    registry->RegisterFunction<AlarmsGetFunction>();
    registry->RegisterFunction<BluetoothIsPoweredFunction>();
    registry->RegisterFunction<BluetoothDisconnectFunction>();
    registry->RegisterFunction<BluetoothReadFunction>();
    registry->RegisterFunction<BluetoothSetOutOfBandPairingDataFunction>();
    registry->RegisterFunction<BluetoothGetAddressFunction>();
    registry->RegisterFunction<BluetoothGetDevicesFunction>();
    registry->RegisterFunction<BluetoothWriteFunction>();
    registry->RegisterFunction<BluetoothGetLocalOutOfBandPairingDataFunction>();
    registry->RegisterFunction<BluetoothConnectFunction>();
    registry->RegisterFunction<BluetoothGetServicesFunction>();
    registry->RegisterFunction<BluetoothIsAvailableFunction>();
    registry->RegisterFunction<BluetoothStartDiscoveryFunction>();
    registry->RegisterFunction<BluetoothStopDiscoveryFunction>();
    registry->RegisterFunction<DnsResolveFunction>();
    registry->RegisterFunction<UsbIsochronousTransferFunction>();
    registry->RegisterFunction<UsbCloseDeviceFunction>();
    registry->RegisterFunction<UsbFindDeviceFunction>();
    registry->RegisterFunction<UsbBulkTransferFunction>();
    registry->RegisterFunction<UsbInterruptTransferFunction>();
    registry->RegisterFunction<UsbControlTransferFunction>();
  }
};

}  // api
}  // extensions


#endif  // CHROME_COMMON_EXTENSIONS_API_GENERATED_API_H__
