// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/permissions.json
// DO NOT EDIT.

#ifndef CHROME_COMMON_EXTENSIONS_API_PERMISSIONS_H__
#define CHROME_COMMON_EXTENSIONS_API_PERMISSIONS_H__
#pragma once

#include <string>
#include <vector>

#include "base/basictypes.h"
#include "base/memory/linked_ptr.h"
#include "base/memory/scoped_ptr.h"
#include "base/values.h"
#include "tools/json_schema_compiler/any.h"

namespace extensions {
namespace api {

namespace permissions {
struct Permissions;
}  // permissions

namespace permissions {

//
// Types
//

struct Permissions {
  ~Permissions();
  Permissions();



  // List of origin permissions.
  scoped_ptr<std::vector<std::string> > origins;

  // List of named permissions (does not include hosts or origins).
  scoped_ptr<std::vector<std::string> > permissions;

  // Populates a Permissions object from a Value. Returns whether |out| was
  // successfully populated.
  static bool Populate(const Value& value, Permissions* out);

  // Returns a new DictionaryValue representing the serialized form of this
  // Permissions object. Passes ownership to caller.
  scoped_ptr<DictionaryValue> ToValue() const;

 private:
  DISALLOW_COPY_AND_ASSIGN(Permissions);
};

//
// Functions
//

namespace Contains {
  struct Params {
    Permissions permissions;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

  namespace Result {
    // True if the extension has the specified permissions.
    Value* Create(const bool result);
  };

};

namespace GetAll {

  namespace Result {
    // The extension's active permissions.
    Value* Create(const Permissions& permissions);
  };

};

namespace Request {
  struct Params {
    Permissions permissions;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

  namespace Result {
    // True if the user granted the specified permissions.
    Value* Create(const bool granted);
  };

};

namespace Remove {
  struct Params {
    Permissions permissions;

    ~Params();

    static scoped_ptr<Params> Create(const ListValue& args);

   private:
    Params();

    DISALLOW_COPY_AND_ASSIGN(Params);
  };

  namespace Result {
    // True if the permissions were removed.
    Value* Create(const bool removed);
  };

};

}  // permissions
}  // api
}  // extensions

#endif  // CHROME_COMMON_EXTENSIONS_API_PERMISSIONS_H__
