// Copyright (c) 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// GENERATED FROM THE API DEFINITION IN
//   chrome/common/extensions/api/web_navigation.json
// DO NOT EDIT.

#include "tools/json_schema_compiler/util.h"
#include "chrome/common/extensions/api/web_navigation.h"

using base::Value;
using base::DictionaryValue;
using base::ListValue;
using base::BinaryValue;
using json_schema_compiler::any::Any;

namespace extensions {
namespace api {
namespace web_navigation {

//
// Functions
//

GetFrame::Params::Details::Details()
  : tab_id(0), frame_id(0) {}
GetFrame::Params::Details::~Details() {}

// static
bool GetFrame::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* tab_id_value = NULL;
  if (!dict->GetWithoutPathExpansion("tabId", &tab_id_value))
    return false;
  {
    if (!tab_id_value->GetAsInteger(&out->tab_id))
      return false;
  }

  Value* frame_id_value = NULL;
  if (!dict->GetWithoutPathExpansion("frameId", &frame_id_value))
    return false;
  {
    if (!frame_id_value->GetAsInteger(&out->frame_id))
      return false;
  }

  return true;
}


GetFrame::Params::Params() {}
GetFrame::Params::~Params() {}

// static
scoped_ptr<GetFrame::Params> GetFrame::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Details::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


GetFrame::Result::Details::Details()
  : error_occurred(false) {}
GetFrame::Result::Details::~Details() {}

scoped_ptr<DictionaryValue> GetFrame::Result::Details::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("url", Value::CreateStringValue(this->url));
  value->SetWithoutPathExpansion("errorOccurred", Value::CreateBooleanValue(this->error_occurred));

  return value.Pass();
}


Value* GetFrame::Result::Create(const Details& details) {
  return details.ToValue().release();
}

GetAllFrames::Params::Details::Details()
  : tab_id(0) {}
GetAllFrames::Params::Details::~Details() {}

// static
bool GetAllFrames::Params::Details::Populate(const Value& value, Details* out) {
  if (!value.IsType(Value::TYPE_DICTIONARY))
    return false;
  const DictionaryValue* dict = static_cast<const DictionaryValue*>(&value);

  Value* tab_id_value = NULL;
  if (!dict->GetWithoutPathExpansion("tabId", &tab_id_value))
    return false;
  {
    if (!tab_id_value->GetAsInteger(&out->tab_id))
      return false;
  }

  return true;
}


GetAllFrames::Params::Params() {}
GetAllFrames::Params::~Params() {}

// static
scoped_ptr<GetAllFrames::Params> GetAllFrames::Params::Create(const ListValue& args) {
  if (args.GetSize() != 1)
    return scoped_ptr<Params>();
  scoped_ptr<Params> params(new Params());

  Value* details_value = NULL;
  if (args.Get(0, &details_value) && !details_value->IsType(Value::TYPE_NULL))
  {
    {
      DictionaryValue* dictionary = NULL;
      if (!details_value->GetAsDictionary(&dictionary))
        return scoped_ptr<Params>();
      if (!Details::Populate(*dictionary, &params->details))
        return scoped_ptr<Params>();
    }
  }
  else {
    return scoped_ptr<Params>();
  }

  return params.Pass();
}


GetAllFrames::Result::DetailsElement::DetailsElement()
  : error_occurred(false), frame_id(0) {}
GetAllFrames::Result::DetailsElement::~DetailsElement() {}

scoped_ptr<DictionaryValue> GetAllFrames::Result::DetailsElement::ToValue() const {
  scoped_ptr<DictionaryValue> value(new DictionaryValue());

  value->SetWithoutPathExpansion("url", Value::CreateStringValue(this->url));
  value->SetWithoutPathExpansion("errorOccurred", Value::CreateBooleanValue(this->error_occurred));
  value->SetWithoutPathExpansion("frameId", Value::CreateIntegerValue(this->frame_id));

  return value.Pass();
}


Value* GetAllFrames::Result::Create(const std::vector<linked_ptr<DetailsElement> >& details) {
  return json_schema_compiler::util::CreateValueFromArray(details).release();
}

}  // web_navigation
}  // api
}  // extensions
