//
// DO NOT MODIFY THIS FILE DIRECTLY!
// IT IS GENERATED BY generate_policy_source.py
// FROM policy_templates.json
//


#include <limits>
#include <string>

#include "base/logging.h"
#include "base/values.h"
#include "chrome/browser/policy/policy_map.h"
#include "chrome/browser/policy/proto/cloud_policy.pb.h"
#include "policy/policy_constants.h"

using google::protobuf::RepeatedPtrField;

namespace policy {

namespace em = enterprise_management;

Value* DecodeIntegerValue(google::protobuf::int64 value) {
  if (value < std::numeric_limits<int>::min() ||
      value > std::numeric_limits<int>::max()) {
    LOG(WARNING) << "Integer value " << value
                 << " out of numeric limits, ignoring.";
    return NULL;
  }

  return Value::CreateIntegerValue(static_cast<int>(value));
}

ListValue* DecodeStringList(const em::StringList& string_list) {
  ListValue* list_value = new ListValue;
  RepeatedPtrField<std::string>::const_iterator entry;
  for (entry = string_list.entries().begin();
       entry != string_list.entries().end(); ++entry) {
    list_value->Append(Value::CreateStringValue(*entry));
  }
  return list_value;
}

void DecodePolicy(const em::CloudPolicySettings& policy, PolicyMap* map) {
  if (policy.has_homepagelocation()) {
    const em::HomepageLocationProto& homepagelocation_proto = policy.homepagelocation();
    if (homepagelocation_proto.has_homepagelocation()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (homepagelocation_proto.has_policy_options()) {
        do_set = false;
        switch(homepagelocation_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(homepagelocation_proto.homepagelocation());
        map->Set(key::kHomepageLocation, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_homepageisnewtabpage()) {
    const em::HomepageIsNewTabPageProto& homepageisnewtabpage_proto = policy.homepageisnewtabpage();
    if (homepageisnewtabpage_proto.has_homepageisnewtabpage()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (homepageisnewtabpage_proto.has_policy_options()) {
        do_set = false;
        switch(homepageisnewtabpage_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(homepageisnewtabpage_proto.homepageisnewtabpage());
        map->Set(key::kHomepageIsNewTabPage, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultbrowsersettingenabled()) {
    const em::DefaultBrowserSettingEnabledProto& defaultbrowsersettingenabled_proto = policy.defaultbrowsersettingenabled();
    if (defaultbrowsersettingenabled_proto.has_defaultbrowsersettingenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultbrowsersettingenabled_proto.has_policy_options()) {
        do_set = false;
        switch(defaultbrowsersettingenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(defaultbrowsersettingenabled_proto.defaultbrowsersettingenabled());
        map->Set(key::kDefaultBrowserSettingEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_applicationlocalevalue()) {
    const em::ApplicationLocaleValueProto& applicationlocalevalue_proto = policy.applicationlocalevalue();
    if (applicationlocalevalue_proto.has_applicationlocalevalue()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (applicationlocalevalue_proto.has_policy_options()) {
        do_set = false;
        switch(applicationlocalevalue_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(applicationlocalevalue_proto.applicationlocalevalue());
        map->Set(key::kApplicationLocaleValue, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_alternateerrorpagesenabled()) {
    const em::AlternateErrorPagesEnabledProto& alternateerrorpagesenabled_proto = policy.alternateerrorpagesenabled();
    if (alternateerrorpagesenabled_proto.has_alternateerrorpagesenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (alternateerrorpagesenabled_proto.has_policy_options()) {
        do_set = false;
        switch(alternateerrorpagesenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(alternateerrorpagesenabled_proto.alternateerrorpagesenabled());
        map->Set(key::kAlternateErrorPagesEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_searchsuggestenabled()) {
    const em::SearchSuggestEnabledProto& searchsuggestenabled_proto = policy.searchsuggestenabled();
    if (searchsuggestenabled_proto.has_searchsuggestenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (searchsuggestenabled_proto.has_policy_options()) {
        do_set = false;
        switch(searchsuggestenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(searchsuggestenabled_proto.searchsuggestenabled());
        map->Set(key::kSearchSuggestEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_dnsprefetchingenabled()) {
    const em::DnsPrefetchingEnabledProto& dnsprefetchingenabled_proto = policy.dnsprefetchingenabled();
    if (dnsprefetchingenabled_proto.has_dnsprefetchingenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (dnsprefetchingenabled_proto.has_policy_options()) {
        do_set = false;
        switch(dnsprefetchingenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(dnsprefetchingenabled_proto.dnsprefetchingenabled());
        map->Set(key::kDnsPrefetchingEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_disablespdy()) {
    const em::DisableSpdyProto& disablespdy_proto = policy.disablespdy();
    if (disablespdy_proto.has_disablespdy()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (disablespdy_proto.has_policy_options()) {
        do_set = false;
        switch(disablespdy_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(disablespdy_proto.disablespdy());
        map->Set(key::kDisableSpdy, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_disabledschemes()) {
    const em::DisabledSchemesProto& disabledschemes_proto = policy.disabledschemes();
    if (disabledschemes_proto.has_disabledschemes()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (disabledschemes_proto.has_policy_options()) {
        do_set = false;
        switch(disabledschemes_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(disabledschemes_proto.disabledschemes());
        map->Set(key::kDisabledSchemes, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_javascriptenabled()) {
    const em::JavascriptEnabledProto& javascriptenabled_proto = policy.javascriptenabled();
    if (javascriptenabled_proto.has_javascriptenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (javascriptenabled_proto.has_policy_options()) {
        do_set = false;
        switch(javascriptenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(javascriptenabled_proto.javascriptenabled());
        map->Set(key::kJavascriptEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_incognitoenabled()) {
    const em::IncognitoEnabledProto& incognitoenabled_proto = policy.incognitoenabled();
    if (incognitoenabled_proto.has_incognitoenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (incognitoenabled_proto.has_policy_options()) {
        do_set = false;
        switch(incognitoenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(incognitoenabled_proto.incognitoenabled());
        map->Set(key::kIncognitoEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_incognitomodeavailability()) {
    const em::IncognitoModeAvailabilityProto& incognitomodeavailability_proto = policy.incognitomodeavailability();
    if (incognitomodeavailability_proto.has_incognitomodeavailability()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (incognitomodeavailability_proto.has_policy_options()) {
        do_set = false;
        switch(incognitomodeavailability_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(incognitomodeavailability_proto.incognitomodeavailability());
        map->Set(key::kIncognitoModeAvailability, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_savingbrowserhistorydisabled()) {
    const em::SavingBrowserHistoryDisabledProto& savingbrowserhistorydisabled_proto = policy.savingbrowserhistorydisabled();
    if (savingbrowserhistorydisabled_proto.has_savingbrowserhistorydisabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (savingbrowserhistorydisabled_proto.has_policy_options()) {
        do_set = false;
        switch(savingbrowserhistorydisabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(savingbrowserhistorydisabled_proto.savingbrowserhistorydisabled());
        map->Set(key::kSavingBrowserHistoryDisabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_remoteaccessclientfirewalltraversal()) {
    const em::RemoteAccessClientFirewallTraversalProto& remoteaccessclientfirewalltraversal_proto = policy.remoteaccessclientfirewalltraversal();
    if (remoteaccessclientfirewalltraversal_proto.has_remoteaccessclientfirewalltraversal()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (remoteaccessclientfirewalltraversal_proto.has_policy_options()) {
        do_set = false;
        switch(remoteaccessclientfirewalltraversal_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(remoteaccessclientfirewalltraversal_proto.remoteaccessclientfirewalltraversal());
        map->Set(key::kRemoteAccessClientFirewallTraversal, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_remoteaccesshostfirewalltraversal()) {
    const em::RemoteAccessHostFirewallTraversalProto& remoteaccesshostfirewalltraversal_proto = policy.remoteaccesshostfirewalltraversal();
    if (remoteaccesshostfirewalltraversal_proto.has_remoteaccesshostfirewalltraversal()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (remoteaccesshostfirewalltraversal_proto.has_policy_options()) {
        do_set = false;
        switch(remoteaccesshostfirewalltraversal_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(remoteaccesshostfirewalltraversal_proto.remoteaccesshostfirewalltraversal());
        map->Set(key::kRemoteAccessHostFirewallTraversal, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_printingenabled()) {
    const em::PrintingEnabledProto& printingenabled_proto = policy.printingenabled();
    if (printingenabled_proto.has_printingenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (printingenabled_proto.has_policy_options()) {
        do_set = false;
        switch(printingenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(printingenabled_proto.printingenabled());
        map->Set(key::kPrintingEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_cloudprintproxyenabled()) {
    const em::CloudPrintProxyEnabledProto& cloudprintproxyenabled_proto = policy.cloudprintproxyenabled();
    if (cloudprintproxyenabled_proto.has_cloudprintproxyenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (cloudprintproxyenabled_proto.has_policy_options()) {
        do_set = false;
        switch(cloudprintproxyenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(cloudprintproxyenabled_proto.cloudprintproxyenabled());
        map->Set(key::kCloudPrintProxyEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_safebrowsingenabled()) {
    const em::SafeBrowsingEnabledProto& safebrowsingenabled_proto = policy.safebrowsingenabled();
    if (safebrowsingenabled_proto.has_safebrowsingenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (safebrowsingenabled_proto.has_policy_options()) {
        do_set = false;
        switch(safebrowsingenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(safebrowsingenabled_proto.safebrowsingenabled());
        map->Set(key::kSafeBrowsingEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_metricsreportingenabled()) {
    const em::MetricsReportingEnabledProto& metricsreportingenabled_proto = policy.metricsreportingenabled();
    if (metricsreportingenabled_proto.has_metricsreportingenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (metricsreportingenabled_proto.has_policy_options()) {
        do_set = false;
        switch(metricsreportingenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(metricsreportingenabled_proto.metricsreportingenabled());
        map->Set(key::kMetricsReportingEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_passwordmanagerenabled()) {
    const em::PasswordManagerEnabledProto& passwordmanagerenabled_proto = policy.passwordmanagerenabled();
    if (passwordmanagerenabled_proto.has_passwordmanagerenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (passwordmanagerenabled_proto.has_policy_options()) {
        do_set = false;
        switch(passwordmanagerenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(passwordmanagerenabled_proto.passwordmanagerenabled());
        map->Set(key::kPasswordManagerEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_passwordmanagerallowshowpasswords()) {
    const em::PasswordManagerAllowShowPasswordsProto& passwordmanagerallowshowpasswords_proto = policy.passwordmanagerallowshowpasswords();
    if (passwordmanagerallowshowpasswords_proto.has_passwordmanagerallowshowpasswords()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (passwordmanagerallowshowpasswords_proto.has_policy_options()) {
        do_set = false;
        switch(passwordmanagerallowshowpasswords_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(passwordmanagerallowshowpasswords_proto.passwordmanagerallowshowpasswords());
        map->Set(key::kPasswordManagerAllowShowPasswords, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_autofillenabled()) {
    const em::AutoFillEnabledProto& autofillenabled_proto = policy.autofillenabled();
    if (autofillenabled_proto.has_autofillenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (autofillenabled_proto.has_policy_options()) {
        do_set = false;
        switch(autofillenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(autofillenabled_proto.autofillenabled());
        map->Set(key::kAutoFillEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_disabledplugins()) {
    const em::DisabledPluginsProto& disabledplugins_proto = policy.disabledplugins();
    if (disabledplugins_proto.has_disabledplugins()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (disabledplugins_proto.has_policy_options()) {
        do_set = false;
        switch(disabledplugins_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(disabledplugins_proto.disabledplugins());
        map->Set(key::kDisabledPlugins, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_enabledplugins()) {
    const em::EnabledPluginsProto& enabledplugins_proto = policy.enabledplugins();
    if (enabledplugins_proto.has_enabledplugins()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (enabledplugins_proto.has_policy_options()) {
        do_set = false;
        switch(enabledplugins_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(enabledplugins_proto.enabledplugins());
        map->Set(key::kEnabledPlugins, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_disabledpluginsexceptions()) {
    const em::DisabledPluginsExceptionsProto& disabledpluginsexceptions_proto = policy.disabledpluginsexceptions();
    if (disabledpluginsexceptions_proto.has_disabledpluginsexceptions()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (disabledpluginsexceptions_proto.has_policy_options()) {
        do_set = false;
        switch(disabledpluginsexceptions_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(disabledpluginsexceptions_proto.disabledpluginsexceptions());
        map->Set(key::kDisabledPluginsExceptions, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_disablepluginfinder()) {
    const em::DisablePluginFinderProto& disablepluginfinder_proto = policy.disablepluginfinder();
    if (disablepluginfinder_proto.has_disablepluginfinder()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (disablepluginfinder_proto.has_policy_options()) {
        do_set = false;
        switch(disablepluginfinder_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(disablepluginfinder_proto.disablepluginfinder());
        map->Set(key::kDisablePluginFinder, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_syncdisabled()) {
    const em::SyncDisabledProto& syncdisabled_proto = policy.syncdisabled();
    if (syncdisabled_proto.has_syncdisabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (syncdisabled_proto.has_policy_options()) {
        do_set = false;
        switch(syncdisabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(syncdisabled_proto.syncdisabled());
        map->Set(key::kSyncDisabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_userdatadir()) {
    const em::UserDataDirProto& userdatadir_proto = policy.userdatadir();
    if (userdatadir_proto.has_userdatadir()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (userdatadir_proto.has_policy_options()) {
        do_set = false;
        switch(userdatadir_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(userdatadir_proto.userdatadir());
        map->Set(key::kUserDataDir, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_diskcachedir()) {
    const em::DiskCacheDirProto& diskcachedir_proto = policy.diskcachedir();
    if (diskcachedir_proto.has_diskcachedir()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (diskcachedir_proto.has_policy_options()) {
        do_set = false;
        switch(diskcachedir_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(diskcachedir_proto.diskcachedir());
        map->Set(key::kDiskCacheDir, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_diskcachesize()) {
    const em::DiskCacheSizeProto& diskcachesize_proto = policy.diskcachesize();
    if (diskcachesize_proto.has_diskcachesize()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (diskcachesize_proto.has_policy_options()) {
        do_set = false;
        switch(diskcachesize_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(diskcachesize_proto.diskcachesize());
        map->Set(key::kDiskCacheSize, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_mediacachesize()) {
    const em::MediaCacheSizeProto& mediacachesize_proto = policy.mediacachesize();
    if (mediacachesize_proto.has_mediacachesize()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (mediacachesize_proto.has_policy_options()) {
        do_set = false;
        switch(mediacachesize_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(mediacachesize_proto.mediacachesize());
        map->Set(key::kMediaCacheSize, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_downloaddirectory()) {
    const em::DownloadDirectoryProto& downloaddirectory_proto = policy.downloaddirectory();
    if (downloaddirectory_proto.has_downloaddirectory()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (downloaddirectory_proto.has_policy_options()) {
        do_set = false;
        switch(downloaddirectory_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(downloaddirectory_proto.downloaddirectory());
        map->Set(key::kDownloadDirectory, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_clearsitedataonexit()) {
    const em::ClearSiteDataOnExitProto& clearsitedataonexit_proto = policy.clearsitedataonexit();
    if (clearsitedataonexit_proto.has_clearsitedataonexit()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (clearsitedataonexit_proto.has_policy_options()) {
        do_set = false;
        switch(clearsitedataonexit_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(clearsitedataonexit_proto.clearsitedataonexit());
        map->Set(key::kClearSiteDataOnExit, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_proxymode()) {
    const em::ProxyModeProto& proxymode_proto = policy.proxymode();
    if (proxymode_proto.has_proxymode()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (proxymode_proto.has_policy_options()) {
        do_set = false;
        switch(proxymode_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(proxymode_proto.proxymode());
        map->Set(key::kProxyMode, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_proxyservermode()) {
    const em::ProxyServerModeProto& proxyservermode_proto = policy.proxyservermode();
    if (proxyservermode_proto.has_proxyservermode()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (proxyservermode_proto.has_policy_options()) {
        do_set = false;
        switch(proxyservermode_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(proxyservermode_proto.proxyservermode());
        map->Set(key::kProxyServerMode, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_proxyserver()) {
    const em::ProxyServerProto& proxyserver_proto = policy.proxyserver();
    if (proxyserver_proto.has_proxyserver()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (proxyserver_proto.has_policy_options()) {
        do_set = false;
        switch(proxyserver_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(proxyserver_proto.proxyserver());
        map->Set(key::kProxyServer, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_proxypacurl()) {
    const em::ProxyPacUrlProto& proxypacurl_proto = policy.proxypacurl();
    if (proxypacurl_proto.has_proxypacurl()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (proxypacurl_proto.has_policy_options()) {
        do_set = false;
        switch(proxypacurl_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(proxypacurl_proto.proxypacurl());
        map->Set(key::kProxyPacUrl, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_proxybypasslist()) {
    const em::ProxyBypassListProto& proxybypasslist_proto = policy.proxybypasslist();
    if (proxybypasslist_proto.has_proxybypasslist()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (proxybypasslist_proto.has_policy_options()) {
        do_set = false;
        switch(proxybypasslist_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(proxybypasslist_proto.proxybypasslist());
        map->Set(key::kProxyBypassList, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_proxysettings()) {
    const em::ProxySettingsProto& proxysettings_proto = policy.proxysettings();
    if (proxysettings_proto.has_proxysettings()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (proxysettings_proto.has_policy_options()) {
        do_set = false;
        switch(proxysettings_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = new DictionaryValue();
        map->Set(key::kProxySettings, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_authschemes()) {
    const em::AuthSchemesProto& authschemes_proto = policy.authschemes();
    if (authschemes_proto.has_authschemes()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (authschemes_proto.has_policy_options()) {
        do_set = false;
        switch(authschemes_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(authschemes_proto.authschemes());
        map->Set(key::kAuthSchemes, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_disableauthnegotiatecnamelookup()) {
    const em::DisableAuthNegotiateCnameLookupProto& disableauthnegotiatecnamelookup_proto = policy.disableauthnegotiatecnamelookup();
    if (disableauthnegotiatecnamelookup_proto.has_disableauthnegotiatecnamelookup()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (disableauthnegotiatecnamelookup_proto.has_policy_options()) {
        do_set = false;
        switch(disableauthnegotiatecnamelookup_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(disableauthnegotiatecnamelookup_proto.disableauthnegotiatecnamelookup());
        map->Set(key::kDisableAuthNegotiateCnameLookup, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_enableauthnegotiateport()) {
    const em::EnableAuthNegotiatePortProto& enableauthnegotiateport_proto = policy.enableauthnegotiateport();
    if (enableauthnegotiateport_proto.has_enableauthnegotiateport()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (enableauthnegotiateport_proto.has_policy_options()) {
        do_set = false;
        switch(enableauthnegotiateport_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(enableauthnegotiateport_proto.enableauthnegotiateport());
        map->Set(key::kEnableAuthNegotiatePort, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_authserverwhitelist()) {
    const em::AuthServerWhitelistProto& authserverwhitelist_proto = policy.authserverwhitelist();
    if (authserverwhitelist_proto.has_authserverwhitelist()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (authserverwhitelist_proto.has_policy_options()) {
        do_set = false;
        switch(authserverwhitelist_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(authserverwhitelist_proto.authserverwhitelist());
        map->Set(key::kAuthServerWhitelist, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_authnegotiatedelegatewhitelist()) {
    const em::AuthNegotiateDelegateWhitelistProto& authnegotiatedelegatewhitelist_proto = policy.authnegotiatedelegatewhitelist();
    if (authnegotiatedelegatewhitelist_proto.has_authnegotiatedelegatewhitelist()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (authnegotiatedelegatewhitelist_proto.has_policy_options()) {
        do_set = false;
        switch(authnegotiatedelegatewhitelist_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(authnegotiatedelegatewhitelist_proto.authnegotiatedelegatewhitelist());
        map->Set(key::kAuthNegotiateDelegateWhitelist, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_gssapilibraryname()) {
    const em::GSSAPILibraryNameProto& gssapilibraryname_proto = policy.gssapilibraryname();
    if (gssapilibraryname_proto.has_gssapilibraryname()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (gssapilibraryname_proto.has_policy_options()) {
        do_set = false;
        switch(gssapilibraryname_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(gssapilibraryname_proto.gssapilibraryname());
        map->Set(key::kGSSAPILibraryName, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_allowcrossoriginauthprompt()) {
    const em::AllowCrossOriginAuthPromptProto& allowcrossoriginauthprompt_proto = policy.allowcrossoriginauthprompt();
    if (allowcrossoriginauthprompt_proto.has_allowcrossoriginauthprompt()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (allowcrossoriginauthprompt_proto.has_policy_options()) {
        do_set = false;
        switch(allowcrossoriginauthprompt_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(allowcrossoriginauthprompt_proto.allowcrossoriginauthprompt());
        map->Set(key::kAllowCrossOriginAuthPrompt, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_extensioninstallblacklist()) {
    const em::ExtensionInstallBlacklistProto& extensioninstallblacklist_proto = policy.extensioninstallblacklist();
    if (extensioninstallblacklist_proto.has_extensioninstallblacklist()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (extensioninstallblacklist_proto.has_policy_options()) {
        do_set = false;
        switch(extensioninstallblacklist_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(extensioninstallblacklist_proto.extensioninstallblacklist());
        map->Set(key::kExtensionInstallBlacklist, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_extensioninstallwhitelist()) {
    const em::ExtensionInstallWhitelistProto& extensioninstallwhitelist_proto = policy.extensioninstallwhitelist();
    if (extensioninstallwhitelist_proto.has_extensioninstallwhitelist()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (extensioninstallwhitelist_proto.has_policy_options()) {
        do_set = false;
        switch(extensioninstallwhitelist_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(extensioninstallwhitelist_proto.extensioninstallwhitelist());
        map->Set(key::kExtensionInstallWhitelist, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_extensioninstallforcelist()) {
    const em::ExtensionInstallForcelistProto& extensioninstallforcelist_proto = policy.extensioninstallforcelist();
    if (extensioninstallforcelist_proto.has_extensioninstallforcelist()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (extensioninstallforcelist_proto.has_policy_options()) {
        do_set = false;
        switch(extensioninstallforcelist_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(extensioninstallforcelist_proto.extensioninstallforcelist());
        map->Set(key::kExtensionInstallForcelist, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_extensioninstallsources()) {
    const em::ExtensionInstallSourcesProto& extensioninstallsources_proto = policy.extensioninstallsources();
    if (extensioninstallsources_proto.has_extensioninstallsources()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (extensioninstallsources_proto.has_policy_options()) {
        do_set = false;
        switch(extensioninstallsources_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(extensioninstallsources_proto.extensioninstallsources());
        map->Set(key::kExtensionInstallSources, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_showhomebutton()) {
    const em::ShowHomeButtonProto& showhomebutton_proto = policy.showhomebutton();
    if (showhomebutton_proto.has_showhomebutton()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (showhomebutton_proto.has_policy_options()) {
        do_set = false;
        switch(showhomebutton_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(showhomebutton_proto.showhomebutton());
        map->Set(key::kShowHomeButton, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_developertoolsdisabled()) {
    const em::DeveloperToolsDisabledProto& developertoolsdisabled_proto = policy.developertoolsdisabled();
    if (developertoolsdisabled_proto.has_developertoolsdisabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (developertoolsdisabled_proto.has_policy_options()) {
        do_set = false;
        switch(developertoolsdisabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(developertoolsdisabled_proto.developertoolsdisabled());
        map->Set(key::kDeveloperToolsDisabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_restoreonstartup()) {
    const em::RestoreOnStartupProto& restoreonstartup_proto = policy.restoreonstartup();
    if (restoreonstartup_proto.has_restoreonstartup()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (restoreonstartup_proto.has_policy_options()) {
        do_set = false;
        switch(restoreonstartup_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(restoreonstartup_proto.restoreonstartup());
        map->Set(key::kRestoreOnStartup, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_restoreonstartupurls()) {
    const em::RestoreOnStartupURLsProto& restoreonstartupurls_proto = policy.restoreonstartupurls();
    if (restoreonstartupurls_proto.has_restoreonstartupurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (restoreonstartupurls_proto.has_policy_options()) {
        do_set = false;
        switch(restoreonstartupurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(restoreonstartupurls_proto.restoreonstartupurls());
        map->Set(key::kRestoreOnStartupURLs, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_blockthirdpartycookies()) {
    const em::BlockThirdPartyCookiesProto& blockthirdpartycookies_proto = policy.blockthirdpartycookies();
    if (blockthirdpartycookies_proto.has_blockthirdpartycookies()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (blockthirdpartycookies_proto.has_policy_options()) {
        do_set = false;
        switch(blockthirdpartycookies_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(blockthirdpartycookies_proto.blockthirdpartycookies());
        map->Set(key::kBlockThirdPartyCookies, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultsearchproviderenabled()) {
    const em::DefaultSearchProviderEnabledProto& defaultsearchproviderenabled_proto = policy.defaultsearchproviderenabled();
    if (defaultsearchproviderenabled_proto.has_defaultsearchproviderenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultsearchproviderenabled_proto.has_policy_options()) {
        do_set = false;
        switch(defaultsearchproviderenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(defaultsearchproviderenabled_proto.defaultsearchproviderenabled());
        map->Set(key::kDefaultSearchProviderEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultsearchprovidername()) {
    const em::DefaultSearchProviderNameProto& defaultsearchprovidername_proto = policy.defaultsearchprovidername();
    if (defaultsearchprovidername_proto.has_defaultsearchprovidername()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultsearchprovidername_proto.has_policy_options()) {
        do_set = false;
        switch(defaultsearchprovidername_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(defaultsearchprovidername_proto.defaultsearchprovidername());
        map->Set(key::kDefaultSearchProviderName, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultsearchproviderkeyword()) {
    const em::DefaultSearchProviderKeywordProto& defaultsearchproviderkeyword_proto = policy.defaultsearchproviderkeyword();
    if (defaultsearchproviderkeyword_proto.has_defaultsearchproviderkeyword()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultsearchproviderkeyword_proto.has_policy_options()) {
        do_set = false;
        switch(defaultsearchproviderkeyword_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(defaultsearchproviderkeyword_proto.defaultsearchproviderkeyword());
        map->Set(key::kDefaultSearchProviderKeyword, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultsearchprovidersearchurl()) {
    const em::DefaultSearchProviderSearchURLProto& defaultsearchprovidersearchurl_proto = policy.defaultsearchprovidersearchurl();
    if (defaultsearchprovidersearchurl_proto.has_defaultsearchprovidersearchurl()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultsearchprovidersearchurl_proto.has_policy_options()) {
        do_set = false;
        switch(defaultsearchprovidersearchurl_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(defaultsearchprovidersearchurl_proto.defaultsearchprovidersearchurl());
        map->Set(key::kDefaultSearchProviderSearchURL, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultsearchprovidersuggesturl()) {
    const em::DefaultSearchProviderSuggestURLProto& defaultsearchprovidersuggesturl_proto = policy.defaultsearchprovidersuggesturl();
    if (defaultsearchprovidersuggesturl_proto.has_defaultsearchprovidersuggesturl()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultsearchprovidersuggesturl_proto.has_policy_options()) {
        do_set = false;
        switch(defaultsearchprovidersuggesturl_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(defaultsearchprovidersuggesturl_proto.defaultsearchprovidersuggesturl());
        map->Set(key::kDefaultSearchProviderSuggestURL, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultsearchproviderinstanturl()) {
    const em::DefaultSearchProviderInstantURLProto& defaultsearchproviderinstanturl_proto = policy.defaultsearchproviderinstanturl();
    if (defaultsearchproviderinstanturl_proto.has_defaultsearchproviderinstanturl()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultsearchproviderinstanturl_proto.has_policy_options()) {
        do_set = false;
        switch(defaultsearchproviderinstanturl_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(defaultsearchproviderinstanturl_proto.defaultsearchproviderinstanturl());
        map->Set(key::kDefaultSearchProviderInstantURL, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultsearchprovidericonurl()) {
    const em::DefaultSearchProviderIconURLProto& defaultsearchprovidericonurl_proto = policy.defaultsearchprovidericonurl();
    if (defaultsearchprovidericonurl_proto.has_defaultsearchprovidericonurl()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultsearchprovidericonurl_proto.has_policy_options()) {
        do_set = false;
        switch(defaultsearchprovidericonurl_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(defaultsearchprovidericonurl_proto.defaultsearchprovidericonurl());
        map->Set(key::kDefaultSearchProviderIconURL, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultsearchproviderencodings()) {
    const em::DefaultSearchProviderEncodingsProto& defaultsearchproviderencodings_proto = policy.defaultsearchproviderencodings();
    if (defaultsearchproviderencodings_proto.has_defaultsearchproviderencodings()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultsearchproviderencodings_proto.has_policy_options()) {
        do_set = false;
        switch(defaultsearchproviderencodings_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(defaultsearchproviderencodings_proto.defaultsearchproviderencodings());
        map->Set(key::kDefaultSearchProviderEncodings, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultcookiessetting()) {
    const em::DefaultCookiesSettingProto& defaultcookiessetting_proto = policy.defaultcookiessetting();
    if (defaultcookiessetting_proto.has_defaultcookiessetting()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultcookiessetting_proto.has_policy_options()) {
        do_set = false;
        switch(defaultcookiessetting_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(defaultcookiessetting_proto.defaultcookiessetting());
        map->Set(key::kDefaultCookiesSetting, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultimagessetting()) {
    const em::DefaultImagesSettingProto& defaultimagessetting_proto = policy.defaultimagessetting();
    if (defaultimagessetting_proto.has_defaultimagessetting()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultimagessetting_proto.has_policy_options()) {
        do_set = false;
        switch(defaultimagessetting_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(defaultimagessetting_proto.defaultimagessetting());
        map->Set(key::kDefaultImagesSetting, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultjavascriptsetting()) {
    const em::DefaultJavaScriptSettingProto& defaultjavascriptsetting_proto = policy.defaultjavascriptsetting();
    if (defaultjavascriptsetting_proto.has_defaultjavascriptsetting()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultjavascriptsetting_proto.has_policy_options()) {
        do_set = false;
        switch(defaultjavascriptsetting_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(defaultjavascriptsetting_proto.defaultjavascriptsetting());
        map->Set(key::kDefaultJavaScriptSetting, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultpluginssetting()) {
    const em::DefaultPluginsSettingProto& defaultpluginssetting_proto = policy.defaultpluginssetting();
    if (defaultpluginssetting_proto.has_defaultpluginssetting()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultpluginssetting_proto.has_policy_options()) {
        do_set = false;
        switch(defaultpluginssetting_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(defaultpluginssetting_proto.defaultpluginssetting());
        map->Set(key::kDefaultPluginsSetting, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultpopupssetting()) {
    const em::DefaultPopupsSettingProto& defaultpopupssetting_proto = policy.defaultpopupssetting();
    if (defaultpopupssetting_proto.has_defaultpopupssetting()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultpopupssetting_proto.has_policy_options()) {
        do_set = false;
        switch(defaultpopupssetting_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(defaultpopupssetting_proto.defaultpopupssetting());
        map->Set(key::kDefaultPopupsSetting, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultnotificationssetting()) {
    const em::DefaultNotificationsSettingProto& defaultnotificationssetting_proto = policy.defaultnotificationssetting();
    if (defaultnotificationssetting_proto.has_defaultnotificationssetting()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultnotificationssetting_proto.has_policy_options()) {
        do_set = false;
        switch(defaultnotificationssetting_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(defaultnotificationssetting_proto.defaultnotificationssetting());
        map->Set(key::kDefaultNotificationsSetting, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultgeolocationsetting()) {
    const em::DefaultGeolocationSettingProto& defaultgeolocationsetting_proto = policy.defaultgeolocationsetting();
    if (defaultgeolocationsetting_proto.has_defaultgeolocationsetting()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultgeolocationsetting_proto.has_policy_options()) {
        do_set = false;
        switch(defaultgeolocationsetting_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(defaultgeolocationsetting_proto.defaultgeolocationsetting());
        map->Set(key::kDefaultGeolocationSetting, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_defaultmediastreamsetting()) {
    const em::DefaultMediaStreamSettingProto& defaultmediastreamsetting_proto = policy.defaultmediastreamsetting();
    if (defaultmediastreamsetting_proto.has_defaultmediastreamsetting()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (defaultmediastreamsetting_proto.has_policy_options()) {
        do_set = false;
        switch(defaultmediastreamsetting_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(defaultmediastreamsetting_proto.defaultmediastreamsetting());
        map->Set(key::kDefaultMediaStreamSetting, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_autoselectcertificateforurls()) {
    const em::AutoSelectCertificateForUrlsProto& autoselectcertificateforurls_proto = policy.autoselectcertificateforurls();
    if (autoselectcertificateforurls_proto.has_autoselectcertificateforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (autoselectcertificateforurls_proto.has_policy_options()) {
        do_set = false;
        switch(autoselectcertificateforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(autoselectcertificateforurls_proto.autoselectcertificateforurls());
        map->Set(key::kAutoSelectCertificateForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_cookiesallowedforurls()) {
    const em::CookiesAllowedForUrlsProto& cookiesallowedforurls_proto = policy.cookiesallowedforurls();
    if (cookiesallowedforurls_proto.has_cookiesallowedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (cookiesallowedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(cookiesallowedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(cookiesallowedforurls_proto.cookiesallowedforurls());
        map->Set(key::kCookiesAllowedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_cookiesblockedforurls()) {
    const em::CookiesBlockedForUrlsProto& cookiesblockedforurls_proto = policy.cookiesblockedforurls();
    if (cookiesblockedforurls_proto.has_cookiesblockedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (cookiesblockedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(cookiesblockedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(cookiesblockedforurls_proto.cookiesblockedforurls());
        map->Set(key::kCookiesBlockedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_cookiessessiononlyforurls()) {
    const em::CookiesSessionOnlyForUrlsProto& cookiessessiononlyforurls_proto = policy.cookiessessiononlyforurls();
    if (cookiessessiononlyforurls_proto.has_cookiessessiononlyforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (cookiessessiononlyforurls_proto.has_policy_options()) {
        do_set = false;
        switch(cookiessessiononlyforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(cookiessessiononlyforurls_proto.cookiessessiononlyforurls());
        map->Set(key::kCookiesSessionOnlyForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_imagesallowedforurls()) {
    const em::ImagesAllowedForUrlsProto& imagesallowedforurls_proto = policy.imagesallowedforurls();
    if (imagesallowedforurls_proto.has_imagesallowedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (imagesallowedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(imagesallowedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(imagesallowedforurls_proto.imagesallowedforurls());
        map->Set(key::kImagesAllowedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_imagesblockedforurls()) {
    const em::ImagesBlockedForUrlsProto& imagesblockedforurls_proto = policy.imagesblockedforurls();
    if (imagesblockedforurls_proto.has_imagesblockedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (imagesblockedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(imagesblockedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(imagesblockedforurls_proto.imagesblockedforurls());
        map->Set(key::kImagesBlockedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_javascriptallowedforurls()) {
    const em::JavaScriptAllowedForUrlsProto& javascriptallowedforurls_proto = policy.javascriptallowedforurls();
    if (javascriptallowedforurls_proto.has_javascriptallowedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (javascriptallowedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(javascriptallowedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(javascriptallowedforurls_proto.javascriptallowedforurls());
        map->Set(key::kJavaScriptAllowedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_javascriptblockedforurls()) {
    const em::JavaScriptBlockedForUrlsProto& javascriptblockedforurls_proto = policy.javascriptblockedforurls();
    if (javascriptblockedforurls_proto.has_javascriptblockedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (javascriptblockedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(javascriptblockedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(javascriptblockedforurls_proto.javascriptblockedforurls());
        map->Set(key::kJavaScriptBlockedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_pluginsallowedforurls()) {
    const em::PluginsAllowedForUrlsProto& pluginsallowedforurls_proto = policy.pluginsallowedforurls();
    if (pluginsallowedforurls_proto.has_pluginsallowedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (pluginsallowedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(pluginsallowedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(pluginsallowedforurls_proto.pluginsallowedforurls());
        map->Set(key::kPluginsAllowedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_pluginsblockedforurls()) {
    const em::PluginsBlockedForUrlsProto& pluginsblockedforurls_proto = policy.pluginsblockedforurls();
    if (pluginsblockedforurls_proto.has_pluginsblockedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (pluginsblockedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(pluginsblockedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(pluginsblockedforurls_proto.pluginsblockedforurls());
        map->Set(key::kPluginsBlockedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_popupsallowedforurls()) {
    const em::PopupsAllowedForUrlsProto& popupsallowedforurls_proto = policy.popupsallowedforurls();
    if (popupsallowedforurls_proto.has_popupsallowedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (popupsallowedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(popupsallowedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(popupsallowedforurls_proto.popupsallowedforurls());
        map->Set(key::kPopupsAllowedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_popupsblockedforurls()) {
    const em::PopupsBlockedForUrlsProto& popupsblockedforurls_proto = policy.popupsblockedforurls();
    if (popupsblockedforurls_proto.has_popupsblockedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (popupsblockedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(popupsblockedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(popupsblockedforurls_proto.popupsblockedforurls());
        map->Set(key::kPopupsBlockedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_notificationsallowedforurls()) {
    const em::NotificationsAllowedForUrlsProto& notificationsallowedforurls_proto = policy.notificationsallowedforurls();
    if (notificationsallowedforurls_proto.has_notificationsallowedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (notificationsallowedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(notificationsallowedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(notificationsallowedforurls_proto.notificationsallowedforurls());
        map->Set(key::kNotificationsAllowedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_notificationsblockedforurls()) {
    const em::NotificationsBlockedForUrlsProto& notificationsblockedforurls_proto = policy.notificationsblockedforurls();
    if (notificationsblockedforurls_proto.has_notificationsblockedforurls()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (notificationsblockedforurls_proto.has_policy_options()) {
        do_set = false;
        switch(notificationsblockedforurls_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(notificationsblockedforurls_proto.notificationsblockedforurls());
        map->Set(key::kNotificationsBlockedForUrls, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_disable3dapis()) {
    const em::Disable3DAPIsProto& disable3dapis_proto = policy.disable3dapis();
    if (disable3dapis_proto.has_disable3dapis()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (disable3dapis_proto.has_policy_options()) {
        do_set = false;
        switch(disable3dapis_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(disable3dapis_proto.disable3dapis());
        map->Set(key::kDisable3DAPIs, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_policyrefreshrate()) {
    const em::PolicyRefreshRateProto& policyrefreshrate_proto = policy.policyrefreshrate();
    if (policyrefreshrate_proto.has_policyrefreshrate()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (policyrefreshrate_proto.has_policy_options()) {
        do_set = false;
        switch(policyrefreshrate_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(policyrefreshrate_proto.policyrefreshrate());
        map->Set(key::kPolicyRefreshRate, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_chromeframerenderersettings()) {
    const em::ChromeFrameRendererSettingsProto& chromeframerenderersettings_proto = policy.chromeframerenderersettings();
    if (chromeframerenderersettings_proto.has_chromeframerenderersettings()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (chromeframerenderersettings_proto.has_policy_options()) {
        do_set = false;
        switch(chromeframerenderersettings_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(chromeframerenderersettings_proto.chromeframerenderersettings());
        map->Set(key::kChromeFrameRendererSettings, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_renderinchromeframelist()) {
    const em::RenderInChromeFrameListProto& renderinchromeframelist_proto = policy.renderinchromeframelist();
    if (renderinchromeframelist_proto.has_renderinchromeframelist()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (renderinchromeframelist_proto.has_policy_options()) {
        do_set = false;
        switch(renderinchromeframelist_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(renderinchromeframelist_proto.renderinchromeframelist());
        map->Set(key::kRenderInChromeFrameList, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_renderinhostlist()) {
    const em::RenderInHostListProto& renderinhostlist_proto = policy.renderinhostlist();
    if (renderinhostlist_proto.has_renderinhostlist()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (renderinhostlist_proto.has_policy_options()) {
        do_set = false;
        switch(renderinhostlist_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(renderinhostlist_proto.renderinhostlist());
        map->Set(key::kRenderInHostList, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_additionallaunchparameters()) {
    const em::AdditionalLaunchParametersProto& additionallaunchparameters_proto = policy.additionallaunchparameters();
    if (additionallaunchparameters_proto.has_additionallaunchparameters()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (additionallaunchparameters_proto.has_policy_options()) {
        do_set = false;
        switch(additionallaunchparameters_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(additionallaunchparameters_proto.additionallaunchparameters());
        map->Set(key::kAdditionalLaunchParameters, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_chromeframecontenttypes()) {
    const em::ChromeFrameContentTypesProto& chromeframecontenttypes_proto = policy.chromeframecontenttypes();
    if (chromeframecontenttypes_proto.has_chromeframecontenttypes()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (chromeframecontenttypes_proto.has_policy_options()) {
        do_set = false;
        switch(chromeframecontenttypes_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(chromeframecontenttypes_proto.chromeframecontenttypes());
        map->Set(key::kChromeFrameContentTypes, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_chromeoslockonidlesuspend()) {
    const em::ChromeOsLockOnIdleSuspendProto& chromeoslockonidlesuspend_proto = policy.chromeoslockonidlesuspend();
    if (chromeoslockonidlesuspend_proto.has_chromeoslockonidlesuspend()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (chromeoslockonidlesuspend_proto.has_policy_options()) {
        do_set = false;
        switch(chromeoslockonidlesuspend_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(chromeoslockonidlesuspend_proto.chromeoslockonidlesuspend());
        map->Set(key::kChromeOsLockOnIdleSuspend, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_instantenabled()) {
    const em::InstantEnabledProto& instantenabled_proto = policy.instantenabled();
    if (instantenabled_proto.has_instantenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (instantenabled_proto.has_policy_options()) {
        do_set = false;
        switch(instantenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(instantenabled_proto.instantenabled());
        map->Set(key::kInstantEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_translateenabled()) {
    const em::TranslateEnabledProto& translateenabled_proto = policy.translateenabled();
    if (translateenabled_proto.has_translateenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (translateenabled_proto.has_policy_options()) {
        do_set = false;
        switch(translateenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(translateenabled_proto.translateenabled());
        map->Set(key::kTranslateEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_allowoutdatedplugins()) {
    const em::AllowOutdatedPluginsProto& allowoutdatedplugins_proto = policy.allowoutdatedplugins();
    if (allowoutdatedplugins_proto.has_allowoutdatedplugins()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (allowoutdatedplugins_proto.has_policy_options()) {
        do_set = false;
        switch(allowoutdatedplugins_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(allowoutdatedplugins_proto.allowoutdatedplugins());
        map->Set(key::kAllowOutdatedPlugins, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_alwaysauthorizeplugins()) {
    const em::AlwaysAuthorizePluginsProto& alwaysauthorizeplugins_proto = policy.alwaysauthorizeplugins();
    if (alwaysauthorizeplugins_proto.has_alwaysauthorizeplugins()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (alwaysauthorizeplugins_proto.has_policy_options()) {
        do_set = false;
        switch(alwaysauthorizeplugins_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(alwaysauthorizeplugins_proto.alwaysauthorizeplugins());
        map->Set(key::kAlwaysAuthorizePlugins, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_bookmarkbarenabled()) {
    const em::BookmarkBarEnabledProto& bookmarkbarenabled_proto = policy.bookmarkbarenabled();
    if (bookmarkbarenabled_proto.has_bookmarkbarenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (bookmarkbarenabled_proto.has_policy_options()) {
        do_set = false;
        switch(bookmarkbarenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(bookmarkbarenabled_proto.bookmarkbarenabled());
        map->Set(key::kBookmarkBarEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_editbookmarksenabled()) {
    const em::EditBookmarksEnabledProto& editbookmarksenabled_proto = policy.editbookmarksenabled();
    if (editbookmarksenabled_proto.has_editbookmarksenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (editbookmarksenabled_proto.has_policy_options()) {
        do_set = false;
        switch(editbookmarksenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(editbookmarksenabled_proto.editbookmarksenabled());
        map->Set(key::kEditBookmarksEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_allowfileselectiondialogs()) {
    const em::AllowFileSelectionDialogsProto& allowfileselectiondialogs_proto = policy.allowfileselectiondialogs();
    if (allowfileselectiondialogs_proto.has_allowfileselectiondialogs()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (allowfileselectiondialogs_proto.has_policy_options()) {
        do_set = false;
        switch(allowfileselectiondialogs_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(allowfileselectiondialogs_proto.allowfileselectiondialogs());
        map->Set(key::kAllowFileSelectionDialogs, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_gcfuserdatadir()) {
    const em::GCFUserDataDirProto& gcfuserdatadir_proto = policy.gcfuserdatadir();
    if (gcfuserdatadir_proto.has_gcfuserdatadir()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (gcfuserdatadir_proto.has_policy_options()) {
        do_set = false;
        switch(gcfuserdatadir_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(gcfuserdatadir_proto.gcfuserdatadir());
        map->Set(key::kGCFUserDataDir, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_importbookmarks()) {
    const em::ImportBookmarksProto& importbookmarks_proto = policy.importbookmarks();
    if (importbookmarks_proto.has_importbookmarks()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (importbookmarks_proto.has_policy_options()) {
        do_set = false;
        switch(importbookmarks_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(importbookmarks_proto.importbookmarks());
        map->Set(key::kImportBookmarks, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_importhistory()) {
    const em::ImportHistoryProto& importhistory_proto = policy.importhistory();
    if (importhistory_proto.has_importhistory()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (importhistory_proto.has_policy_options()) {
        do_set = false;
        switch(importhistory_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(importhistory_proto.importhistory());
        map->Set(key::kImportHistory, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_importhomepage()) {
    const em::ImportHomepageProto& importhomepage_proto = policy.importhomepage();
    if (importhomepage_proto.has_importhomepage()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (importhomepage_proto.has_policy_options()) {
        do_set = false;
        switch(importhomepage_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(importhomepage_proto.importhomepage());
        map->Set(key::kImportHomepage, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_importsearchengine()) {
    const em::ImportSearchEngineProto& importsearchengine_proto = policy.importsearchengine();
    if (importsearchengine_proto.has_importsearchengine()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (importsearchengine_proto.has_policy_options()) {
        do_set = false;
        switch(importsearchengine_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(importsearchengine_proto.importsearchengine());
        map->Set(key::kImportSearchEngine, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_importsavedpasswords()) {
    const em::ImportSavedPasswordsProto& importsavedpasswords_proto = policy.importsavedpasswords();
    if (importsavedpasswords_proto.has_importsavedpasswords()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (importsavedpasswords_proto.has_policy_options()) {
        do_set = false;
        switch(importsavedpasswords_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(importsavedpasswords_proto.importsavedpasswords());
        map->Set(key::kImportSavedPasswords, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_maxconnectionsperproxy()) {
    const em::MaxConnectionsPerProxyProto& maxconnectionsperproxy_proto = policy.maxconnectionsperproxy();
    if (maxconnectionsperproxy_proto.has_maxconnectionsperproxy()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (maxconnectionsperproxy_proto.has_policy_options()) {
        do_set = false;
        switch(maxconnectionsperproxy_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeIntegerValue(maxconnectionsperproxy_proto.maxconnectionsperproxy());
        map->Set(key::kMaxConnectionsPerProxy, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_hidewebstorepromo()) {
    const em::HideWebStorePromoProto& hidewebstorepromo_proto = policy.hidewebstorepromo();
    if (hidewebstorepromo_proto.has_hidewebstorepromo()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (hidewebstorepromo_proto.has_policy_options()) {
        do_set = false;
        switch(hidewebstorepromo_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(hidewebstorepromo_proto.hidewebstorepromo());
        map->Set(key::kHideWebStorePromo, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_urlblacklist()) {
    const em::URLBlacklistProto& urlblacklist_proto = policy.urlblacklist();
    if (urlblacklist_proto.has_urlblacklist()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (urlblacklist_proto.has_policy_options()) {
        do_set = false;
        switch(urlblacklist_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(urlblacklist_proto.urlblacklist());
        map->Set(key::kURLBlacklist, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_urlwhitelist()) {
    const em::URLWhitelistProto& urlwhitelist_proto = policy.urlwhitelist();
    if (urlwhitelist_proto.has_urlwhitelist()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (urlwhitelist_proto.has_policy_options()) {
        do_set = false;
        switch(urlwhitelist_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(urlwhitelist_proto.urlwhitelist());
        map->Set(key::kURLWhitelist, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_opennetworkconfiguration()) {
    const em::OpenNetworkConfigurationProto& opennetworkconfiguration_proto = policy.opennetworkconfiguration();
    if (opennetworkconfiguration_proto.has_opennetworkconfiguration()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (opennetworkconfiguration_proto.has_policy_options()) {
        do_set = false;
        switch(opennetworkconfiguration_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(opennetworkconfiguration_proto.opennetworkconfiguration());
        map->Set(key::kOpenNetworkConfiguration, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_cloudprintsubmitenabled()) {
    const em::CloudPrintSubmitEnabledProto& cloudprintsubmitenabled_proto = policy.cloudprintsubmitenabled();
    if (cloudprintsubmitenabled_proto.has_cloudprintsubmitenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (cloudprintsubmitenabled_proto.has_policy_options()) {
        do_set = false;
        switch(cloudprintsubmitenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(cloudprintsubmitenabled_proto.cloudprintsubmitenabled());
        map->Set(key::kCloudPrintSubmitEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_enterprisewebstoreurl()) {
    const em::EnterpriseWebStoreURLProto& enterprisewebstoreurl_proto = policy.enterprisewebstoreurl();
    if (enterprisewebstoreurl_proto.has_enterprisewebstoreurl()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (enterprisewebstoreurl_proto.has_policy_options()) {
        do_set = false;
        switch(enterprisewebstoreurl_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(enterprisewebstoreurl_proto.enterprisewebstoreurl());
        map->Set(key::kEnterpriseWebStoreURL, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_enterprisewebstorename()) {
    const em::EnterpriseWebStoreNameProto& enterprisewebstorename_proto = policy.enterprisewebstorename();
    if (enterprisewebstorename_proto.has_enterprisewebstorename()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (enterprisewebstorename_proto.has_policy_options()) {
        do_set = false;
        switch(enterprisewebstorename_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(enterprisewebstorename_proto.enterprisewebstorename());
        map->Set(key::kEnterpriseWebStoreName, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_enableoriginboundcerts()) {
    const em::EnableOriginBoundCertsProto& enableoriginboundcerts_proto = policy.enableoriginboundcerts();
    if (enableoriginboundcerts_proto.has_enableoriginboundcerts()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (enableoriginboundcerts_proto.has_policy_options()) {
        do_set = false;
        switch(enableoriginboundcerts_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(enableoriginboundcerts_proto.enableoriginboundcerts());
        map->Set(key::kEnableOriginBoundCerts, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_enablememoryinfo()) {
    const em::EnableMemoryInfoProto& enablememoryinfo_proto = policy.enablememoryinfo();
    if (enablememoryinfo_proto.has_enablememoryinfo()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (enablememoryinfo_proto.has_policy_options()) {
        do_set = false;
        switch(enablememoryinfo_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(enablememoryinfo_proto.enablememoryinfo());
        map->Set(key::kEnableMemoryInfo, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_disableprintpreview()) {
    const em::DisablePrintPreviewProto& disableprintpreview_proto = policy.disableprintpreview();
    if (disableprintpreview_proto.has_disableprintpreview()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (disableprintpreview_proto.has_policy_options()) {
        do_set = false;
        switch(disableprintpreview_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(disableprintpreview_proto.disableprintpreview());
        map->Set(key::kDisablePrintPreview, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_disablesslrecordsplitting()) {
    const em::DisableSSLRecordSplittingProto& disablesslrecordsplitting_proto = policy.disablesslrecordsplitting();
    if (disablesslrecordsplitting_proto.has_disablesslrecordsplitting()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (disablesslrecordsplitting_proto.has_policy_options()) {
        do_set = false;
        switch(disablesslrecordsplitting_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(disablesslrecordsplitting_proto.disablesslrecordsplitting());
        map->Set(key::kDisableSSLRecordSplitting, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_enableonlinerevocationchecks()) {
    const em::EnableOnlineRevocationChecksProto& enableonlinerevocationchecks_proto = policy.enableonlinerevocationchecks();
    if (enableonlinerevocationchecks_proto.has_enableonlinerevocationchecks()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (enableonlinerevocationchecks_proto.has_policy_options()) {
        do_set = false;
        switch(enableonlinerevocationchecks_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(enableonlinerevocationchecks_proto.enableonlinerevocationchecks());
        map->Set(key::kEnableOnlineRevocationChecks, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_backgroundmodeenabled()) {
    const em::BackgroundModeEnabledProto& backgroundmodeenabled_proto = policy.backgroundmodeenabled();
    if (backgroundmodeenabled_proto.has_backgroundmodeenabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (backgroundmodeenabled_proto.has_policy_options()) {
        do_set = false;
        switch(backgroundmodeenabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(backgroundmodeenabled_proto.backgroundmodeenabled());
        map->Set(key::kBackgroundModeEnabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_gdatadisabled()) {
    const em::GDataDisabledProto& gdatadisabled_proto = policy.gdatadisabled();
    if (gdatadisabled_proto.has_gdatadisabled()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (gdatadisabled_proto.has_policy_options()) {
        do_set = false;
        switch(gdatadisabled_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(gdatadisabled_proto.gdatadisabled());
        map->Set(key::kGDataDisabled, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_gdatadisabledovercellular()) {
    const em::GDataDisabledOverCellularProto& gdatadisabledovercellular_proto = policy.gdatadisabledovercellular();
    if (gdatadisabledovercellular_proto.has_gdatadisabledovercellular()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (gdatadisabledovercellular_proto.has_policy_options()) {
        do_set = false;
        switch(gdatadisabledovercellular_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateBooleanValue(gdatadisabledovercellular_proto.gdatadisabledovercellular());
        map->Set(key::kGDataDisabledOverCellular, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_pinnedlauncherapps()) {
    const em::PinnedLauncherAppsProto& pinnedlauncherapps_proto = policy.pinnedlauncherapps();
    if (pinnedlauncherapps_proto.has_pinnedlauncherapps()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (pinnedlauncherapps_proto.has_policy_options()) {
        do_set = false;
        switch(pinnedlauncherapps_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = DecodeStringList(pinnedlauncherapps_proto.pinnedlauncherapps());
        map->Set(key::kPinnedLauncherApps, level, POLICY_SCOPE_USER, value);
      }
    }
  }
  if (policy.has_restrictsignintopattern()) {
    const em::RestrictSigninToPatternProto& restrictsignintopattern_proto = policy.restrictsignintopattern();
    if (restrictsignintopattern_proto.has_restrictsignintopattern()) {
      PolicyLevel level = POLICY_LEVEL_MANDATORY;
      bool do_set = true;
      if (restrictsignintopattern_proto.has_policy_options()) {
        do_set = false;
        switch(restrictsignintopattern_proto.policy_options().mode()) {
          case em::PolicyOptions::MANDATORY:
            do_set = true;
            level = POLICY_LEVEL_MANDATORY;
            break;
          case em::PolicyOptions::RECOMMENDED:
            do_set = true;
            level = POLICY_LEVEL_RECOMMENDED;
            break;
          case em::PolicyOptions::UNSET:
            break;
        }
      }
      if (do_set) {
        Value* value = Value::CreateStringValue(restrictsignintopattern_proto.restrictsignintopattern());
        map->Set(key::kRestrictSigninToPattern, level, POLICY_SCOPE_USER, value);
      }
    }
  }
}

}  // namespace policy
