//
// DO NOT MODIFY THIS FILE DIRECTLY!
// IT IS GENERATED BY generate_policy_source.py
// FROM policy_templates.json
//

#ifndef CHROME_COMMON_POLICY_CONSTANTS_H_
#define CHROME_COMMON_POLICY_CONSTANTS_H_
#pragma once

#include <string>

#include "base/values.h"

namespace policy {

// Lists policy types mapped to their names and expected types.
// Used to initialize ConfigurationPolicyProviders.
struct PolicyDefinitionList {
  struct Entry {
    const char* name;
    base::Value::Type value_type;
    bool device_policy;
  };

  const Entry* begin;
  const Entry* end;
};

// Returns true if the given policy is deprecated.
bool IsDeprecatedPolicy(const std::string& policy);

// Returns the default policy definition list for Chrome.
const PolicyDefinitionList* GetChromePolicyDefinitionList();

// Key names for the policy settings.
namespace key {

extern const char kAdditionalLaunchParameters[];
extern const char kAllowCrossOriginAuthPrompt[];
extern const char kAllowFileSelectionDialogs[];
extern const char kAllowOutdatedPlugins[];
extern const char kAlternateErrorPagesEnabled[];
extern const char kAlwaysAuthorizePlugins[];
extern const char kApplicationLocaleValue[];
extern const char kAuthNegotiateDelegateWhitelist[];
extern const char kAuthSchemes[];
extern const char kAuthServerWhitelist[];
extern const char kAutoFillEnabled[];
extern const char kAutoSelectCertificateForUrls[];
extern const char kBackgroundModeEnabled[];
extern const char kBlockThirdPartyCookies[];
extern const char kBookmarkBarEnabled[];
extern const char kChromeFrameContentTypes[];
extern const char kChromeFrameRendererSettings[];
extern const char kChromeOsLockOnIdleSuspend[];
extern const char kChromeOsReleaseChannel[];
extern const char kChromeOsReleaseChannelDelegated[];
extern const char kClearSiteDataOnExit[];
extern const char kCloudPrintProxyEnabled[];
extern const char kCloudPrintSubmitEnabled[];
extern const char kCookiesAllowedForUrls[];
extern const char kCookiesBlockedForUrls[];
extern const char kCookiesSessionOnlyForUrls[];
extern const char kDefaultBrowserSettingEnabled[];
extern const char kDefaultCookiesSetting[];
extern const char kDefaultGeolocationSetting[];
extern const char kDefaultImagesSetting[];
extern const char kDefaultJavaScriptSetting[];
extern const char kDefaultMediaStreamSetting[];
extern const char kDefaultNotificationsSetting[];
extern const char kDefaultPluginsSetting[];
extern const char kDefaultPopupsSetting[];
extern const char kDefaultSearchProviderEnabled[];
extern const char kDefaultSearchProviderEncodings[];
extern const char kDefaultSearchProviderIconURL[];
extern const char kDefaultSearchProviderInstantURL[];
extern const char kDefaultSearchProviderKeyword[];
extern const char kDefaultSearchProviderName[];
extern const char kDefaultSearchProviderSearchURL[];
extern const char kDefaultSearchProviderSuggestURL[];
extern const char kDeveloperToolsDisabled[];
extern const char kDeviceAllowNewUsers[];
extern const char kDeviceAppPack[];
extern const char kDeviceAutoUpdateDisabled[];
extern const char kDeviceDataRoamingEnabled[];
extern const char kDeviceEphemeralUsersEnabled[];
extern const char kDeviceGuestModeEnabled[];
extern const char kDeviceIdleLogoutTimeout[];
extern const char kDeviceIdleLogoutWarningDuration[];
extern const char kDeviceLoginScreenSaverId[];
extern const char kDeviceLoginScreenSaverTimeout[];
extern const char kDeviceMetricsReportingEnabled[];
extern const char kDeviceOpenNetworkConfiguration[];
extern const char kDevicePolicyRefreshRate[];
extern const char kDeviceShowUserNamesOnSignin[];
extern const char kDeviceStartUpUrls[];
extern const char kDeviceTargetVersionPrefix[];
extern const char kDeviceUpdateAllowedConnectionTypes[];
extern const char kDeviceUpdateScatterFactor[];
extern const char kDeviceUserWhitelist[];
extern const char kDisable3DAPIs[];
extern const char kDisableAuthNegotiateCnameLookup[];
extern const char kDisablePluginFinder[];
extern const char kDisablePrintPreview[];
extern const char kDisableSSLRecordSplitting[];
extern const char kDisableSpdy[];
extern const char kDisabledPlugins[];
extern const char kDisabledPluginsExceptions[];
extern const char kDisabledSchemes[];
extern const char kDiskCacheDir[];
extern const char kDiskCacheSize[];
extern const char kDnsPrefetchingEnabled[];
extern const char kDownloadDirectory[];
extern const char kEditBookmarksEnabled[];
extern const char kEnableAuthNegotiatePort[];
extern const char kEnableMemoryInfo[];
extern const char kEnableOnlineRevocationChecks[];
extern const char kEnableOriginBoundCerts[];
extern const char kEnabledPlugins[];
extern const char kEnterpriseWebStoreName[];
extern const char kEnterpriseWebStoreURL[];
extern const char kExtensionInstallBlacklist[];
extern const char kExtensionInstallForcelist[];
extern const char kExtensionInstallSources[];
extern const char kExtensionInstallWhitelist[];
extern const char kGCFUserDataDir[];
extern const char kGDataDisabled[];
extern const char kGDataDisabledOverCellular[];
extern const char kGSSAPILibraryName[];
extern const char kHideWebStorePromo[];
extern const char kHomepageIsNewTabPage[];
extern const char kHomepageLocation[];
extern const char kImagesAllowedForUrls[];
extern const char kImagesBlockedForUrls[];
extern const char kImportBookmarks[];
extern const char kImportHistory[];
extern const char kImportHomepage[];
extern const char kImportSavedPasswords[];
extern const char kImportSearchEngine[];
extern const char kIncognitoEnabled[];
extern const char kIncognitoModeAvailability[];
extern const char kInstantEnabled[];
extern const char kJavaScriptAllowedForUrls[];
extern const char kJavaScriptBlockedForUrls[];
extern const char kJavascriptEnabled[];
extern const char kMaxConnectionsPerProxy[];
extern const char kMediaCacheSize[];
extern const char kMetricsReportingEnabled[];
extern const char kNotificationsAllowedForUrls[];
extern const char kNotificationsBlockedForUrls[];
extern const char kOpenNetworkConfiguration[];
extern const char kPasswordManagerAllowShowPasswords[];
extern const char kPasswordManagerEnabled[];
extern const char kPinnedLauncherApps[];
extern const char kPluginsAllowedForUrls[];
extern const char kPluginsBlockedForUrls[];
extern const char kPolicyRefreshRate[];
extern const char kPopupsAllowedForUrls[];
extern const char kPopupsBlockedForUrls[];
extern const char kPrintingEnabled[];
extern const char kProxyBypassList[];
extern const char kProxyMode[];
extern const char kProxyPacUrl[];
extern const char kProxyServer[];
extern const char kProxyServerMode[];
extern const char kProxySettings[];
extern const char kRemoteAccessClientFirewallTraversal[];
extern const char kRemoteAccessHostFirewallTraversal[];
extern const char kRenderInChromeFrameList[];
extern const char kRenderInHostList[];
extern const char kReportDeviceActivityTimes[];
extern const char kReportDeviceBootMode[];
extern const char kReportDeviceLocation[];
extern const char kReportDeviceVersionInfo[];
extern const char kRestoreOnStartup[];
extern const char kRestoreOnStartupURLs[];
extern const char kRestrictSigninToPattern[];
extern const char kSafeBrowsingEnabled[];
extern const char kSavingBrowserHistoryDisabled[];
extern const char kSearchSuggestEnabled[];
extern const char kShowHomeButton[];
extern const char kSyncDisabled[];
extern const char kTranslateEnabled[];
extern const char kURLBlacklist[];
extern const char kURLWhitelist[];
extern const char kUserDataDir[];

}  // namespace key

}  // namespace policy

#endif  // CHROME_COMMON_POLICY_CONSTANTS_H_
