// Copyright (c) 2012 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file is automatically generated.

#ifndef UI_GFX_GL_GL_BINDINGS_AUTOGEN_OSMESA_H_
#define UI_GFX_GL_GL_BINDINGS_AUTOGEN_OSMESA_H_

namespace gfx {

class GLContext;

void InitializeGLBindingsOSMESA();
void InitializeGLExtensionBindingsOSMESA(GLContext* context);
void InitializeDebugGLBindingsOSMESA();
void ClearGLBindingsOSMESA();

typedef OSMesaContext (GL_BINDING_CALL *OSMesaCreateContextProc)(GLenum format, OSMesaContext sharelist);
typedef OSMesaContext (GL_BINDING_CALL *OSMesaCreateContextExtProc)(GLenum format, GLint depthBits, GLint stencilBits, GLint accumBits, OSMesaContext sharelist);
typedef void (GL_BINDING_CALL *OSMesaDestroyContextProc)(OSMesaContext ctx);
typedef GLboolean (GL_BINDING_CALL *OSMesaMakeCurrentProc)(OSMesaContext ctx, void* buffer, GLenum type, GLsizei width, GLsizei height);
typedef OSMesaContext (GL_BINDING_CALL *OSMesaGetCurrentContextProc)(void);
typedef void (GL_BINDING_CALL *OSMesaPixelStoreProc)(GLint pname, GLint value);
typedef void (GL_BINDING_CALL *OSMesaGetIntegervProc)(GLint pname, GLint* value);
typedef GLboolean (GL_BINDING_CALL *OSMesaGetDepthBufferProc)(OSMesaContext c, GLint* width, GLint* height, GLint* bytesPerValue, void** buffer);
typedef GLboolean (GL_BINDING_CALL *OSMesaGetColorBufferProc)(OSMesaContext c, GLint* width, GLint* height, GLint* format, void** buffer);
typedef OSMESAproc (GL_BINDING_CALL *OSMesaGetProcAddressProc)(const char* funcName);
typedef void (GL_BINDING_CALL *OSMesaColorClampProc)(GLboolean enable);


GL_EXPORT extern OSMesaCreateContextProc g_OSMesaCreateContext;
GL_EXPORT extern OSMesaCreateContextExtProc g_OSMesaCreateContextExt;
GL_EXPORT extern OSMesaDestroyContextProc g_OSMesaDestroyContext;
GL_EXPORT extern OSMesaMakeCurrentProc g_OSMesaMakeCurrent;
GL_EXPORT extern OSMesaGetCurrentContextProc g_OSMesaGetCurrentContext;
GL_EXPORT extern OSMesaPixelStoreProc g_OSMesaPixelStore;
GL_EXPORT extern OSMesaGetIntegervProc g_OSMesaGetIntegerv;
GL_EXPORT extern OSMesaGetDepthBufferProc g_OSMesaGetDepthBuffer;
GL_EXPORT extern OSMesaGetColorBufferProc g_OSMesaGetColorBuffer;
GL_EXPORT extern OSMesaGetProcAddressProc g_OSMesaGetProcAddress;
GL_EXPORT extern OSMesaColorClampProc g_OSMesaColorClamp;

}  // namespace gfx

#define OSMesaCreateContext ::gfx::g_OSMesaCreateContext
#define OSMesaCreateContextExt ::gfx::g_OSMesaCreateContextExt
#define OSMesaDestroyContext ::gfx::g_OSMesaDestroyContext
#define OSMesaMakeCurrent ::gfx::g_OSMesaMakeCurrent
#define OSMesaGetCurrentContext ::gfx::g_OSMesaGetCurrentContext
#define OSMesaPixelStore ::gfx::g_OSMesaPixelStore
#define OSMesaGetIntegerv ::gfx::g_OSMesaGetIntegerv
#define OSMesaGetDepthBuffer ::gfx::g_OSMesaGetDepthBuffer
#define OSMesaGetColorBuffer ::gfx::g_OSMesaGetColorBuffer
#define OSMesaGetProcAddress ::gfx::g_OSMesaGetProcAddress
#define OSMesaColorClamp ::gfx::g_OSMesaColorClamp

#endif  //  UI_GFX_GL_GL_BINDINGS_AUTOGEN_OSMESA_H_
