// Copyright (c) 2012 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file is automatically generated.

#ifndef UI_GFX_GL_GL_BINDINGS_AUTOGEN_WGL_H_
#define UI_GFX_GL_GL_BINDINGS_AUTOGEN_WGL_H_

namespace gfx {

class GLContext;

void InitializeGLBindingsWGL();
void InitializeGLExtensionBindingsWGL(GLContext* context);
void InitializeDebugGLBindingsWGL();
void ClearGLBindingsWGL();

typedef HGLRC (GL_BINDING_CALL *wglCreateContextProc)(HDC hdc);
typedef HGLRC (GL_BINDING_CALL *wglCreateLayerContextProc)(HDC hdc, int iLayerPlane);
typedef BOOL (GL_BINDING_CALL *wglCopyContextProc)(HGLRC hglrcSrc, HGLRC hglrcDst, UINT mask);
typedef BOOL (GL_BINDING_CALL *wglDeleteContextProc)(HGLRC hglrc);
typedef HGLRC (GL_BINDING_CALL *wglGetCurrentContextProc)();
typedef HDC (GL_BINDING_CALL *wglGetCurrentDCProc)();
typedef BOOL (GL_BINDING_CALL *wglMakeCurrentProc)(HDC hdc, HGLRC hglrc);
typedef BOOL (GL_BINDING_CALL *wglShareListsProc)(HGLRC hglrc1, HGLRC hglrc2);
typedef BOOL (GL_BINDING_CALL *wglSwapIntervalEXTProc)(int interval);
typedef BOOL (GL_BINDING_CALL *wglSwapLayerBuffersProc)(HDC hdc, UINT fuPlanes);
typedef const char* (GL_BINDING_CALL *wglGetExtensionsStringARBProc)(HDC hDC);
typedef const char* (GL_BINDING_CALL *wglGetExtensionsStringEXTProc)();
typedef BOOL (GL_BINDING_CALL *wglChoosePixelFormatARBProc)(HDC dc, const int* int_attrib_list, const float* float_attrib_list, UINT max_formats, int* formats, UINT* num_formats);
typedef HPBUFFERARB (GL_BINDING_CALL *wglCreatePbufferARBProc)(HDC hDC, int iPixelFormat, int iWidth, int iHeight, const int* piAttribList);
typedef HDC (GL_BINDING_CALL *wglGetPbufferDCARBProc)(HPBUFFERARB hPbuffer);
typedef int (GL_BINDING_CALL *wglReleasePbufferDCARBProc)(HPBUFFERARB hPbuffer, HDC hDC);
typedef BOOL (GL_BINDING_CALL *wglDestroyPbufferARBProc)(HPBUFFERARB hPbuffer);
typedef BOOL (GL_BINDING_CALL *wglQueryPbufferARBProc)(HPBUFFERARB hPbuffer, int iAttribute, int* piValue);

GL_EXPORT extern bool g_WGL_EXT_swap_control;
GL_EXPORT extern bool g_WGL_EXT_extensions_string;
GL_EXPORT extern bool g_WGL_ARB_extensions_string;
GL_EXPORT extern bool g_WGL_ARB_pixel_format;
GL_EXPORT extern bool g_WGL_ARB_pbuffer;

GL_EXPORT extern wglCreateContextProc g_wglCreateContext;
GL_EXPORT extern wglCreateLayerContextProc g_wglCreateLayerContext;
GL_EXPORT extern wglCopyContextProc g_wglCopyContext;
GL_EXPORT extern wglDeleteContextProc g_wglDeleteContext;
GL_EXPORT extern wglGetCurrentContextProc g_wglGetCurrentContext;
GL_EXPORT extern wglGetCurrentDCProc g_wglGetCurrentDC;
GL_EXPORT extern wglMakeCurrentProc g_wglMakeCurrent;
GL_EXPORT extern wglShareListsProc g_wglShareLists;
GL_EXPORT extern wglSwapIntervalEXTProc g_wglSwapIntervalEXT;
GL_EXPORT extern wglSwapLayerBuffersProc g_wglSwapLayerBuffers;
GL_EXPORT extern wglGetExtensionsStringARBProc g_wglGetExtensionsStringARB;
GL_EXPORT extern wglGetExtensionsStringEXTProc g_wglGetExtensionsStringEXT;
GL_EXPORT extern wglChoosePixelFormatARBProc g_wglChoosePixelFormatARB;
GL_EXPORT extern wglCreatePbufferARBProc g_wglCreatePbufferARB;
GL_EXPORT extern wglGetPbufferDCARBProc g_wglGetPbufferDCARB;
GL_EXPORT extern wglReleasePbufferDCARBProc g_wglReleasePbufferDCARB;
GL_EXPORT extern wglDestroyPbufferARBProc g_wglDestroyPbufferARB;
GL_EXPORT extern wglQueryPbufferARBProc g_wglQueryPbufferARB;

}  // namespace gfx

#define wglCreateContext ::gfx::g_wglCreateContext
#define wglCreateLayerContext ::gfx::g_wglCreateLayerContext
#define wglCopyContext ::gfx::g_wglCopyContext
#define wglDeleteContext ::gfx::g_wglDeleteContext
#define wglGetCurrentContext ::gfx::g_wglGetCurrentContext
#define wglGetCurrentDC ::gfx::g_wglGetCurrentDC
#define wglMakeCurrent ::gfx::g_wglMakeCurrent
#define wglShareLists ::gfx::g_wglShareLists
#define wglSwapIntervalEXT ::gfx::g_wglSwapIntervalEXT
#define wglSwapLayerBuffers ::gfx::g_wglSwapLayerBuffers
#define wglGetExtensionsStringARB ::gfx::g_wglGetExtensionsStringARB
#define wglGetExtensionsStringEXT ::gfx::g_wglGetExtensionsStringEXT
#define wglChoosePixelFormatARB ::gfx::g_wglChoosePixelFormatARB
#define wglCreatePbufferARB ::gfx::g_wglCreatePbufferARB
#define wglGetPbufferDCARB ::gfx::g_wglGetPbufferDCARB
#define wglReleasePbufferDCARB ::gfx::g_wglReleasePbufferDCARB
#define wglDestroyPbufferARB ::gfx::g_wglDestroyPbufferARB
#define wglQueryPbufferARB ::gfx::g_wglQueryPbufferARB

#endif  //  UI_GFX_GL_GL_BINDINGS_AUTOGEN_WGL_H_
