/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8AudioListener.h"

#if ENABLE(WEB_AUDIO)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8AudioListener::info = { V8AudioListener::GetTemplate, V8AudioListener::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace AudioListenerV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> dopplerFactorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.AudioListener.dopplerFactor._get");
    AudioListener* imp = V8AudioListener::toNative(info.Holder());
    return v8::Number::New(imp->dopplerFactor());
}

static void dopplerFactorAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.AudioListener.dopplerFactor._set");
    AudioListener* imp = V8AudioListener::toNative(info.Holder());
    float v = static_cast<float>(value->NumberValue());
    imp->setDopplerFactor(v);
    return;
}

static v8::Handle<v8::Value> speedOfSoundAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.AudioListener.speedOfSound._get");
    AudioListener* imp = V8AudioListener::toNative(info.Holder());
    return v8::Number::New(imp->speedOfSound());
}

static void speedOfSoundAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.AudioListener.speedOfSound._set");
    AudioListener* imp = V8AudioListener::toNative(info.Holder());
    float v = static_cast<float>(value->NumberValue());
    imp->setSpeedOfSound(v);
    return;
}

static v8::Handle<v8::Value> setPositionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.AudioListener.setPosition");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    AudioListener* imp = V8AudioListener::toNative(args.Holder());
    EXCEPTION_BLOCK(float, x, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, y, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, z, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)->NumberValue()));
    imp->setPosition(x, y, z);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> setOrientationCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.AudioListener.setOrientation");
    if (args.Length() < 6)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    AudioListener* imp = V8AudioListener::toNative(args.Holder());
    EXCEPTION_BLOCK(float, x, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, y, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, z, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, xUp, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, yUp, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, zUp, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 5, DefaultIsUndefined)->NumberValue()));
    imp->setOrientation(x, y, z, xUp, yUp, zUp);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> setVelocityCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.AudioListener.setVelocity");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    AudioListener* imp = V8AudioListener::toNative(args.Holder());
    EXCEPTION_BLOCK(float, x, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, y, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, z, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)->NumberValue()));
    imp->setVelocity(x, y, z);
    return v8::Handle<v8::Value>();
}

} // namespace AudioListenerV8Internal

static const BatchedAttribute AudioListenerAttrs[] = {
    // Attribute 'dopplerFactor' (Type: 'attribute' ExtAttr: '')
    {"dopplerFactor", AudioListenerV8Internal::dopplerFactorAttrGetter, AudioListenerV8Internal::dopplerFactorAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'speedOfSound' (Type: 'attribute' ExtAttr: '')
    {"speedOfSound", AudioListenerV8Internal::speedOfSoundAttrGetter, AudioListenerV8Internal::speedOfSoundAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback AudioListenerCallbacks[] = {
    {"setPosition", AudioListenerV8Internal::setPositionCallback},
    {"setOrientation", AudioListenerV8Internal::setOrientationCallback},
    {"setVelocity", AudioListenerV8Internal::setVelocityCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8AudioListenerTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "AudioListener", v8::Persistent<v8::FunctionTemplate>(), V8AudioListener::internalFieldCount,
        AudioListenerAttrs, WTF_ARRAY_LENGTH(AudioListenerAttrs),
        AudioListenerCallbacks, WTF_ARRAY_LENGTH(AudioListenerCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8AudioListener::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8AudioListener::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8AudioListenerTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8AudioListener::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8AudioListener::wrapSlow(PassRefPtr<AudioListener> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8AudioListener::derefObject(void* object)
{
    static_cast<AudioListener*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(WEB_AUDIO)
