/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8AudioNode.h"

#if ENABLE(WEB_AUDIO)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8AudioContext.h"
#include "V8AudioParam.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8AudioNode::info = { V8AudioNode::GetTemplate, V8AudioNode::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace AudioNodeV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> contextAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.AudioNode.context._get");
    AudioNode* imp = V8AudioNode::toNative(info.Holder());
    RefPtr<AudioContext> result = imp->context();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "context", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> numberOfInputsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.AudioNode.numberOfInputs._get");
    AudioNode* imp = V8AudioNode::toNative(info.Holder());
    return v8UnsignedInteger(imp->numberOfInputs(), info.GetIsolate());
}

static v8::Handle<v8::Value> numberOfOutputsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.AudioNode.numberOfOutputs._get");
    AudioNode* imp = V8AudioNode::toNative(info.Holder());
    return v8UnsignedInteger(imp->numberOfOutputs(), info.GetIsolate());
}

static v8::Handle<v8::Value> connect1Callback(const v8::Arguments& args)
{
    INC_STATS("DOM.AudioNode.connect1");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    AudioNode* imp = V8AudioNode::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(AudioNode*, destination, V8AudioNode::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8AudioNode::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(unsigned, output, toUInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(unsigned, input, toUInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    imp->connect(destination, output, input, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> connect2Callback(const v8::Arguments& args)
{
    INC_STATS("DOM.AudioNode.connect2");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    AudioNode* imp = V8AudioNode::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(AudioParam*, destination, V8AudioParam::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8AudioParam::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(unsigned, output, toUInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    imp->connect(destination, output, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> connectCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.AudioNode.connect");
    if ((args.Length() == 1 && (args[0]->IsNull() || V8AudioNode::HasInstance(args[0]))) || (args.Length() == 2 && (args[0]->IsNull() || V8AudioNode::HasInstance(args[0]))) || (args.Length() == 3 && (args[0]->IsNull() || V8AudioNode::HasInstance(args[0]))))
        return connect1Callback(args);
    if ((args.Length() == 1 && (args[0]->IsNull() || V8AudioParam::HasInstance(args[0]))) || (args.Length() == 2 && (args[0]->IsNull() || V8AudioParam::HasInstance(args[0]))))
        return connect2Callback(args);
    return V8Proxy::throwTypeError(0, args.GetIsolate());
}

static v8::Handle<v8::Value> disconnectCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.AudioNode.disconnect");
    AudioNode* imp = V8AudioNode::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(unsigned, output, toUInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    imp->disconnect(output, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace AudioNodeV8Internal

static const BatchedAttribute AudioNodeAttrs[] = {
    // Attribute 'context' (Type: 'readonly attribute' ExtAttr: '')
    {"context", AudioNodeV8Internal::contextAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'numberOfInputs' (Type: 'readonly attribute' ExtAttr: '')
    {"numberOfInputs", AudioNodeV8Internal::numberOfInputsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'numberOfOutputs' (Type: 'readonly attribute' ExtAttr: '')
    {"numberOfOutputs", AudioNodeV8Internal::numberOfOutputsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback AudioNodeCallbacks[] = {
    {"connect", AudioNodeV8Internal::connectCallback},
    {"disconnect", AudioNodeV8Internal::disconnectCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8AudioNodeTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "AudioNode", v8::Persistent<v8::FunctionTemplate>(), V8AudioNode::internalFieldCount,
        AudioNodeAttrs, WTF_ARRAY_LENGTH(AudioNodeAttrs),
        AudioNodeCallbacks, WTF_ARRAY_LENGTH(AudioNodeCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8AudioNode::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8AudioNode::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8AudioNodeTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8AudioNode::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8AudioNode::wrapSlow(PassRefPtr<AudioNode> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8AudioNode::derefObject(void* object)
{
    static_cast<AudioNode*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(WEB_AUDIO)
