/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8CSSStyleDeclaration.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "StylePropertySet.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8CSSRule.h"
#include "V8CSSValue.h"
#include "V8Collection.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8CSSStyleDeclaration::info = { V8CSSStyleDeclaration::GetTemplate, V8CSSStyleDeclaration::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace CSSStyleDeclarationV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> cssTextAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.CSSStyleDeclaration.cssText._get");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(info.Holder());
    return v8StringOrNull(imp->cssText(), info.GetIsolate());
}

static void cssTextAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.CSSStyleDeclaration.cssText._set");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    ExceptionCode ec = 0;
    imp->setCssText(v, ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> lengthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.CSSStyleDeclaration.length._get");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(info.Holder());
    return v8UnsignedInteger(imp->length(), info.GetIsolate());
}

static v8::Handle<v8::Value> parentRuleAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.CSSStyleDeclaration.parentRule._get");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(info.Holder());
    RefPtr<CSSRule> result = imp->parentRule();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "parentRule", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> getPropertyValueCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CSSStyleDeclaration.getPropertyValue");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, propertyName, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return v8StringOrNull(imp->getPropertyValue(propertyName), args.GetIsolate());
}

static v8::Handle<v8::Value> getPropertyCSSValueCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CSSStyleDeclaration.getPropertyCSSValue");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, propertyName, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return toV8(imp->getPropertyCSSValue(propertyName), args.GetIsolate());
}

static v8::Handle<v8::Value> removePropertyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CSSStyleDeclaration.removeProperty");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, propertyName, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    String result = imp->removeProperty(propertyName, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8StringOrNull(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> getPropertyPriorityCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CSSStyleDeclaration.getPropertyPriority");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, propertyName, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return v8StringOrNull(imp->getPropertyPriority(propertyName), args.GetIsolate());
}

static v8::Handle<v8::Value> setPropertyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CSSStyleDeclaration.setProperty");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, propertyName, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithNullCheck>, value, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, priority, MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined));
    imp->setProperty(propertyName, value, priority, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> itemCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CSSStyleDeclaration.item");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(args.Holder());
    EXCEPTION_BLOCK(unsigned, index, toUInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    return v8String(imp->item(index), args.GetIsolate());
}

static v8::Handle<v8::Value> getPropertyShorthandCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CSSStyleDeclaration.getPropertyShorthand");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, propertyName, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return v8StringOrNull(imp->getPropertyShorthand(propertyName), args.GetIsolate());
}

static v8::Handle<v8::Value> isPropertyImplicitCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CSSStyleDeclaration.isPropertyImplicit");
    CSSStyleDeclaration* imp = V8CSSStyleDeclaration::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, propertyName, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return v8Boolean(imp->isPropertyImplicit(propertyName), args.GetIsolate());
}

} // namespace CSSStyleDeclarationV8Internal

static const BatchedAttribute CSSStyleDeclarationAttrs[] = {
    // Attribute 'cssText' (Type: 'attribute' ExtAttr: 'TreatNullAs TreatReturnedNullStringAs')
    {"cssText", CSSStyleDeclarationV8Internal::cssTextAttrGetter, CSSStyleDeclarationV8Internal::cssTextAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'length' (Type: 'readonly attribute' ExtAttr: '')
    {"length", CSSStyleDeclarationV8Internal::lengthAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'parentRule' (Type: 'readonly attribute' ExtAttr: '')
    {"parentRule", CSSStyleDeclarationV8Internal::parentRuleAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback CSSStyleDeclarationCallbacks[] = {
    {"getPropertyValue", CSSStyleDeclarationV8Internal::getPropertyValueCallback},
    {"getPropertyCSSValue", CSSStyleDeclarationV8Internal::getPropertyCSSValueCallback},
    {"removeProperty", CSSStyleDeclarationV8Internal::removePropertyCallback},
    {"getPropertyPriority", CSSStyleDeclarationV8Internal::getPropertyPriorityCallback},
    {"setProperty", CSSStyleDeclarationV8Internal::setPropertyCallback},
    {"item", CSSStyleDeclarationV8Internal::itemCallback},
    {"getPropertyShorthand", CSSStyleDeclarationV8Internal::getPropertyShorthandCallback},
    {"isPropertyImplicit", CSSStyleDeclarationV8Internal::isPropertyImplicitCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8CSSStyleDeclarationTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "CSSStyleDeclaration", v8::Persistent<v8::FunctionTemplate>(), V8CSSStyleDeclaration::internalFieldCount,
        CSSStyleDeclarationAttrs, WTF_ARRAY_LENGTH(CSSStyleDeclarationAttrs),
        CSSStyleDeclarationCallbacks, WTF_ARRAY_LENGTH(CSSStyleDeclarationCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    setCollectionStringIndexedGetter<CSSStyleDeclaration>(desc);
    desc->InstanceTemplate()->SetNamedPropertyHandler(V8CSSStyleDeclaration::namedPropertyGetter, V8CSSStyleDeclaration::namedPropertySetter, V8CSSStyleDeclaration::namedPropertyQuery, 0, V8CSSStyleDeclaration::namedPropertyEnumerator);

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8CSSStyleDeclaration::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8CSSStyleDeclaration::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8CSSStyleDeclarationTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8CSSStyleDeclaration::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8CSSStyleDeclaration::wrapSlow(PassRefPtr<CSSStyleDeclaration> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8CSSStyleDeclaration::derefObject(void* object)
{
    static_cast<CSSStyleDeclaration*>(object)->deref();
}

} // namespace WebCore
