/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8CharacterData.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Node.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8CharacterData::info = { V8CharacterData::GetTemplate, V8CharacterData::derefObject, 0, 0, &V8Node::info, WrapperTypeObjectPrototype };

namespace CharacterDataV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> dataAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.CharacterData.data._get");
    CharacterData* imp = V8CharacterData::toNative(info.Holder());
    return v8String(imp->data(), info.GetIsolate());
}

static void dataAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.CharacterData.data._set");
    CharacterData* imp = V8CharacterData::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    ExceptionCode ec = 0;
    imp->setData(v, ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> lengthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.CharacterData.length._get");
    CharacterData* imp = V8CharacterData::toNative(info.Holder());
    return v8UnsignedInteger(imp->length(), info.GetIsolate());
}

static v8::Handle<v8::Value> substringDataCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CharacterData.substringData");
    CharacterData* imp = V8CharacterData::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, offset, toUInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    if (UNLIKELY(offset < 0)) {
        ec = INDEX_SIZE_ERR;
        goto fail;
    }
    EXCEPTION_BLOCK(int, length, toUInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    if (UNLIKELY(length < 0)) {
        ec = INDEX_SIZE_ERR;
        goto fail;
    }
    String result = imp->substringData(offset, length, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8StringOrNull(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> appendDataCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CharacterData.appendData");
    CharacterData* imp = V8CharacterData::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, data, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->appendData(data, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> insertDataCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CharacterData.insertData");
    CharacterData* imp = V8CharacterData::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, offset, toUInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    if (UNLIKELY(offset < 0)) {
        ec = INDEX_SIZE_ERR;
        goto fail;
    }
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, data, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->insertData(offset, data, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> deleteDataCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CharacterData.deleteData");
    CharacterData* imp = V8CharacterData::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, offset, toUInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    if (UNLIKELY(offset < 0)) {
        ec = INDEX_SIZE_ERR;
        goto fail;
    }
    EXCEPTION_BLOCK(int, length, toUInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    if (UNLIKELY(length < 0)) {
        ec = INDEX_SIZE_ERR;
        goto fail;
    }
    imp->deleteData(offset, length, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> replaceDataCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.CharacterData.replaceData");
    CharacterData* imp = V8CharacterData::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, offset, toUInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    if (UNLIKELY(offset < 0)) {
        ec = INDEX_SIZE_ERR;
        goto fail;
    }
    EXCEPTION_BLOCK(int, length, toUInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    if (UNLIKELY(length < 0)) {
        ec = INDEX_SIZE_ERR;
        goto fail;
    }
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, data, MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined));
    imp->replaceData(offset, length, data, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace CharacterDataV8Internal

static const BatchedAttribute CharacterDataAttrs[] = {
    // Attribute 'data' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"data", CharacterDataV8Internal::dataAttrGetter, CharacterDataV8Internal::dataAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'length' (Type: 'readonly attribute' ExtAttr: '')
    {"length", CharacterDataV8Internal::lengthAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback CharacterDataCallbacks[] = {
    {"substringData", CharacterDataV8Internal::substringDataCallback},
    {"appendData", CharacterDataV8Internal::appendDataCallback},
    {"insertData", CharacterDataV8Internal::insertDataCallback},
    {"deleteData", CharacterDataV8Internal::deleteDataCallback},
    {"replaceData", CharacterDataV8Internal::replaceDataCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8CharacterDataTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "CharacterData", V8Node::GetTemplate(), V8CharacterData::internalFieldCount,
        CharacterDataAttrs, WTF_ARRAY_LENGTH(CharacterDataAttrs),
        CharacterDataCallbacks, WTF_ARRAY_LENGTH(CharacterDataCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8CharacterData::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8CharacterData::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8CharacterDataTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8CharacterData::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8CharacterData::wrapSlow(PassRefPtr<CharacterData> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = V8Proxy::retrieve(impl->document()->frame());

    // Enter the node's context and create the wrapper in that context.
    v8::Handle<v8::Context> context;
    if (proxy && !proxy->matchesCurrentContext()) {
        // For performance, we enter the context only if the currently running context
        // is different from the context that we are about to enter.
        context = proxy->context();
        if (!context.IsEmpty())
            context->Enter();
    }
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    // Exit the node's context if it was entered.
    if (!context.IsEmpty())
        context->Exit();
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    wrapperHandle.SetWrapperClassId(v8DOMSubtreeClassId);
    V8DOMWrapper::setJSWrapperForDOMNode(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8CharacterData::derefObject(void* object)
{
    static_cast<CharacterData*>(object)->deref();
}

} // namespace WebCore
