/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8Console.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "ScriptArguments.h"
#include "ScriptCallStack.h"
#include "ScriptCallStackFactory.h"
#include "ScriptProfile.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8ScriptProfile.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8Console::info = { V8Console::GetTemplate, V8Console::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace ConsoleV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> profilesAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Console.profiles._get");
    Console* imp = V8Console::toNative(info.Holder());
    return v8Array(imp->profiles(), info.GetIsolate());
}

static v8::Handle<v8::Value> debugCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.debug");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->debug(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> errorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.error");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->error(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> infoCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.info");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->info(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> logCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.log");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->log(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> warnCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.warn");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->warn(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> dirCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.dir");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->dir(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> dirxmlCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.dirxml");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->dirxml(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> countCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.count");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->count(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> markTimelineCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.markTimeline");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->markTimeline(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> timeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.time");
    Console* imp = V8Console::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithUndefinedOrNullCheck>, title, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->time(title);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> timeEndCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.timeEnd");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Console* imp = V8Console::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithUndefinedOrNullCheck>, title, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 1));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->timeEnd(scriptArguments, callStack, title);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> timeStampCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.timeStamp");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->timeStamp(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> groupCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.group");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->group(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> groupCollapsedCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.groupCollapsed");
    Console* imp = V8Console::toNative(args.Holder());
    RefPtr<ScriptArguments> scriptArguments(createScriptArguments(args, 0));
    RefPtr<ScriptCallStack> callStack(createScriptCallStackForInspector());
    if (!callStack)
        return v8::Undefined();
    imp->groupCollapsed(scriptArguments, callStack);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> groupEndCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Console.groupEnd");
    Console* imp = V8Console::toNative(args.Holder());
    imp->groupEnd();
    return v8::Handle<v8::Value>();
}

} // namespace ConsoleV8Internal

static const BatchedAttribute ConsoleAttrs[] = {
    // Attribute 'profiles' (Type: 'readonly attribute' ExtAttr: '')
    {"profiles", ConsoleV8Internal::profilesAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'memory' (Type: 'readonly attribute' ExtAttr: 'V8CustomGetter')
    {"memory", V8Console::memoryAccessorGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback ConsoleCallbacks[] = {
    {"debug", ConsoleV8Internal::debugCallback},
    {"error", ConsoleV8Internal::errorCallback},
    {"info", ConsoleV8Internal::infoCallback},
    {"log", ConsoleV8Internal::logCallback},
    {"warn", ConsoleV8Internal::warnCallback},
    {"dir", ConsoleV8Internal::dirCallback},
    {"dirxml", ConsoleV8Internal::dirxmlCallback},
    {"trace", V8Console::traceCallback},
    {"assert", V8Console::assertCallback},
    {"count", ConsoleV8Internal::countCallback},
    {"markTimeline", ConsoleV8Internal::markTimelineCallback},
    {"profile", V8Console::profileCallback},
    {"profileEnd", V8Console::profileEndCallback},
    {"time", ConsoleV8Internal::timeCallback},
    {"timeEnd", ConsoleV8Internal::timeEndCallback},
    {"timeStamp", ConsoleV8Internal::timeStampCallback},
    {"group", ConsoleV8Internal::groupCallback},
    {"groupCollapsed", ConsoleV8Internal::groupCollapsedCallback},
    {"groupEnd", ConsoleV8Internal::groupEndCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8ConsoleTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "Console", v8::Persistent<v8::FunctionTemplate>(), V8Console::internalFieldCount,
        ConsoleAttrs, WTF_ARRAY_LENGTH(ConsoleAttrs),
        ConsoleCallbacks, WTF_ARRAY_LENGTH(ConsoleCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8Console::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8Console::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8ConsoleTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8Console::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8Console::wrapSlow(PassRefPtr<Console> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8Console::derefObject(void* object)
{
    static_cast<Console*>(object)->deref();
}

} // namespace WebCore
