/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8DOMApplicationCache.h"

#include "ContextFeatures.h"
#include "EventListener.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8AbstractEventListener.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8Event.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8DOMApplicationCache::info = { V8DOMApplicationCache::GetTemplate, V8DOMApplicationCache::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace DOMApplicationCacheV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> statusAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.status._get");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    return v8Integer(imp->status(), info.GetIsolate());
}

static v8::Handle<v8::Value> oncheckingAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onchecking._get");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    return imp->onchecking() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onchecking())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void oncheckingAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onchecking._set");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onchecking(), value, V8DOMApplicationCache::eventListenerCacheIndex);
    imp->setOnchecking(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onerrorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onerror._get");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    return imp->onerror() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onerror())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onerrorAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onerror._set");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onerror(), value, V8DOMApplicationCache::eventListenerCacheIndex);
    imp->setOnerror(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onnoupdateAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onnoupdate._get");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    return imp->onnoupdate() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onnoupdate())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onnoupdateAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onnoupdate._set");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onnoupdate(), value, V8DOMApplicationCache::eventListenerCacheIndex);
    imp->setOnnoupdate(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> ondownloadingAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.ondownloading._get");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    return imp->ondownloading() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->ondownloading())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void ondownloadingAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.ondownloading._set");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->ondownloading(), value, V8DOMApplicationCache::eventListenerCacheIndex);
    imp->setOndownloading(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onprogressAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onprogress._get");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    return imp->onprogress() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onprogress())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onprogressAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onprogress._set");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onprogress(), value, V8DOMApplicationCache::eventListenerCacheIndex);
    imp->setOnprogress(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onupdatereadyAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onupdateready._get");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    return imp->onupdateready() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onupdateready())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onupdatereadyAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onupdateready._set");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onupdateready(), value, V8DOMApplicationCache::eventListenerCacheIndex);
    imp->setOnupdateready(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> oncachedAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.oncached._get");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    return imp->oncached() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->oncached())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void oncachedAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.oncached._set");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->oncached(), value, V8DOMApplicationCache::eventListenerCacheIndex);
    imp->setOncached(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onobsoleteAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onobsolete._get");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    return imp->onobsolete() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onobsolete())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onobsoleteAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DOMApplicationCache.onobsolete._set");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onobsolete(), value, V8DOMApplicationCache::eventListenerCacheIndex);
    imp->setOnobsolete(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> updateCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DOMApplicationCache.update");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    imp->update(ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> swapCacheCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DOMApplicationCache.swapCache");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    imp->swapCache(ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> abortCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DOMApplicationCache.abort");
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(args.Holder());
    imp->abort();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> addEventListenerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DOMApplicationCache.addEventListener()");
    RefPtr<EventListener> listener = V8DOMWrapper::getEventListener(args[1], false, ListenerFindOrCreate);
    if (listener) {
        V8DOMApplicationCache::toNative(args.Holder())->addEventListener(v8ValueToAtomicWebCoreString(args[0]), listener, args[2]->BooleanValue());
        createHiddenDependency(args.Holder(), args[1], V8DOMApplicationCache::eventListenerCacheIndex);
    }
    return v8::Undefined();
}

static v8::Handle<v8::Value> removeEventListenerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DOMApplicationCache.removeEventListener()");
    RefPtr<EventListener> listener = V8DOMWrapper::getEventListener(args[1], false, ListenerFindOnly);
    if (listener) {
        V8DOMApplicationCache::toNative(args.Holder())->removeEventListener(v8ValueToAtomicWebCoreString(args[0]), listener.get(), args[2]->BooleanValue());
        removeHiddenDependency(args.Holder(), args[1], V8DOMApplicationCache::eventListenerCacheIndex);
    }
    return v8::Undefined();
}

static v8::Handle<v8::Value> dispatchEventCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DOMApplicationCache.dispatchEvent");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DOMApplicationCache* imp = V8DOMApplicationCache::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Event*, evt, V8Event::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Event::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    bool result = imp->dispatchEvent(evt, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace DOMApplicationCacheV8Internal

static const BatchedAttribute DOMApplicationCacheAttrs[] = {
    // Attribute 'status' (Type: 'readonly attribute' ExtAttr: '')
    {"status", DOMApplicationCacheV8Internal::statusAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onchecking' (Type: 'attribute' ExtAttr: '')
    {"onchecking", DOMApplicationCacheV8Internal::oncheckingAttrGetter, DOMApplicationCacheV8Internal::oncheckingAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onerror' (Type: 'attribute' ExtAttr: '')
    {"onerror", DOMApplicationCacheV8Internal::onerrorAttrGetter, DOMApplicationCacheV8Internal::onerrorAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onnoupdate' (Type: 'attribute' ExtAttr: '')
    {"onnoupdate", DOMApplicationCacheV8Internal::onnoupdateAttrGetter, DOMApplicationCacheV8Internal::onnoupdateAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'ondownloading' (Type: 'attribute' ExtAttr: '')
    {"ondownloading", DOMApplicationCacheV8Internal::ondownloadingAttrGetter, DOMApplicationCacheV8Internal::ondownloadingAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onprogress' (Type: 'attribute' ExtAttr: '')
    {"onprogress", DOMApplicationCacheV8Internal::onprogressAttrGetter, DOMApplicationCacheV8Internal::onprogressAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onupdateready' (Type: 'attribute' ExtAttr: '')
    {"onupdateready", DOMApplicationCacheV8Internal::onupdatereadyAttrGetter, DOMApplicationCacheV8Internal::onupdatereadyAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'oncached' (Type: 'attribute' ExtAttr: '')
    {"oncached", DOMApplicationCacheV8Internal::oncachedAttrGetter, DOMApplicationCacheV8Internal::oncachedAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onobsolete' (Type: 'attribute' ExtAttr: '')
    {"onobsolete", DOMApplicationCacheV8Internal::onobsoleteAttrGetter, DOMApplicationCacheV8Internal::onobsoleteAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback DOMApplicationCacheCallbacks[] = {
    {"update", DOMApplicationCacheV8Internal::updateCallback},
    {"swapCache", DOMApplicationCacheV8Internal::swapCacheCallback},
    {"abort", DOMApplicationCacheV8Internal::abortCallback},
    {"addEventListener", DOMApplicationCacheV8Internal::addEventListenerCallback},
    {"removeEventListener", DOMApplicationCacheV8Internal::removeEventListenerCallback},
};

static const BatchedConstant DOMApplicationCacheConsts[] = {
    {"UNCACHED", static_cast<signed int>(0)},
    {"IDLE", static_cast<signed int>(1)},
    {"CHECKING", static_cast<signed int>(2)},
    {"DOWNLOADING", static_cast<signed int>(3)},
    {"UPDATEREADY", static_cast<signed int>(4)},
    {"OBSOLETE", static_cast<signed int>(5)},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8DOMApplicationCacheTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "DOMApplicationCache", v8::Persistent<v8::FunctionTemplate>(), V8DOMApplicationCache::internalFieldCount,
        DOMApplicationCacheAttrs, WTF_ARRAY_LENGTH(DOMApplicationCacheAttrs),
        DOMApplicationCacheCallbacks, WTF_ARRAY_LENGTH(DOMApplicationCacheCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'dispatchEvent'
    const int dispatchEventArgc = 1;
    v8::Handle<v8::FunctionTemplate> dispatchEventArgv[dispatchEventArgc] = { V8Event::GetRawTemplate() };
    v8::Handle<v8::Signature> dispatchEventSignature = v8::Signature::New(desc, dispatchEventArgc, dispatchEventArgv);
    proto->Set(v8::String::New("dispatchEvent"), v8::FunctionTemplate::New(DOMApplicationCacheV8Internal::dispatchEventCallback, v8::Handle<v8::Value>(), dispatchEventSignature));
    batchConfigureConstants(desc, proto, DOMApplicationCacheConsts, WTF_ARRAY_LENGTH(DOMApplicationCacheConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8DOMApplicationCache::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8DOMApplicationCache::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8DOMApplicationCacheTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8DOMApplicationCache::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8DOMApplicationCache::wrapSlow(PassRefPtr<DOMApplicationCache> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8DOMApplicationCache::derefObject(void* object)
{
    static_cast<DOMApplicationCache*>(object)->deref();
}

} // namespace WebCore
