/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8DatabaseSync.h"

#if ENABLE(SQL_DATABASE)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8SQLTransactionSyncCallback.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8DatabaseSync::info = { V8DatabaseSync::GetTemplate, V8DatabaseSync::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace DatabaseSyncV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> versionAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DatabaseSync.version._get");
    DatabaseSync* imp = V8DatabaseSync::toNative(info.Holder());
    return v8String(imp->version(), info.GetIsolate());
}

static v8::Handle<v8::Value> lastErrorMessageAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DatabaseSync.lastErrorMessage._get");
    DatabaseSync* imp = V8DatabaseSync::toNative(info.Holder());
    return v8String(imp->lastErrorMessage(), info.GetIsolate());
}

static v8::Handle<v8::Value> changeVersionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DatabaseSync.changeVersion");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DatabaseSync* imp = V8DatabaseSync::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, oldVersion, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, newVersion, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    RefPtr<SQLTransactionSyncCallback> callback;
    if (args.Length() > 2 && !args[2]->IsNull() && !args[2]->IsUndefined()) {
        if (!args[2]->IsFunction())
            return throwError(TYPE_MISMATCH_ERR, args.GetIsolate());
        callback = V8SQLTransactionSyncCallback::create(args[2], getScriptExecutionContext());
    }
    imp->changeVersion(oldVersion, newVersion, callback, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> transactionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DatabaseSync.transaction");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DatabaseSync* imp = V8DatabaseSync::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    if (args.Length() <= 0 || !args[0]->IsFunction())
        return throwError(TYPE_MISMATCH_ERR, args.GetIsolate());
    RefPtr<SQLTransactionSyncCallback> callback = V8SQLTransactionSyncCallback::create(args[0], getScriptExecutionContext());
    imp->transaction(callback, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> readTransactionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DatabaseSync.readTransaction");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DatabaseSync* imp = V8DatabaseSync::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    if (args.Length() <= 0 || !args[0]->IsFunction())
        return throwError(TYPE_MISMATCH_ERR, args.GetIsolate());
    RefPtr<SQLTransactionSyncCallback> callback = V8SQLTransactionSyncCallback::create(args[0], getScriptExecutionContext());
    imp->readTransaction(callback, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace DatabaseSyncV8Internal

static const BatchedAttribute DatabaseSyncAttrs[] = {
    // Attribute 'version' (Type: 'readonly attribute' ExtAttr: '')
    {"version", DatabaseSyncV8Internal::versionAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'lastErrorMessage' (Type: 'readonly attribute' ExtAttr: '')
    {"lastErrorMessage", DatabaseSyncV8Internal::lastErrorMessageAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback DatabaseSyncCallbacks[] = {
    {"changeVersion", DatabaseSyncV8Internal::changeVersionCallback},
    {"transaction", DatabaseSyncV8Internal::transactionCallback},
    {"readTransaction", DatabaseSyncV8Internal::readTransactionCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8DatabaseSyncTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "DatabaseSync", v8::Persistent<v8::FunctionTemplate>(), V8DatabaseSync::internalFieldCount,
        DatabaseSyncAttrs, WTF_ARRAY_LENGTH(DatabaseSyncAttrs),
        DatabaseSyncCallbacks, WTF_ARRAY_LENGTH(DatabaseSyncCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8DatabaseSync::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8DatabaseSync::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8DatabaseSyncTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8DatabaseSync::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8DatabaseSync::wrapSlow(PassRefPtr<DatabaseSync> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8DatabaseSync::derefObject(void* object)
{
    static_cast<DatabaseSync*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(SQL_DATABASE)
