/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8DeliveredIntent.h"

#if ENABLE(WEB_INTENTS)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "MessagePort.h"
#include "RuntimeEnabledFeatures.h"
#include "SerializedScriptValue.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8Intent.h"
#include "V8IsolatedContext.h"
#include "V8MessagePort.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8DeliveredIntent::info = { V8DeliveredIntent::GetTemplate, V8DeliveredIntent::derefObject, 0, 0, &V8Intent::info, WrapperTypeObjectPrototype };

namespace DeliveredIntentV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> portsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeliveredIntent.ports._get");
    DeliveredIntent* imp = V8DeliveredIntent::toNative(info.Holder());
    MessagePortArray* ports = imp->ports();
    if (!ports)
        return v8::Array::New(0);
    MessagePortArray portsCopy(*ports);
    v8::Local<v8::Array> portArray = v8::Array::New(portsCopy.size());
    for (size_t i = 0; i < portsCopy.size(); ++i)
        portArray->Set(v8Integer(i, info.GetIsolate()), toV8(portsCopy[i].get(), info.GetIsolate()));
    return portArray;
}

static v8::Handle<v8::Value> getExtraCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeliveredIntent.getExtra");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DeliveredIntent* imp = V8DeliveredIntent::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, key, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return v8StringOrNull(imp->getExtra(key), args.GetIsolate());
}

static v8::Handle<v8::Value> postResultCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeliveredIntent.postResult");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DeliveredIntent* imp = V8DeliveredIntent::toNative(args.Holder());
    bool resultDidThrow = false;
    RefPtr<SerializedScriptValue> result = SerializedScriptValue::create(args[0], 0, 0, resultDidThrow, args.GetIsolate());
    if (resultDidThrow)
        return v8::Undefined();
    imp->postResult(result);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> postFailureCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeliveredIntent.postFailure");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DeliveredIntent* imp = V8DeliveredIntent::toNative(args.Holder());
    bool resultDidThrow = false;
    RefPtr<SerializedScriptValue> result = SerializedScriptValue::create(args[0], 0, 0, resultDidThrow, args.GetIsolate());
    if (resultDidThrow)
        return v8::Undefined();
    imp->postFailure(result);
    return v8::Handle<v8::Value>();
}

} // namespace DeliveredIntentV8Internal

static const BatchedAttribute DeliveredIntentAttrs[] = {
    // Attribute 'ports' (Type: 'readonly attribute' ExtAttr: '')
    {"ports", DeliveredIntentV8Internal::portsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback DeliveredIntentCallbacks[] = {
    {"getExtra", DeliveredIntentV8Internal::getExtraCallback},
    {"postResult", DeliveredIntentV8Internal::postResultCallback},
    {"postFailure", DeliveredIntentV8Internal::postFailureCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8DeliveredIntentTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "DeliveredIntent", V8Intent::GetTemplate(), V8DeliveredIntent::internalFieldCount,
        DeliveredIntentAttrs, WTF_ARRAY_LENGTH(DeliveredIntentAttrs),
        DeliveredIntentCallbacks, WTF_ARRAY_LENGTH(DeliveredIntentCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8DeliveredIntent::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8DeliveredIntent::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8DeliveredIntentTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8DeliveredIntent::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8DeliveredIntent::wrapSlow(PassRefPtr<DeliveredIntent> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8DeliveredIntent::derefObject(void* object)
{
    static_cast<DeliveredIntent*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(WEB_INTENTS)
