/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8DeprecatedPeerConnection.h"

#if ENABLE(MEDIA_STREAM)

#include "ContextFeatures.h"
#include "EventListener.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8AbstractEventListener.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8Event.h"
#include "V8IsolatedContext.h"
#include "V8MediaStream.h"
#include "V8MediaStreamList.h"
#include "V8Proxy.h"
#include "V8SignalingCallback.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8DeprecatedPeerConnection::info = { V8DeprecatedPeerConnection::GetTemplate, V8DeprecatedPeerConnection::derefObject, V8DeprecatedPeerConnection::toActiveDOMObject, 0, 0, WrapperTypeObjectPrototype };

namespace DeprecatedPeerConnectionV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> readyStateAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.readyState._get");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    return v8Integer(imp->readyState(), info.GetIsolate());
}

static v8::Handle<v8::Value> localStreamsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.localStreams._get");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    RefPtr<MediaStreamList> result = imp->localStreams();
    v8::Handle<v8::Value> wrapper = result.get() ? getActiveDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "localStreams", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> remoteStreamsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.remoteStreams._get");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    RefPtr<MediaStreamList> result = imp->remoteStreams();
    v8::Handle<v8::Value> wrapper = result.get() ? getActiveDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "remoteStreams", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> onconnectingAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onconnecting._get");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    return imp->onconnecting() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onconnecting())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onconnectingAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onconnecting._set");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onconnecting(), value, V8DeprecatedPeerConnection::eventListenerCacheIndex);
    imp->setOnconnecting(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onopenAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onopen._get");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    return imp->onopen() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onopen())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onopenAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onopen._set");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onopen(), value, V8DeprecatedPeerConnection::eventListenerCacheIndex);
    imp->setOnopen(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onmessageAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onmessage._get");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    return imp->onmessage() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onmessage())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onmessageAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onmessage._set");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onmessage(), value, V8DeprecatedPeerConnection::eventListenerCacheIndex);
    imp->setOnmessage(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onstatechangeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onstatechange._get");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    return imp->onstatechange() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onstatechange())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onstatechangeAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onstatechange._set");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onstatechange(), value, V8DeprecatedPeerConnection::eventListenerCacheIndex);
    imp->setOnstatechange(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onaddstreamAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onaddstream._get");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    return imp->onaddstream() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onaddstream())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onaddstreamAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onaddstream._set");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onaddstream(), value, V8DeprecatedPeerConnection::eventListenerCacheIndex);
    imp->setOnaddstream(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onremovestreamAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onremovestream._get");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    return imp->onremovestream() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onremovestream())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onremovestreamAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DeprecatedPeerConnection.onremovestream._set");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onremovestream(), value, V8DeprecatedPeerConnection::eventListenerCacheIndex);
    imp->setOnremovestream(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> processSignalingMessageCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeprecatedPeerConnection.processSignalingMessage");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, message, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->processSignalingMessage(message, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> sendCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeprecatedPeerConnection.send");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, text, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->send(text, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> addStreamCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeprecatedPeerConnection.addStream");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    if (args.Length() > 0 && !isUndefinedOrNull(args[0]) && !V8MediaStream::HasInstance(args[0]))
        return V8Proxy::throwTypeError(0, args.GetIsolate());
    EXCEPTION_BLOCK(MediaStream*, stream, V8MediaStream::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8MediaStream::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->addStream(stream, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> removeStreamCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeprecatedPeerConnection.removeStream");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    if (args.Length() > 0 && !isUndefinedOrNull(args[0]) && !V8MediaStream::HasInstance(args[0]))
        return V8Proxy::throwTypeError(0, args.GetIsolate());
    EXCEPTION_BLOCK(MediaStream*, stream, V8MediaStream::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8MediaStream::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->removeStream(stream, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> closeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeprecatedPeerConnection.close");
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    imp->close(ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> addEventListenerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeprecatedPeerConnection.addEventListener()");
    RefPtr<EventListener> listener = V8DOMWrapper::getEventListener(args[1], false, ListenerFindOrCreate);
    if (listener) {
        V8DeprecatedPeerConnection::toNative(args.Holder())->addEventListener(v8ValueToAtomicWebCoreString(args[0]), listener, args[2]->BooleanValue());
        createHiddenDependency(args.Holder(), args[1], V8DeprecatedPeerConnection::eventListenerCacheIndex);
    }
    return v8::Undefined();
}

static v8::Handle<v8::Value> removeEventListenerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeprecatedPeerConnection.removeEventListener()");
    RefPtr<EventListener> listener = V8DOMWrapper::getEventListener(args[1], false, ListenerFindOnly);
    if (listener) {
        V8DeprecatedPeerConnection::toNative(args.Holder())->removeEventListener(v8ValueToAtomicWebCoreString(args[0]), listener.get(), args[2]->BooleanValue());
        removeHiddenDependency(args.Holder(), args[1], V8DeprecatedPeerConnection::eventListenerCacheIndex);
    }
    return v8::Undefined();
}

static v8::Handle<v8::Value> dispatchEventCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeprecatedPeerConnection.dispatchEvent");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DeprecatedPeerConnection* imp = V8DeprecatedPeerConnection::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Event*, event, V8Event::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Event::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    bool result = imp->dispatchEvent(event, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace DeprecatedPeerConnectionV8Internal

static const BatchedAttribute DeprecatedPeerConnectionAttrs[] = {
    // Attribute 'readyState' (Type: 'readonly attribute' ExtAttr: '')
    {"readyState", DeprecatedPeerConnectionV8Internal::readyStateAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'localStreams' (Type: 'readonly attribute' ExtAttr: '')
    {"localStreams", DeprecatedPeerConnectionV8Internal::localStreamsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'remoteStreams' (Type: 'readonly attribute' ExtAttr: '')
    {"remoteStreams", DeprecatedPeerConnectionV8Internal::remoteStreamsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onconnecting' (Type: 'attribute' ExtAttr: '')
    {"onconnecting", DeprecatedPeerConnectionV8Internal::onconnectingAttrGetter, DeprecatedPeerConnectionV8Internal::onconnectingAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onopen' (Type: 'attribute' ExtAttr: '')
    {"onopen", DeprecatedPeerConnectionV8Internal::onopenAttrGetter, DeprecatedPeerConnectionV8Internal::onopenAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onmessage' (Type: 'attribute' ExtAttr: '')
    {"onmessage", DeprecatedPeerConnectionV8Internal::onmessageAttrGetter, DeprecatedPeerConnectionV8Internal::onmessageAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onstatechange' (Type: 'attribute' ExtAttr: '')
    {"onstatechange", DeprecatedPeerConnectionV8Internal::onstatechangeAttrGetter, DeprecatedPeerConnectionV8Internal::onstatechangeAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onaddstream' (Type: 'attribute' ExtAttr: '')
    {"onaddstream", DeprecatedPeerConnectionV8Internal::onaddstreamAttrGetter, DeprecatedPeerConnectionV8Internal::onaddstreamAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onremovestream' (Type: 'attribute' ExtAttr: '')
    {"onremovestream", DeprecatedPeerConnectionV8Internal::onremovestreamAttrGetter, DeprecatedPeerConnectionV8Internal::onremovestreamAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback DeprecatedPeerConnectionCallbacks[] = {
    {"processSignalingMessage", DeprecatedPeerConnectionV8Internal::processSignalingMessageCallback},
    {"send", DeprecatedPeerConnectionV8Internal::sendCallback},
    {"addStream", DeprecatedPeerConnectionV8Internal::addStreamCallback},
    {"removeStream", DeprecatedPeerConnectionV8Internal::removeStreamCallback},
    {"close", DeprecatedPeerConnectionV8Internal::closeCallback},
    {"addEventListener", DeprecatedPeerConnectionV8Internal::addEventListenerCallback},
    {"removeEventListener", DeprecatedPeerConnectionV8Internal::removeEventListenerCallback},
};

static const BatchedConstant DeprecatedPeerConnectionConsts[] = {
    {"NEW", static_cast<signed int>(0)},
    {"NEGOTIATING", static_cast<signed int>(1)},
    {"ACTIVE", static_cast<signed int>(2)},
    {"CLOSED", static_cast<signed int>(3)},
};


COMPILE_ASSERT(0 == DeprecatedPeerConnection::NEW, DeprecatedPeerConnectionEnumNEWIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(1 == DeprecatedPeerConnection::NEGOTIATING, DeprecatedPeerConnectionEnumNEGOTIATINGIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(2 == DeprecatedPeerConnection::ACTIVE, DeprecatedPeerConnectionEnumACTIVEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(3 == DeprecatedPeerConnection::CLOSED, DeprecatedPeerConnectionEnumCLOSEDIsWrongUseDoNotCheckConstants);

v8::Handle<v8::Value> V8DeprecatedPeerConnection::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DeprecatedPeerConnection.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, serverConfiguration, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    if (args.Length() <= 1 || !args[1]->IsFunction())
        return throwError(TYPE_MISMATCH_ERR, args.GetIsolate());
    RefPtr<SignalingCallback> signalingCallback = V8SignalingCallback::create(args[1], getScriptExecutionContext());

    ScriptExecutionContext* context = getScriptExecutionContext();
    if (!context)
        return V8Proxy::throwError(V8Proxy::ReferenceError, "DeprecatedPeerConnection constructor's associated context is not available", args.GetIsolate());

    RefPtr<DeprecatedPeerConnection> impl = DeprecatedPeerConnection::create(context, serverConfiguration, signalingCallback);
    v8::Handle<v8::Object> wrapper = args.Holder();

    V8DOMWrapper::setDOMWrapper(wrapper, &info, impl.get());
    V8DOMWrapper::setJSWrapperForActiveDOMObject(impl.release(), v8::Persistent<v8::Object>::New(wrapper), args.GetIsolate());
    return args.Holder();
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8DeprecatedPeerConnectionTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "DeprecatedPeerConnection", v8::Persistent<v8::FunctionTemplate>(), V8DeprecatedPeerConnection::internalFieldCount,
        DeprecatedPeerConnectionAttrs, WTF_ARRAY_LENGTH(DeprecatedPeerConnectionAttrs),
        DeprecatedPeerConnectionCallbacks, WTF_ARRAY_LENGTH(DeprecatedPeerConnectionCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8DeprecatedPeerConnection::constructorCallback);
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'dispatchEvent'
    const int dispatchEventArgc = 1;
    v8::Handle<v8::FunctionTemplate> dispatchEventArgv[dispatchEventArgc] = { V8Event::GetRawTemplate() };
    v8::Handle<v8::Signature> dispatchEventSignature = v8::Signature::New(desc, dispatchEventArgc, dispatchEventArgv);
    proto->Set(v8::String::New("dispatchEvent"), v8::FunctionTemplate::New(DeprecatedPeerConnectionV8Internal::dispatchEventCallback, v8::Handle<v8::Value>(), dispatchEventSignature));
    batchConfigureConstants(desc, proto, DeprecatedPeerConnectionConsts, WTF_ARRAY_LENGTH(DeprecatedPeerConnectionConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8DeprecatedPeerConnection::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8DeprecatedPeerConnection::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8DeprecatedPeerConnectionTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8DeprecatedPeerConnection::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}

ActiveDOMObject* V8DeprecatedPeerConnection::toActiveDOMObject(v8::Handle<v8::Object> object)
{
    return toNative(object);
}      

v8::Handle<v8::Object> V8DeprecatedPeerConnection::wrapSlow(PassRefPtr<DeprecatedPeerConnection> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForActiveDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8DeprecatedPeerConnection::derefObject(void* object)
{
    static_cast<DeprecatedPeerConnection*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(MEDIA_STREAM)
