/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8DirectoryEntry.h"

#if ENABLE(FILE_SYSTEM)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8CustomVoidCallback.h"
#include "V8DOMWrapper.h"
#include "V8DirectoryReader.h"
#include "V8Entry.h"
#include "V8ErrorCallback.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8DirectoryEntry::info = { V8DirectoryEntry::GetTemplate, V8DirectoryEntry::derefObject, 0, 0, &V8Entry::info, WrapperTypeObjectPrototype };

namespace DirectoryEntryV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> createReaderCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DirectoryEntry.createReader");
    DirectoryEntry* imp = V8DirectoryEntry::toNative(args.Holder());
    return toV8(imp->createReader(), args.GetIsolate());
}

static v8::Handle<v8::Value> removeRecursivelyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.DirectoryEntry.removeRecursively");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    DirectoryEntry* imp = V8DirectoryEntry::toNative(args.Holder());
    if (args.Length() <= 0 || !args[0]->IsFunction())
        return throwError(TYPE_MISMATCH_ERR, args.GetIsolate());
    RefPtr<VoidCallback> successCallback = V8CustomVoidCallback::create(args[0], getScriptExecutionContext());
    RefPtr<ErrorCallback> errorCallback;
    if (args.Length() > 1 && !args[1]->IsNull() && !args[1]->IsUndefined()) {
        if (!args[1]->IsFunction())
            return throwError(TYPE_MISMATCH_ERR, args.GetIsolate());
        errorCallback = V8ErrorCallback::create(args[1], getScriptExecutionContext());
    }
    imp->removeRecursively(successCallback, errorCallback);
    return v8::Handle<v8::Value>();
}

} // namespace DirectoryEntryV8Internal

static const BatchedCallback DirectoryEntryCallbacks[] = {
    {"createReader", DirectoryEntryV8Internal::createReaderCallback},
    {"getFile", V8DirectoryEntry::getFileCallback},
    {"getDirectory", V8DirectoryEntry::getDirectoryCallback},
    {"removeRecursively", DirectoryEntryV8Internal::removeRecursivelyCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8DirectoryEntryTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "DirectoryEntry", V8Entry::GetTemplate(), V8DirectoryEntry::internalFieldCount,
        0, 0,
        DirectoryEntryCallbacks, WTF_ARRAY_LENGTH(DirectoryEntryCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8DirectoryEntry::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8DirectoryEntry::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8DirectoryEntryTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8DirectoryEntry::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8DirectoryEntry::wrapSlow(PassRefPtr<DirectoryEntry> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8DirectoryEntry::derefObject(void* object)
{
    static_cast<DirectoryEntry*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(FILE_SYSTEM)
