/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8DynamicsCompressorNode.h"

#if ENABLE(WEB_AUDIO)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8AudioNode.h"
#include "V8AudioParam.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8DynamicsCompressorNode::info = { V8DynamicsCompressorNode::GetTemplate, V8DynamicsCompressorNode::derefObject, 0, 0, &V8AudioNode::info, WrapperTypeObjectPrototype };

namespace DynamicsCompressorNodeV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> thresholdAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DynamicsCompressorNode.threshold._get");
    DynamicsCompressorNode* imp = V8DynamicsCompressorNode::toNative(info.Holder());
    RefPtr<AudioParam> result = imp->threshold();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "threshold", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> kneeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DynamicsCompressorNode.knee._get");
    DynamicsCompressorNode* imp = V8DynamicsCompressorNode::toNative(info.Holder());
    RefPtr<AudioParam> result = imp->knee();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "knee", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> ratioAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DynamicsCompressorNode.ratio._get");
    DynamicsCompressorNode* imp = V8DynamicsCompressorNode::toNative(info.Holder());
    RefPtr<AudioParam> result = imp->ratio();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "ratio", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> reductionAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DynamicsCompressorNode.reduction._get");
    DynamicsCompressorNode* imp = V8DynamicsCompressorNode::toNative(info.Holder());
    RefPtr<AudioParam> result = imp->reduction();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "reduction", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> attackAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DynamicsCompressorNode.attack._get");
    DynamicsCompressorNode* imp = V8DynamicsCompressorNode::toNative(info.Holder());
    RefPtr<AudioParam> result = imp->attack();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "attack", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> releaseAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.DynamicsCompressorNode.release._get");
    DynamicsCompressorNode* imp = V8DynamicsCompressorNode::toNative(info.Holder());
    RefPtr<AudioParam> result = imp->release();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "release", wrapper);
    }
    return wrapper;
}

} // namespace DynamicsCompressorNodeV8Internal

static const BatchedAttribute DynamicsCompressorNodeAttrs[] = {
    // Attribute 'threshold' (Type: 'readonly attribute' ExtAttr: '')
    {"threshold", DynamicsCompressorNodeV8Internal::thresholdAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'knee' (Type: 'readonly attribute' ExtAttr: '')
    {"knee", DynamicsCompressorNodeV8Internal::kneeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'ratio' (Type: 'readonly attribute' ExtAttr: '')
    {"ratio", DynamicsCompressorNodeV8Internal::ratioAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'reduction' (Type: 'readonly attribute' ExtAttr: '')
    {"reduction", DynamicsCompressorNodeV8Internal::reductionAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'attack' (Type: 'readonly attribute' ExtAttr: '')
    {"attack", DynamicsCompressorNodeV8Internal::attackAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'release' (Type: 'readonly attribute' ExtAttr: '')
    {"release", DynamicsCompressorNodeV8Internal::releaseAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8DynamicsCompressorNodeTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "DynamicsCompressorNode", V8AudioNode::GetTemplate(), V8DynamicsCompressorNode::internalFieldCount,
        DynamicsCompressorNodeAttrs, WTF_ARRAY_LENGTH(DynamicsCompressorNodeAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8DynamicsCompressorNode::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8DynamicsCompressorNode::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8DynamicsCompressorNodeTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8DynamicsCompressorNode::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8DynamicsCompressorNode::wrapSlow(PassRefPtr<DynamicsCompressorNode> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8DynamicsCompressorNode::derefObject(void* object)
{
    static_cast<DynamicsCompressorNode*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(WEB_AUDIO)
