/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8EntrySync.h"

#if ENABLE(FILE_SYSTEM)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMFileSystemSync.h"
#include "V8DOMWrapper.h"
#include "V8DirectoryEntrySync.h"
#include "V8IsolatedContext.h"
#include "V8Metadata.h"
#include "V8Proxy.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8EntrySync::info = { V8EntrySync::GetTemplate, V8EntrySync::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace EntrySyncV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> isFileAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.EntrySync.isFile._get");
    EntrySync* imp = V8EntrySync::toNative(info.Holder());
    return v8Boolean(imp->isFile(), info.GetIsolate());
}

static v8::Handle<v8::Value> isDirectoryAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.EntrySync.isDirectory._get");
    EntrySync* imp = V8EntrySync::toNative(info.Holder());
    return v8Boolean(imp->isDirectory(), info.GetIsolate());
}

static v8::Handle<v8::Value> nameAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.EntrySync.name._get");
    EntrySync* imp = V8EntrySync::toNative(info.Holder());
    return v8String(imp->name(), info.GetIsolate());
}

static v8::Handle<v8::Value> fullPathAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.EntrySync.fullPath._get");
    EntrySync* imp = V8EntrySync::toNative(info.Holder());
    return v8String(imp->fullPath(), info.GetIsolate());
}

static v8::Handle<v8::Value> filesystemAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.EntrySync.filesystem._get");
    EntrySync* imp = V8EntrySync::toNative(info.Holder());
    RefPtr<DOMFileSystemSync> result = imp->filesystem();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "filesystem", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> getMetadataCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.EntrySync.getMetadata");
    EntrySync* imp = V8EntrySync::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    RefPtr<Metadata> result = imp->getMetadata(ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> moveToCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.EntrySync.moveTo");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    EntrySync* imp = V8EntrySync::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(DirectoryEntrySync*, parent, V8DirectoryEntrySync::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8DirectoryEntrySync::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithUndefinedOrNullCheck>, name, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    RefPtr<EntrySync> result = imp->moveTo(parent, name, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> copyToCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.EntrySync.copyTo");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    EntrySync* imp = V8EntrySync::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(DirectoryEntrySync*, parent, V8DirectoryEntrySync::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8DirectoryEntrySync::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithUndefinedOrNullCheck>, name, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    RefPtr<EntrySync> result = imp->copyTo(parent, name, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> toURLCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.EntrySync.toURL");
    EntrySync* imp = V8EntrySync::toNative(args.Holder());
    return v8String(imp->toURL(), args.GetIsolate());
}

static v8::Handle<v8::Value> removeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.EntrySync.remove");
    EntrySync* imp = V8EntrySync::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    imp->remove(ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> getParentCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.EntrySync.getParent");
    EntrySync* imp = V8EntrySync::toNative(args.Holder());
    return toV8(imp->getParent(), args.GetIsolate());
}

} // namespace EntrySyncV8Internal

static const BatchedAttribute EntrySyncAttrs[] = {
    // Attribute 'isFile' (Type: 'readonly attribute' ExtAttr: '')
    {"isFile", EntrySyncV8Internal::isFileAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'isDirectory' (Type: 'readonly attribute' ExtAttr: '')
    {"isDirectory", EntrySyncV8Internal::isDirectoryAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'name' (Type: 'readonly attribute' ExtAttr: '')
    {"name", EntrySyncV8Internal::nameAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'fullPath' (Type: 'readonly attribute' ExtAttr: '')
    {"fullPath", EntrySyncV8Internal::fullPathAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'filesystem' (Type: 'readonly attribute' ExtAttr: '')
    {"filesystem", EntrySyncV8Internal::filesystemAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback EntrySyncCallbacks[] = {
    {"getMetadata", EntrySyncV8Internal::getMetadataCallback},
    {"toURL", EntrySyncV8Internal::toURLCallback},
    {"remove", EntrySyncV8Internal::removeCallback},
    {"getParent", EntrySyncV8Internal::getParentCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8EntrySyncTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "EntrySync", v8::Persistent<v8::FunctionTemplate>(), V8EntrySync::internalFieldCount,
        EntrySyncAttrs, WTF_ARRAY_LENGTH(EntrySyncAttrs),
        EntrySyncCallbacks, WTF_ARRAY_LENGTH(EntrySyncCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'moveTo'
    const int moveToArgc = 2;
    v8::Handle<v8::FunctionTemplate> moveToArgv[moveToArgc] = { V8DirectoryEntrySync::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> moveToSignature = v8::Signature::New(desc, moveToArgc, moveToArgv);
    proto->Set(v8::String::New("moveTo"), v8::FunctionTemplate::New(EntrySyncV8Internal::moveToCallback, v8::Handle<v8::Value>(), moveToSignature));

    // Custom Signature 'copyTo'
    const int copyToArgc = 2;
    v8::Handle<v8::FunctionTemplate> copyToArgv[copyToArgc] = { V8DirectoryEntrySync::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> copyToSignature = v8::Signature::New(desc, copyToArgc, copyToArgv);
    proto->Set(v8::String::New("copyTo"), v8::FunctionTemplate::New(EntrySyncV8Internal::copyToCallback, v8::Handle<v8::Value>(), copyToSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8EntrySync::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8EntrySync::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8EntrySyncTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8EntrySync::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8EntrySync::wrapSlow(PassRefPtr<EntrySync> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8EntrySync::derefObject(void* object)
{
    static_cast<EntrySync*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(FILE_SYSTEM)
