/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8FileWriterSync.h"

#if ENABLE(FILE_SYSTEM)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8Blob.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8FileWriterSync::info = { V8FileWriterSync::GetTemplate, V8FileWriterSync::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace FileWriterSyncV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> positionAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.FileWriterSync.position._get");
    FileWriterSync* imp = V8FileWriterSync::toNative(info.Holder());
    return v8::Number::New(static_cast<double>(imp->position()));
}

static v8::Handle<v8::Value> lengthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.FileWriterSync.length._get");
    FileWriterSync* imp = V8FileWriterSync::toNative(info.Holder());
    return v8::Number::New(static_cast<double>(imp->length()));
}

static v8::Handle<v8::Value> writeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.FileWriterSync.write");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    FileWriterSync* imp = V8FileWriterSync::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Blob*, data, V8Blob::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Blob::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->write(data, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> seekCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.FileWriterSync.seek");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    FileWriterSync* imp = V8FileWriterSync::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(long long, position, toInt64(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    imp->seek(position, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> truncateCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.FileWriterSync.truncate");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    FileWriterSync* imp = V8FileWriterSync::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(long long, size, toInt64(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    imp->truncate(size, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace FileWriterSyncV8Internal

static const BatchedAttribute FileWriterSyncAttrs[] = {
    // Attribute 'position' (Type: 'readonly attribute' ExtAttr: '')
    {"position", FileWriterSyncV8Internal::positionAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'length' (Type: 'readonly attribute' ExtAttr: '')
    {"length", FileWriterSyncV8Internal::lengthAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback FileWriterSyncCallbacks[] = {
    {"seek", FileWriterSyncV8Internal::seekCallback},
    {"truncate", FileWriterSyncV8Internal::truncateCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8FileWriterSyncTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "FileWriterSync", v8::Persistent<v8::FunctionTemplate>(), V8FileWriterSync::internalFieldCount,
        FileWriterSyncAttrs, WTF_ARRAY_LENGTH(FileWriterSyncAttrs),
        FileWriterSyncCallbacks, WTF_ARRAY_LENGTH(FileWriterSyncCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'write'
    const int writeArgc = 1;
    v8::Handle<v8::FunctionTemplate> writeArgv[writeArgc] = { V8Blob::GetRawTemplate() };
    v8::Handle<v8::Signature> writeSignature = v8::Signature::New(desc, writeArgc, writeArgv);
    proto->Set(v8::String::New("write"), v8::FunctionTemplate::New(FileWriterSyncV8Internal::writeCallback, v8::Handle<v8::Value>(), writeSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8FileWriterSync::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8FileWriterSync::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8FileWriterSyncTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8FileWriterSync::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8FileWriterSync::wrapSlow(PassRefPtr<FileWriterSync> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8FileWriterSync::derefObject(void* object)
{
    static_cast<FileWriterSync*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(FILE_SYSTEM)
