/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8HTMLDocument.h"

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8Document.h"
#include "V8Element.h"
#include "V8HTMLCollection.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8HTMLDocument::info = { V8HTMLDocument::GetTemplate, V8HTMLDocument::derefObject, 0, 0, &V8Document::info, WrapperTypeObjectPrototype };

namespace HTMLDocumentV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> embedsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.embeds._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return toV8(imp->embeds(), info.GetIsolate());
}

static v8::Handle<v8::Value> pluginsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.plugins._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return toV8(imp->plugins(), info.GetIsolate());
}

static v8::Handle<v8::Value> scriptsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.scripts._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return toV8(imp->scripts(), info.GetIsolate());
}

static v8::Handle<v8::Value> widthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.width._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return v8Integer(imp->width(), info.GetIsolate());
}

static v8::Handle<v8::Value> heightAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.height._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return v8Integer(imp->height(), info.GetIsolate());
}

static v8::Handle<v8::Value> dirAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.dir._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return v8String(imp->dir(), info.GetIsolate());
}

static void dirAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.dir._set");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    imp->setDir(v);
    return;
}

static v8::Handle<v8::Value> designModeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.designMode._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return v8String(imp->designMode(), info.GetIsolate());
}

static void designModeAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.designMode._set");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    imp->setDesignMode(v);
    return;
}

static v8::Handle<v8::Value> compatModeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.compatMode._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return v8String(imp->compatMode(), info.GetIsolate());
}

static v8::Handle<v8::Value> activeElementAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.activeElement._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return toV8(imp->activeElement(), info.GetIsolate());
}

static v8::Handle<v8::Value> bgColorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.bgColor._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return v8String(imp->bgColor(), info.GetIsolate());
}

static void bgColorAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.bgColor._set");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    imp->setBgColor(v);
    return;
}

static v8::Handle<v8::Value> fgColorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.fgColor._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return v8String(imp->fgColor(), info.GetIsolate());
}

static void fgColorAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.fgColor._set");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    imp->setFgColor(v);
    return;
}

static v8::Handle<v8::Value> alinkColorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.alinkColor._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return v8String(imp->alinkColor(), info.GetIsolate());
}

static void alinkColorAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.alinkColor._set");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    imp->setAlinkColor(v);
    return;
}

static v8::Handle<v8::Value> linkColorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.linkColor._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return v8String(imp->linkColor(), info.GetIsolate());
}

static void linkColorAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.linkColor._set");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    imp->setLinkColor(v);
    return;
}

static v8::Handle<v8::Value> vlinkColorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.vlinkColor._get");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    return v8String(imp->vlinkColor(), info.GetIsolate());
}

static void vlinkColorAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLDocument.vlinkColor._set");
    HTMLDocument* imp = V8HTMLDocument::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    imp->setVlinkColor(v);
    return;
}

static v8::Handle<v8::Value> closeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLDocument.close");
    HTMLDocument* imp = V8HTMLDocument::toNative(args.Holder());
    imp->close();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> clearCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLDocument.clear");
    HTMLDocument* imp = V8HTMLDocument::toNative(args.Holder());
    imp->clear();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> captureEventsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLDocument.captureEvents");
    HTMLDocument* imp = V8HTMLDocument::toNative(args.Holder());
    imp->captureEvents();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> releaseEventsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLDocument.releaseEvents");
    HTMLDocument* imp = V8HTMLDocument::toNative(args.Holder());
    imp->releaseEvents();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> hasFocusCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLDocument.hasFocus");
    HTMLDocument* imp = V8HTMLDocument::toNative(args.Holder());
    return v8Boolean(imp->hasFocus(), args.GetIsolate());
}

} // namespace HTMLDocumentV8Internal

static const BatchedAttribute HTMLDocumentAttrs[] = {
    // Attribute 'embeds' (Type: 'readonly attribute' ExtAttr: '')
    {"embeds", HTMLDocumentV8Internal::embedsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'plugins' (Type: 'readonly attribute' ExtAttr: '')
    {"plugins", HTMLDocumentV8Internal::pluginsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'scripts' (Type: 'readonly attribute' ExtAttr: '')
    {"scripts", HTMLDocumentV8Internal::scriptsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'all' (Type: 'attribute' ExtAttr: 'Custom Deletable')
    {"all", V8HTMLDocument::allAccessorGetter, V8HTMLDocument::allAccessorSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'width' (Type: 'readonly attribute' ExtAttr: '')
    {"width", HTMLDocumentV8Internal::widthAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'height' (Type: 'readonly attribute' ExtAttr: '')
    {"height", HTMLDocumentV8Internal::heightAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'dir' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"dir", HTMLDocumentV8Internal::dirAttrGetter, HTMLDocumentV8Internal::dirAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'designMode' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"designMode", HTMLDocumentV8Internal::designModeAttrGetter, HTMLDocumentV8Internal::designModeAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'compatMode' (Type: 'readonly attribute' ExtAttr: '')
    {"compatMode", HTMLDocumentV8Internal::compatModeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'activeElement' (Type: 'readonly attribute' ExtAttr: '')
    {"activeElement", HTMLDocumentV8Internal::activeElementAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'bgColor' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"bgColor", HTMLDocumentV8Internal::bgColorAttrGetter, HTMLDocumentV8Internal::bgColorAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'fgColor' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"fgColor", HTMLDocumentV8Internal::fgColorAttrGetter, HTMLDocumentV8Internal::fgColorAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'alinkColor' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"alinkColor", HTMLDocumentV8Internal::alinkColorAttrGetter, HTMLDocumentV8Internal::alinkColorAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'linkColor' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"linkColor", HTMLDocumentV8Internal::linkColorAttrGetter, HTMLDocumentV8Internal::linkColorAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'vlinkColor' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"vlinkColor", HTMLDocumentV8Internal::vlinkColorAttrGetter, HTMLDocumentV8Internal::vlinkColorAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback HTMLDocumentCallbacks[] = {
    {"open", V8HTMLDocument::openCallback},
    {"close", HTMLDocumentV8Internal::closeCallback},
    {"write", V8HTMLDocument::writeCallback},
    {"writeln", V8HTMLDocument::writelnCallback},
    {"clear", HTMLDocumentV8Internal::clearCallback},
    {"captureEvents", HTMLDocumentV8Internal::captureEventsCallback},
    {"releaseEvents", HTMLDocumentV8Internal::releaseEventsCallback},
    {"hasFocus", HTMLDocumentV8Internal::hasFocusCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8HTMLDocumentTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "HTMLDocument", V8Document::GetTemplate(), V8HTMLDocument::internalFieldCount,
        HTMLDocumentAttrs, WTF_ARRAY_LENGTH(HTMLDocumentAttrs),
        HTMLDocumentCallbacks, WTF_ARRAY_LENGTH(HTMLDocumentCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    desc->SetHiddenPrototype(true);

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8HTMLDocument::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8HTMLDocument::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8HTMLDocumentTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8HTMLDocument::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8HTMLDocument::wrapSlow(PassRefPtr<HTMLDocument> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = V8Proxy::retrieve(impl->document()->frame());
    if (proxy && proxy->windowShell()->context().IsEmpty() && proxy->windowShell()->initContextIfNeeded()) {
        // initContextIfNeeded may have created a wrapper for the object, retry from the start.
        return V8HTMLDocument::wrap(impl.get(), isolate);
    }

    // Enter the node's context and create the wrapper in that context.
    v8::Handle<v8::Context> context;
    if (proxy && !proxy->matchesCurrentContext()) {
        // For performance, we enter the context only if the currently running context
        // is different from the context that we are about to enter.
        context = proxy->context();
        if (!context.IsEmpty())
            context->Enter();
    }
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    // Exit the node's context if it was entered.
    if (!context.IsEmpty())
        context->Exit();
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    wrapperHandle.SetWrapperClassId(v8DOMSubtreeClassId);
    V8DOMWrapper::setJSWrapperForDOMNode(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8HTMLDocument::derefObject(void* object)
{
    static_cast<HTMLDocument*>(object)->deref();
}

} // namespace WebCore
