/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8HTMLElement.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "HTMLNames.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMSettableTokenList.h"
#include "V8DOMTokenList.h"
#include "V8DOMWrapper.h"
#include "V8Element.h"
#include "V8HTMLCollection.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8HTMLElement::info = { V8HTMLElement::GetTemplate, V8HTMLElement::derefObject, 0, 0, &V8Element::info, WrapperTypeObjectPrototype };

namespace HTMLElementV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> idAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.id._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::idAttr), info.GetIsolate());
}

static void idAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.id._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::idAttr, v);
}

static v8::Handle<v8::Value> titleAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.title._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::titleAttr), info.GetIsolate());
}

static void titleAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.title._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::titleAttr, v);
}

static v8::Handle<v8::Value> langAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.lang._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::langAttr), info.GetIsolate());
}

static void langAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.lang._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::langAttr, v);
}

static v8::Handle<v8::Value> translateAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.translate._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8Boolean(imp->translate(), info.GetIsolate());
}

static void translateAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.translate._set");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setTranslate(v);
    return;
}

static v8::Handle<v8::Value> dirAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.dir._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::dirAttr), info.GetIsolate());
}

static void dirAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.dir._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::dirAttr, v);
}

static v8::Handle<v8::Value> classNameAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.className._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::classAttr), info.GetIsolate());
}

static void classNameAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.className._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::classAttr, v);
}

static v8::Handle<v8::Value> classListAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.classList._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return toV8(imp->classList(), info.GetIsolate());
}

static v8::Handle<v8::Value> tabIndexAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.tabIndex._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8Integer(imp->tabIndex(), info.GetIsolate());
}

static void tabIndexAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.tabIndex._set");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    int v = toInt32(value);
    imp->setTabIndex(v);
    return;
}

static v8::Handle<v8::Value> draggableAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.draggable._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8Boolean(imp->draggable(), info.GetIsolate());
}

static void draggableAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.draggable._set");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setDraggable(v);
    return;
}

static v8::Handle<v8::Value> webkitdropzoneAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.webkitdropzone._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::webkitdropzoneAttr), info.GetIsolate());
}

static void webkitdropzoneAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.webkitdropzone._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::webkitdropzoneAttr, v);
}

static v8::Handle<v8::Value> hiddenAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.hidden._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8Boolean(imp->hasAttribute(WebCore::HTMLNames::hiddenAttr), info.GetIsolate());
}

static void hiddenAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.hidden._set");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setBooleanAttribute(WebCore::HTMLNames::hiddenAttr, v);
    return;
}

static v8::Handle<v8::Value> accessKeyAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.accessKey._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::accesskeyAttr), info.GetIsolate());
}

static void accessKeyAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.accessKey._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::accesskeyAttr, v);
}

static v8::Handle<v8::Value> innerHTMLAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.innerHTML._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8String(imp->innerHTML(), info.GetIsolate());
}

static void innerHTMLAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.innerHTML._set");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    ExceptionCode ec = 0;
    imp->setInnerHTML(v, ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> innerTextAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.innerText._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8String(imp->innerText(), info.GetIsolate());
}

static void innerTextAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.innerText._set");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    ExceptionCode ec = 0;
    imp->setInnerText(v, ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> outerHTMLAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.outerHTML._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8String(imp->outerHTML(), info.GetIsolate());
}

static void outerHTMLAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.outerHTML._set");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    ExceptionCode ec = 0;
    imp->setOuterHTML(v, ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> outerTextAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.outerText._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8String(imp->outerText(), info.GetIsolate());
}

static void outerTextAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.outerText._set");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    ExceptionCode ec = 0;
    imp->setOuterText(v, ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> childrenAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.children._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return toV8(imp->children(), info.GetIsolate());
}

static v8::Handle<v8::Value> contentEditableAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.contentEditable._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8String(imp->contentEditable(), info.GetIsolate());
}

static void contentEditableAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.contentEditable._set");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    ExceptionCode ec = 0;
    imp->setContentEditable(v, ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> isContentEditableAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.isContentEditable._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8Boolean(imp->isContentEditable(), info.GetIsolate());
}

static v8::Handle<v8::Value> spellcheckAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.spellcheck._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8Boolean(imp->spellcheck(), info.GetIsolate());
}

static void spellcheckAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.spellcheck._set");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setSpellcheck(v);
    return;
}

#if ENABLE(MICRODATA)

static v8::Handle<v8::Value> itemScopeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.itemScope._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8Boolean(imp->hasAttribute(WebCore::HTMLNames::itemscopeAttr), info.GetIsolate());
}

#endif // ENABLE(MICRODATA)

#if ENABLE(MICRODATA)

static void itemScopeAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.itemScope._set");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setBooleanAttribute(WebCore::HTMLNames::itemscopeAttr, v);
    return;
}

#endif // ENABLE(MICRODATA)

#if ENABLE(MICRODATA)

static v8::Handle<v8::Value> itemTypeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.itemType._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return toV8(imp->itemType(), info.GetIsolate());
}

#endif // ENABLE(MICRODATA)

#if ENABLE(MICRODATA)

static v8::Handle<v8::Value> itemIdAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.itemId._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return v8String(imp->getURLAttribute(WebCore::HTMLNames::itemidAttr), info.GetIsolate());
}

#endif // ENABLE(MICRODATA)

#if ENABLE(MICRODATA)

static void itemIdAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.itemId._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::itemidAttr, v);
}

#endif // ENABLE(MICRODATA)

#if ENABLE(MICRODATA)

static v8::Handle<v8::Value> itemRefAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.itemRef._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return toV8(imp->itemRef(), info.GetIsolate());
}

#endif // ENABLE(MICRODATA)

#if ENABLE(MICRODATA)

static v8::Handle<v8::Value> itemPropAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLElement.itemProp._get");
    HTMLElement* imp = V8HTMLElement::toNative(info.Holder());
    return toV8(imp->itemProp(), info.GetIsolate());
}

#endif // ENABLE(MICRODATA)

static v8::Handle<v8::Value> insertAdjacentElementCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLElement.insertAdjacentElement");
    HTMLElement* imp = V8HTMLElement::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, where, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined))) : 0);
    RefPtr<Element> result = imp->insertAdjacentElement(where, element, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> insertAdjacentHTMLCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLElement.insertAdjacentHTML");
    HTMLElement* imp = V8HTMLElement::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, where, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, html, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->insertAdjacentHTML(where, html, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> insertAdjacentTextCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLElement.insertAdjacentText");
    HTMLElement* imp = V8HTMLElement::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, where, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, text, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->insertAdjacentText(where, text, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> clickCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLElement.click");
    HTMLElement* imp = V8HTMLElement::toNative(args.Holder());
    imp->click();
    return v8::Handle<v8::Value>();
}

} // namespace HTMLElementV8Internal

static const BatchedAttribute HTMLElementAttrs[] = {
    // Attribute 'id' (Type: 'attribute' ExtAttr: 'Reflect')
    {"id", HTMLElementV8Internal::idAttrGetter, HTMLElementV8Internal::idAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'title' (Type: 'attribute' ExtAttr: 'Reflect')
    {"title", HTMLElementV8Internal::titleAttrGetter, HTMLElementV8Internal::titleAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'lang' (Type: 'attribute' ExtAttr: 'Reflect')
    {"lang", HTMLElementV8Internal::langAttrGetter, HTMLElementV8Internal::langAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'translate' (Type: 'attribute' ExtAttr: '')
    {"translate", HTMLElementV8Internal::translateAttrGetter, HTMLElementV8Internal::translateAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'dir' (Type: 'attribute' ExtAttr: 'Reflect')
    {"dir", HTMLElementV8Internal::dirAttrGetter, HTMLElementV8Internal::dirAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'className' (Type: 'attribute' ExtAttr: 'Reflect')
    {"className", HTMLElementV8Internal::classNameAttrGetter, HTMLElementV8Internal::classNameAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'classList' (Type: 'readonly attribute' ExtAttr: '')
    {"classList", HTMLElementV8Internal::classListAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'tabIndex' (Type: 'attribute' ExtAttr: '')
    {"tabIndex", HTMLElementV8Internal::tabIndexAttrGetter, HTMLElementV8Internal::tabIndexAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'draggable' (Type: 'attribute' ExtAttr: '')
    {"draggable", HTMLElementV8Internal::draggableAttrGetter, HTMLElementV8Internal::draggableAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'webkitdropzone' (Type: 'attribute' ExtAttr: 'Reflect')
    {"webkitdropzone", HTMLElementV8Internal::webkitdropzoneAttrGetter, HTMLElementV8Internal::webkitdropzoneAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'hidden' (Type: 'attribute' ExtAttr: 'Reflect')
    {"hidden", HTMLElementV8Internal::hiddenAttrGetter, HTMLElementV8Internal::hiddenAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'accessKey' (Type: 'attribute' ExtAttr: 'Reflect')
    {"accessKey", HTMLElementV8Internal::accessKeyAttrGetter, HTMLElementV8Internal::accessKeyAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'innerHTML' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"innerHTML", HTMLElementV8Internal::innerHTMLAttrGetter, HTMLElementV8Internal::innerHTMLAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'innerText' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"innerText", HTMLElementV8Internal::innerTextAttrGetter, HTMLElementV8Internal::innerTextAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'outerHTML' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"outerHTML", HTMLElementV8Internal::outerHTMLAttrGetter, HTMLElementV8Internal::outerHTMLAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'outerText' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"outerText", HTMLElementV8Internal::outerTextAttrGetter, HTMLElementV8Internal::outerTextAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'children' (Type: 'readonly attribute' ExtAttr: '')
    {"children", HTMLElementV8Internal::childrenAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'contentEditable' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"contentEditable", HTMLElementV8Internal::contentEditableAttrGetter, HTMLElementV8Internal::contentEditableAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'isContentEditable' (Type: 'readonly attribute' ExtAttr: '')
    {"isContentEditable", HTMLElementV8Internal::isContentEditableAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'spellcheck' (Type: 'attribute' ExtAttr: '')
    {"spellcheck", HTMLElementV8Internal::spellcheckAttrGetter, HTMLElementV8Internal::spellcheckAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
#if ENABLE(MICRODATA)
    // Attribute 'itemScope' (Type: 'attribute' ExtAttr: 'Reflect Conditional')
    {"itemScope", HTMLElementV8Internal::itemScopeAttrGetter, HTMLElementV8Internal::itemScopeAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
#endif // ENABLE(MICRODATA)
#if ENABLE(MICRODATA)
    // Attribute 'itemType' (Type: 'readonly attribute' ExtAttr: 'Conditional')
    {"itemType", HTMLElementV8Internal::itemTypeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
#endif // ENABLE(MICRODATA)
#if ENABLE(MICRODATA)
    // Attribute 'itemId' (Type: 'attribute' ExtAttr: 'URL Reflect Conditional')
    {"itemId", HTMLElementV8Internal::itemIdAttrGetter, HTMLElementV8Internal::itemIdAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
#endif // ENABLE(MICRODATA)
#if ENABLE(MICRODATA)
    // Attribute 'itemRef' (Type: 'readonly attribute' ExtAttr: 'Conditional')
    {"itemRef", HTMLElementV8Internal::itemRefAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
#endif // ENABLE(MICRODATA)
#if ENABLE(MICRODATA)
    // Attribute 'itemProp' (Type: 'readonly attribute' ExtAttr: 'Conditional')
    {"itemProp", HTMLElementV8Internal::itemPropAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
#endif // ENABLE(MICRODATA)
#if ENABLE(MICRODATA)
    // Attribute 'itemValue' (Type: 'attribute' ExtAttr: 'Custom Conditional')
    {"itemValue", V8HTMLElement::itemValueAccessorGetter, V8HTMLElement::itemValueAccessorSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
#endif // ENABLE(MICRODATA)
};

static const BatchedCallback HTMLElementCallbacks[] = {
    {"insertAdjacentHTML", HTMLElementV8Internal::insertAdjacentHTMLCallback},
    {"insertAdjacentText", HTMLElementV8Internal::insertAdjacentTextCallback},
    {"click", HTMLElementV8Internal::clickCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8HTMLElementTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "HTMLElement", V8Element::GetTemplate(), V8HTMLElement::internalFieldCount,
        HTMLElementAttrs, WTF_ARRAY_LENGTH(HTMLElementAttrs),
        HTMLElementCallbacks, WTF_ARRAY_LENGTH(HTMLElementCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'insertAdjacentElement'
    const int insertAdjacentElementArgc = 2;
    v8::Handle<v8::FunctionTemplate> insertAdjacentElementArgv[insertAdjacentElementArgc] = { v8::Handle<v8::FunctionTemplate>(), V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> insertAdjacentElementSignature = v8::Signature::New(desc, insertAdjacentElementArgc, insertAdjacentElementArgv);
    proto->Set(v8::String::New("insertAdjacentElement"), v8::FunctionTemplate::New(HTMLElementV8Internal::insertAdjacentElementCallback, v8::Handle<v8::Value>(), insertAdjacentElementSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8HTMLElement::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8HTMLElement::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8HTMLElementTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8HTMLElement::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8HTMLElement::wrapSlow(PassRefPtr<HTMLElement> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = V8Proxy::retrieve(impl->document()->frame());

    // Enter the node's context and create the wrapper in that context.
    v8::Handle<v8::Context> context;
    if (proxy && !proxy->matchesCurrentContext()) {
        // For performance, we enter the context only if the currently running context
        // is different from the context that we are about to enter.
        context = proxy->context();
        if (!context.IsEmpty())
            context->Enter();
    }
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    // Exit the node's context if it was entered.
    if (!context.IsEmpty())
        context->Exit();
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    wrapperHandle.SetWrapperClassId(v8DOMSubtreeClassId);
    V8DOMWrapper::setJSWrapperForDOMNode(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8HTMLElement::derefObject(void* object)
{
    static_cast<HTMLElement*>(object)->deref();
}

} // namespace WebCore
