/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8HTMLTableElement.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "HTMLNames.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8HTMLCollection.h"
#include "V8HTMLElement.h"
#include "V8HTMLTableCaptionElement.h"
#include "V8HTMLTableSectionElement.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8HTMLTableElement::info = { V8HTMLTableElement::GetTemplate, V8HTMLTableElement::derefObject, 0, 0, &V8HTMLElement::info, WrapperTypeObjectPrototype };

namespace HTMLTableElementV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> captionAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.caption._get");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(info.Holder());
    return toV8(imp->caption(), info.GetIsolate());
}

static void captionAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.caption._set");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(info.Holder());
    HTMLTableCaptionElement* v = V8HTMLTableCaptionElement::HasInstance(value) ? V8HTMLTableCaptionElement::toNative(v8::Handle<v8::Object>::Cast(value)) : 0;
    ExceptionCode ec = 0;
    imp->setCaption(WTF::getPtr(v), ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> tHeadAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.tHead._get");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(info.Holder());
    return toV8(imp->tHead(), info.GetIsolate());
}

static void tHeadAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.tHead._set");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(info.Holder());
    HTMLTableSectionElement* v = V8HTMLTableSectionElement::HasInstance(value) ? V8HTMLTableSectionElement::toNative(v8::Handle<v8::Object>::Cast(value)) : 0;
    ExceptionCode ec = 0;
    imp->setTHead(WTF::getPtr(v), ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> tFootAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.tFoot._get");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(info.Holder());
    return toV8(imp->tFoot(), info.GetIsolate());
}

static void tFootAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.tFoot._set");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(info.Holder());
    HTMLTableSectionElement* v = V8HTMLTableSectionElement::HasInstance(value) ? V8HTMLTableSectionElement::toNative(v8::Handle<v8::Object>::Cast(value)) : 0;
    ExceptionCode ec = 0;
    imp->setTFoot(WTF::getPtr(v), ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> rowsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.rows._get");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(info.Holder());
    return toV8(imp->rows(), info.GetIsolate());
}

static v8::Handle<v8::Value> tBodiesAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.tBodies._get");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(info.Holder());
    return toV8(imp->tBodies(), info.GetIsolate());
}

static v8::Handle<v8::Value> alignAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.align._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::alignAttr), info.GetIsolate());
}

static void alignAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.align._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::alignAttr, v);
}

static v8::Handle<v8::Value> bgColorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.bgColor._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::bgcolorAttr), info.GetIsolate());
}

static void bgColorAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.bgColor._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::bgcolorAttr, v);
}

static v8::Handle<v8::Value> borderAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.border._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::borderAttr), info.GetIsolate());
}

static void borderAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.border._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::borderAttr, v);
}

static v8::Handle<v8::Value> cellPaddingAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.cellPadding._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::cellpaddingAttr), info.GetIsolate());
}

static void cellPaddingAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.cellPadding._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::cellpaddingAttr, v);
}

static v8::Handle<v8::Value> cellSpacingAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.cellSpacing._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::cellspacingAttr), info.GetIsolate());
}

static void cellSpacingAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.cellSpacing._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::cellspacingAttr, v);
}

static v8::Handle<v8::Value> frameAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.frame._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::frameAttr), info.GetIsolate());
}

static void frameAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.frame._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::frameAttr, v);
}

static v8::Handle<v8::Value> rulesAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.rules._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::rulesAttr), info.GetIsolate());
}

static void rulesAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.rules._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::rulesAttr, v);
}

static v8::Handle<v8::Value> summaryAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.summary._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::summaryAttr), info.GetIsolate());
}

static void summaryAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.summary._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::summaryAttr, v);
}

static v8::Handle<v8::Value> widthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.width._get");
    Element* imp = V8Element::toNative(info.Holder());
    return v8ExternalString(imp->getAttribute(HTMLNames::widthAttr), info.GetIsolate());
}

static void widthAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.HTMLTableElement.width._set");
    Element* imp = V8Element::toNative(info.Holder());
    AtomicString v = toAtomicWebCoreStringWithNullCheck(value);
    imp->setAttribute(HTMLNames::widthAttr, v);
}

static v8::Handle<v8::Value> createTHeadCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLTableElement.createTHead");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(args.Holder());
    return toV8(imp->createTHead(), args.GetIsolate());
}

static v8::Handle<v8::Value> deleteTHeadCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLTableElement.deleteTHead");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(args.Holder());
    imp->deleteTHead();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> createTFootCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLTableElement.createTFoot");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(args.Holder());
    return toV8(imp->createTFoot(), args.GetIsolate());
}

static v8::Handle<v8::Value> deleteTFootCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLTableElement.deleteTFoot");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(args.Holder());
    imp->deleteTFoot();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> createTBodyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLTableElement.createTBody");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(args.Holder());
    return toV8(imp->createTBody(), args.GetIsolate());
}

static v8::Handle<v8::Value> createCaptionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLTableElement.createCaption");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(args.Holder());
    return toV8(imp->createCaption(), args.GetIsolate());
}

static v8::Handle<v8::Value> deleteCaptionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLTableElement.deleteCaption");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(args.Holder());
    imp->deleteCaption();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> insertRowCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLTableElement.insertRow");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, index, toInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    RefPtr<HTMLElement> result = imp->insertRow(index, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> deleteRowCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.HTMLTableElement.deleteRow");
    HTMLTableElement* imp = V8HTMLTableElement::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, index, toInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    imp->deleteRow(index, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace HTMLTableElementV8Internal

static const BatchedAttribute HTMLTableElementAttrs[] = {
    // Attribute 'caption' (Type: 'attribute' ExtAttr: '')
    {"caption", HTMLTableElementV8Internal::captionAttrGetter, HTMLTableElementV8Internal::captionAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'tHead' (Type: 'attribute' ExtAttr: '')
    {"tHead", HTMLTableElementV8Internal::tHeadAttrGetter, HTMLTableElementV8Internal::tHeadAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'tFoot' (Type: 'attribute' ExtAttr: '')
    {"tFoot", HTMLTableElementV8Internal::tFootAttrGetter, HTMLTableElementV8Internal::tFootAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'rows' (Type: 'readonly attribute' ExtAttr: '')
    {"rows", HTMLTableElementV8Internal::rowsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'tBodies' (Type: 'readonly attribute' ExtAttr: '')
    {"tBodies", HTMLTableElementV8Internal::tBodiesAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'align' (Type: 'attribute' ExtAttr: 'Reflect')
    {"align", HTMLTableElementV8Internal::alignAttrGetter, HTMLTableElementV8Internal::alignAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'bgColor' (Type: 'attribute' ExtAttr: 'Reflect')
    {"bgColor", HTMLTableElementV8Internal::bgColorAttrGetter, HTMLTableElementV8Internal::bgColorAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'border' (Type: 'attribute' ExtAttr: 'Reflect')
    {"border", HTMLTableElementV8Internal::borderAttrGetter, HTMLTableElementV8Internal::borderAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'cellPadding' (Type: 'attribute' ExtAttr: 'Reflect')
    {"cellPadding", HTMLTableElementV8Internal::cellPaddingAttrGetter, HTMLTableElementV8Internal::cellPaddingAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'cellSpacing' (Type: 'attribute' ExtAttr: 'Reflect')
    {"cellSpacing", HTMLTableElementV8Internal::cellSpacingAttrGetter, HTMLTableElementV8Internal::cellSpacingAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'frame' (Type: 'attribute' ExtAttr: 'Reflect')
    {"frame", HTMLTableElementV8Internal::frameAttrGetter, HTMLTableElementV8Internal::frameAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'rules' (Type: 'attribute' ExtAttr: 'Reflect')
    {"rules", HTMLTableElementV8Internal::rulesAttrGetter, HTMLTableElementV8Internal::rulesAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'summary' (Type: 'attribute' ExtAttr: 'Reflect')
    {"summary", HTMLTableElementV8Internal::summaryAttrGetter, HTMLTableElementV8Internal::summaryAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'width' (Type: 'attribute' ExtAttr: 'Reflect')
    {"width", HTMLTableElementV8Internal::widthAttrGetter, HTMLTableElementV8Internal::widthAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback HTMLTableElementCallbacks[] = {
    {"createTHead", HTMLTableElementV8Internal::createTHeadCallback},
    {"deleteTHead", HTMLTableElementV8Internal::deleteTHeadCallback},
    {"createTFoot", HTMLTableElementV8Internal::createTFootCallback},
    {"deleteTFoot", HTMLTableElementV8Internal::deleteTFootCallback},
    {"createTBody", HTMLTableElementV8Internal::createTBodyCallback},
    {"createCaption", HTMLTableElementV8Internal::createCaptionCallback},
    {"deleteCaption", HTMLTableElementV8Internal::deleteCaptionCallback},
    {"insertRow", HTMLTableElementV8Internal::insertRowCallback},
    {"deleteRow", HTMLTableElementV8Internal::deleteRowCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8HTMLTableElementTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "HTMLTableElement", V8HTMLElement::GetTemplate(), V8HTMLTableElement::internalFieldCount,
        HTMLTableElementAttrs, WTF_ARRAY_LENGTH(HTMLTableElementAttrs),
        HTMLTableElementCallbacks, WTF_ARRAY_LENGTH(HTMLTableElementCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8HTMLTableElement::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8HTMLTableElement::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8HTMLTableElementTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8HTMLTableElement::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8HTMLTableElement::wrapSlow(PassRefPtr<HTMLTableElement> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = V8Proxy::retrieve(impl->document()->frame());

    // Enter the node's context and create the wrapper in that context.
    v8::Handle<v8::Context> context;
    if (proxy && !proxy->matchesCurrentContext()) {
        // For performance, we enter the context only if the currently running context
        // is different from the context that we are about to enter.
        context = proxy->context();
        if (!context.IsEmpty())
            context->Enter();
    }
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    // Exit the node's context if it was entered.
    if (!context.IsEmpty())
        context->Exit();
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    wrapperHandle.SetWrapperClassId(v8DOMSubtreeClassId);
    V8DOMWrapper::setJSWrapperForDOMNode(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8HTMLTableElement::derefObject(void* object)
{
    static_cast<HTMLTableElement*>(object)->deref();
}

} // namespace WebCore
