/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8IDBKeyRange.h"

#if ENABLE(INDEXED_DATABASE)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "IDBBindingUtilities.h"
#include "IDBKey.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IDBKey.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8IDBKeyRange::info = { V8IDBKeyRange::GetTemplate, V8IDBKeyRange::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace IDBKeyRangeV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> lowerAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.IDBKeyRange.lower._get");
    IDBKeyRange* imp = V8IDBKeyRange::toNative(info.Holder());
    return toV8(imp->lower(), info.GetIsolate());
}

static v8::Handle<v8::Value> upperAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.IDBKeyRange.upper._get");
    IDBKeyRange* imp = V8IDBKeyRange::toNative(info.Holder());
    return toV8(imp->upper(), info.GetIsolate());
}

static v8::Handle<v8::Value> lowerOpenAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.IDBKeyRange.lowerOpen._get");
    IDBKeyRange* imp = V8IDBKeyRange::toNative(info.Holder());
    return v8Boolean(imp->lowerOpen(), info.GetIsolate());
}

static v8::Handle<v8::Value> upperOpenAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.IDBKeyRange.upperOpen._get");
    IDBKeyRange* imp = V8IDBKeyRange::toNative(info.Holder());
    return v8Boolean(imp->upperOpen(), info.GetIsolate());
}

static v8::Handle<v8::Value> onlyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.IDBKeyRange.only");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(RefPtr<IDBKey>, value, createIDBKeyFromValue(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    RefPtr<IDBKeyRange> result = IDBKeyRange::only(value.get(), ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> lowerBoundCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.IDBKeyRange.lowerBound");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(RefPtr<IDBKey>, bound, createIDBKeyFromValue(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    if (args.Length() <= 1) {
        RefPtr<IDBKeyRange> result = IDBKeyRange::lowerBound(bound.get(), ec);
        if (UNLIKELY(ec))
            goto fail;
        return toV8(result.release(), args.GetIsolate());
    }
    EXCEPTION_BLOCK(bool, open, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)->BooleanValue());
    RefPtr<IDBKeyRange> result = IDBKeyRange::lowerBound(bound.get(), open, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> upperBoundCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.IDBKeyRange.upperBound");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(RefPtr<IDBKey>, bound, createIDBKeyFromValue(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    if (args.Length() <= 1) {
        RefPtr<IDBKeyRange> result = IDBKeyRange::upperBound(bound.get(), ec);
        if (UNLIKELY(ec))
            goto fail;
        return toV8(result.release(), args.GetIsolate());
    }
    EXCEPTION_BLOCK(bool, open, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)->BooleanValue());
    RefPtr<IDBKeyRange> result = IDBKeyRange::upperBound(bound.get(), open, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> boundCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.IDBKeyRange.bound");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(RefPtr<IDBKey>, lower, createIDBKeyFromValue(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    EXCEPTION_BLOCK(RefPtr<IDBKey>, upper, createIDBKeyFromValue(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    if (args.Length() <= 2) {
        RefPtr<IDBKeyRange> result = IDBKeyRange::bound(lower.get(), upper.get(), ec);
        if (UNLIKELY(ec))
            goto fail;
        return toV8(result.release(), args.GetIsolate());
    }
    EXCEPTION_BLOCK(bool, lowerOpen, MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)->BooleanValue());
    if (args.Length() <= 3) {
        RefPtr<IDBKeyRange> result = IDBKeyRange::bound(lower.get(), upper.get(), lowerOpen, ec);
        if (UNLIKELY(ec))
            goto fail;
        return toV8(result.release(), args.GetIsolate());
    }
    EXCEPTION_BLOCK(bool, upperOpen, MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined)->BooleanValue());
    RefPtr<IDBKeyRange> result = IDBKeyRange::bound(lower.get(), upper.get(), lowerOpen, upperOpen, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace IDBKeyRangeV8Internal

static const BatchedAttribute IDBKeyRangeAttrs[] = {
    // Attribute 'lower' (Type: 'readonly attribute' ExtAttr: '')
    {"lower", IDBKeyRangeV8Internal::lowerAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'upper' (Type: 'readonly attribute' ExtAttr: '')
    {"upper", IDBKeyRangeV8Internal::upperAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'lowerOpen' (Type: 'readonly attribute' ExtAttr: '')
    {"lowerOpen", IDBKeyRangeV8Internal::lowerOpenAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'upperOpen' (Type: 'readonly attribute' ExtAttr: '')
    {"upperOpen", IDBKeyRangeV8Internal::upperOpenAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8IDBKeyRangeTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "IDBKeyRange", v8::Persistent<v8::FunctionTemplate>(), V8IDBKeyRange::internalFieldCount,
        IDBKeyRangeAttrs, WTF_ARRAY_LENGTH(IDBKeyRangeAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    desc->Set(v8::String::New("only"), v8::FunctionTemplate::New(IDBKeyRangeV8Internal::onlyCallback, v8::Handle<v8::Value>(), v8::Local<v8::Signature>()));
    desc->Set(v8::String::New("lowerBound"), v8::FunctionTemplate::New(IDBKeyRangeV8Internal::lowerBoundCallback, v8::Handle<v8::Value>(), v8::Local<v8::Signature>()));
    desc->Set(v8::String::New("upperBound"), v8::FunctionTemplate::New(IDBKeyRangeV8Internal::upperBoundCallback, v8::Handle<v8::Value>(), v8::Local<v8::Signature>()));
    desc->Set(v8::String::New("bound"), v8::FunctionTemplate::New(IDBKeyRangeV8Internal::boundCallback, v8::Handle<v8::Value>(), v8::Local<v8::Signature>()));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8IDBKeyRange::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8IDBKeyRange::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8IDBKeyRangeTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8IDBKeyRange::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8IDBKeyRange::wrapSlow(PassRefPtr<IDBKeyRange> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8IDBKeyRange::derefObject(void* object)
{
    static_cast<IDBKeyRange*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(INDEXED_DATABASE)
