/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8InspectorFrontendHost.h"

#if ENABLE(INSPECTOR)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8InspectorFrontendHost::info = { V8InspectorFrontendHost::GetTemplate, V8InspectorFrontendHost::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace InspectorFrontendHostV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> loadedCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.loaded");
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    imp->loaded();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> closeWindowCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.closeWindow");
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    imp->closeWindow();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> bringToFrontCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.bringToFront");
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    imp->bringToFront();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> setZoomFactorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.setZoomFactor");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    EXCEPTION_BLOCK(float, zoom, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    imp->setZoomFactor(zoom);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> inspectedURLChangedCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.inspectedURLChanged");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, newURL, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->inspectedURLChanged(newURL);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> requestAttachWindowCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.requestAttachWindow");
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    imp->requestAttachWindow();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> requestDetachWindowCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.requestDetachWindow");
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    imp->requestDetachWindow();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> requestSetDockSideCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.requestSetDockSide");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, side, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->requestSetDockSide(side);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> setAttachedWindowHeightCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.setAttachedWindowHeight");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    EXCEPTION_BLOCK(unsigned, height, toUInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    imp->setAttachedWindowHeight(height);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> moveWindowByCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.moveWindowBy");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    EXCEPTION_BLOCK(float, x, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, y, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)->NumberValue()));
    imp->moveWindowBy(x, y);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> setInjectedScriptForOriginCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.setInjectedScriptForOrigin");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, origin, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, script, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->setInjectedScriptForOrigin(origin, script);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> localizedStringsURLCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.localizedStringsURL");
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    return v8String(imp->localizedStringsURL(), args.GetIsolate());
}

static v8::Handle<v8::Value> hiddenPanelsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.hiddenPanels");
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    return v8String(imp->hiddenPanels(), args.GetIsolate());
}

static v8::Handle<v8::Value> copyTextCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.copyText");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, text, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->copyText(text);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> openInNewTabCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.openInNewTab");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, url, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->openInNewTab(url);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> canSaveCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.canSave");
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    return v8Boolean(imp->canSave(), args.GetIsolate());
}

static v8::Handle<v8::Value> saveCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.save");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, url, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, content, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    EXCEPTION_BLOCK(bool, forceSaveAs, MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)->BooleanValue());
    imp->save(url, content, forceSaveAs);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> appendCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.append");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, url, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, content, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->append(url, content);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> sendMessageToBackendCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.sendMessageToBackend");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, message, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->sendMessageToBackend(message);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> loadResourceSynchronouslyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InspectorFrontendHost.loadResourceSynchronously");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InspectorFrontendHost* imp = V8InspectorFrontendHost::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, url, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return v8String(imp->loadResourceSynchronously(url), args.GetIsolate());
}

} // namespace InspectorFrontendHostV8Internal

static const BatchedCallback InspectorFrontendHostCallbacks[] = {
    {"loaded", InspectorFrontendHostV8Internal::loadedCallback},
    {"closeWindow", InspectorFrontendHostV8Internal::closeWindowCallback},
    {"bringToFront", InspectorFrontendHostV8Internal::bringToFrontCallback},
    {"setZoomFactor", InspectorFrontendHostV8Internal::setZoomFactorCallback},
    {"inspectedURLChanged", InspectorFrontendHostV8Internal::inspectedURLChangedCallback},
    {"requestAttachWindow", InspectorFrontendHostV8Internal::requestAttachWindowCallback},
    {"requestDetachWindow", InspectorFrontendHostV8Internal::requestDetachWindowCallback},
    {"requestSetDockSide", InspectorFrontendHostV8Internal::requestSetDockSideCallback},
    {"setAttachedWindowHeight", InspectorFrontendHostV8Internal::setAttachedWindowHeightCallback},
    {"moveWindowBy", InspectorFrontendHostV8Internal::moveWindowByCallback},
    {"setInjectedScriptForOrigin", InspectorFrontendHostV8Internal::setInjectedScriptForOriginCallback},
    {"localizedStringsURL", InspectorFrontendHostV8Internal::localizedStringsURLCallback},
    {"hiddenPanels", InspectorFrontendHostV8Internal::hiddenPanelsCallback},
    {"copyText", InspectorFrontendHostV8Internal::copyTextCallback},
    {"openInNewTab", InspectorFrontendHostV8Internal::openInNewTabCallback},
    {"canSave", InspectorFrontendHostV8Internal::canSaveCallback},
    {"save", InspectorFrontendHostV8Internal::saveCallback},
    {"append", InspectorFrontendHostV8Internal::appendCallback},
    {"platform", V8InspectorFrontendHost::platformCallback},
    {"port", V8InspectorFrontendHost::portCallback},
    {"showContextMenu", V8InspectorFrontendHost::showContextMenuCallback},
    {"sendMessageToBackend", InspectorFrontendHostV8Internal::sendMessageToBackendCallback},
    {"recordActionTaken", V8InspectorFrontendHost::recordActionTakenCallback},
    {"recordPanelShown", V8InspectorFrontendHost::recordPanelShownCallback},
    {"recordSettingChanged", V8InspectorFrontendHost::recordSettingChangedCallback},
    {"loadResourceSynchronously", InspectorFrontendHostV8Internal::loadResourceSynchronouslyCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8InspectorFrontendHostTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "InspectorFrontendHost", v8::Persistent<v8::FunctionTemplate>(), V8InspectorFrontendHost::internalFieldCount,
        0, 0,
        InspectorFrontendHostCallbacks, WTF_ARRAY_LENGTH(InspectorFrontendHostCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8InspectorFrontendHost::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8InspectorFrontendHost::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8InspectorFrontendHostTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8InspectorFrontendHost::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8InspectorFrontendHost::wrapSlow(PassRefPtr<InspectorFrontendHost> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8InspectorFrontendHost::derefObject(void* object)
{
    static_cast<InspectorFrontendHost*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(INSPECTOR)
