/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8InternalSettings.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8InternalSettings::info = { V8InternalSettings::GetTemplate, V8InternalSettings::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace InternalSettingsV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> setInspectorResourcesDataSizeLimitsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setInspectorResourcesDataSizeLimits");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, maximumResourcesContentSize, toInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, maximumSingleResourceContentSize, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    imp->setInspectorResourcesDataSizeLimits(maximumResourcesContentSize, maximumSingleResourceContentSize, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setForceCompositingModeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setForceCompositingMode");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setForceCompositingMode(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setEnableCompositingForFixedPositionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setEnableCompositingForFixedPosition");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setEnableCompositingForFixedPosition(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setEnableCompositingForScrollableFramesCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setEnableCompositingForScrollableFrames");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setEnableCompositingForScrollableFrames(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setAcceleratedDrawingEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setAcceleratedDrawingEnabled");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setAcceleratedDrawingEnabled(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setAcceleratedFiltersEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setAcceleratedFiltersEnabled");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setAcceleratedFiltersEnabled(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setMockScrollbarsEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setMockScrollbarsEnabled");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setMockScrollbarsEnabled(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setPasswordEchoEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setPasswordEchoEnabled");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setPasswordEchoEnabled(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setPasswordEchoDurationInSecondsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setPasswordEchoDurationInSeconds");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(double, durationInSeconds, static_cast<double>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    imp->setPasswordEchoDurationInSeconds(durationInSeconds, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setFixedElementsLayoutRelativeToFrameCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setFixedElementsLayoutRelativeToFrame");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setFixedElementsLayoutRelativeToFrame(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setUnifiedTextCheckingEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setUnifiedTextCheckingEnabled");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setUnifiedTextCheckingEnabled(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> unifiedTextCheckingEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.unifiedTextCheckingEnabled");
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    bool result = imp->unifiedTextCheckingEnabled(ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setPageScaleFactorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setPageScaleFactor");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(float, scaleFactor, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(int, x, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, y, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    imp->setPageScaleFactor(scaleFactor, x, y, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setTouchEventEmulationEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setTouchEventEmulationEnabled");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setTouchEventEmulationEnabled(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setDeviceSupportsTouchCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setDeviceSupportsTouch");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setDeviceSupportsTouch(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setDeviceSupportsMouseCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setDeviceSupportsMouse");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setDeviceSupportsMouse(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setShadowDOMEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setShadowDOMEnabled");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setShadowDOMEnabled(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setStandardFontFamilyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setStandardFontFamily");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, family, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, script, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->setStandardFontFamily(family, script, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setSerifFontFamilyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setSerifFontFamily");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, family, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, script, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->setSerifFontFamily(family, script, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setSansSerifFontFamilyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setSansSerifFontFamily");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, family, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, script, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->setSansSerifFontFamily(family, script, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setFixedFontFamilyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setFixedFontFamily");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, family, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, script, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->setFixedFontFamily(family, script, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setCursiveFontFamilyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setCursiveFontFamily");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, family, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, script, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->setCursiveFontFamily(family, script, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setFantasyFontFamilyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setFantasyFontFamily");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, family, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, script, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->setFantasyFontFamily(family, script, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setPictographFontFamilyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setPictographFontFamily");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, family, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, script, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->setPictographFontFamily(family, script, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setEnableScrollAnimatorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setEnableScrollAnimator");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setEnableScrollAnimator(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> scrollAnimatorEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.scrollAnimatorEnabled");
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    bool result = imp->scrollAnimatorEnabled(ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setCSSExclusionsEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setCSSExclusionsEnabled");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setCSSExclusionsEnabled(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setCSSVariablesEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setCSSVariablesEnabled");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setCSSVariablesEnabled(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> cssVariablesEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.cssVariablesEnabled");
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    bool result = imp->cssVariablesEnabled(ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setMediaPlaybackRequiresUserGestureCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setMediaPlaybackRequiresUserGesture");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setMediaPlaybackRequiresUserGesture(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setEditingBehaviorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setEditingBehavior");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, behavior, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->setEditingBehavior(behavior, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setFixedPositionCreatesStackingContextCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setFixedPositionCreatesStackingContext");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, creates, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setFixedPositionCreatesStackingContext(creates, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setSyncXHRInDocumentsEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setSyncXHRInDocumentsEnabled");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setSyncXHRInDocumentsEnabled(enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setJavaScriptProfilingEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setJavaScriptProfilingEnabled");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, creates, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setJavaScriptProfilingEnabled(creates, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setWindowFocusRestrictedCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.InternalSettings.setWindowFocusRestricted");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    InternalSettings* imp = V8InternalSettings::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, restricted, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    imp->setWindowFocusRestricted(restricted, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace InternalSettingsV8Internal

static const BatchedCallback InternalSettingsCallbacks[] = {
    {"setInspectorResourcesDataSizeLimits", InternalSettingsV8Internal::setInspectorResourcesDataSizeLimitsCallback},
    {"setForceCompositingMode", InternalSettingsV8Internal::setForceCompositingModeCallback},
    {"setEnableCompositingForFixedPosition", InternalSettingsV8Internal::setEnableCompositingForFixedPositionCallback},
    {"setEnableCompositingForScrollableFrames", InternalSettingsV8Internal::setEnableCompositingForScrollableFramesCallback},
    {"setAcceleratedDrawingEnabled", InternalSettingsV8Internal::setAcceleratedDrawingEnabledCallback},
    {"setAcceleratedFiltersEnabled", InternalSettingsV8Internal::setAcceleratedFiltersEnabledCallback},
    {"setMockScrollbarsEnabled", InternalSettingsV8Internal::setMockScrollbarsEnabledCallback},
    {"setPasswordEchoEnabled", InternalSettingsV8Internal::setPasswordEchoEnabledCallback},
    {"setPasswordEchoDurationInSeconds", InternalSettingsV8Internal::setPasswordEchoDurationInSecondsCallback},
    {"setFixedElementsLayoutRelativeToFrame", InternalSettingsV8Internal::setFixedElementsLayoutRelativeToFrameCallback},
    {"setUnifiedTextCheckingEnabled", InternalSettingsV8Internal::setUnifiedTextCheckingEnabledCallback},
    {"unifiedTextCheckingEnabled", InternalSettingsV8Internal::unifiedTextCheckingEnabledCallback},
    {"setPageScaleFactor", InternalSettingsV8Internal::setPageScaleFactorCallback},
    {"setTouchEventEmulationEnabled", InternalSettingsV8Internal::setTouchEventEmulationEnabledCallback},
    {"setDeviceSupportsTouch", InternalSettingsV8Internal::setDeviceSupportsTouchCallback},
    {"setDeviceSupportsMouse", InternalSettingsV8Internal::setDeviceSupportsMouseCallback},
    {"setShadowDOMEnabled", InternalSettingsV8Internal::setShadowDOMEnabledCallback},
    {"setStandardFontFamily", InternalSettingsV8Internal::setStandardFontFamilyCallback},
    {"setSerifFontFamily", InternalSettingsV8Internal::setSerifFontFamilyCallback},
    {"setSansSerifFontFamily", InternalSettingsV8Internal::setSansSerifFontFamilyCallback},
    {"setFixedFontFamily", InternalSettingsV8Internal::setFixedFontFamilyCallback},
    {"setCursiveFontFamily", InternalSettingsV8Internal::setCursiveFontFamilyCallback},
    {"setFantasyFontFamily", InternalSettingsV8Internal::setFantasyFontFamilyCallback},
    {"setPictographFontFamily", InternalSettingsV8Internal::setPictographFontFamilyCallback},
    {"setEnableScrollAnimator", InternalSettingsV8Internal::setEnableScrollAnimatorCallback},
    {"scrollAnimatorEnabled", InternalSettingsV8Internal::scrollAnimatorEnabledCallback},
    {"setCSSExclusionsEnabled", InternalSettingsV8Internal::setCSSExclusionsEnabledCallback},
    {"setCSSVariablesEnabled", InternalSettingsV8Internal::setCSSVariablesEnabledCallback},
    {"cssVariablesEnabled", InternalSettingsV8Internal::cssVariablesEnabledCallback},
    {"setMediaPlaybackRequiresUserGesture", InternalSettingsV8Internal::setMediaPlaybackRequiresUserGestureCallback},
    {"setEditingBehavior", InternalSettingsV8Internal::setEditingBehaviorCallback},
    {"setFixedPositionCreatesStackingContext", InternalSettingsV8Internal::setFixedPositionCreatesStackingContextCallback},
    {"setSyncXHRInDocumentsEnabled", InternalSettingsV8Internal::setSyncXHRInDocumentsEnabledCallback},
    {"setJavaScriptProfilingEnabled", InternalSettingsV8Internal::setJavaScriptProfilingEnabledCallback},
    {"setWindowFocusRestricted", InternalSettingsV8Internal::setWindowFocusRestrictedCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8InternalSettingsTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "InternalSettings", v8::Persistent<v8::FunctionTemplate>(), V8InternalSettings::internalFieldCount,
        0, 0,
        InternalSettingsCallbacks, WTF_ARRAY_LENGTH(InternalSettingsCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8InternalSettings::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8InternalSettings::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8InternalSettingsTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8InternalSettings::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8InternalSettings::wrapSlow(PassRefPtr<InternalSettings> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8InternalSettings::derefObject(void* object)
{
    static_cast<InternalSettings*>(object)->deref();
}

} // namespace WebCore
