/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8Internals.h"

#include "ContextFeatures.h"
#include "DOMStringList.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8ClientRect.h"
#include "V8ClientRectList.h"
#include "V8DOMStringList.h"
#include "V8DOMWrapper.h"
#include "V8Document.h"
#include "V8Element.h"
#include "V8InternalSettings.h"
#include "V8IsolatedContext.h"
#include "V8Node.h"
#include "V8NodeList.h"
#include "V8Proxy.h"
#include "V8Range.h"
#include "V8ShadowRoot.h"
#include "V8WebKitPoint.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8Internals::info = { V8Internals::GetTemplate, V8Internals::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace InternalsV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> settingsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Internals.settings._get");
    Internals* imp = V8Internals::toNative(info.Holder());
    RefPtr<InternalSettings> result = imp->settings();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "settings", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> addressCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.address");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    return v8String(imp->address(node), args.GetIsolate());
}

static v8::Handle<v8::Value> elementRenderTreeAsTextCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.elementRenderTreeAsText");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    String result = imp->elementRenderTreeAsText(element, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8String(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> isPreloadedCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.isPreloaded");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, url, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    return v8Boolean(imp->isPreloaded(document, url), args.GetIsolate());
}

static v8::Handle<v8::Value> numberOfScopedHTMLStyleChildrenCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.numberOfScopedHTMLStyleChildren");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, scope, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    unsigned result = imp->numberOfScopedHTMLStyleChildren(scope, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8UnsignedInteger(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> ensureShadowRootCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.ensureShadowRoot");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, host, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<ShadowRoot> result = imp->ensureShadowRoot(host, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> shadowRootCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.shadowRoot");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, host, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<ShadowRoot> result = imp->shadowRoot(host, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> youngestShadowRootCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.youngestShadowRoot");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, host, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<ShadowRoot> result = imp->youngestShadowRoot(host, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> oldestShadowRootCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.oldestShadowRoot");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, host, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<ShadowRoot> result = imp->oldestShadowRoot(host, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> youngerShadowRootCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.youngerShadowRoot");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, root, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<ShadowRoot> result = imp->youngerShadowRoot(root, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> olderShadowRootCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.olderShadowRoot");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, root, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<ShadowRoot> result = imp->olderShadowRoot(root, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> includerForCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.includerFor");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<Element> result = imp->includerFor(node, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> shadowPseudoIdCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.shadowPseudoId");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    String result = imp->shadowPseudoId(element, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8String(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setShadowPseudoIdCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.setShadowPseudoId");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, id, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->setShadowPseudoId(element, id, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> createContentElementCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.createContentElement");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<Element> result = imp->createContentElement(document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> getElementByIdInShadowRootCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.getElementByIdInShadowRoot");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, shadowRoot, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, id, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    RefPtr<Element> result = imp->getElementByIdInShadowRoot(shadowRoot, id, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> isValidContentSelectCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.isValidContentSelect");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, contentElement, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    bool result = imp->isValidContentSelect(contentElement, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> treeScopeRootNodeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.treeScopeRootNode");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<Node> result = imp->treeScopeRootNode(node, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> parentTreeScopeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.parentTreeScope");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<Node> result = imp->parentTreeScope(node, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> nextSiblingByWalkerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.nextSiblingByWalker");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<Node> result = imp->nextSiblingByWalker(node, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> firstChildByWalkerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.firstChildByWalker");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<Node> result = imp->firstChildByWalker(node, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> lastChildByWalkerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.lastChildByWalker");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<Node> result = imp->lastChildByWalker(node, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> nextNodeByWalkerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.nextNodeByWalker");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<Node> result = imp->nextNodeByWalker(node, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> previousNodeByWalkerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.previousNodeByWalker");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<Node> result = imp->previousNodeByWalker(node, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> attachedCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.attached");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    bool result = imp->attached(node, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> visiblePlaceholderCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.visiblePlaceholder");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    return v8String(imp->visiblePlaceholder(element), args.GetIsolate());
}

static v8::Handle<v8::Value> selectColorInColorChooserCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.selectColorInColorChooser");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, colorValue, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->selectColorInColorChooser(element, colorValue);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> formControlStateOfPreviousHistoryItemCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.formControlStateOfPreviousHistoryItem");
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    RefPtr<DOMStringList> result = imp->formControlStateOfPreviousHistoryItem(ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Array(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setFormControlStateOfPreviousHistoryItemCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.setFormControlStateOfPreviousHistoryItem");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(RefPtr<DOMStringList>, values, v8ValueToWebCoreDOMStringList(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    imp->setFormControlStateOfPreviousHistoryItem(values, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> absoluteCaretBoundsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.absoluteCaretBounds");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<ClientRect> result = imp->absoluteCaretBounds(document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> boundingBoxCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.boundingBox");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<ClientRect> result = imp->boundingBox(element, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> inspectorHighlightRectsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.inspectorHighlightRects");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<ClientRectList> result = imp->inspectorHighlightRects(document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setBackgroundBlurOnNodeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.setBackgroundBlurOnNode");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(int, blurLength, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    imp->setBackgroundBlurOnNode(node, blurLength, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> markerCountForNodeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.markerCountForNode");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, markerType, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    unsigned result = imp->markerCountForNode(node, markerType, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8UnsignedInteger(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> markerRangeForNodeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.markerRangeForNode");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, markerType, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    EXCEPTION_BLOCK(unsigned, index, toUInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    RefPtr<Range> result = imp->markerRangeForNode(node, markerType, index, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> markerDescriptionForNodeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.markerDescriptionForNode");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, markerType, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    EXCEPTION_BLOCK(unsigned, index, toUInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    String result = imp->markerDescriptionForNode(node, markerType, index, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8String(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setScrollViewPositionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.setScrollViewPosition");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(int, x, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, y, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    imp->setScrollViewPosition(document, x, y, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setPaginationCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.setPagination");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, mode, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    EXCEPTION_BLOCK(int, gap, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    imp->setPagination(document, mode, gap, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> wasLastChangeUserEditCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.wasLastChangeUserEdit");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, textField, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    bool result = imp->wasLastChangeUserEdit(textField, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> suggestedValueCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.suggestedValue");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, inputElement, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    String result = imp->suggestedValue(inputElement, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8String(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setSuggestedValueCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.setSuggestedValue");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, inputElement, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, value, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->setSuggestedValue(inputElement, value, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setEditingValueCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.setEditingValue");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, inputElement, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, value, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->setEditingValue(inputElement, value, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> paintControlTintsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.paintControlTints");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->paintControlTints(document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> scrollElementToRectCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.scrollElementToRect");
    if (args.Length() < 5)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(int, x, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, y, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, w, toInt32(MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, h, toInt32(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined)));
    imp->scrollElementToRect(element, x, y, w, h, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> rangeFromLocationAndLengthCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.rangeFromLocationAndLength");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, scope, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(int, rangeLocation, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, rangeLength, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    RefPtr<Range> result = imp->rangeFromLocationAndLength(scope, rangeLocation, rangeLength, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> locationFromRangeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.locationFromRange");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, scope, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(Range*, range, V8Range::HasInstance(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)) ? V8Range::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined))) : 0);
    unsigned result = imp->locationFromRange(scope, range, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8UnsignedInteger(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> lengthFromRangeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.lengthFromRange");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Element*, scope, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(Range*, range, V8Range::HasInstance(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)) ? V8Range::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined))) : 0);
    unsigned result = imp->lengthFromRange(scope, range, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8UnsignedInteger(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> rangeAsTextCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.rangeAsText");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Range*, range, V8Range::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Range::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    String result = imp->rangeAsText(range, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8String(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setDelegatesScrollingCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.setDelegatesScrolling");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined))) : 0);
    imp->setDelegatesScrolling(enabled, document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> touchPositionAdjustedToBestClickableNodeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.touchPositionAdjustedToBestClickableNode");
    if (args.Length() < 5)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, x, toInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, y, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, width, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, height, toInt32(MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined)));
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined))) : 0);
    RefPtr<WebKitPoint> result = imp->touchPositionAdjustedToBestClickableNode(x, y, width, height, document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> touchNodeAdjustedToBestClickableNodeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.touchNodeAdjustedToBestClickableNode");
    if (args.Length() < 5)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, x, toInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, y, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, width, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, height, toInt32(MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined)));
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined))) : 0);
    RefPtr<Node> result = imp->touchNodeAdjustedToBestClickableNode(x, y, width, height, document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> bestZoomableAreaForTouchPointCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.bestZoomableAreaForTouchPoint");
    if (args.Length() < 5)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, x, toInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, y, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, width, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, height, toInt32(MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined)));
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined))) : 0);
    RefPtr<ClientRect> result = imp->bestZoomableAreaForTouchPoint(x, y, width, height, document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> lastSpellCheckRequestSequenceCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.lastSpellCheckRequestSequence");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    int result = imp->lastSpellCheckRequestSequence(document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Integer(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> lastSpellCheckProcessedSequenceCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.lastSpellCheckProcessedSequence");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    int result = imp->lastSpellCheckProcessedSequence(document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Integer(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setShouldDisplayTrackKindCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.setShouldDisplayTrackKind");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, kind, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    EXCEPTION_BLOCK(bool, enabled, MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)->BooleanValue());
    imp->setShouldDisplayTrackKind(document, kind, enabled, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> shouldDisplayTrackKindCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.shouldDisplayTrackKind");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, trackKind, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    bool result = imp->shouldDisplayTrackKind(document, trackKind, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> userPreferredLanguagesCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.userPreferredLanguages");
    Internals* imp = V8Internals::toNative(args.Holder());
    return v8Array(imp->userPreferredLanguages(), args.GetIsolate());
}

static v8::Handle<v8::Value> setUserPreferredLanguagesCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.setUserPreferredLanguages");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    EXCEPTION_BLOCK(Vector<String>, languages, toNativeArray<String>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    imp->setUserPreferredLanguages(languages);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> wheelEventHandlerCountCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.wheelEventHandlerCount");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    unsigned result = imp->wheelEventHandlerCount(document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8UnsignedInteger(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> touchEventHandlerCountCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.touchEventHandlerCount");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    unsigned result = imp->touchEventHandlerCount(document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8UnsignedInteger(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> nodesFromRectCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.nodesFromRect");
    if (args.Length() < 9)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(int, x, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, y, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    EXCEPTION_BLOCK(unsigned, topPadding, toUInt32(MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined)));
    EXCEPTION_BLOCK(unsigned, rightPadding, toUInt32(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined)));
    EXCEPTION_BLOCK(unsigned, bottomPadding, toUInt32(MAYBE_MISSING_PARAMETER(args, 5, DefaultIsUndefined)));
    EXCEPTION_BLOCK(unsigned, leftPadding, toUInt32(MAYBE_MISSING_PARAMETER(args, 6, DefaultIsUndefined)));
    EXCEPTION_BLOCK(bool, ignoreClipping, MAYBE_MISSING_PARAMETER(args, 7, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(bool, allowShadowContent, MAYBE_MISSING_PARAMETER(args, 8, DefaultIsUndefined)->BooleanValue());
    RefPtr<NodeList> result = imp->nodesFromRect(document, x, y, topPadding, rightPadding, bottomPadding, leftPadding, ignoreClipping, allowShadowContent, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> emitInspectorDidBeginFrameCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.emitInspectorDidBeginFrame");
    Internals* imp = V8Internals::toNative(args.Holder());
    imp->emitInspectorDidBeginFrame();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> emitInspectorDidCancelFrameCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.emitInspectorDidCancelFrame");
    Internals* imp = V8Internals::toNative(args.Holder());
    imp->emitInspectorDidCancelFrame();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> hasSpellingMarkerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.hasSpellingMarker");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(int, from, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, length, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    bool result = imp->hasSpellingMarker(document, from, length, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> hasGrammarMarkerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.hasGrammarMarker");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(int, from, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, length, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    bool result = imp->hasGrammarMarker(document, from, length, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> hasAutocorrectedMarkerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.hasAutocorrectedMarker");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(int, from, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, length, toInt32(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    bool result = imp->hasAutocorrectedMarker(document, from, length, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> numberOfScrollableAreasCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.numberOfScrollableAreas");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    unsigned result = imp->numberOfScrollableAreas(document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8UnsignedInteger(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> isPageBoxVisibleCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.isPageBoxVisible");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(int, pageNumber, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    bool result = imp->isPageBoxVisible(document, pageNumber, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> suspendAnimationsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.suspendAnimations");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->suspendAnimations(document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> resumeAnimationsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.resumeAnimations");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->resumeAnimations(document, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> allowRoundingHacksCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.allowRoundingHacks");
    Internals* imp = V8Internals::toNative(args.Holder());
    imp->allowRoundingHacks();
    return v8::Handle<v8::Value>();
}

#if ENABLE(INSPECTOR)

static v8::Handle<v8::Value> numberOfLiveNodesCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.numberOfLiveNodes");
    Internals* imp = V8Internals::toNative(args.Holder());
    return v8UnsignedInteger(imp->numberOfLiveNodes(), args.GetIsolate());
}

#endif // ENABLE(INSPECTOR)

#if ENABLE(INSPECTOR)

static v8::Handle<v8::Value> numberOfLiveDocumentsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.numberOfLiveDocuments");
    Internals* imp = V8Internals::toNative(args.Holder());
    return v8UnsignedInteger(imp->numberOfLiveDocuments(), args.GetIsolate());
}

#endif // ENABLE(INSPECTOR)

#if ENABLE(INSPECTOR)

static v8::Handle<v8::Value> consoleMessageArgumentCountsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.consoleMessageArgumentCounts");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    return v8Array(imp->consoleMessageArgumentCounts(document), args.GetIsolate());
}

#endif // ENABLE(INSPECTOR)

static v8::Handle<v8::Value> counterValueCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.counterValue");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    return v8String(imp->counterValue(element), args.GetIsolate());
}

static v8::Handle<v8::Value> webkitWillEnterFullScreenForElementCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.webkitWillEnterFullScreenForElement");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined))) : 0);
    imp->webkitWillEnterFullScreenForElement(document, element);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> webkitDidEnterFullScreenForElementCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.webkitDidEnterFullScreenForElement");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined))) : 0);
    imp->webkitDidEnterFullScreenForElement(document, element);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> webkitWillExitFullScreenForElementCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.webkitWillExitFullScreenForElement");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined))) : 0);
    imp->webkitWillExitFullScreenForElement(document, element);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> webkitDidExitFullScreenForElementCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.webkitDidExitFullScreenForElement");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    EXCEPTION_BLOCK(Document*, document, V8Document::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Document::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(Element*, element, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined))) : 0);
    imp->webkitDidExitFullScreenForElement(document, element);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> registerURLSchemeAsBypassingContentSecurityPolicyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.registerURLSchemeAsBypassingContentSecurityPolicy");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, scheme, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->registerURLSchemeAsBypassingContentSecurityPolicy(scheme);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> removeURLSchemeRegisteredAsBypassingContentSecurityPolicyCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Internals.removeURLSchemeRegisteredAsBypassingContentSecurityPolicy");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Internals* imp = V8Internals::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, scheme, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    imp->removeURLSchemeRegisteredAsBypassingContentSecurityPolicy(scheme);
    return v8::Handle<v8::Value>();
}

} // namespace InternalsV8Internal

static const BatchedAttribute InternalsAttrs[] = {
    // Attribute 'settings' (Type: 'readonly attribute' ExtAttr: '')
    {"settings", InternalsV8Internal::settingsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback InternalsCallbacks[] = {
    {"formControlStateOfPreviousHistoryItem", InternalsV8Internal::formControlStateOfPreviousHistoryItemCallback},
    {"setFormControlStateOfPreviousHistoryItem", InternalsV8Internal::setFormControlStateOfPreviousHistoryItemCallback},
    {"userPreferredLanguages", InternalsV8Internal::userPreferredLanguagesCallback},
    {"emitInspectorDidBeginFrame", InternalsV8Internal::emitInspectorDidBeginFrameCallback},
    {"emitInspectorDidCancelFrame", InternalsV8Internal::emitInspectorDidCancelFrameCallback},
    {"allowRoundingHacks", InternalsV8Internal::allowRoundingHacksCallback},
#if ENABLE(INSPECTOR)
    {"numberOfLiveNodes", InternalsV8Internal::numberOfLiveNodesCallback},
#endif
#if ENABLE(INSPECTOR)
    {"numberOfLiveDocuments", InternalsV8Internal::numberOfLiveDocumentsCallback},
#endif
    {"registerURLSchemeAsBypassingContentSecurityPolicy", InternalsV8Internal::registerURLSchemeAsBypassingContentSecurityPolicyCallback},
    {"removeURLSchemeRegisteredAsBypassingContentSecurityPolicy", InternalsV8Internal::removeURLSchemeRegisteredAsBypassingContentSecurityPolicyCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8InternalsTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "Internals", v8::Persistent<v8::FunctionTemplate>(), V8Internals::internalFieldCount,
        InternalsAttrs, WTF_ARRAY_LENGTH(InternalsAttrs),
        InternalsCallbacks, WTF_ARRAY_LENGTH(InternalsCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'address'
    const int addressArgc = 1;
    v8::Handle<v8::FunctionTemplate> addressArgv[addressArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> addressSignature = v8::Signature::New(desc, addressArgc, addressArgv);
    proto->Set(v8::String::New("address"), v8::FunctionTemplate::New(InternalsV8Internal::addressCallback, v8::Handle<v8::Value>(), addressSignature));

    // Custom Signature 'elementRenderTreeAsText'
    const int elementRenderTreeAsTextArgc = 1;
    v8::Handle<v8::FunctionTemplate> elementRenderTreeAsTextArgv[elementRenderTreeAsTextArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> elementRenderTreeAsTextSignature = v8::Signature::New(desc, elementRenderTreeAsTextArgc, elementRenderTreeAsTextArgv);
    proto->Set(v8::String::New("elementRenderTreeAsText"), v8::FunctionTemplate::New(InternalsV8Internal::elementRenderTreeAsTextCallback, v8::Handle<v8::Value>(), elementRenderTreeAsTextSignature));

    // Custom Signature 'isPreloaded'
    const int isPreloadedArgc = 2;
    v8::Handle<v8::FunctionTemplate> isPreloadedArgv[isPreloadedArgc] = { V8Document::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> isPreloadedSignature = v8::Signature::New(desc, isPreloadedArgc, isPreloadedArgv);
    proto->Set(v8::String::New("isPreloaded"), v8::FunctionTemplate::New(InternalsV8Internal::isPreloadedCallback, v8::Handle<v8::Value>(), isPreloadedSignature));

    // Custom Signature 'numberOfScopedHTMLStyleChildren'
    const int numberOfScopedHTMLStyleChildrenArgc = 1;
    v8::Handle<v8::FunctionTemplate> numberOfScopedHTMLStyleChildrenArgv[numberOfScopedHTMLStyleChildrenArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> numberOfScopedHTMLStyleChildrenSignature = v8::Signature::New(desc, numberOfScopedHTMLStyleChildrenArgc, numberOfScopedHTMLStyleChildrenArgv);
    proto->Set(v8::String::New("numberOfScopedHTMLStyleChildren"), v8::FunctionTemplate::New(InternalsV8Internal::numberOfScopedHTMLStyleChildrenCallback, v8::Handle<v8::Value>(), numberOfScopedHTMLStyleChildrenSignature));

    // Custom Signature 'ensureShadowRoot'
    const int ensureShadowRootArgc = 1;
    v8::Handle<v8::FunctionTemplate> ensureShadowRootArgv[ensureShadowRootArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> ensureShadowRootSignature = v8::Signature::New(desc, ensureShadowRootArgc, ensureShadowRootArgv);
    proto->Set(v8::String::New("ensureShadowRoot"), v8::FunctionTemplate::New(InternalsV8Internal::ensureShadowRootCallback, v8::Handle<v8::Value>(), ensureShadowRootSignature));

    // Custom Signature 'shadowRoot'
    const int shadowRootArgc = 1;
    v8::Handle<v8::FunctionTemplate> shadowRootArgv[shadowRootArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> shadowRootSignature = v8::Signature::New(desc, shadowRootArgc, shadowRootArgv);
    proto->Set(v8::String::New("shadowRoot"), v8::FunctionTemplate::New(InternalsV8Internal::shadowRootCallback, v8::Handle<v8::Value>(), shadowRootSignature));

    // Custom Signature 'youngestShadowRoot'
    const int youngestShadowRootArgc = 1;
    v8::Handle<v8::FunctionTemplate> youngestShadowRootArgv[youngestShadowRootArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> youngestShadowRootSignature = v8::Signature::New(desc, youngestShadowRootArgc, youngestShadowRootArgv);
    proto->Set(v8::String::New("youngestShadowRoot"), v8::FunctionTemplate::New(InternalsV8Internal::youngestShadowRootCallback, v8::Handle<v8::Value>(), youngestShadowRootSignature));

    // Custom Signature 'oldestShadowRoot'
    const int oldestShadowRootArgc = 1;
    v8::Handle<v8::FunctionTemplate> oldestShadowRootArgv[oldestShadowRootArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> oldestShadowRootSignature = v8::Signature::New(desc, oldestShadowRootArgc, oldestShadowRootArgv);
    proto->Set(v8::String::New("oldestShadowRoot"), v8::FunctionTemplate::New(InternalsV8Internal::oldestShadowRootCallback, v8::Handle<v8::Value>(), oldestShadowRootSignature));

    // Custom Signature 'youngerShadowRoot'
    const int youngerShadowRootArgc = 1;
    v8::Handle<v8::FunctionTemplate> youngerShadowRootArgv[youngerShadowRootArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> youngerShadowRootSignature = v8::Signature::New(desc, youngerShadowRootArgc, youngerShadowRootArgv);
    proto->Set(v8::String::New("youngerShadowRoot"), v8::FunctionTemplate::New(InternalsV8Internal::youngerShadowRootCallback, v8::Handle<v8::Value>(), youngerShadowRootSignature));

    // Custom Signature 'olderShadowRoot'
    const int olderShadowRootArgc = 1;
    v8::Handle<v8::FunctionTemplate> olderShadowRootArgv[olderShadowRootArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> olderShadowRootSignature = v8::Signature::New(desc, olderShadowRootArgc, olderShadowRootArgv);
    proto->Set(v8::String::New("olderShadowRoot"), v8::FunctionTemplate::New(InternalsV8Internal::olderShadowRootCallback, v8::Handle<v8::Value>(), olderShadowRootSignature));

    // Custom Signature 'includerFor'
    const int includerForArgc = 1;
    v8::Handle<v8::FunctionTemplate> includerForArgv[includerForArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> includerForSignature = v8::Signature::New(desc, includerForArgc, includerForArgv);
    proto->Set(v8::String::New("includerFor"), v8::FunctionTemplate::New(InternalsV8Internal::includerForCallback, v8::Handle<v8::Value>(), includerForSignature));

    // Custom Signature 'shadowPseudoId'
    const int shadowPseudoIdArgc = 1;
    v8::Handle<v8::FunctionTemplate> shadowPseudoIdArgv[shadowPseudoIdArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> shadowPseudoIdSignature = v8::Signature::New(desc, shadowPseudoIdArgc, shadowPseudoIdArgv);
    proto->Set(v8::String::New("shadowPseudoId"), v8::FunctionTemplate::New(InternalsV8Internal::shadowPseudoIdCallback, v8::Handle<v8::Value>(), shadowPseudoIdSignature));

    // Custom Signature 'setShadowPseudoId'
    const int setShadowPseudoIdArgc = 2;
    v8::Handle<v8::FunctionTemplate> setShadowPseudoIdArgv[setShadowPseudoIdArgc] = { V8Element::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> setShadowPseudoIdSignature = v8::Signature::New(desc, setShadowPseudoIdArgc, setShadowPseudoIdArgv);
    proto->Set(v8::String::New("setShadowPseudoId"), v8::FunctionTemplate::New(InternalsV8Internal::setShadowPseudoIdCallback, v8::Handle<v8::Value>(), setShadowPseudoIdSignature));

    // Custom Signature 'createContentElement'
    const int createContentElementArgc = 1;
    v8::Handle<v8::FunctionTemplate> createContentElementArgv[createContentElementArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> createContentElementSignature = v8::Signature::New(desc, createContentElementArgc, createContentElementArgv);
    proto->Set(v8::String::New("createContentElement"), v8::FunctionTemplate::New(InternalsV8Internal::createContentElementCallback, v8::Handle<v8::Value>(), createContentElementSignature));

    // Custom Signature 'getElementByIdInShadowRoot'
    const int getElementByIdInShadowRootArgc = 2;
    v8::Handle<v8::FunctionTemplate> getElementByIdInShadowRootArgv[getElementByIdInShadowRootArgc] = { V8Node::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> getElementByIdInShadowRootSignature = v8::Signature::New(desc, getElementByIdInShadowRootArgc, getElementByIdInShadowRootArgv);
    proto->Set(v8::String::New("getElementByIdInShadowRoot"), v8::FunctionTemplate::New(InternalsV8Internal::getElementByIdInShadowRootCallback, v8::Handle<v8::Value>(), getElementByIdInShadowRootSignature));

    // Custom Signature 'isValidContentSelect'
    const int isValidContentSelectArgc = 1;
    v8::Handle<v8::FunctionTemplate> isValidContentSelectArgv[isValidContentSelectArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> isValidContentSelectSignature = v8::Signature::New(desc, isValidContentSelectArgc, isValidContentSelectArgv);
    proto->Set(v8::String::New("isValidContentSelect"), v8::FunctionTemplate::New(InternalsV8Internal::isValidContentSelectCallback, v8::Handle<v8::Value>(), isValidContentSelectSignature));

    // Custom Signature 'treeScopeRootNode'
    const int treeScopeRootNodeArgc = 1;
    v8::Handle<v8::FunctionTemplate> treeScopeRootNodeArgv[treeScopeRootNodeArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> treeScopeRootNodeSignature = v8::Signature::New(desc, treeScopeRootNodeArgc, treeScopeRootNodeArgv);
    proto->Set(v8::String::New("treeScopeRootNode"), v8::FunctionTemplate::New(InternalsV8Internal::treeScopeRootNodeCallback, v8::Handle<v8::Value>(), treeScopeRootNodeSignature));

    // Custom Signature 'parentTreeScope'
    const int parentTreeScopeArgc = 1;
    v8::Handle<v8::FunctionTemplate> parentTreeScopeArgv[parentTreeScopeArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> parentTreeScopeSignature = v8::Signature::New(desc, parentTreeScopeArgc, parentTreeScopeArgv);
    proto->Set(v8::String::New("parentTreeScope"), v8::FunctionTemplate::New(InternalsV8Internal::parentTreeScopeCallback, v8::Handle<v8::Value>(), parentTreeScopeSignature));

    // Custom Signature 'nextSiblingByWalker'
    const int nextSiblingByWalkerArgc = 1;
    v8::Handle<v8::FunctionTemplate> nextSiblingByWalkerArgv[nextSiblingByWalkerArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> nextSiblingByWalkerSignature = v8::Signature::New(desc, nextSiblingByWalkerArgc, nextSiblingByWalkerArgv);
    proto->Set(v8::String::New("nextSiblingByWalker"), v8::FunctionTemplate::New(InternalsV8Internal::nextSiblingByWalkerCallback, v8::Handle<v8::Value>(), nextSiblingByWalkerSignature));

    // Custom Signature 'firstChildByWalker'
    const int firstChildByWalkerArgc = 1;
    v8::Handle<v8::FunctionTemplate> firstChildByWalkerArgv[firstChildByWalkerArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> firstChildByWalkerSignature = v8::Signature::New(desc, firstChildByWalkerArgc, firstChildByWalkerArgv);
    proto->Set(v8::String::New("firstChildByWalker"), v8::FunctionTemplate::New(InternalsV8Internal::firstChildByWalkerCallback, v8::Handle<v8::Value>(), firstChildByWalkerSignature));

    // Custom Signature 'lastChildByWalker'
    const int lastChildByWalkerArgc = 1;
    v8::Handle<v8::FunctionTemplate> lastChildByWalkerArgv[lastChildByWalkerArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> lastChildByWalkerSignature = v8::Signature::New(desc, lastChildByWalkerArgc, lastChildByWalkerArgv);
    proto->Set(v8::String::New("lastChildByWalker"), v8::FunctionTemplate::New(InternalsV8Internal::lastChildByWalkerCallback, v8::Handle<v8::Value>(), lastChildByWalkerSignature));

    // Custom Signature 'nextNodeByWalker'
    const int nextNodeByWalkerArgc = 1;
    v8::Handle<v8::FunctionTemplate> nextNodeByWalkerArgv[nextNodeByWalkerArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> nextNodeByWalkerSignature = v8::Signature::New(desc, nextNodeByWalkerArgc, nextNodeByWalkerArgv);
    proto->Set(v8::String::New("nextNodeByWalker"), v8::FunctionTemplate::New(InternalsV8Internal::nextNodeByWalkerCallback, v8::Handle<v8::Value>(), nextNodeByWalkerSignature));

    // Custom Signature 'previousNodeByWalker'
    const int previousNodeByWalkerArgc = 1;
    v8::Handle<v8::FunctionTemplate> previousNodeByWalkerArgv[previousNodeByWalkerArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> previousNodeByWalkerSignature = v8::Signature::New(desc, previousNodeByWalkerArgc, previousNodeByWalkerArgv);
    proto->Set(v8::String::New("previousNodeByWalker"), v8::FunctionTemplate::New(InternalsV8Internal::previousNodeByWalkerCallback, v8::Handle<v8::Value>(), previousNodeByWalkerSignature));

    // Custom Signature 'attached'
    const int attachedArgc = 1;
    v8::Handle<v8::FunctionTemplate> attachedArgv[attachedArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> attachedSignature = v8::Signature::New(desc, attachedArgc, attachedArgv);
    proto->Set(v8::String::New("attached"), v8::FunctionTemplate::New(InternalsV8Internal::attachedCallback, v8::Handle<v8::Value>(), attachedSignature));

    // Custom Signature 'visiblePlaceholder'
    const int visiblePlaceholderArgc = 1;
    v8::Handle<v8::FunctionTemplate> visiblePlaceholderArgv[visiblePlaceholderArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> visiblePlaceholderSignature = v8::Signature::New(desc, visiblePlaceholderArgc, visiblePlaceholderArgv);
    proto->Set(v8::String::New("visiblePlaceholder"), v8::FunctionTemplate::New(InternalsV8Internal::visiblePlaceholderCallback, v8::Handle<v8::Value>(), visiblePlaceholderSignature));

    // Custom Signature 'selectColorInColorChooser'
    const int selectColorInColorChooserArgc = 2;
    v8::Handle<v8::FunctionTemplate> selectColorInColorChooserArgv[selectColorInColorChooserArgc] = { V8Element::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> selectColorInColorChooserSignature = v8::Signature::New(desc, selectColorInColorChooserArgc, selectColorInColorChooserArgv);
    proto->Set(v8::String::New("selectColorInColorChooser"), v8::FunctionTemplate::New(InternalsV8Internal::selectColorInColorChooserCallback, v8::Handle<v8::Value>(), selectColorInColorChooserSignature));

    // Custom Signature 'absoluteCaretBounds'
    const int absoluteCaretBoundsArgc = 1;
    v8::Handle<v8::FunctionTemplate> absoluteCaretBoundsArgv[absoluteCaretBoundsArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> absoluteCaretBoundsSignature = v8::Signature::New(desc, absoluteCaretBoundsArgc, absoluteCaretBoundsArgv);
    proto->Set(v8::String::New("absoluteCaretBounds"), v8::FunctionTemplate::New(InternalsV8Internal::absoluteCaretBoundsCallback, v8::Handle<v8::Value>(), absoluteCaretBoundsSignature));

    // Custom Signature 'boundingBox'
    const int boundingBoxArgc = 1;
    v8::Handle<v8::FunctionTemplate> boundingBoxArgv[boundingBoxArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> boundingBoxSignature = v8::Signature::New(desc, boundingBoxArgc, boundingBoxArgv);
    proto->Set(v8::String::New("boundingBox"), v8::FunctionTemplate::New(InternalsV8Internal::boundingBoxCallback, v8::Handle<v8::Value>(), boundingBoxSignature));

    // Custom Signature 'inspectorHighlightRects'
    const int inspectorHighlightRectsArgc = 1;
    v8::Handle<v8::FunctionTemplate> inspectorHighlightRectsArgv[inspectorHighlightRectsArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> inspectorHighlightRectsSignature = v8::Signature::New(desc, inspectorHighlightRectsArgc, inspectorHighlightRectsArgv);
    proto->Set(v8::String::New("inspectorHighlightRects"), v8::FunctionTemplate::New(InternalsV8Internal::inspectorHighlightRectsCallback, v8::Handle<v8::Value>(), inspectorHighlightRectsSignature));

    // Custom Signature 'setBackgroundBlurOnNode'
    const int setBackgroundBlurOnNodeArgc = 2;
    v8::Handle<v8::FunctionTemplate> setBackgroundBlurOnNodeArgv[setBackgroundBlurOnNodeArgc] = { V8Node::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> setBackgroundBlurOnNodeSignature = v8::Signature::New(desc, setBackgroundBlurOnNodeArgc, setBackgroundBlurOnNodeArgv);
    proto->Set(v8::String::New("setBackgroundBlurOnNode"), v8::FunctionTemplate::New(InternalsV8Internal::setBackgroundBlurOnNodeCallback, v8::Handle<v8::Value>(), setBackgroundBlurOnNodeSignature));

    // Custom Signature 'markerCountForNode'
    const int markerCountForNodeArgc = 2;
    v8::Handle<v8::FunctionTemplate> markerCountForNodeArgv[markerCountForNodeArgc] = { V8Node::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> markerCountForNodeSignature = v8::Signature::New(desc, markerCountForNodeArgc, markerCountForNodeArgv);
    proto->Set(v8::String::New("markerCountForNode"), v8::FunctionTemplate::New(InternalsV8Internal::markerCountForNodeCallback, v8::Handle<v8::Value>(), markerCountForNodeSignature));

    // Custom Signature 'markerRangeForNode'
    const int markerRangeForNodeArgc = 3;
    v8::Handle<v8::FunctionTemplate> markerRangeForNodeArgv[markerRangeForNodeArgc] = { V8Node::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> markerRangeForNodeSignature = v8::Signature::New(desc, markerRangeForNodeArgc, markerRangeForNodeArgv);
    proto->Set(v8::String::New("markerRangeForNode"), v8::FunctionTemplate::New(InternalsV8Internal::markerRangeForNodeCallback, v8::Handle<v8::Value>(), markerRangeForNodeSignature));

    // Custom Signature 'markerDescriptionForNode'
    const int markerDescriptionForNodeArgc = 3;
    v8::Handle<v8::FunctionTemplate> markerDescriptionForNodeArgv[markerDescriptionForNodeArgc] = { V8Node::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> markerDescriptionForNodeSignature = v8::Signature::New(desc, markerDescriptionForNodeArgc, markerDescriptionForNodeArgv);
    proto->Set(v8::String::New("markerDescriptionForNode"), v8::FunctionTemplate::New(InternalsV8Internal::markerDescriptionForNodeCallback, v8::Handle<v8::Value>(), markerDescriptionForNodeSignature));

    // Custom Signature 'setScrollViewPosition'
    const int setScrollViewPositionArgc = 3;
    v8::Handle<v8::FunctionTemplate> setScrollViewPositionArgv[setScrollViewPositionArgc] = { V8Document::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> setScrollViewPositionSignature = v8::Signature::New(desc, setScrollViewPositionArgc, setScrollViewPositionArgv);
    proto->Set(v8::String::New("setScrollViewPosition"), v8::FunctionTemplate::New(InternalsV8Internal::setScrollViewPositionCallback, v8::Handle<v8::Value>(), setScrollViewPositionSignature));

    // Custom Signature 'setPagination'
    const int setPaginationArgc = 3;
    v8::Handle<v8::FunctionTemplate> setPaginationArgv[setPaginationArgc] = { V8Document::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> setPaginationSignature = v8::Signature::New(desc, setPaginationArgc, setPaginationArgv);
    proto->Set(v8::String::New("setPagination"), v8::FunctionTemplate::New(InternalsV8Internal::setPaginationCallback, v8::Handle<v8::Value>(), setPaginationSignature));

    // Custom Signature 'wasLastChangeUserEdit'
    const int wasLastChangeUserEditArgc = 1;
    v8::Handle<v8::FunctionTemplate> wasLastChangeUserEditArgv[wasLastChangeUserEditArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> wasLastChangeUserEditSignature = v8::Signature::New(desc, wasLastChangeUserEditArgc, wasLastChangeUserEditArgv);
    proto->Set(v8::String::New("wasLastChangeUserEdit"), v8::FunctionTemplate::New(InternalsV8Internal::wasLastChangeUserEditCallback, v8::Handle<v8::Value>(), wasLastChangeUserEditSignature));

    // Custom Signature 'suggestedValue'
    const int suggestedValueArgc = 1;
    v8::Handle<v8::FunctionTemplate> suggestedValueArgv[suggestedValueArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> suggestedValueSignature = v8::Signature::New(desc, suggestedValueArgc, suggestedValueArgv);
    proto->Set(v8::String::New("suggestedValue"), v8::FunctionTemplate::New(InternalsV8Internal::suggestedValueCallback, v8::Handle<v8::Value>(), suggestedValueSignature));

    // Custom Signature 'setSuggestedValue'
    const int setSuggestedValueArgc = 2;
    v8::Handle<v8::FunctionTemplate> setSuggestedValueArgv[setSuggestedValueArgc] = { V8Element::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> setSuggestedValueSignature = v8::Signature::New(desc, setSuggestedValueArgc, setSuggestedValueArgv);
    proto->Set(v8::String::New("setSuggestedValue"), v8::FunctionTemplate::New(InternalsV8Internal::setSuggestedValueCallback, v8::Handle<v8::Value>(), setSuggestedValueSignature));

    // Custom Signature 'setEditingValue'
    const int setEditingValueArgc = 2;
    v8::Handle<v8::FunctionTemplate> setEditingValueArgv[setEditingValueArgc] = { V8Element::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> setEditingValueSignature = v8::Signature::New(desc, setEditingValueArgc, setEditingValueArgv);
    proto->Set(v8::String::New("setEditingValue"), v8::FunctionTemplate::New(InternalsV8Internal::setEditingValueCallback, v8::Handle<v8::Value>(), setEditingValueSignature));

    // Custom Signature 'paintControlTints'
    const int paintControlTintsArgc = 1;
    v8::Handle<v8::FunctionTemplate> paintControlTintsArgv[paintControlTintsArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> paintControlTintsSignature = v8::Signature::New(desc, paintControlTintsArgc, paintControlTintsArgv);
    proto->Set(v8::String::New("paintControlTints"), v8::FunctionTemplate::New(InternalsV8Internal::paintControlTintsCallback, v8::Handle<v8::Value>(), paintControlTintsSignature));

    // Custom Signature 'scrollElementToRect'
    const int scrollElementToRectArgc = 5;
    v8::Handle<v8::FunctionTemplate> scrollElementToRectArgv[scrollElementToRectArgc] = { V8Element::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> scrollElementToRectSignature = v8::Signature::New(desc, scrollElementToRectArgc, scrollElementToRectArgv);
    proto->Set(v8::String::New("scrollElementToRect"), v8::FunctionTemplate::New(InternalsV8Internal::scrollElementToRectCallback, v8::Handle<v8::Value>(), scrollElementToRectSignature));

    // Custom Signature 'rangeFromLocationAndLength'
    const int rangeFromLocationAndLengthArgc = 3;
    v8::Handle<v8::FunctionTemplate> rangeFromLocationAndLengthArgv[rangeFromLocationAndLengthArgc] = { V8Element::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> rangeFromLocationAndLengthSignature = v8::Signature::New(desc, rangeFromLocationAndLengthArgc, rangeFromLocationAndLengthArgv);
    proto->Set(v8::String::New("rangeFromLocationAndLength"), v8::FunctionTemplate::New(InternalsV8Internal::rangeFromLocationAndLengthCallback, v8::Handle<v8::Value>(), rangeFromLocationAndLengthSignature));

    // Custom Signature 'locationFromRange'
    const int locationFromRangeArgc = 2;
    v8::Handle<v8::FunctionTemplate> locationFromRangeArgv[locationFromRangeArgc] = { V8Element::GetRawTemplate(), V8Range::GetRawTemplate() };
    v8::Handle<v8::Signature> locationFromRangeSignature = v8::Signature::New(desc, locationFromRangeArgc, locationFromRangeArgv);
    proto->Set(v8::String::New("locationFromRange"), v8::FunctionTemplate::New(InternalsV8Internal::locationFromRangeCallback, v8::Handle<v8::Value>(), locationFromRangeSignature));

    // Custom Signature 'lengthFromRange'
    const int lengthFromRangeArgc = 2;
    v8::Handle<v8::FunctionTemplate> lengthFromRangeArgv[lengthFromRangeArgc] = { V8Element::GetRawTemplate(), V8Range::GetRawTemplate() };
    v8::Handle<v8::Signature> lengthFromRangeSignature = v8::Signature::New(desc, lengthFromRangeArgc, lengthFromRangeArgv);
    proto->Set(v8::String::New("lengthFromRange"), v8::FunctionTemplate::New(InternalsV8Internal::lengthFromRangeCallback, v8::Handle<v8::Value>(), lengthFromRangeSignature));

    // Custom Signature 'rangeAsText'
    const int rangeAsTextArgc = 1;
    v8::Handle<v8::FunctionTemplate> rangeAsTextArgv[rangeAsTextArgc] = { V8Range::GetRawTemplate() };
    v8::Handle<v8::Signature> rangeAsTextSignature = v8::Signature::New(desc, rangeAsTextArgc, rangeAsTextArgv);
    proto->Set(v8::String::New("rangeAsText"), v8::FunctionTemplate::New(InternalsV8Internal::rangeAsTextCallback, v8::Handle<v8::Value>(), rangeAsTextSignature));

    // Custom Signature 'setDelegatesScrolling'
    const int setDelegatesScrollingArgc = 2;
    v8::Handle<v8::FunctionTemplate> setDelegatesScrollingArgv[setDelegatesScrollingArgc] = { v8::Handle<v8::FunctionTemplate>(), V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> setDelegatesScrollingSignature = v8::Signature::New(desc, setDelegatesScrollingArgc, setDelegatesScrollingArgv);
    proto->Set(v8::String::New("setDelegatesScrolling"), v8::FunctionTemplate::New(InternalsV8Internal::setDelegatesScrollingCallback, v8::Handle<v8::Value>(), setDelegatesScrollingSignature));

    // Custom Signature 'touchPositionAdjustedToBestClickableNode'
    const int touchPositionAdjustedToBestClickableNodeArgc = 5;
    v8::Handle<v8::FunctionTemplate> touchPositionAdjustedToBestClickableNodeArgv[touchPositionAdjustedToBestClickableNodeArgc] = { v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> touchPositionAdjustedToBestClickableNodeSignature = v8::Signature::New(desc, touchPositionAdjustedToBestClickableNodeArgc, touchPositionAdjustedToBestClickableNodeArgv);
    proto->Set(v8::String::New("touchPositionAdjustedToBestClickableNode"), v8::FunctionTemplate::New(InternalsV8Internal::touchPositionAdjustedToBestClickableNodeCallback, v8::Handle<v8::Value>(), touchPositionAdjustedToBestClickableNodeSignature));

    // Custom Signature 'touchNodeAdjustedToBestClickableNode'
    const int touchNodeAdjustedToBestClickableNodeArgc = 5;
    v8::Handle<v8::FunctionTemplate> touchNodeAdjustedToBestClickableNodeArgv[touchNodeAdjustedToBestClickableNodeArgc] = { v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> touchNodeAdjustedToBestClickableNodeSignature = v8::Signature::New(desc, touchNodeAdjustedToBestClickableNodeArgc, touchNodeAdjustedToBestClickableNodeArgv);
    proto->Set(v8::String::New("touchNodeAdjustedToBestClickableNode"), v8::FunctionTemplate::New(InternalsV8Internal::touchNodeAdjustedToBestClickableNodeCallback, v8::Handle<v8::Value>(), touchNodeAdjustedToBestClickableNodeSignature));

    // Custom Signature 'bestZoomableAreaForTouchPoint'
    const int bestZoomableAreaForTouchPointArgc = 5;
    v8::Handle<v8::FunctionTemplate> bestZoomableAreaForTouchPointArgv[bestZoomableAreaForTouchPointArgc] = { v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> bestZoomableAreaForTouchPointSignature = v8::Signature::New(desc, bestZoomableAreaForTouchPointArgc, bestZoomableAreaForTouchPointArgv);
    proto->Set(v8::String::New("bestZoomableAreaForTouchPoint"), v8::FunctionTemplate::New(InternalsV8Internal::bestZoomableAreaForTouchPointCallback, v8::Handle<v8::Value>(), bestZoomableAreaForTouchPointSignature));

    // Custom Signature 'lastSpellCheckRequestSequence'
    const int lastSpellCheckRequestSequenceArgc = 1;
    v8::Handle<v8::FunctionTemplate> lastSpellCheckRequestSequenceArgv[lastSpellCheckRequestSequenceArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> lastSpellCheckRequestSequenceSignature = v8::Signature::New(desc, lastSpellCheckRequestSequenceArgc, lastSpellCheckRequestSequenceArgv);
    proto->Set(v8::String::New("lastSpellCheckRequestSequence"), v8::FunctionTemplate::New(InternalsV8Internal::lastSpellCheckRequestSequenceCallback, v8::Handle<v8::Value>(), lastSpellCheckRequestSequenceSignature));

    // Custom Signature 'lastSpellCheckProcessedSequence'
    const int lastSpellCheckProcessedSequenceArgc = 1;
    v8::Handle<v8::FunctionTemplate> lastSpellCheckProcessedSequenceArgv[lastSpellCheckProcessedSequenceArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> lastSpellCheckProcessedSequenceSignature = v8::Signature::New(desc, lastSpellCheckProcessedSequenceArgc, lastSpellCheckProcessedSequenceArgv);
    proto->Set(v8::String::New("lastSpellCheckProcessedSequence"), v8::FunctionTemplate::New(InternalsV8Internal::lastSpellCheckProcessedSequenceCallback, v8::Handle<v8::Value>(), lastSpellCheckProcessedSequenceSignature));

    // Custom Signature 'setShouldDisplayTrackKind'
    const int setShouldDisplayTrackKindArgc = 3;
    v8::Handle<v8::FunctionTemplate> setShouldDisplayTrackKindArgv[setShouldDisplayTrackKindArgc] = { V8Document::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> setShouldDisplayTrackKindSignature = v8::Signature::New(desc, setShouldDisplayTrackKindArgc, setShouldDisplayTrackKindArgv);
    proto->Set(v8::String::New("setShouldDisplayTrackKind"), v8::FunctionTemplate::New(InternalsV8Internal::setShouldDisplayTrackKindCallback, v8::Handle<v8::Value>(), setShouldDisplayTrackKindSignature));

    // Custom Signature 'shouldDisplayTrackKind'
    const int shouldDisplayTrackKindArgc = 2;
    v8::Handle<v8::FunctionTemplate> shouldDisplayTrackKindArgv[shouldDisplayTrackKindArgc] = { V8Document::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> shouldDisplayTrackKindSignature = v8::Signature::New(desc, shouldDisplayTrackKindArgc, shouldDisplayTrackKindArgv);
    proto->Set(v8::String::New("shouldDisplayTrackKind"), v8::FunctionTemplate::New(InternalsV8Internal::shouldDisplayTrackKindCallback, v8::Handle<v8::Value>(), shouldDisplayTrackKindSignature));

    // Custom Signature 'setUserPreferredLanguages'
    const int setUserPreferredLanguagesArgc = 1;
    v8::Handle<v8::FunctionTemplate> setUserPreferredLanguagesArgv[setUserPreferredLanguagesArgc] = { v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> setUserPreferredLanguagesSignature = v8::Signature::New(desc, setUserPreferredLanguagesArgc, setUserPreferredLanguagesArgv);
    proto->Set(v8::String::New("setUserPreferredLanguages"), v8::FunctionTemplate::New(InternalsV8Internal::setUserPreferredLanguagesCallback, v8::Handle<v8::Value>(), setUserPreferredLanguagesSignature));

    // Custom Signature 'wheelEventHandlerCount'
    const int wheelEventHandlerCountArgc = 1;
    v8::Handle<v8::FunctionTemplate> wheelEventHandlerCountArgv[wheelEventHandlerCountArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> wheelEventHandlerCountSignature = v8::Signature::New(desc, wheelEventHandlerCountArgc, wheelEventHandlerCountArgv);
    proto->Set(v8::String::New("wheelEventHandlerCount"), v8::FunctionTemplate::New(InternalsV8Internal::wheelEventHandlerCountCallback, v8::Handle<v8::Value>(), wheelEventHandlerCountSignature));

    // Custom Signature 'touchEventHandlerCount'
    const int touchEventHandlerCountArgc = 1;
    v8::Handle<v8::FunctionTemplate> touchEventHandlerCountArgv[touchEventHandlerCountArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> touchEventHandlerCountSignature = v8::Signature::New(desc, touchEventHandlerCountArgc, touchEventHandlerCountArgv);
    proto->Set(v8::String::New("touchEventHandlerCount"), v8::FunctionTemplate::New(InternalsV8Internal::touchEventHandlerCountCallback, v8::Handle<v8::Value>(), touchEventHandlerCountSignature));

    // Custom Signature 'nodesFromRect'
    const int nodesFromRectArgc = 9;
    v8::Handle<v8::FunctionTemplate> nodesFromRectArgv[nodesFromRectArgc] = { V8Document::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> nodesFromRectSignature = v8::Signature::New(desc, nodesFromRectArgc, nodesFromRectArgv);
    proto->Set(v8::String::New("nodesFromRect"), v8::FunctionTemplate::New(InternalsV8Internal::nodesFromRectCallback, v8::Handle<v8::Value>(), nodesFromRectSignature));

    // Custom Signature 'hasSpellingMarker'
    const int hasSpellingMarkerArgc = 3;
    v8::Handle<v8::FunctionTemplate> hasSpellingMarkerArgv[hasSpellingMarkerArgc] = { V8Document::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> hasSpellingMarkerSignature = v8::Signature::New(desc, hasSpellingMarkerArgc, hasSpellingMarkerArgv);
    proto->Set(v8::String::New("hasSpellingMarker"), v8::FunctionTemplate::New(InternalsV8Internal::hasSpellingMarkerCallback, v8::Handle<v8::Value>(), hasSpellingMarkerSignature));

    // Custom Signature 'hasGrammarMarker'
    const int hasGrammarMarkerArgc = 3;
    v8::Handle<v8::FunctionTemplate> hasGrammarMarkerArgv[hasGrammarMarkerArgc] = { V8Document::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> hasGrammarMarkerSignature = v8::Signature::New(desc, hasGrammarMarkerArgc, hasGrammarMarkerArgv);
    proto->Set(v8::String::New("hasGrammarMarker"), v8::FunctionTemplate::New(InternalsV8Internal::hasGrammarMarkerCallback, v8::Handle<v8::Value>(), hasGrammarMarkerSignature));

    // Custom Signature 'hasAutocorrectedMarker'
    const int hasAutocorrectedMarkerArgc = 3;
    v8::Handle<v8::FunctionTemplate> hasAutocorrectedMarkerArgv[hasAutocorrectedMarkerArgc] = { V8Document::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> hasAutocorrectedMarkerSignature = v8::Signature::New(desc, hasAutocorrectedMarkerArgc, hasAutocorrectedMarkerArgv);
    proto->Set(v8::String::New("hasAutocorrectedMarker"), v8::FunctionTemplate::New(InternalsV8Internal::hasAutocorrectedMarkerCallback, v8::Handle<v8::Value>(), hasAutocorrectedMarkerSignature));

    // Custom Signature 'numberOfScrollableAreas'
    const int numberOfScrollableAreasArgc = 1;
    v8::Handle<v8::FunctionTemplate> numberOfScrollableAreasArgv[numberOfScrollableAreasArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> numberOfScrollableAreasSignature = v8::Signature::New(desc, numberOfScrollableAreasArgc, numberOfScrollableAreasArgv);
    proto->Set(v8::String::New("numberOfScrollableAreas"), v8::FunctionTemplate::New(InternalsV8Internal::numberOfScrollableAreasCallback, v8::Handle<v8::Value>(), numberOfScrollableAreasSignature));

    // Custom Signature 'isPageBoxVisible'
    const int isPageBoxVisibleArgc = 2;
    v8::Handle<v8::FunctionTemplate> isPageBoxVisibleArgv[isPageBoxVisibleArgc] = { V8Document::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> isPageBoxVisibleSignature = v8::Signature::New(desc, isPageBoxVisibleArgc, isPageBoxVisibleArgv);
    proto->Set(v8::String::New("isPageBoxVisible"), v8::FunctionTemplate::New(InternalsV8Internal::isPageBoxVisibleCallback, v8::Handle<v8::Value>(), isPageBoxVisibleSignature));

    // Custom Signature 'suspendAnimations'
    const int suspendAnimationsArgc = 1;
    v8::Handle<v8::FunctionTemplate> suspendAnimationsArgv[suspendAnimationsArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> suspendAnimationsSignature = v8::Signature::New(desc, suspendAnimationsArgc, suspendAnimationsArgv);
    proto->Set(v8::String::New("suspendAnimations"), v8::FunctionTemplate::New(InternalsV8Internal::suspendAnimationsCallback, v8::Handle<v8::Value>(), suspendAnimationsSignature));

    // Custom Signature 'resumeAnimations'
    const int resumeAnimationsArgc = 1;
    v8::Handle<v8::FunctionTemplate> resumeAnimationsArgv[resumeAnimationsArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> resumeAnimationsSignature = v8::Signature::New(desc, resumeAnimationsArgc, resumeAnimationsArgv);
    proto->Set(v8::String::New("resumeAnimations"), v8::FunctionTemplate::New(InternalsV8Internal::resumeAnimationsCallback, v8::Handle<v8::Value>(), resumeAnimationsSignature));

    // Custom Signature 'consoleMessageArgumentCounts'
    const int consoleMessageArgumentCountsArgc = 1;
    v8::Handle<v8::FunctionTemplate> consoleMessageArgumentCountsArgv[consoleMessageArgumentCountsArgc] = { V8Document::GetRawTemplate() };
    v8::Handle<v8::Signature> consoleMessageArgumentCountsSignature = v8::Signature::New(desc, consoleMessageArgumentCountsArgc, consoleMessageArgumentCountsArgv);
#if ENABLE(INSPECTOR)
    proto->Set(v8::String::New("consoleMessageArgumentCounts"), v8::FunctionTemplate::New(InternalsV8Internal::consoleMessageArgumentCountsCallback, v8::Handle<v8::Value>(), consoleMessageArgumentCountsSignature));
#endif // ENABLE(INSPECTOR)

    // Custom Signature 'counterValue'
    const int counterValueArgc = 1;
    v8::Handle<v8::FunctionTemplate> counterValueArgv[counterValueArgc] = { V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> counterValueSignature = v8::Signature::New(desc, counterValueArgc, counterValueArgv);
    proto->Set(v8::String::New("counterValue"), v8::FunctionTemplate::New(InternalsV8Internal::counterValueCallback, v8::Handle<v8::Value>(), counterValueSignature));

    // Custom Signature 'webkitWillEnterFullScreenForElement'
    const int webkitWillEnterFullScreenForElementArgc = 2;
    v8::Handle<v8::FunctionTemplate> webkitWillEnterFullScreenForElementArgv[webkitWillEnterFullScreenForElementArgc] = { V8Document::GetRawTemplate(), V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> webkitWillEnterFullScreenForElementSignature = v8::Signature::New(desc, webkitWillEnterFullScreenForElementArgc, webkitWillEnterFullScreenForElementArgv);
    proto->Set(v8::String::New("webkitWillEnterFullScreenForElement"), v8::FunctionTemplate::New(InternalsV8Internal::webkitWillEnterFullScreenForElementCallback, v8::Handle<v8::Value>(), webkitWillEnterFullScreenForElementSignature));

    // Custom Signature 'webkitDidEnterFullScreenForElement'
    const int webkitDidEnterFullScreenForElementArgc = 2;
    v8::Handle<v8::FunctionTemplate> webkitDidEnterFullScreenForElementArgv[webkitDidEnterFullScreenForElementArgc] = { V8Document::GetRawTemplate(), V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> webkitDidEnterFullScreenForElementSignature = v8::Signature::New(desc, webkitDidEnterFullScreenForElementArgc, webkitDidEnterFullScreenForElementArgv);
    proto->Set(v8::String::New("webkitDidEnterFullScreenForElement"), v8::FunctionTemplate::New(InternalsV8Internal::webkitDidEnterFullScreenForElementCallback, v8::Handle<v8::Value>(), webkitDidEnterFullScreenForElementSignature));

    // Custom Signature 'webkitWillExitFullScreenForElement'
    const int webkitWillExitFullScreenForElementArgc = 2;
    v8::Handle<v8::FunctionTemplate> webkitWillExitFullScreenForElementArgv[webkitWillExitFullScreenForElementArgc] = { V8Document::GetRawTemplate(), V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> webkitWillExitFullScreenForElementSignature = v8::Signature::New(desc, webkitWillExitFullScreenForElementArgc, webkitWillExitFullScreenForElementArgv);
    proto->Set(v8::String::New("webkitWillExitFullScreenForElement"), v8::FunctionTemplate::New(InternalsV8Internal::webkitWillExitFullScreenForElementCallback, v8::Handle<v8::Value>(), webkitWillExitFullScreenForElementSignature));

    // Custom Signature 'webkitDidExitFullScreenForElement'
    const int webkitDidExitFullScreenForElementArgc = 2;
    v8::Handle<v8::FunctionTemplate> webkitDidExitFullScreenForElementArgv[webkitDidExitFullScreenForElementArgc] = { V8Document::GetRawTemplate(), V8Element::GetRawTemplate() };
    v8::Handle<v8::Signature> webkitDidExitFullScreenForElementSignature = v8::Signature::New(desc, webkitDidExitFullScreenForElementArgc, webkitDidExitFullScreenForElementArgv);
    proto->Set(v8::String::New("webkitDidExitFullScreenForElement"), v8::FunctionTemplate::New(InternalsV8Internal::webkitDidExitFullScreenForElementCallback, v8::Handle<v8::Value>(), webkitDidExitFullScreenForElementSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8Internals::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8Internals::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8InternalsTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8Internals::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8Internals::wrapSlow(PassRefPtr<Internals> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8Internals::derefObject(void* object)
{
    static_cast<Internals*>(object)->deref();
}

} // namespace WebCore
