/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8JavaScriptCallFrame.h"

#if ENABLE(JAVASCRIPT_DEBUGGER)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8JavaScriptCallFrame::info = { V8JavaScriptCallFrame::GetTemplate, V8JavaScriptCallFrame::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace JavaScriptCallFrameV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> callerAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.JavaScriptCallFrame.caller._get");
    JavaScriptCallFrame* imp = V8JavaScriptCallFrame::toNative(info.Holder());
    RefPtr<JavaScriptCallFrame> result = imp->caller();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "caller", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> sourceIDAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.JavaScriptCallFrame.sourceID._get");
    JavaScriptCallFrame* imp = V8JavaScriptCallFrame::toNative(info.Holder());
    return v8Integer(imp->sourceID(), info.GetIsolate());
}

static v8::Handle<v8::Value> lineAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.JavaScriptCallFrame.line._get");
    JavaScriptCallFrame* imp = V8JavaScriptCallFrame::toNative(info.Holder());
    return v8Integer(imp->line(), info.GetIsolate());
}

static v8::Handle<v8::Value> columnAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.JavaScriptCallFrame.column._get");
    JavaScriptCallFrame* imp = V8JavaScriptCallFrame::toNative(info.Holder());
    return v8Integer(imp->column(), info.GetIsolate());
}

static v8::Handle<v8::Value> functionNameAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.JavaScriptCallFrame.functionName._get");
    JavaScriptCallFrame* imp = V8JavaScriptCallFrame::toNative(info.Holder());
    return v8String(imp->functionName(), info.GetIsolate());
}

} // namespace JavaScriptCallFrameV8Internal

static const BatchedAttribute JavaScriptCallFrameAttrs[] = {
    // Attribute 'caller' (Type: 'readonly attribute' ExtAttr: '')
    {"caller", JavaScriptCallFrameV8Internal::callerAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'sourceID' (Type: 'readonly attribute' ExtAttr: '')
    {"sourceID", JavaScriptCallFrameV8Internal::sourceIDAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'line' (Type: 'readonly attribute' ExtAttr: '')
    {"line", JavaScriptCallFrameV8Internal::lineAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'column' (Type: 'readonly attribute' ExtAttr: '')
    {"column", JavaScriptCallFrameV8Internal::columnAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'scopeChain' (Type: 'readonly attribute' ExtAttr: 'CustomGetter')
    {"scopeChain", V8JavaScriptCallFrame::scopeChainAccessorGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'thisObject' (Type: 'readonly attribute' ExtAttr: 'CustomGetter')
    {"thisObject", V8JavaScriptCallFrame::thisObjectAccessorGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'functionName' (Type: 'readonly attribute' ExtAttr: '')
    {"functionName", JavaScriptCallFrameV8Internal::functionNameAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'type' (Type: 'readonly attribute' ExtAttr: 'CustomGetter')
    {"type", V8JavaScriptCallFrame::typeAccessorGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback JavaScriptCallFrameCallbacks[] = {
    {"evaluate", V8JavaScriptCallFrame::evaluateCallback},
    {"restart", V8JavaScriptCallFrame::restartCallback},
    {"scopeType", V8JavaScriptCallFrame::scopeTypeCallback},
};

static const BatchedConstant JavaScriptCallFrameConsts[] = {
    {"GLOBAL_SCOPE", static_cast<signed int>(0)},
    {"LOCAL_SCOPE", static_cast<signed int>(1)},
    {"WITH_SCOPE", static_cast<signed int>(2)},
    {"CLOSURE_SCOPE", static_cast<signed int>(3)},
    {"CATCH_SCOPE", static_cast<signed int>(4)},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8JavaScriptCallFrameTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "JavaScriptCallFrame", v8::Persistent<v8::FunctionTemplate>(), V8JavaScriptCallFrame::internalFieldCount,
        JavaScriptCallFrameAttrs, WTF_ARRAY_LENGTH(JavaScriptCallFrameAttrs),
        JavaScriptCallFrameCallbacks, WTF_ARRAY_LENGTH(JavaScriptCallFrameCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    batchConfigureConstants(desc, proto, JavaScriptCallFrameConsts, WTF_ARRAY_LENGTH(JavaScriptCallFrameConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8JavaScriptCallFrame::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8JavaScriptCallFrame::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8JavaScriptCallFrameTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8JavaScriptCallFrame::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8JavaScriptCallFrame::wrapSlow(PassRefPtr<JavaScriptCallFrame> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8JavaScriptCallFrame::derefObject(void* object)
{
    static_cast<JavaScriptCallFrame*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(JAVASCRIPT_DEBUGGER)
