/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8KeyboardEvent.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWindow.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8UIEvent.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8KeyboardEvent::info = { V8KeyboardEvent::GetTemplate, V8KeyboardEvent::derefObject, 0, 0, &V8UIEvent::info, WrapperTypeObjectPrototype };

namespace KeyboardEventV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> keyIdentifierAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.KeyboardEvent.keyIdentifier._get");
    KeyboardEvent* imp = V8KeyboardEvent::toNative(info.Holder());
    return v8String(imp->keyIdentifier(), info.GetIsolate());
}

static v8::Handle<v8::Value> keyLocationAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.KeyboardEvent.keyLocation._get");
    KeyboardEvent* imp = V8KeyboardEvent::toNative(info.Holder());
    return v8UnsignedInteger(imp->keyLocation(), info.GetIsolate());
}

static v8::Handle<v8::Value> ctrlKeyAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.KeyboardEvent.ctrlKey._get");
    KeyboardEvent* imp = V8KeyboardEvent::toNative(info.Holder());
    return v8Boolean(imp->ctrlKey(), info.GetIsolate());
}

static v8::Handle<v8::Value> shiftKeyAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.KeyboardEvent.shiftKey._get");
    KeyboardEvent* imp = V8KeyboardEvent::toNative(info.Holder());
    return v8Boolean(imp->shiftKey(), info.GetIsolate());
}

static v8::Handle<v8::Value> altKeyAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.KeyboardEvent.altKey._get");
    KeyboardEvent* imp = V8KeyboardEvent::toNative(info.Holder());
    return v8Boolean(imp->altKey(), info.GetIsolate());
}

static v8::Handle<v8::Value> metaKeyAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.KeyboardEvent.metaKey._get");
    KeyboardEvent* imp = V8KeyboardEvent::toNative(info.Holder());
    return v8Boolean(imp->metaKey(), info.GetIsolate());
}

static v8::Handle<v8::Value> altGraphKeyAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.KeyboardEvent.altGraphKey._get");
    KeyboardEvent* imp = V8KeyboardEvent::toNative(info.Holder());
    return v8Boolean(imp->altGraphKey(), info.GetIsolate());
}

static v8::Handle<v8::Value> initKeyboardEventCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.KeyboardEvent.initKeyboardEvent");
    KeyboardEvent* imp = V8KeyboardEvent::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, type, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    EXCEPTION_BLOCK(bool, canBubble, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(bool, cancelable, MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(DOMWindow*, view, V8DOMWindow::HasInstance(MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined)) ? V8DOMWindow::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined))) : 0);
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, keyIdentifier, MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined));
    EXCEPTION_BLOCK(unsigned, keyLocation, toUInt32(MAYBE_MISSING_PARAMETER(args, 5, DefaultIsUndefined)));
    EXCEPTION_BLOCK(bool, ctrlKey, MAYBE_MISSING_PARAMETER(args, 6, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(bool, altKey, MAYBE_MISSING_PARAMETER(args, 7, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(bool, shiftKey, MAYBE_MISSING_PARAMETER(args, 8, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(bool, metaKey, MAYBE_MISSING_PARAMETER(args, 9, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(bool, altGraphKey, MAYBE_MISSING_PARAMETER(args, 10, DefaultIsUndefined)->BooleanValue());
    imp->initKeyboardEvent(type, canBubble, cancelable, view, keyIdentifier, keyLocation, ctrlKey, altKey, shiftKey, metaKey, altGraphKey);
    return v8::Handle<v8::Value>();
}

} // namespace KeyboardEventV8Internal

static const BatchedAttribute KeyboardEventAttrs[] = {
    // Attribute 'keyIdentifier' (Type: 'readonly attribute' ExtAttr: '')
    {"keyIdentifier", KeyboardEventV8Internal::keyIdentifierAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'keyLocation' (Type: 'readonly attribute' ExtAttr: '')
    {"keyLocation", KeyboardEventV8Internal::keyLocationAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'ctrlKey' (Type: 'readonly attribute' ExtAttr: '')
    {"ctrlKey", KeyboardEventV8Internal::ctrlKeyAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'shiftKey' (Type: 'readonly attribute' ExtAttr: '')
    {"shiftKey", KeyboardEventV8Internal::shiftKeyAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'altKey' (Type: 'readonly attribute' ExtAttr: '')
    {"altKey", KeyboardEventV8Internal::altKeyAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'metaKey' (Type: 'readonly attribute' ExtAttr: '')
    {"metaKey", KeyboardEventV8Internal::metaKeyAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'altGraphKey' (Type: 'readonly attribute' ExtAttr: '')
    {"altGraphKey", KeyboardEventV8Internal::altGraphKeyAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8KeyboardEventTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "KeyboardEvent", V8UIEvent::GetTemplate(), V8KeyboardEvent::internalFieldCount,
        KeyboardEventAttrs, WTF_ARRAY_LENGTH(KeyboardEventAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'initKeyboardEvent'
    const int initKeyboardEventArgc = 11;
    v8::Handle<v8::FunctionTemplate> initKeyboardEventArgv[initKeyboardEventArgc] = { v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), V8DOMWindow::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> initKeyboardEventSignature = v8::Signature::New(desc, initKeyboardEventArgc, initKeyboardEventArgv);
    proto->Set(v8::String::New("initKeyboardEvent"), v8::FunctionTemplate::New(KeyboardEventV8Internal::initKeyboardEventCallback, v8::Handle<v8::Value>(), initKeyboardEventSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8KeyboardEvent::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8KeyboardEvent::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8KeyboardEventTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8KeyboardEvent::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8KeyboardEvent::wrapSlow(PassRefPtr<KeyboardEvent> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8KeyboardEvent::derefObject(void* object)
{
    static_cast<KeyboardEvent*>(object)->deref();
}

} // namespace WebCore
