/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8MediaElementAudioSourceNode.h"

#if ENABLE(VIDEO) && ENABLE(WEB_AUDIO)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8AudioSourceNode.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8HTMLMediaElement.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8MediaElementAudioSourceNode::info = { V8MediaElementAudioSourceNode::GetTemplate, V8MediaElementAudioSourceNode::derefObject, 0, 0, &V8AudioSourceNode::info, WrapperTypeObjectPrototype };

namespace MediaElementAudioSourceNodeV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> mediaElementAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MediaElementAudioSourceNode.mediaElement._get");
    MediaElementAudioSourceNode* imp = V8MediaElementAudioSourceNode::toNative(info.Holder());
    return toV8(imp->mediaElement(), info.GetIsolate());
}

} // namespace MediaElementAudioSourceNodeV8Internal

static const BatchedAttribute MediaElementAudioSourceNodeAttrs[] = {
    // Attribute 'mediaElement' (Type: 'readonly attribute' ExtAttr: '')
    {"mediaElement", MediaElementAudioSourceNodeV8Internal::mediaElementAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8MediaElementAudioSourceNodeTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "MediaElementAudioSourceNode", V8AudioSourceNode::GetTemplate(), V8MediaElementAudioSourceNode::internalFieldCount,
        MediaElementAudioSourceNodeAttrs, WTF_ARRAY_LENGTH(MediaElementAudioSourceNodeAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8MediaElementAudioSourceNode::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8MediaElementAudioSourceNode::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8MediaElementAudioSourceNodeTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8MediaElementAudioSourceNode::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8MediaElementAudioSourceNode::wrapSlow(PassRefPtr<MediaElementAudioSourceNode> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8MediaElementAudioSourceNode::derefObject(void* object)
{
    static_cast<MediaElementAudioSourceNode*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(VIDEO) && ENABLE(WEB_AUDIO)
