/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8MediaKeyError.h"

#if ENABLE(ENCRYPTED_MEDIA)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8MediaKeyError::info = { V8MediaKeyError::GetTemplate, V8MediaKeyError::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace MediaKeyErrorV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> codeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MediaKeyError.code._get");
    MediaKeyError* imp = V8MediaKeyError::toNative(info.Holder());
    return v8Integer(imp->code(), info.GetIsolate());
}

} // namespace MediaKeyErrorV8Internal

static const BatchedAttribute MediaKeyErrorAttrs[] = {
    // Attribute 'code' (Type: 'readonly attribute' ExtAttr: '')
    {"code", MediaKeyErrorV8Internal::codeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedConstant MediaKeyErrorConsts[] = {
    {"MEDIA_KEYERR_UNKNOWN", static_cast<signed int>(1)},
    {"MEDIA_KEYERR_CLIENT", static_cast<signed int>(2)},
    {"MEDIA_KEYERR_SERVICE", static_cast<signed int>(3)},
    {"MEDIA_KEYERR_OUTPUT", static_cast<signed int>(4)},
    {"MEDIA_KEYERR_HARDWARECHANGE", static_cast<signed int>(5)},
    {"MEDIA_KEYERR_DOMAIN", static_cast<signed int>(6)},
};


COMPILE_ASSERT(1 == MediaKeyError::MEDIA_KEYERR_UNKNOWN, MediaKeyErrorEnumMEDIA_KEYERR_UNKNOWNIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(2 == MediaKeyError::MEDIA_KEYERR_CLIENT, MediaKeyErrorEnumMEDIA_KEYERR_CLIENTIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(3 == MediaKeyError::MEDIA_KEYERR_SERVICE, MediaKeyErrorEnumMEDIA_KEYERR_SERVICEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(4 == MediaKeyError::MEDIA_KEYERR_OUTPUT, MediaKeyErrorEnumMEDIA_KEYERR_OUTPUTIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(5 == MediaKeyError::MEDIA_KEYERR_HARDWARECHANGE, MediaKeyErrorEnumMEDIA_KEYERR_HARDWARECHANGEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(6 == MediaKeyError::MEDIA_KEYERR_DOMAIN, MediaKeyErrorEnumMEDIA_KEYERR_DOMAINIsWrongUseDoNotCheckConstants);

static v8::Persistent<v8::FunctionTemplate> ConfigureV8MediaKeyErrorTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    if (!RuntimeEnabledFeatures::encryptedMediaEnabled())
        defaultSignature = configureTemplate(desc, "", v8::Persistent<v8::FunctionTemplate>(), V8MediaKeyError::internalFieldCount, 0, 0, 0, 0);
    else
    defaultSignature = configureTemplate(desc, "MediaKeyError", v8::Persistent<v8::FunctionTemplate>(), V8MediaKeyError::internalFieldCount,
        MediaKeyErrorAttrs, WTF_ARRAY_LENGTH(MediaKeyErrorAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    batchConfigureConstants(desc, proto, MediaKeyErrorConsts, WTF_ARRAY_LENGTH(MediaKeyErrorConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8MediaKeyError::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8MediaKeyError::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8MediaKeyErrorTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8MediaKeyError::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8MediaKeyError::wrapSlow(PassRefPtr<MediaKeyError> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8MediaKeyError::derefObject(void* object)
{
    static_cast<MediaKeyError*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(ENCRYPTED_MEDIA)
