/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8MediaKeyEvent.h"

#if ENABLE(ENCRYPTED_MEDIA)

#include "ContextFeatures.h"
#include "Dictionary.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8Event.h"
#include "V8IsolatedContext.h"
#include "V8MediaKeyError.h"
#include "V8Proxy.h"
#include "V8Uint8Array.h"
#include <wtf/Uint8Array.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8MediaKeyEvent::info = { V8MediaKeyEvent::GetTemplate, V8MediaKeyEvent::derefObject, 0, 0, &V8Event::info, WrapperTypeObjectPrototype };

namespace MediaKeyEventV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> keySystemAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MediaKeyEvent.keySystem._get");
    MediaKeyEvent* imp = V8MediaKeyEvent::toNative(info.Holder());
    return v8String(imp->keySystem(), info.GetIsolate());
}

static v8::Handle<v8::Value> sessionIdAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MediaKeyEvent.sessionId._get");
    MediaKeyEvent* imp = V8MediaKeyEvent::toNative(info.Holder());
    return v8String(imp->sessionId(), info.GetIsolate());
}

static v8::Handle<v8::Value> initDataAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MediaKeyEvent.initData._get");
    MediaKeyEvent* imp = V8MediaKeyEvent::toNative(info.Holder());
    RefPtr<Uint8Array> result = imp->initData();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "initData", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> messageAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MediaKeyEvent.message._get");
    MediaKeyEvent* imp = V8MediaKeyEvent::toNative(info.Holder());
    RefPtr<Uint8Array> result = imp->message();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "message", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> defaultURLAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MediaKeyEvent.defaultURL._get");
    MediaKeyEvent* imp = V8MediaKeyEvent::toNative(info.Holder());
    return v8String(imp->defaultURL(), info.GetIsolate());
}

static v8::Handle<v8::Value> errorCodeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MediaKeyEvent.errorCode._get");
    MediaKeyEvent* imp = V8MediaKeyEvent::toNative(info.Holder());
    RefPtr<MediaKeyError> result = imp->errorCode();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "errorCode", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> systemCodeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MediaKeyEvent.systemCode._get");
    MediaKeyEvent* imp = V8MediaKeyEvent::toNative(info.Holder());
    return v8Integer(imp->systemCode(), info.GetIsolate());
}

} // namespace MediaKeyEventV8Internal

static const BatchedAttribute MediaKeyEventAttrs[] = {
    // Attribute 'keySystem' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"keySystem", MediaKeyEventV8Internal::keySystemAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'sessionId' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"sessionId", MediaKeyEventV8Internal::sessionIdAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'initData' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"initData", MediaKeyEventV8Internal::initDataAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'message' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"message", MediaKeyEventV8Internal::messageAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'defaultURL' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"defaultURL", MediaKeyEventV8Internal::defaultURLAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'errorCode' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"errorCode", MediaKeyEventV8Internal::errorCodeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'systemCode' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"systemCode", MediaKeyEventV8Internal::systemCodeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

v8::Handle<v8::Value> V8MediaKeyEvent::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.MediaKeyEvent.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();

    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());

    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, type, args[0]);
    MediaKeyEventInit eventInit;
    if (args.Length() >= 2) {
        EXCEPTION_BLOCK(Dictionary, options, args[1]);
        if (!fillMediaKeyEventInit(eventInit, options))
            return v8::Undefined();
    }

    RefPtr<MediaKeyEvent> event = MediaKeyEvent::create(type, eventInit);

    V8DOMWrapper::setDOMWrapper(args.Holder(), &info, event.get());
    V8DOMWrapper::setJSWrapperForDOMObject(event.release(), v8::Persistent<v8::Object>::New(args.Holder()), args.GetIsolate());
    return args.Holder();
}

bool fillMediaKeyEventInit(MediaKeyEventInit& eventInit, const Dictionary& options)
{
    if (!fillEventInit(eventInit, options))
        return false;

    options.get("keySystem", eventInit.keySystem);
    options.get("sessionId", eventInit.sessionId);
    options.get("initData", eventInit.initData);
    options.get("message", eventInit.message);
    options.get("defaultURL", eventInit.defaultURL);
    options.get("errorCode", eventInit.errorCode);
    options.get("systemCode", eventInit.systemCode);
    return true;
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8MediaKeyEventTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    if (!RuntimeEnabledFeatures::encryptedMediaEnabled())
        defaultSignature = configureTemplate(desc, "", V8Event::GetTemplate(), V8MediaKeyEvent::internalFieldCount, 0, 0, 0, 0);
    else
    defaultSignature = configureTemplate(desc, "MediaKeyEvent", V8Event::GetTemplate(), V8MediaKeyEvent::internalFieldCount,
        MediaKeyEventAttrs, WTF_ARRAY_LENGTH(MediaKeyEventAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8MediaKeyEvent::constructorCallback);
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8MediaKeyEvent::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8MediaKeyEvent::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8MediaKeyEventTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8MediaKeyEvent::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8MediaKeyEvent::wrapSlow(PassRefPtr<MediaKeyEvent> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8MediaKeyEvent::derefObject(void* object)
{
    static_cast<MediaKeyEvent*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(ENCRYPTED_MEDIA)
