/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8MediaQueryList.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "MediaQueryListListener.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8MediaQueryList::info = { V8MediaQueryList::GetTemplate, V8MediaQueryList::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace MediaQueryListV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> mediaAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MediaQueryList.media._get");
    MediaQueryList* imp = V8MediaQueryList::toNative(info.Holder());
    return v8String(imp->media(), info.GetIsolate());
}

static v8::Handle<v8::Value> matchesAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MediaQueryList.matches._get");
    MediaQueryList* imp = V8MediaQueryList::toNative(info.Holder());
    return v8Boolean(imp->matches(), info.GetIsolate());
}

static v8::Handle<v8::Value> addListenerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.MediaQueryList.addListener");
    MediaQueryList* imp = V8MediaQueryList::toNative(args.Holder());
    EXCEPTION_BLOCK(RefPtr<MediaQueryListListener>, listener, MediaQueryListListener::create(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    imp->addListener(listener);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> removeListenerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.MediaQueryList.removeListener");
    MediaQueryList* imp = V8MediaQueryList::toNative(args.Holder());
    EXCEPTION_BLOCK(RefPtr<MediaQueryListListener>, listener, MediaQueryListListener::create(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    imp->removeListener(listener);
    return v8::Handle<v8::Value>();
}

} // namespace MediaQueryListV8Internal

static const BatchedAttribute MediaQueryListAttrs[] = {
    // Attribute 'media' (Type: 'readonly attribute' ExtAttr: '')
    {"media", MediaQueryListV8Internal::mediaAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'matches' (Type: 'readonly attribute' ExtAttr: '')
    {"matches", MediaQueryListV8Internal::matchesAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback MediaQueryListCallbacks[] = {
    {"addListener", MediaQueryListV8Internal::addListenerCallback},
    {"removeListener", MediaQueryListV8Internal::removeListenerCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8MediaQueryListTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "MediaQueryList", v8::Persistent<v8::FunctionTemplate>(), V8MediaQueryList::internalFieldCount,
        MediaQueryListAttrs, WTF_ARRAY_LENGTH(MediaQueryListAttrs),
        MediaQueryListCallbacks, WTF_ARRAY_LENGTH(MediaQueryListCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8MediaQueryList::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8MediaQueryList::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8MediaQueryListTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8MediaQueryList::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8MediaQueryList::wrapSlow(PassRefPtr<MediaQueryList> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8MediaQueryList::derefObject(void* object)
{
    static_cast<MediaQueryList*>(object)->deref();
}

} // namespace WebCore
