/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8MutationRecord.h"

#if ENABLE(MUTATION_OBSERVERS)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Node.h"
#include "V8NodeList.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8MutationRecord::info = { V8MutationRecord::GetTemplate, V8MutationRecord::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace MutationRecordV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> typeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MutationRecord.type._get");
    MutationRecord* imp = V8MutationRecord::toNative(info.Holder());
    return v8String(imp->type(), info.GetIsolate());
}

static v8::Handle<v8::Value> targetAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MutationRecord.target._get");
    MutationRecord* imp = V8MutationRecord::toNative(info.Holder());
    return toV8(imp->target(), info.GetIsolate());
}

static v8::Handle<v8::Value> addedNodesAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MutationRecord.addedNodes._get");
    MutationRecord* imp = V8MutationRecord::toNative(info.Holder());
    RefPtr<NodeList> result = imp->addedNodes();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "addedNodes", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> removedNodesAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MutationRecord.removedNodes._get");
    MutationRecord* imp = V8MutationRecord::toNative(info.Holder());
    RefPtr<NodeList> result = imp->removedNodes();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "removedNodes", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> previousSiblingAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MutationRecord.previousSibling._get");
    MutationRecord* imp = V8MutationRecord::toNative(info.Holder());
    return toV8(imp->previousSibling(), info.GetIsolate());
}

static v8::Handle<v8::Value> nextSiblingAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MutationRecord.nextSibling._get");
    MutationRecord* imp = V8MutationRecord::toNative(info.Holder());
    return toV8(imp->nextSibling(), info.GetIsolate());
}

static v8::Handle<v8::Value> attributeNameAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MutationRecord.attributeName._get");
    MutationRecord* imp = V8MutationRecord::toNative(info.Holder());
    return v8String(imp->attributeName(), info.GetIsolate());
}

static v8::Handle<v8::Value> attributeNamespaceAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MutationRecord.attributeNamespace._get");
    MutationRecord* imp = V8MutationRecord::toNative(info.Holder());
    return v8StringOrNull(imp->attributeNamespace(), info.GetIsolate());
}

static v8::Handle<v8::Value> oldValueAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.MutationRecord.oldValue._get");
    MutationRecord* imp = V8MutationRecord::toNative(info.Holder());
    return v8StringOrNull(imp->oldValue(), info.GetIsolate());
}

} // namespace MutationRecordV8Internal

static const BatchedAttribute MutationRecordAttrs[] = {
    // Attribute 'type' (Type: 'readonly attribute' ExtAttr: '')
    {"type", MutationRecordV8Internal::typeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'target' (Type: 'readonly attribute' ExtAttr: '')
    {"target", MutationRecordV8Internal::targetAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'addedNodes' (Type: 'readonly attribute' ExtAttr: '')
    {"addedNodes", MutationRecordV8Internal::addedNodesAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'removedNodes' (Type: 'readonly attribute' ExtAttr: '')
    {"removedNodes", MutationRecordV8Internal::removedNodesAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'previousSibling' (Type: 'readonly attribute' ExtAttr: '')
    {"previousSibling", MutationRecordV8Internal::previousSiblingAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'nextSibling' (Type: 'readonly attribute' ExtAttr: '')
    {"nextSibling", MutationRecordV8Internal::nextSiblingAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'attributeName' (Type: 'readonly attribute' ExtAttr: '')
    {"attributeName", MutationRecordV8Internal::attributeNameAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'attributeNamespace' (Type: 'readonly attribute' ExtAttr: 'TreatReturnedNullStringAs')
    {"attributeNamespace", MutationRecordV8Internal::attributeNamespaceAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'oldValue' (Type: 'readonly attribute' ExtAttr: 'TreatReturnedNullStringAs')
    {"oldValue", MutationRecordV8Internal::oldValueAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8MutationRecordTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "MutationRecord", v8::Persistent<v8::FunctionTemplate>(), V8MutationRecord::internalFieldCount,
        MutationRecordAttrs, WTF_ARRAY_LENGTH(MutationRecordAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8MutationRecord::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8MutationRecord::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8MutationRecordTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8MutationRecord::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8MutationRecord::wrapSlow(PassRefPtr<MutationRecord> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8MutationRecord::derefObject(void* object)
{
    static_cast<MutationRecord*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(MUTATION_OBSERVERS)
