/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8NamedNodeMap.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8Collection.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Node.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8NamedNodeMap::info = { V8NamedNodeMap::GetTemplate, V8NamedNodeMap::derefObject, 0, V8NamedNodeMap::visitDOMWrapper, 0, WrapperTypeObjectPrototype };

namespace NamedNodeMapV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> lengthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.NamedNodeMap.length._get");
    NamedNodeMap* imp = V8NamedNodeMap::toNative(info.Holder());
    return v8UnsignedInteger(imp->length(), info.GetIsolate());
}

static v8::Handle<v8::Value> getNamedItemCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.NamedNodeMap.getNamedItem");
    NamedNodeMap* imp = V8NamedNodeMap::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, name, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return toV8(imp->getNamedItem(name), args.GetIsolate());
}

static v8::Handle<v8::Value> setNamedItemCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.NamedNodeMap.setNamedItem");
    NamedNodeMap* imp = V8NamedNodeMap::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<Node> result = imp->setNamedItem(node, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> removeNamedItemCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.NamedNodeMap.removeNamedItem");
    NamedNodeMap* imp = V8NamedNodeMap::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, name, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    RefPtr<Node> result = imp->removeNamedItem(name, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> itemCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.NamedNodeMap.item");
    NamedNodeMap* imp = V8NamedNodeMap::toNative(args.Holder());
    EXCEPTION_BLOCK(unsigned, index, toUInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    return toV8(imp->item(index), args.GetIsolate());
}

static v8::Handle<v8::Value> getNamedItemNSCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.NamedNodeMap.getNamedItemNS");
    NamedNodeMap* imp = V8NamedNodeMap::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithNullCheck>, namespaceURI, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, localName, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    return toV8(imp->getNamedItemNS(namespaceURI, localName), args.GetIsolate());
}

static v8::Handle<v8::Value> setNamedItemNSCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.NamedNodeMap.setNamedItemNS");
    NamedNodeMap* imp = V8NamedNodeMap::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, node, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<Node> result = imp->setNamedItemNS(node, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> removeNamedItemNSCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.NamedNodeMap.removeNamedItemNS");
    NamedNodeMap* imp = V8NamedNodeMap::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithNullCheck>, namespaceURI, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, localName, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    RefPtr<Node> result = imp->removeNamedItemNS(namespaceURI, localName, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace NamedNodeMapV8Internal

void V8NamedNodeMap::visitDOMWrapper(DOMDataStore* store, void* object, v8::Persistent<v8::Object> wrapper)
{
    NamedNodeMap* impl = static_cast<NamedNodeMap*>(object);
    if (Node* owner = impl->element()) {
        v8::Persistent<v8::Object> ownerWrapper = store->domNodeMap().get(owner);
        if (!ownerWrapper.IsEmpty()) {
            v8::Persistent<v8::Value> value = wrapper;
            v8::V8::AddImplicitReferences(ownerWrapper, &value, 1);
        }
    }
}

static const BatchedAttribute NamedNodeMapAttrs[] = {
    // Attribute 'length' (Type: 'readonly attribute' ExtAttr: '')
    {"length", NamedNodeMapV8Internal::lengthAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback NamedNodeMapCallbacks[] = {
    {"getNamedItem", NamedNodeMapV8Internal::getNamedItemCallback},
    {"removeNamedItem", NamedNodeMapV8Internal::removeNamedItemCallback},
    {"item", NamedNodeMapV8Internal::itemCallback},
    {"getNamedItemNS", NamedNodeMapV8Internal::getNamedItemNSCallback},
    {"removeNamedItemNS", NamedNodeMapV8Internal::removeNamedItemNSCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8NamedNodeMapTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "NamedNodeMap", v8::Persistent<v8::FunctionTemplate>(), V8NamedNodeMap::internalFieldCount,
        NamedNodeMapAttrs, WTF_ARRAY_LENGTH(NamedNodeMapAttrs),
        NamedNodeMapCallbacks, WTF_ARRAY_LENGTH(NamedNodeMapCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    setCollectionIndexedGetter<NamedNodeMap, Node>(desc);
    desc->InstanceTemplate()->SetNamedPropertyHandler(V8NamedNodeMap::namedPropertyGetter, 0, 0, 0, 0);

    // Custom Signature 'setNamedItem'
    const int setNamedItemArgc = 1;
    v8::Handle<v8::FunctionTemplate> setNamedItemArgv[setNamedItemArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> setNamedItemSignature = v8::Signature::New(desc, setNamedItemArgc, setNamedItemArgv);
    proto->Set(v8::String::New("setNamedItem"), v8::FunctionTemplate::New(NamedNodeMapV8Internal::setNamedItemCallback, v8::Handle<v8::Value>(), setNamedItemSignature));

    // Custom Signature 'setNamedItemNS'
    const int setNamedItemNSArgc = 1;
    v8::Handle<v8::FunctionTemplate> setNamedItemNSArgv[setNamedItemNSArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> setNamedItemNSSignature = v8::Signature::New(desc, setNamedItemNSArgc, setNamedItemNSArgv);
    proto->Set(v8::String::New("setNamedItemNS"), v8::FunctionTemplate::New(NamedNodeMapV8Internal::setNamedItemNSCallback, v8::Handle<v8::Value>(), setNamedItemNSSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8NamedNodeMap::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8NamedNodeMap::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8NamedNodeMapTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8NamedNodeMap::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8NamedNodeMap::wrapSlow(PassRefPtr<NamedNodeMap> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8NamedNodeMap::derefObject(void* object)
{
    static_cast<NamedNodeMap*>(object)->deref();
}

} // namespace WebCore
