/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8Navigator.h"

#include "ContextFeatures.h"
#include "Dictionary.h"
#include "ExceptionCode.h"
#include "NavigatorBattery.h"
#include "NavigatorGamepad.h"
#include "NavigatorGeolocation.h"
#include "NavigatorIntents.h"
#include "NavigatorMediaStream.h"
#include "NavigatorRegisterProtocolHandler.h"
#include "RuntimeEnabledFeatures.h"
#include "V8BatteryManager.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMMimeTypeArray.h"
#include "V8DOMPluginArray.h"
#include "V8DOMWrapper.h"
#include "V8GamepadList.h"
#include "V8Geolocation.h"
#include "V8Intent.h"
#include "V8IntentResultCallback.h"
#include "V8IsolatedContext.h"
#include "V8NavigatorUserMediaErrorCallback.h"
#include "V8NavigatorUserMediaSuccessCallback.h"
#include "V8PointerLock.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8Navigator::info = { V8Navigator::GetTemplate, V8Navigator::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace NavigatorV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> appCodeNameAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.appCodeName._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8String(imp->appCodeName(), info.GetIsolate());
}

static v8::Handle<v8::Value> appNameAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.appName._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8String(imp->appName(), info.GetIsolate());
}

static v8::Handle<v8::Value> appVersionAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.appVersion._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8String(imp->appVersion(), info.GetIsolate());
}

static v8::Handle<v8::Value> languageAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.language._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8String(imp->language(), info.GetIsolate());
}

static v8::Handle<v8::Value> userAgentAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.userAgent._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8String(imp->userAgent(), info.GetIsolate());
}

static v8::Handle<v8::Value> platformAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.platform._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8String(imp->platform(), info.GetIsolate());
}

static v8::Handle<v8::Value> pluginsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.plugins._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    RefPtr<DOMPluginArray> result = imp->plugins();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "plugins", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> mimeTypesAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.mimeTypes._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    RefPtr<DOMMimeTypeArray> result = imp->mimeTypes();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "mimeTypes", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> productAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.product._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8String(imp->product(), info.GetIsolate());
}

static v8::Handle<v8::Value> productSubAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.productSub._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8String(imp->productSub(), info.GetIsolate());
}

static v8::Handle<v8::Value> vendorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.vendor._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8String(imp->vendor(), info.GetIsolate());
}

static v8::Handle<v8::Value> vendorSubAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.vendorSub._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8String(imp->vendorSub(), info.GetIsolate());
}

static v8::Handle<v8::Value> cookieEnabledAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.cookieEnabled._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8Boolean(imp->cookieEnabled(), info.GetIsolate());
}

static v8::Handle<v8::Value> onLineAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.onLine._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    return v8Boolean(imp->onLine(), info.GetIsolate());
}

#if ENABLE(POINTER_LOCK)

static v8::Handle<v8::Value> webkitPointerAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.webkitPointer._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    RefPtr<PointerLock> result = imp->webkitPointer();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "webkitPointer", wrapper);
    }
    return wrapper;
}

#endif // ENABLE(POINTER_LOCK)

#if ENABLE(GAMEPAD)

static v8::Handle<v8::Value> webkitGamepadsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.webkitGamepads._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    RefPtr<GamepadList> result = NavigatorGamepad::webkitGamepads(imp);
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "webkitGamepads", wrapper);
    }
    return wrapper;
}

#endif // ENABLE(GAMEPAD)

#if ENABLE(BATTERY_STATUS)

static v8::Handle<v8::Value> webkitBatteryAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.webkitBattery._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    RefPtr<BatteryManager> result = NavigatorBattery::webkitBattery(imp);
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "webkitBattery", wrapper);
    }
    return wrapper;
}

#endif // ENABLE(BATTERY_STATUS)

#if ENABLE(GEOLOCATION)

static v8::Handle<v8::Value> geolocationAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Navigator.geolocation._get");
    Navigator* imp = V8Navigator::toNative(info.Holder());
    RefPtr<Geolocation> result = NavigatorGeolocation::geolocation(imp);
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "geolocation", wrapper);
    }
    return wrapper;
}

#endif // ENABLE(GEOLOCATION)

static v8::Handle<v8::Value> javaEnabledCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Navigator.javaEnabled");
    Navigator* imp = V8Navigator::toNative(args.Holder());
    return v8Boolean(imp->javaEnabled(), args.GetIsolate());
}

static v8::Handle<v8::Value> getStorageUpdatesCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Navigator.getStorageUpdates");
    Navigator* imp = V8Navigator::toNative(args.Holder());
    imp->getStorageUpdates();
    return v8::Handle<v8::Value>();
}

#if ENABLE(WEB_INTENTS)

static v8::Handle<v8::Value> webkitStartActivityCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Navigator.webkitStartActivity");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Navigator* imp = V8Navigator::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Intent*, intent, V8Intent::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Intent::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    RefPtr<IntentResultCallback> successCallback;
    if (args.Length() > 1 && !args[1]->IsNull() && !args[1]->IsUndefined()) {
        if (!args[1]->IsFunction())
            return throwError(TYPE_MISMATCH_ERR, args.GetIsolate());
        successCallback = V8IntentResultCallback::create(args[1], getScriptExecutionContext());
    }
    RefPtr<IntentResultCallback> failureCallback;
    if (args.Length() > 2 && !args[2]->IsNull() && !args[2]->IsUndefined()) {
        if (!args[2]->IsFunction())
            return throwError(TYPE_MISMATCH_ERR, args.GetIsolate());
        failureCallback = V8IntentResultCallback::create(args[2], getScriptExecutionContext());
    }
    NavigatorIntents::webkitStartActivity(imp, intent, successCallback, failureCallback, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

#endif // ENABLE(WEB_INTENTS)

#if ENABLE(REGISTER_PROTOCOL_HANDLER)

static v8::Handle<v8::Value> registerProtocolHandlerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Navigator.registerProtocolHandler");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Navigator* imp = V8Navigator::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, scheme, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, url, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, title, MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined));
    NavigatorRegisterProtocolHandler::registerProtocolHandler(imp, scheme, url, title, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

#endif // ENABLE(REGISTER_PROTOCOL_HANDLER)

#if ENABLE(CUSTOM_SCHEME_HANDLER)

static v8::Handle<v8::Value> isProtocolHandlerRegisteredCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Navigator.isProtocolHandlerRegistered");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Navigator* imp = V8Navigator::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, scheme, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, url, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    String result = NavigatorRegisterProtocolHandler::isProtocolHandlerRegistered(imp, scheme, url, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8String(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

#endif // ENABLE(CUSTOM_SCHEME_HANDLER)

#if ENABLE(CUSTOM_SCHEME_HANDLER)

static v8::Handle<v8::Value> unregisterProtocolHandlerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Navigator.unregisterProtocolHandler");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Navigator* imp = V8Navigator::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, scheme, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, url, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    NavigatorRegisterProtocolHandler::unregisterProtocolHandler(imp, scheme, url, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

#endif // ENABLE(CUSTOM_SCHEME_HANDLER)

#if ENABLE(MEDIA_STREAM)

static v8::Handle<v8::Value> webkitGetUserMediaCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Navigator.webkitGetUserMedia");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Navigator* imp = V8Navigator::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Dictionary, options, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    if (!options.isUndefinedOrNull() && !options.isObject())
        return V8Proxy::throwTypeError("Not an object.", args.GetIsolate());
    if (args.Length() <= 1 || !args[1]->IsFunction())
        return throwError(TYPE_MISMATCH_ERR, args.GetIsolate());
    RefPtr<NavigatorUserMediaSuccessCallback> successCallback = V8NavigatorUserMediaSuccessCallback::create(args[1], getScriptExecutionContext());
    RefPtr<NavigatorUserMediaErrorCallback> errorCallback;
    if (args.Length() > 2 && !args[2]->IsNull() && !args[2]->IsUndefined()) {
        if (!args[2]->IsFunction())
            return throwError(TYPE_MISMATCH_ERR, args.GetIsolate());
        errorCallback = V8NavigatorUserMediaErrorCallback::create(args[2], getScriptExecutionContext());
    }
    NavigatorMediaStream::webkitGetUserMedia(imp, options, successCallback, errorCallback, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

#endif // ENABLE(MEDIA_STREAM)

} // namespace NavigatorV8Internal

static const BatchedAttribute NavigatorAttrs[] = {
    // Attribute 'appCodeName' (Type: 'readonly attribute' ExtAttr: '')
    {"appCodeName", NavigatorV8Internal::appCodeNameAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'appName' (Type: 'readonly attribute' ExtAttr: '')
    {"appName", NavigatorV8Internal::appNameAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'appVersion' (Type: 'readonly attribute' ExtAttr: '')
    {"appVersion", NavigatorV8Internal::appVersionAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'language' (Type: 'readonly attribute' ExtAttr: '')
    {"language", NavigatorV8Internal::languageAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'userAgent' (Type: 'readonly attribute' ExtAttr: '')
    {"userAgent", NavigatorV8Internal::userAgentAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'platform' (Type: 'readonly attribute' ExtAttr: '')
    {"platform", NavigatorV8Internal::platformAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'plugins' (Type: 'readonly attribute' ExtAttr: '')
    {"plugins", NavigatorV8Internal::pluginsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'mimeTypes' (Type: 'readonly attribute' ExtAttr: '')
    {"mimeTypes", NavigatorV8Internal::mimeTypesAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'product' (Type: 'readonly attribute' ExtAttr: '')
    {"product", NavigatorV8Internal::productAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'productSub' (Type: 'readonly attribute' ExtAttr: '')
    {"productSub", NavigatorV8Internal::productSubAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'vendor' (Type: 'readonly attribute' ExtAttr: '')
    {"vendor", NavigatorV8Internal::vendorAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'vendorSub' (Type: 'readonly attribute' ExtAttr: '')
    {"vendorSub", NavigatorV8Internal::vendorSubAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'cookieEnabled' (Type: 'readonly attribute' ExtAttr: '')
    {"cookieEnabled", NavigatorV8Internal::cookieEnabledAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onLine' (Type: 'readonly attribute' ExtAttr: '')
    {"onLine", NavigatorV8Internal::onLineAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
#if ENABLE(BATTERY_STATUS)
    // Attribute 'webkitBattery' (Type: 'readonly attribute' ExtAttr: 'Conditional ImplementedBy')
    {"webkitBattery", NavigatorV8Internal::webkitBatteryAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
#endif // ENABLE(BATTERY_STATUS)
};

static const BatchedCallback NavigatorCallbacks[] = {
    {"javaEnabled", NavigatorV8Internal::javaEnabledCallback},
    {"getStorageUpdates", NavigatorV8Internal::getStorageUpdatesCallback},
#if ENABLE(WEB_INTENTS)
    {"webkitStartActivity", NavigatorV8Internal::webkitStartActivityCallback},
#endif
#if ENABLE(REGISTER_PROTOCOL_HANDLER)
    {"registerProtocolHandler", NavigatorV8Internal::registerProtocolHandlerCallback},
#endif
#if ENABLE(CUSTOM_SCHEME_HANDLER)
    {"isProtocolHandlerRegistered", NavigatorV8Internal::isProtocolHandlerRegisteredCallback},
#endif
#if ENABLE(CUSTOM_SCHEME_HANDLER)
    {"unregisterProtocolHandler", NavigatorV8Internal::unregisterProtocolHandlerCallback},
#endif
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8NavigatorTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "Navigator", v8::Persistent<v8::FunctionTemplate>(), V8Navigator::internalFieldCount,
        NavigatorAttrs, WTF_ARRAY_LENGTH(NavigatorAttrs),
        NavigatorCallbacks, WTF_ARRAY_LENGTH(NavigatorCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

#if ENABLE(POINTER_LOCK)
    if (RuntimeEnabledFeatures::pointerLockEnabled()) {
        static const BatchedAttribute attrData =\
        // Attribute 'webkitPointer' (Type: 'readonly attribute' ExtAttr: 'V8EnabledAtRuntime Conditional')
        {"webkitPointer", NavigatorV8Internal::webkitPointerAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */};
        configureAttribute(instance, proto, attrData);
    }

#endif // ENABLE(POINTER_LOCK)

#if ENABLE(GAMEPAD)
    if (RuntimeEnabledFeatures::webkitGamepadsEnabled()) {
        static const BatchedAttribute attrData =\
        // Attribute 'webkitGamepads' (Type: 'readonly attribute' ExtAttr: 'V8EnabledAtRuntime Conditional ImplementedBy')
        {"webkitGamepads", NavigatorV8Internal::webkitGamepadsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */};
        configureAttribute(instance, proto, attrData);
    }

#endif // ENABLE(GAMEPAD)

#if ENABLE(GEOLOCATION)
    if (RuntimeEnabledFeatures::geolocationEnabled()) {
        static const BatchedAttribute attrData =\
        // Attribute 'geolocation' (Type: 'readonly attribute' ExtAttr: 'V8EnabledAtRuntime Conditional ImplementedBy')
        {"geolocation", NavigatorV8Internal::geolocationAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */};
        configureAttribute(instance, proto, attrData);
    }

#endif // ENABLE(GEOLOCATION)
#if ENABLE(MEDIA_STREAM)
    if (RuntimeEnabledFeatures::webkitGetUserMediaEnabled())
        proto->Set(v8::String::New("webkitGetUserMedia"), v8::FunctionTemplate::New(NavigatorV8Internal::webkitGetUserMediaCallback, v8::Handle<v8::Value>(), defaultSignature));
#endif // ENABLE(MEDIA_STREAM)

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8Navigator::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8Navigator::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8NavigatorTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8Navigator::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8Navigator::wrapSlow(PassRefPtr<Navigator> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8Navigator::derefObject(void* object)
{
    static_cast<Navigator*>(object)->deref();
}

} // namespace WebCore
