/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8NotificationCenter.h"

#if ENABLE(LEGACY_NOTIFICATIONS)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8NotificationCenter::info = { V8NotificationCenter::GetTemplate, V8NotificationCenter::derefObject, V8NotificationCenter::toActiveDOMObject, 0, 0, WrapperTypeObjectPrototype };

namespace NotificationCenterV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> checkPermissionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.NotificationCenter.checkPermission");
    NotificationCenter* imp = V8NotificationCenter::toNative(args.Holder());
    return v8Integer(imp->checkPermission(), args.GetIsolate());
}

} // namespace NotificationCenterV8Internal

static const BatchedCallback NotificationCenterCallbacks[] = {
    {"createHTMLNotification", V8NotificationCenter::createHTMLNotificationCallback},
    {"createNotification", V8NotificationCenter::createNotificationCallback},
    {"checkPermission", NotificationCenterV8Internal::checkPermissionCallback},
    {"requestPermission", V8NotificationCenter::requestPermissionCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8NotificationCenterTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "NotificationCenter", v8::Persistent<v8::FunctionTemplate>(), V8NotificationCenter::internalFieldCount,
        0, 0,
        NotificationCenterCallbacks, WTF_ARRAY_LENGTH(NotificationCenterCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8NotificationCenter::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8NotificationCenter::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8NotificationCenterTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8NotificationCenter::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}

ActiveDOMObject* V8NotificationCenter::toActiveDOMObject(v8::Handle<v8::Object> object)
{
    return toNative(object);
}      

v8::Handle<v8::Object> V8NotificationCenter::wrapSlow(PassRefPtr<NotificationCenter> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForActiveDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8NotificationCenter::derefObject(void* object)
{
    static_cast<NotificationCenter*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(LEGACY_NOTIFICATIONS)
