/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8OESVertexArrayObject.h"

#if ENABLE(WEBGL)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8WebGLVertexArrayObjectOES.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8OESVertexArrayObject::info = { V8OESVertexArrayObject::GetTemplate, V8OESVertexArrayObject::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace OESVertexArrayObjectV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> createVertexArrayOESCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.OESVertexArrayObject.createVertexArrayOES");
    OESVertexArrayObject* imp = V8OESVertexArrayObject::toNative(args.Holder());
    return toV8(imp->createVertexArrayOES(), args.GetIsolate());
}

static v8::Handle<v8::Value> deleteVertexArrayOESCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.OESVertexArrayObject.deleteVertexArrayOES");
    OESVertexArrayObject* imp = V8OESVertexArrayObject::toNative(args.Holder());
    if (args.Length() > 0 && !isUndefinedOrNull(args[0]) && !V8WebGLVertexArrayObjectOES::HasInstance(args[0]))
        return V8Proxy::throwTypeError(0, args.GetIsolate());
    EXCEPTION_BLOCK(WebGLVertexArrayObjectOES*, arrayObject, V8WebGLVertexArrayObjectOES::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8WebGLVertexArrayObjectOES::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->deleteVertexArrayOES(arrayObject);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> isVertexArrayOESCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.OESVertexArrayObject.isVertexArrayOES");
    OESVertexArrayObject* imp = V8OESVertexArrayObject::toNative(args.Holder());
    if (args.Length() > 0 && !isUndefinedOrNull(args[0]) && !V8WebGLVertexArrayObjectOES::HasInstance(args[0]))
        return V8Proxy::throwTypeError(0, args.GetIsolate());
    EXCEPTION_BLOCK(WebGLVertexArrayObjectOES*, arrayObject, V8WebGLVertexArrayObjectOES::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8WebGLVertexArrayObjectOES::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    return v8Boolean(imp->isVertexArrayOES(arrayObject), args.GetIsolate());
}

static v8::Handle<v8::Value> bindVertexArrayOESCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.OESVertexArrayObject.bindVertexArrayOES");
    OESVertexArrayObject* imp = V8OESVertexArrayObject::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    if (args.Length() > 0 && !isUndefinedOrNull(args[0]) && !V8WebGLVertexArrayObjectOES::HasInstance(args[0]))
        return V8Proxy::throwTypeError(0, args.GetIsolate());
    EXCEPTION_BLOCK(WebGLVertexArrayObjectOES*, arrayObject, V8WebGLVertexArrayObjectOES::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8WebGLVertexArrayObjectOES::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->bindVertexArrayOES(arrayObject, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace OESVertexArrayObjectV8Internal

static const BatchedCallback OESVertexArrayObjectCallbacks[] = {
    {"createVertexArrayOES", OESVertexArrayObjectV8Internal::createVertexArrayOESCallback},
    {"deleteVertexArrayOES", OESVertexArrayObjectV8Internal::deleteVertexArrayOESCallback},
    {"isVertexArrayOES", OESVertexArrayObjectV8Internal::isVertexArrayOESCallback},
    {"bindVertexArrayOES", OESVertexArrayObjectV8Internal::bindVertexArrayOESCallback},
};

static const BatchedConstant OESVertexArrayObjectConsts[] = {
    {"VERTEX_ARRAY_BINDING_OES", static_cast<signed int>(0x85B5)},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8OESVertexArrayObjectTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "OESVertexArrayObject", v8::Persistent<v8::FunctionTemplate>(), V8OESVertexArrayObject::internalFieldCount,
        0, 0,
        OESVertexArrayObjectCallbacks, WTF_ARRAY_LENGTH(OESVertexArrayObjectCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    batchConfigureConstants(desc, proto, OESVertexArrayObjectConsts, WTF_ARRAY_LENGTH(OESVertexArrayObjectConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8OESVertexArrayObject::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8OESVertexArrayObject::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8OESVertexArrayObjectTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8OESVertexArrayObject::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8OESVertexArrayObject::wrapSlow(PassRefPtr<OESVertexArrayObject> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8OESVertexArrayObject::derefObject(void* object)
{
    static_cast<OESVertexArrayObject*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(WEBGL)
