/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8Oscillator.h"

#if ENABLE(WEB_AUDIO)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8AudioParam.h"
#include "V8AudioSourceNode.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8WaveTable.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8Oscillator::info = { V8Oscillator::GetTemplate, V8Oscillator::derefObject, 0, 0, &V8AudioSourceNode::info, WrapperTypeObjectPrototype };

namespace OscillatorV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> typeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Oscillator.type._get");
    Oscillator* imp = V8Oscillator::toNative(info.Holder());
    return v8Integer(imp->type(), info.GetIsolate());
}

static void typeAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Oscillator.type._set");
    Oscillator* imp = V8Oscillator::toNative(info.Holder());
    int v = toUInt32(value);
    imp->setType(v);
    return;
}

static v8::Handle<v8::Value> playbackStateAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Oscillator.playbackState._get");
    Oscillator* imp = V8Oscillator::toNative(info.Holder());
    return v8Integer(imp->playbackState(), info.GetIsolate());
}

static v8::Handle<v8::Value> frequencyAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Oscillator.frequency._get");
    Oscillator* imp = V8Oscillator::toNative(info.Holder());
    RefPtr<AudioParam> result = imp->frequency();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "frequency", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> detuneAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Oscillator.detune._get");
    Oscillator* imp = V8Oscillator::toNative(info.Holder());
    RefPtr<AudioParam> result = imp->detune();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "detune", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> noteOnCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Oscillator.noteOn");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Oscillator* imp = V8Oscillator::toNative(args.Holder());
    EXCEPTION_BLOCK(double, when, static_cast<double>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    imp->noteOn(when);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> noteOffCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Oscillator.noteOff");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Oscillator* imp = V8Oscillator::toNative(args.Holder());
    EXCEPTION_BLOCK(double, when, static_cast<double>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    imp->noteOff(when);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> setWaveTableCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.Oscillator.setWaveTable");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    Oscillator* imp = V8Oscillator::toNative(args.Holder());
    EXCEPTION_BLOCK(WaveTable*, waveTable, V8WaveTable::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8WaveTable::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->setWaveTable(waveTable);
    return v8::Handle<v8::Value>();
}

} // namespace OscillatorV8Internal

static const BatchedAttribute OscillatorAttrs[] = {
    // Attribute 'type' (Type: 'attribute' ExtAttr: '')
    {"type", OscillatorV8Internal::typeAttrGetter, OscillatorV8Internal::typeAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'playbackState' (Type: 'readonly attribute' ExtAttr: '')
    {"playbackState", OscillatorV8Internal::playbackStateAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'frequency' (Type: 'readonly attribute' ExtAttr: '')
    {"frequency", OscillatorV8Internal::frequencyAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'detune' (Type: 'readonly attribute' ExtAttr: '')
    {"detune", OscillatorV8Internal::detuneAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback OscillatorCallbacks[] = {
    {"noteOn", OscillatorV8Internal::noteOnCallback},
    {"noteOff", OscillatorV8Internal::noteOffCallback},
};

static const BatchedConstant OscillatorConsts[] = {
    {"SINE", static_cast<signed int>(0)},
    {"SQUARE", static_cast<signed int>(1)},
    {"SAWTOOTH", static_cast<signed int>(2)},
    {"TRIANGLE", static_cast<signed int>(3)},
    {"CUSTOM", static_cast<signed int>(4)},
    {"UNSCHEDULED_STATE", static_cast<signed int>(0)},
    {"SCHEDULED_STATE", static_cast<signed int>(1)},
    {"PLAYING_STATE", static_cast<signed int>(2)},
    {"FINISHED_STATE", static_cast<signed int>(3)},
};


COMPILE_ASSERT(0 == Oscillator::SINE, OscillatorEnumSINEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(1 == Oscillator::SQUARE, OscillatorEnumSQUAREIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(2 == Oscillator::SAWTOOTH, OscillatorEnumSAWTOOTHIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(3 == Oscillator::TRIANGLE, OscillatorEnumTRIANGLEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(4 == Oscillator::CUSTOM, OscillatorEnumCUSTOMIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(0 == Oscillator::UNSCHEDULED_STATE, OscillatorEnumUNSCHEDULED_STATEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(1 == Oscillator::SCHEDULED_STATE, OscillatorEnumSCHEDULED_STATEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(2 == Oscillator::PLAYING_STATE, OscillatorEnumPLAYING_STATEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(3 == Oscillator::FINISHED_STATE, OscillatorEnumFINISHED_STATEIsWrongUseDoNotCheckConstants);

static v8::Persistent<v8::FunctionTemplate> ConfigureV8OscillatorTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "Oscillator", V8AudioSourceNode::GetTemplate(), V8Oscillator::internalFieldCount,
        OscillatorAttrs, WTF_ARRAY_LENGTH(OscillatorAttrs),
        OscillatorCallbacks, WTF_ARRAY_LENGTH(OscillatorCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'setWaveTable'
    const int setWaveTableArgc = 1;
    v8::Handle<v8::FunctionTemplate> setWaveTableArgv[setWaveTableArgc] = { V8WaveTable::GetRawTemplate() };
    v8::Handle<v8::Signature> setWaveTableSignature = v8::Signature::New(desc, setWaveTableArgc, setWaveTableArgv);
    proto->Set(v8::String::New("setWaveTable"), v8::FunctionTemplate::New(OscillatorV8Internal::setWaveTableCallback, v8::Handle<v8::Value>(), setWaveTableSignature));
    batchConfigureConstants(desc, proto, OscillatorConsts, WTF_ARRAY_LENGTH(OscillatorConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8Oscillator::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8Oscillator::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8OscillatorTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8Oscillator::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8Oscillator::wrapSlow(PassRefPtr<Oscillator> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8Oscillator::derefObject(void* object)
{
    static_cast<Oscillator*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(WEB_AUDIO)
