/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8OverflowEvent.h"

#include "ContextFeatures.h"
#include "Dictionary.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8Event.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8OverflowEvent::info = { V8OverflowEvent::GetTemplate, V8OverflowEvent::derefObject, 0, 0, &V8Event::info, WrapperTypeObjectPrototype };

namespace OverflowEventV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> orientAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.OverflowEvent.orient._get");
    OverflowEvent* imp = V8OverflowEvent::toNative(info.Holder());
    return v8Integer(imp->orient(), info.GetIsolate());
}

static v8::Handle<v8::Value> horizontalOverflowAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.OverflowEvent.horizontalOverflow._get");
    OverflowEvent* imp = V8OverflowEvent::toNative(info.Holder());
    return v8Boolean(imp->horizontalOverflow(), info.GetIsolate());
}

static v8::Handle<v8::Value> verticalOverflowAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.OverflowEvent.verticalOverflow._get");
    OverflowEvent* imp = V8OverflowEvent::toNative(info.Holder());
    return v8Boolean(imp->verticalOverflow(), info.GetIsolate());
}

} // namespace OverflowEventV8Internal

static const BatchedAttribute OverflowEventAttrs[] = {
    // Attribute 'orient' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"orient", OverflowEventV8Internal::orientAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'horizontalOverflow' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"horizontalOverflow", OverflowEventV8Internal::horizontalOverflowAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'verticalOverflow' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"verticalOverflow", OverflowEventV8Internal::verticalOverflowAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedConstant OverflowEventConsts[] = {
    {"HORIZONTAL", static_cast<signed int>(0)},
    {"VERTICAL", static_cast<signed int>(1)},
    {"BOTH", static_cast<signed int>(2)},
};


COMPILE_ASSERT(0 == OverflowEvent::HORIZONTAL, OverflowEventEnumHORIZONTALIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(1 == OverflowEvent::VERTICAL, OverflowEventEnumVERTICALIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(2 == OverflowEvent::BOTH, OverflowEventEnumBOTHIsWrongUseDoNotCheckConstants);

v8::Handle<v8::Value> V8OverflowEvent::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.OverflowEvent.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();

    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());

    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, type, args[0]);
    OverflowEventInit eventInit;
    if (args.Length() >= 2) {
        EXCEPTION_BLOCK(Dictionary, options, args[1]);
        if (!fillOverflowEventInit(eventInit, options))
            return v8::Undefined();
    }

    RefPtr<OverflowEvent> event = OverflowEvent::create(type, eventInit);

    V8DOMWrapper::setDOMWrapper(args.Holder(), &info, event.get());
    V8DOMWrapper::setJSWrapperForDOMObject(event.release(), v8::Persistent<v8::Object>::New(args.Holder()), args.GetIsolate());
    return args.Holder();
}

bool fillOverflowEventInit(OverflowEventInit& eventInit, const Dictionary& options)
{
    if (!fillEventInit(eventInit, options))
        return false;

    options.get("orient", eventInit.orient);
    options.get("horizontalOverflow", eventInit.horizontalOverflow);
    options.get("verticalOverflow", eventInit.verticalOverflow);
    return true;
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8OverflowEventTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "OverflowEvent", V8Event::GetTemplate(), V8OverflowEvent::internalFieldCount,
        OverflowEventAttrs, WTF_ARRAY_LENGTH(OverflowEventAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8OverflowEvent::constructorCallback);
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    batchConfigureConstants(desc, proto, OverflowEventConsts, WTF_ARRAY_LENGTH(OverflowEventConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8OverflowEvent::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8OverflowEvent::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8OverflowEventTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8OverflowEvent::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8OverflowEvent::wrapSlow(PassRefPtr<OverflowEvent> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8OverflowEvent::derefObject(void* object)
{
    static_cast<OverflowEvent*>(object)->deref();
}

} // namespace WebCore
