/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8PeerConnection00.h"

#if ENABLE(MEDIA_STREAM)

#include "ContextFeatures.h"
#include "Dictionary.h"
#include "EventListener.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8AbstractEventListener.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8Event.h"
#include "V8IceCallback.h"
#include "V8IceCandidate.h"
#include "V8IsolatedContext.h"
#include "V8MediaStream.h"
#include "V8MediaStreamList.h"
#include "V8Proxy.h"
#include "V8SessionDescription.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8PeerConnection00::info = { V8PeerConnection00::GetTemplate, V8PeerConnection00::derefObject, V8PeerConnection00::toActiveDOMObject, 0, 0, WrapperTypeObjectPrototype };

namespace PeerConnection00V8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> localDescriptionAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.localDescription._get");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    RefPtr<SessionDescription> result = imp->localDescription();
    v8::Handle<v8::Value> wrapper = result.get() ? getActiveDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "localDescription", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> remoteDescriptionAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.remoteDescription._get");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    RefPtr<SessionDescription> result = imp->remoteDescription();
    v8::Handle<v8::Value> wrapper = result.get() ? getActiveDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "remoteDescription", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> readyStateAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.readyState._get");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    return v8Integer(imp->readyState(), info.GetIsolate());
}

static v8::Handle<v8::Value> iceStateAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.iceState._get");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    return v8Integer(imp->iceState(), info.GetIsolate());
}

static v8::Handle<v8::Value> localStreamsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.localStreams._get");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    RefPtr<MediaStreamList> result = imp->localStreams();
    v8::Handle<v8::Value> wrapper = result.get() ? getActiveDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "localStreams", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> remoteStreamsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.remoteStreams._get");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    RefPtr<MediaStreamList> result = imp->remoteStreams();
    v8::Handle<v8::Value> wrapper = result.get() ? getActiveDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "remoteStreams", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> onconnectingAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.onconnecting._get");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    return imp->onconnecting() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onconnecting())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onconnectingAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.onconnecting._set");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onconnecting(), value, V8PeerConnection00::eventListenerCacheIndex);
    imp->setOnconnecting(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onopenAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.onopen._get");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    return imp->onopen() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onopen())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onopenAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.onopen._set");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onopen(), value, V8PeerConnection00::eventListenerCacheIndex);
    imp->setOnopen(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onstatechangeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.onstatechange._get");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    return imp->onstatechange() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onstatechange())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onstatechangeAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.onstatechange._set");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onstatechange(), value, V8PeerConnection00::eventListenerCacheIndex);
    imp->setOnstatechange(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onaddstreamAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.onaddstream._get");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    return imp->onaddstream() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onaddstream())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onaddstreamAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.onaddstream._set");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onaddstream(), value, V8PeerConnection00::eventListenerCacheIndex);
    imp->setOnaddstream(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onremovestreamAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.onremovestream._get");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    return imp->onremovestream() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onremovestream())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onremovestreamAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.PeerConnection00.onremovestream._set");
    PeerConnection00* imp = V8PeerConnection00::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onremovestream(), value, V8PeerConnection00::eventListenerCacheIndex);
    imp->setOnremovestream(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> createOfferCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.createOffer");
    PeerConnection00* imp = V8PeerConnection00::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    if (args.Length() <= 0) {
        RefPtr<SessionDescription> result = imp->createOffer(ec);
        if (UNLIKELY(ec))
            goto fail;
        return toV8(result.release(), args.GetIsolate());
    }
    EXCEPTION_BLOCK(Dictionary, mediaHints, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    if (!mediaHints.isUndefinedOrNull() && !mediaHints.isObject())
        return V8Proxy::throwTypeError("Not an object.", args.GetIsolate());
    RefPtr<SessionDescription> result = imp->createOffer(mediaHints, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> createAnswerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.createAnswer");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    PeerConnection00* imp = V8PeerConnection00::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, offer, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    if (args.Length() <= 1) {
        RefPtr<SessionDescription> result = imp->createAnswer(offer, ec);
        if (UNLIKELY(ec))
            goto fail;
        return toV8(result.release(), args.GetIsolate());
    }
    EXCEPTION_BLOCK(Dictionary, mediaHints, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    if (!mediaHints.isUndefinedOrNull() && !mediaHints.isObject())
        return V8Proxy::throwTypeError("Not an object.", args.GetIsolate());
    RefPtr<SessionDescription> result = imp->createAnswer(offer, mediaHints, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setLocalDescriptionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.setLocalDescription");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    PeerConnection00* imp = V8PeerConnection00::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, action, toUInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    EXCEPTION_BLOCK(SessionDescription*, desc, V8SessionDescription::HasInstance(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)) ? V8SessionDescription::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined))) : 0);
    imp->setLocalDescription(action, desc, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> setRemoteDescriptionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.setRemoteDescription");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    PeerConnection00* imp = V8PeerConnection00::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(int, action, toUInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    EXCEPTION_BLOCK(SessionDescription*, desc, V8SessionDescription::HasInstance(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)) ? V8SessionDescription::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined))) : 0);
    imp->setRemoteDescription(action, desc, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> startIceCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.startIce");
    PeerConnection00* imp = V8PeerConnection00::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    if (args.Length() <= 0) {
        imp->startIce(ec);
        if (UNLIKELY(ec))
            goto fail;
        return v8::Handle<v8::Value>();
    }
    EXCEPTION_BLOCK(Dictionary, iceOptions, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    if (!iceOptions.isUndefinedOrNull() && !iceOptions.isObject())
        return V8Proxy::throwTypeError("Not an object.", args.GetIsolate());
    imp->startIce(iceOptions, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> processIceMessageCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.processIceMessage");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    PeerConnection00* imp = V8PeerConnection00::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(IceCandidate*, candidate, V8IceCandidate::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8IceCandidate::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->processIceMessage(candidate, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> addStreamCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.addStream");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    PeerConnection00* imp = V8PeerConnection00::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    if (args.Length() > 0 && !isUndefinedOrNull(args[0]) && !V8MediaStream::HasInstance(args[0]))
        return V8Proxy::throwTypeError(0, args.GetIsolate());
    EXCEPTION_BLOCK(MediaStream*, stream, V8MediaStream::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8MediaStream::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    if (args.Length() <= 1) {
        imp->addStream(stream, ec);
        if (UNLIKELY(ec))
            goto fail;
        return v8::Handle<v8::Value>();
    }
    EXCEPTION_BLOCK(Dictionary, mediaStreamHints, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    if (!mediaStreamHints.isUndefinedOrNull() && !mediaStreamHints.isObject())
        return V8Proxy::throwTypeError("Not an object.", args.GetIsolate());
    imp->addStream(stream, mediaStreamHints, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> removeStreamCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.removeStream");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    PeerConnection00* imp = V8PeerConnection00::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    if (args.Length() > 0 && !isUndefinedOrNull(args[0]) && !V8MediaStream::HasInstance(args[0]))
        return V8Proxy::throwTypeError(0, args.GetIsolate());
    EXCEPTION_BLOCK(MediaStream*, stream, V8MediaStream::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8MediaStream::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->removeStream(stream, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> closeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.close");
    PeerConnection00* imp = V8PeerConnection00::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    imp->close(ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> addEventListenerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.addEventListener()");
    RefPtr<EventListener> listener = V8DOMWrapper::getEventListener(args[1], false, ListenerFindOrCreate);
    if (listener) {
        V8PeerConnection00::toNative(args.Holder())->addEventListener(v8ValueToAtomicWebCoreString(args[0]), listener, args[2]->BooleanValue());
        createHiddenDependency(args.Holder(), args[1], V8PeerConnection00::eventListenerCacheIndex);
    }
    return v8::Undefined();
}

static v8::Handle<v8::Value> removeEventListenerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.removeEventListener()");
    RefPtr<EventListener> listener = V8DOMWrapper::getEventListener(args[1], false, ListenerFindOnly);
    if (listener) {
        V8PeerConnection00::toNative(args.Holder())->removeEventListener(v8ValueToAtomicWebCoreString(args[0]), listener.get(), args[2]->BooleanValue());
        removeHiddenDependency(args.Holder(), args[1], V8PeerConnection00::eventListenerCacheIndex);
    }
    return v8::Undefined();
}

static v8::Handle<v8::Value> dispatchEventCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.dispatchEvent");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    PeerConnection00* imp = V8PeerConnection00::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Event*, event, V8Event::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Event::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    bool result = imp->dispatchEvent(event, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace PeerConnection00V8Internal

static const BatchedAttribute PeerConnection00Attrs[] = {
    // Attribute 'localDescription' (Type: 'readonly attribute' ExtAttr: '')
    {"localDescription", PeerConnection00V8Internal::localDescriptionAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'remoteDescription' (Type: 'readonly attribute' ExtAttr: '')
    {"remoteDescription", PeerConnection00V8Internal::remoteDescriptionAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'readyState' (Type: 'readonly attribute' ExtAttr: '')
    {"readyState", PeerConnection00V8Internal::readyStateAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'iceState' (Type: 'readonly attribute' ExtAttr: '')
    {"iceState", PeerConnection00V8Internal::iceStateAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'localStreams' (Type: 'readonly attribute' ExtAttr: '')
    {"localStreams", PeerConnection00V8Internal::localStreamsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'remoteStreams' (Type: 'readonly attribute' ExtAttr: '')
    {"remoteStreams", PeerConnection00V8Internal::remoteStreamsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onconnecting' (Type: 'attribute' ExtAttr: '')
    {"onconnecting", PeerConnection00V8Internal::onconnectingAttrGetter, PeerConnection00V8Internal::onconnectingAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onopen' (Type: 'attribute' ExtAttr: '')
    {"onopen", PeerConnection00V8Internal::onopenAttrGetter, PeerConnection00V8Internal::onopenAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onstatechange' (Type: 'attribute' ExtAttr: '')
    {"onstatechange", PeerConnection00V8Internal::onstatechangeAttrGetter, PeerConnection00V8Internal::onstatechangeAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onaddstream' (Type: 'attribute' ExtAttr: '')
    {"onaddstream", PeerConnection00V8Internal::onaddstreamAttrGetter, PeerConnection00V8Internal::onaddstreamAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onremovestream' (Type: 'attribute' ExtAttr: '')
    {"onremovestream", PeerConnection00V8Internal::onremovestreamAttrGetter, PeerConnection00V8Internal::onremovestreamAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback PeerConnection00Callbacks[] = {
    {"createOffer", PeerConnection00V8Internal::createOfferCallback},
    {"createAnswer", PeerConnection00V8Internal::createAnswerCallback},
    {"startIce", PeerConnection00V8Internal::startIceCallback},
    {"addStream", PeerConnection00V8Internal::addStreamCallback},
    {"removeStream", PeerConnection00V8Internal::removeStreamCallback},
    {"close", PeerConnection00V8Internal::closeCallback},
    {"addEventListener", PeerConnection00V8Internal::addEventListenerCallback},
    {"removeEventListener", PeerConnection00V8Internal::removeEventListenerCallback},
};

static const BatchedConstant PeerConnection00Consts[] = {
    {"SDP_OFFER", static_cast<signed int>(0x100)},
    {"SDP_PRANSWER", static_cast<signed int>(0x200)},
    {"SDP_ANSWER", static_cast<signed int>(0x300)},
    {"NEW", static_cast<signed int>(0)},
    {"OPENING", static_cast<signed int>(1)},
    {"ACTIVE", static_cast<signed int>(2)},
    {"CLOSED", static_cast<signed int>(3)},
    {"ICE_GATHERING", static_cast<signed int>(0x100)},
    {"ICE_WAITING", static_cast<signed int>(0x200)},
    {"ICE_CHECKING", static_cast<signed int>(0x300)},
    {"ICE_CONNECTED", static_cast<signed int>(0x400)},
    {"ICE_COMPLETED", static_cast<signed int>(0x500)},
    {"ICE_FAILED", static_cast<signed int>(0x600)},
    {"ICE_CLOSED", static_cast<signed int>(0x700)},
};


COMPILE_ASSERT(0x100 == PeerConnection00::SDP_OFFER, PeerConnection00EnumSDP_OFFERIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(0x200 == PeerConnection00::SDP_PRANSWER, PeerConnection00EnumSDP_PRANSWERIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(0x300 == PeerConnection00::SDP_ANSWER, PeerConnection00EnumSDP_ANSWERIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(0 == PeerConnection00::NEW, PeerConnection00EnumNEWIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(1 == PeerConnection00::OPENING, PeerConnection00EnumOPENINGIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(2 == PeerConnection00::ACTIVE, PeerConnection00EnumACTIVEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(3 == PeerConnection00::CLOSED, PeerConnection00EnumCLOSEDIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(0x100 == PeerConnection00::ICE_GATHERING, PeerConnection00EnumICE_GATHERINGIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(0x200 == PeerConnection00::ICE_WAITING, PeerConnection00EnumICE_WAITINGIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(0x300 == PeerConnection00::ICE_CHECKING, PeerConnection00EnumICE_CHECKINGIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(0x400 == PeerConnection00::ICE_CONNECTED, PeerConnection00EnumICE_CONNECTEDIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(0x500 == PeerConnection00::ICE_COMPLETED, PeerConnection00EnumICE_COMPLETEDIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(0x600 == PeerConnection00::ICE_FAILED, PeerConnection00EnumICE_FAILEDIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(0x700 == PeerConnection00::ICE_CLOSED, PeerConnection00EnumICE_CLOSEDIsWrongUseDoNotCheckConstants);

v8::Handle<v8::Value> V8PeerConnection00::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.PeerConnection00.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());

    ExceptionCode ec = 0;
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, serverConfiguration, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    if (args.Length() <= 1 || !args[1]->IsFunction())
        return throwError(TYPE_MISMATCH_ERR, args.GetIsolate());
    RefPtr<IceCallback> iceCallback = V8IceCallback::create(args[1], getScriptExecutionContext());

    ScriptExecutionContext* context = getScriptExecutionContext();
    if (!context)
        return V8Proxy::throwError(V8Proxy::ReferenceError, "PeerConnection00 constructor's associated context is not available", args.GetIsolate());

    RefPtr<PeerConnection00> impl = PeerConnection00::create(context, serverConfiguration, iceCallback, ec);
    v8::Handle<v8::Object> wrapper = args.Holder();
    if (ec)
        goto fail;

    V8DOMWrapper::setDOMWrapper(wrapper, &info, impl.get());
    V8DOMWrapper::setJSWrapperForActiveDOMObject(impl.release(), v8::Persistent<v8::Object>::New(wrapper), args.GetIsolate());
    return args.Holder();
  fail:
    return throwError(ec, args.GetIsolate());
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8PeerConnection00Template(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "PeerConnection00", v8::Persistent<v8::FunctionTemplate>(), V8PeerConnection00::internalFieldCount,
        PeerConnection00Attrs, WTF_ARRAY_LENGTH(PeerConnection00Attrs),
        PeerConnection00Callbacks, WTF_ARRAY_LENGTH(PeerConnection00Callbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8PeerConnection00::constructorCallback);
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'setLocalDescription'
    const int setLocalDescriptionArgc = 2;
    v8::Handle<v8::FunctionTemplate> setLocalDescriptionArgv[setLocalDescriptionArgc] = { v8::Handle<v8::FunctionTemplate>(), V8SessionDescription::GetRawTemplate() };
    v8::Handle<v8::Signature> setLocalDescriptionSignature = v8::Signature::New(desc, setLocalDescriptionArgc, setLocalDescriptionArgv);
    proto->Set(v8::String::New("setLocalDescription"), v8::FunctionTemplate::New(PeerConnection00V8Internal::setLocalDescriptionCallback, v8::Handle<v8::Value>(), setLocalDescriptionSignature));

    // Custom Signature 'setRemoteDescription'
    const int setRemoteDescriptionArgc = 2;
    v8::Handle<v8::FunctionTemplate> setRemoteDescriptionArgv[setRemoteDescriptionArgc] = { v8::Handle<v8::FunctionTemplate>(), V8SessionDescription::GetRawTemplate() };
    v8::Handle<v8::Signature> setRemoteDescriptionSignature = v8::Signature::New(desc, setRemoteDescriptionArgc, setRemoteDescriptionArgv);
    proto->Set(v8::String::New("setRemoteDescription"), v8::FunctionTemplate::New(PeerConnection00V8Internal::setRemoteDescriptionCallback, v8::Handle<v8::Value>(), setRemoteDescriptionSignature));

    // Custom Signature 'processIceMessage'
    const int processIceMessageArgc = 1;
    v8::Handle<v8::FunctionTemplate> processIceMessageArgv[processIceMessageArgc] = { V8IceCandidate::GetRawTemplate() };
    v8::Handle<v8::Signature> processIceMessageSignature = v8::Signature::New(desc, processIceMessageArgc, processIceMessageArgv);
    proto->Set(v8::String::New("processIceMessage"), v8::FunctionTemplate::New(PeerConnection00V8Internal::processIceMessageCallback, v8::Handle<v8::Value>(), processIceMessageSignature));

    // Custom Signature 'dispatchEvent'
    const int dispatchEventArgc = 1;
    v8::Handle<v8::FunctionTemplate> dispatchEventArgv[dispatchEventArgc] = { V8Event::GetRawTemplate() };
    v8::Handle<v8::Signature> dispatchEventSignature = v8::Signature::New(desc, dispatchEventArgc, dispatchEventArgv);
    proto->Set(v8::String::New("dispatchEvent"), v8::FunctionTemplate::New(PeerConnection00V8Internal::dispatchEventCallback, v8::Handle<v8::Value>(), dispatchEventSignature));
    batchConfigureConstants(desc, proto, PeerConnection00Consts, WTF_ARRAY_LENGTH(PeerConnection00Consts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8PeerConnection00::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8PeerConnection00::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8PeerConnection00Template(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8PeerConnection00::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}

ActiveDOMObject* V8PeerConnection00::toActiveDOMObject(v8::Handle<v8::Object> object)
{
    return toNative(object);
}      

v8::Handle<v8::Object> V8PeerConnection00::wrapSlow(PassRefPtr<PeerConnection00> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForActiveDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8PeerConnection00::derefObject(void* object)
{
    static_cast<PeerConnection00*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(MEDIA_STREAM)
