/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8SVGAnimationElement.h"

#if ENABLE(SVG)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "SVGPropertyTearOff.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8SVGAnimatedBoolean.h"
#include "V8SVGElement.h"
#include "V8SVGStringList.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8SVGAnimationElement::info = { V8SVGAnimationElement::GetTemplate, V8SVGAnimationElement::derefObject, 0, 0, &V8SVGElement::info, WrapperTypeObjectPrototype };

namespace SVGAnimationElementV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> targetElementAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGAnimationElement.targetElement._get");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(info.Holder());
    return toV8(imp->targetElement(), info.GetIsolate());
}

static v8::Handle<v8::Value> requiredFeaturesAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGAnimationElement.requiredFeatures._get");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(info.Holder());
    return toV8(WTF::getPtr(SVGStaticListPropertyTearOff<SVGStringList>::create(imp, imp->requiredFeatures())), info.GetIsolate());
}

static v8::Handle<v8::Value> requiredExtensionsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGAnimationElement.requiredExtensions._get");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(info.Holder());
    return toV8(WTF::getPtr(SVGStaticListPropertyTearOff<SVGStringList>::create(imp, imp->requiredExtensions())), info.GetIsolate());
}

static v8::Handle<v8::Value> systemLanguageAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGAnimationElement.systemLanguage._get");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(info.Holder());
    return toV8(WTF::getPtr(SVGStaticListPropertyTearOff<SVGStringList>::create(imp, imp->systemLanguage())), info.GetIsolate());
}

static v8::Handle<v8::Value> externalResourcesRequiredAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGAnimationElement.externalResourcesRequired._get");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(info.Holder());
    return toV8(imp->externalResourcesRequiredAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> getStartTimeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGAnimationElement.getStartTime");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(args.Holder());
    return v8::Number::New(imp->getStartTime());
}

static v8::Handle<v8::Value> getCurrentTimeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGAnimationElement.getCurrentTime");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(args.Holder());
    return v8::Number::New(imp->getCurrentTime());
}

static v8::Handle<v8::Value> getSimpleDurationCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGAnimationElement.getSimpleDuration");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    float result = imp->getSimpleDuration(ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Number::New(result);
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> hasExtensionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGAnimationElement.hasExtension");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, extension, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return v8Boolean(imp->hasExtension(extension), args.GetIsolate());
}

static v8::Handle<v8::Value> beginElementCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGAnimationElement.beginElement");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(args.Holder());
    imp->beginElement();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> beginElementAtCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGAnimationElement.beginElementAt");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(args.Holder());
    EXCEPTION_BLOCK(float, offset, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    imp->beginElementAt(offset);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> endElementCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGAnimationElement.endElement");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(args.Holder());
    imp->endElement();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> endElementAtCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGAnimationElement.endElementAt");
    SVGAnimationElement* imp = V8SVGAnimationElement::toNative(args.Holder());
    EXCEPTION_BLOCK(float, offset, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    imp->endElementAt(offset);
    return v8::Handle<v8::Value>();
}

} // namespace SVGAnimationElementV8Internal

static const BatchedAttribute SVGAnimationElementAttrs[] = {
    // Attribute 'targetElement' (Type: 'readonly attribute' ExtAttr: '')
    {"targetElement", SVGAnimationElementV8Internal::targetElementAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'requiredFeatures' (Type: 'readonly attribute' ExtAttr: '')
    {"requiredFeatures", SVGAnimationElementV8Internal::requiredFeaturesAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'requiredExtensions' (Type: 'readonly attribute' ExtAttr: '')
    {"requiredExtensions", SVGAnimationElementV8Internal::requiredExtensionsAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'systemLanguage' (Type: 'readonly attribute' ExtAttr: '')
    {"systemLanguage", SVGAnimationElementV8Internal::systemLanguageAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'externalResourcesRequired' (Type: 'readonly attribute' ExtAttr: '')
    {"externalResourcesRequired", SVGAnimationElementV8Internal::externalResourcesRequiredAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback SVGAnimationElementCallbacks[] = {
    {"getStartTime", SVGAnimationElementV8Internal::getStartTimeCallback},
    {"getCurrentTime", SVGAnimationElementV8Internal::getCurrentTimeCallback},
    {"getSimpleDuration", SVGAnimationElementV8Internal::getSimpleDurationCallback},
    {"hasExtension", SVGAnimationElementV8Internal::hasExtensionCallback},
    {"beginElement", SVGAnimationElementV8Internal::beginElementCallback},
    {"beginElementAt", SVGAnimationElementV8Internal::beginElementAtCallback},
    {"endElement", SVGAnimationElementV8Internal::endElementCallback},
    {"endElementAt", SVGAnimationElementV8Internal::endElementAtCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8SVGAnimationElementTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "SVGAnimationElement", V8SVGElement::GetTemplate(), V8SVGAnimationElement::internalFieldCount,
        SVGAnimationElementAttrs, WTF_ARRAY_LENGTH(SVGAnimationElementAttrs),
        SVGAnimationElementCallbacks, WTF_ARRAY_LENGTH(SVGAnimationElementCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8SVGAnimationElement::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8SVGAnimationElement::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8SVGAnimationElementTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8SVGAnimationElement::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8SVGAnimationElement::wrapSlow(PassRefPtr<SVGAnimationElement> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = V8Proxy::retrieve(impl->document()->frame());

    // Enter the node's context and create the wrapper in that context.
    v8::Handle<v8::Context> context;
    if (proxy && !proxy->matchesCurrentContext()) {
        // For performance, we enter the context only if the currently running context
        // is different from the context that we are about to enter.
        context = proxy->context();
        if (!context.IsEmpty())
            context->Enter();
    }
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    // Exit the node's context if it was entered.
    if (!context.IsEmpty())
        context->Exit();
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    wrapperHandle.SetWrapperClassId(v8DOMSubtreeClassId);
    V8DOMWrapper::setJSWrapperForDOMNode(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8SVGAnimationElement::derefObject(void* object)
{
    static_cast<SVGAnimationElement*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(SVG)
