/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8SVGComponentTransferFunctionElement.h"

#if ENABLE(FILTERS) && ENABLE(SVG)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8SVGAnimatedEnumeration.h"
#include "V8SVGAnimatedNumber.h"
#include "V8SVGAnimatedNumberList.h"
#include "V8SVGElement.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8SVGComponentTransferFunctionElement::info = { V8SVGComponentTransferFunctionElement::GetTemplate, V8SVGComponentTransferFunctionElement::derefObject, 0, 0, &V8SVGElement::info, WrapperTypeObjectPrototype };

namespace SVGComponentTransferFunctionElementV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> typeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGComponentTransferFunctionElement.type._get");
    SVGComponentTransferFunctionElement* imp = V8SVGComponentTransferFunctionElement::toNative(info.Holder());
    return toV8(static_pointer_cast<SVGAnimatedEnumeration>(imp->typeAnimated()), info.GetIsolate());
}

static v8::Handle<v8::Value> tableValuesAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGComponentTransferFunctionElement.tableValues._get");
    SVGComponentTransferFunctionElement* imp = V8SVGComponentTransferFunctionElement::toNative(info.Holder());
    return toV8(imp->tableValuesAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> slopeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGComponentTransferFunctionElement.slope._get");
    SVGComponentTransferFunctionElement* imp = V8SVGComponentTransferFunctionElement::toNative(info.Holder());
    return toV8(imp->slopeAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> interceptAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGComponentTransferFunctionElement.intercept._get");
    SVGComponentTransferFunctionElement* imp = V8SVGComponentTransferFunctionElement::toNative(info.Holder());
    return toV8(imp->interceptAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> amplitudeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGComponentTransferFunctionElement.amplitude._get");
    SVGComponentTransferFunctionElement* imp = V8SVGComponentTransferFunctionElement::toNative(info.Holder());
    return toV8(imp->amplitudeAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> exponentAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGComponentTransferFunctionElement.exponent._get");
    SVGComponentTransferFunctionElement* imp = V8SVGComponentTransferFunctionElement::toNative(info.Holder());
    return toV8(imp->exponentAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> offsetAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGComponentTransferFunctionElement.offset._get");
    SVGComponentTransferFunctionElement* imp = V8SVGComponentTransferFunctionElement::toNative(info.Holder());
    return toV8(imp->offsetAnimated(), info.GetIsolate());
}

} // namespace SVGComponentTransferFunctionElementV8Internal

static const BatchedAttribute SVGComponentTransferFunctionElementAttrs[] = {
    // Attribute 'type' (Type: 'readonly attribute' ExtAttr: '')
    {"type", SVGComponentTransferFunctionElementV8Internal::typeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'tableValues' (Type: 'readonly attribute' ExtAttr: '')
    {"tableValues", SVGComponentTransferFunctionElementV8Internal::tableValuesAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'slope' (Type: 'readonly attribute' ExtAttr: '')
    {"slope", SVGComponentTransferFunctionElementV8Internal::slopeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'intercept' (Type: 'readonly attribute' ExtAttr: '')
    {"intercept", SVGComponentTransferFunctionElementV8Internal::interceptAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'amplitude' (Type: 'readonly attribute' ExtAttr: '')
    {"amplitude", SVGComponentTransferFunctionElementV8Internal::amplitudeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'exponent' (Type: 'readonly attribute' ExtAttr: '')
    {"exponent", SVGComponentTransferFunctionElementV8Internal::exponentAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'offset' (Type: 'readonly attribute' ExtAttr: '')
    {"offset", SVGComponentTransferFunctionElementV8Internal::offsetAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedConstant SVGComponentTransferFunctionElementConsts[] = {
    {"SVG_FECOMPONENTTRANSFER_TYPE_UNKNOWN", static_cast<signed int>(0)},
    {"SVG_FECOMPONENTTRANSFER_TYPE_IDENTITY", static_cast<signed int>(1)},
    {"SVG_FECOMPONENTTRANSFER_TYPE_TABLE", static_cast<signed int>(2)},
    {"SVG_FECOMPONENTTRANSFER_TYPE_DISCRETE", static_cast<signed int>(3)},
    {"SVG_FECOMPONENTTRANSFER_TYPE_LINEAR", static_cast<signed int>(4)},
    {"SVG_FECOMPONENTTRANSFER_TYPE_GAMMA", static_cast<signed int>(5)},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8SVGComponentTransferFunctionElementTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "SVGComponentTransferFunctionElement", V8SVGElement::GetTemplate(), V8SVGComponentTransferFunctionElement::internalFieldCount,
        SVGComponentTransferFunctionElementAttrs, WTF_ARRAY_LENGTH(SVGComponentTransferFunctionElementAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    batchConfigureConstants(desc, proto, SVGComponentTransferFunctionElementConsts, WTF_ARRAY_LENGTH(SVGComponentTransferFunctionElementConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8SVGComponentTransferFunctionElement::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8SVGComponentTransferFunctionElement::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8SVGComponentTransferFunctionElementTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8SVGComponentTransferFunctionElement::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8SVGComponentTransferFunctionElement::wrapSlow(PassRefPtr<SVGComponentTransferFunctionElement> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = V8Proxy::retrieve(impl->document()->frame());

    // Enter the node's context and create the wrapper in that context.
    v8::Handle<v8::Context> context;
    if (proxy && !proxy->matchesCurrentContext()) {
        // For performance, we enter the context only if the currently running context
        // is different from the context that we are about to enter.
        context = proxy->context();
        if (!context.IsEmpty())
            context->Enter();
    }
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    // Exit the node's context if it was entered.
    if (!context.IsEmpty())
        context->Exit();
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    wrapperHandle.SetWrapperClassId(v8DOMSubtreeClassId);
    V8DOMWrapper::setJSWrapperForDOMNode(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8SVGComponentTransferFunctionElement::derefObject(void* object)
{
    static_cast<SVGComponentTransferFunctionElement*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(FILTERS) && ENABLE(SVG)
