/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8SVGFEDisplacementMapElement.h"

#if ENABLE(FILTERS) && ENABLE(SVG)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "StylePropertySet.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8CSSStyleDeclaration.h"
#include "V8CSSValue.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8SVGAnimatedEnumeration.h"
#include "V8SVGAnimatedLength.h"
#include "V8SVGAnimatedNumber.h"
#include "V8SVGAnimatedString.h"
#include "V8SVGElement.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8SVGFEDisplacementMapElement::info = { V8SVGFEDisplacementMapElement::GetTemplate, V8SVGFEDisplacementMapElement::derefObject, 0, 0, &V8SVGElement::info, WrapperTypeObjectPrototype };

namespace SVGFEDisplacementMapElementV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> in1AttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.in1._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(imp->in1Animated(), info.GetIsolate());
}

static v8::Handle<v8::Value> in2AttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.in2._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(imp->in2Animated(), info.GetIsolate());
}

static v8::Handle<v8::Value> scaleAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.scale._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(imp->scaleAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> xChannelSelectorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.xChannelSelector._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(static_pointer_cast<SVGAnimatedEnumeration>(imp->xChannelSelectorAnimated()), info.GetIsolate());
}

static v8::Handle<v8::Value> yChannelSelectorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.yChannelSelector._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(static_pointer_cast<SVGAnimatedEnumeration>(imp->yChannelSelectorAnimated()), info.GetIsolate());
}

static v8::Handle<v8::Value> xAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.x._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(imp->xAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> yAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.y._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(imp->yAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> widthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.width._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(imp->widthAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> heightAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.height._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(imp->heightAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> resultAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.result._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(imp->resultAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> classNameAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.className._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(imp->classNameAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> styleAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.style._get");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(info.Holder());
    return toV8(imp->style(), info.GetIsolate());
}

static v8::Handle<v8::Value> getPresentationAttributeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGFEDisplacementMapElement.getPresentationAttribute");
    SVGFEDisplacementMapElement* imp = V8SVGFEDisplacementMapElement::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, name, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return toV8(imp->getPresentationAttribute(name), args.GetIsolate());
}

} // namespace SVGFEDisplacementMapElementV8Internal

static const BatchedAttribute SVGFEDisplacementMapElementAttrs[] = {
    // Attribute 'in1' (Type: 'readonly attribute' ExtAttr: '')
    {"in1", SVGFEDisplacementMapElementV8Internal::in1AttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'in2' (Type: 'readonly attribute' ExtAttr: '')
    {"in2", SVGFEDisplacementMapElementV8Internal::in2AttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'scale' (Type: 'readonly attribute' ExtAttr: '')
    {"scale", SVGFEDisplacementMapElementV8Internal::scaleAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'xChannelSelector' (Type: 'readonly attribute' ExtAttr: '')
    {"xChannelSelector", SVGFEDisplacementMapElementV8Internal::xChannelSelectorAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'yChannelSelector' (Type: 'readonly attribute' ExtAttr: '')
    {"yChannelSelector", SVGFEDisplacementMapElementV8Internal::yChannelSelectorAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'x' (Type: 'readonly attribute' ExtAttr: '')
    {"x", SVGFEDisplacementMapElementV8Internal::xAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'y' (Type: 'readonly attribute' ExtAttr: '')
    {"y", SVGFEDisplacementMapElementV8Internal::yAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'width' (Type: 'readonly attribute' ExtAttr: '')
    {"width", SVGFEDisplacementMapElementV8Internal::widthAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'height' (Type: 'readonly attribute' ExtAttr: '')
    {"height", SVGFEDisplacementMapElementV8Internal::heightAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'result' (Type: 'readonly attribute' ExtAttr: '')
    {"result", SVGFEDisplacementMapElementV8Internal::resultAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'className' (Type: 'readonly attribute' ExtAttr: '')
    {"className", SVGFEDisplacementMapElementV8Internal::classNameAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'style' (Type: 'readonly attribute' ExtAttr: '')
    {"style", SVGFEDisplacementMapElementV8Internal::styleAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback SVGFEDisplacementMapElementCallbacks[] = {
    {"getPresentationAttribute", SVGFEDisplacementMapElementV8Internal::getPresentationAttributeCallback},
};

static const BatchedConstant SVGFEDisplacementMapElementConsts[] = {
    {"SVG_CHANNEL_UNKNOWN", static_cast<signed int>(0)},
    {"SVG_CHANNEL_R", static_cast<signed int>(1)},
    {"SVG_CHANNEL_G", static_cast<signed int>(2)},
    {"SVG_CHANNEL_B", static_cast<signed int>(3)},
    {"SVG_CHANNEL_A", static_cast<signed int>(4)},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8SVGFEDisplacementMapElementTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "SVGFEDisplacementMapElement", V8SVGElement::GetTemplate(), V8SVGFEDisplacementMapElement::internalFieldCount,
        SVGFEDisplacementMapElementAttrs, WTF_ARRAY_LENGTH(SVGFEDisplacementMapElementAttrs),
        SVGFEDisplacementMapElementCallbacks, WTF_ARRAY_LENGTH(SVGFEDisplacementMapElementCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    batchConfigureConstants(desc, proto, SVGFEDisplacementMapElementConsts, WTF_ARRAY_LENGTH(SVGFEDisplacementMapElementConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8SVGFEDisplacementMapElement::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8SVGFEDisplacementMapElement::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8SVGFEDisplacementMapElementTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8SVGFEDisplacementMapElement::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8SVGFEDisplacementMapElement::wrapSlow(PassRefPtr<SVGFEDisplacementMapElement> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = V8Proxy::retrieve(impl->document()->frame());

    // Enter the node's context and create the wrapper in that context.
    v8::Handle<v8::Context> context;
    if (proxy && !proxy->matchesCurrentContext()) {
        // For performance, we enter the context only if the currently running context
        // is different from the context that we are about to enter.
        context = proxy->context();
        if (!context.IsEmpty())
            context->Enter();
    }
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    // Exit the node's context if it was entered.
    if (!context.IsEmpty())
        context->Exit();
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    wrapperHandle.SetWrapperClassId(v8DOMSubtreeClassId);
    V8DOMWrapper::setJSWrapperForDOMNode(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8SVGFEDisplacementMapElement::derefObject(void* object)
{
    static_cast<SVGFEDisplacementMapElement*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(FILTERS) && ENABLE(SVG)
