/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8SVGLinearGradientElement.h"

#if ENABLE(SVG)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8SVGAnimatedLength.h"
#include "V8SVGGradientElement.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8SVGLinearGradientElement::info = { V8SVGLinearGradientElement::GetTemplate, V8SVGLinearGradientElement::derefObject, 0, 0, &V8SVGGradientElement::info, WrapperTypeObjectPrototype };

namespace SVGLinearGradientElementV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> x1AttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGLinearGradientElement.x1._get");
    SVGLinearGradientElement* imp = V8SVGLinearGradientElement::toNative(info.Holder());
    return toV8(imp->x1Animated(), info.GetIsolate());
}

static v8::Handle<v8::Value> y1AttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGLinearGradientElement.y1._get");
    SVGLinearGradientElement* imp = V8SVGLinearGradientElement::toNative(info.Holder());
    return toV8(imp->y1Animated(), info.GetIsolate());
}

static v8::Handle<v8::Value> x2AttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGLinearGradientElement.x2._get");
    SVGLinearGradientElement* imp = V8SVGLinearGradientElement::toNative(info.Holder());
    return toV8(imp->x2Animated(), info.GetIsolate());
}

static v8::Handle<v8::Value> y2AttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGLinearGradientElement.y2._get");
    SVGLinearGradientElement* imp = V8SVGLinearGradientElement::toNative(info.Holder());
    return toV8(imp->y2Animated(), info.GetIsolate());
}

} // namespace SVGLinearGradientElementV8Internal

static const BatchedAttribute SVGLinearGradientElementAttrs[] = {
    // Attribute 'x1' (Type: 'readonly attribute' ExtAttr: '')
    {"x1", SVGLinearGradientElementV8Internal::x1AttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'y1' (Type: 'readonly attribute' ExtAttr: '')
    {"y1", SVGLinearGradientElementV8Internal::y1AttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'x2' (Type: 'readonly attribute' ExtAttr: '')
    {"x2", SVGLinearGradientElementV8Internal::x2AttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'y2' (Type: 'readonly attribute' ExtAttr: '')
    {"y2", SVGLinearGradientElementV8Internal::y2AttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8SVGLinearGradientElementTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "SVGLinearGradientElement", V8SVGGradientElement::GetTemplate(), V8SVGLinearGradientElement::internalFieldCount,
        SVGLinearGradientElementAttrs, WTF_ARRAY_LENGTH(SVGLinearGradientElementAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8SVGLinearGradientElement::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8SVGLinearGradientElement::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8SVGLinearGradientElementTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8SVGLinearGradientElement::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8SVGLinearGradientElement::wrapSlow(PassRefPtr<SVGLinearGradientElement> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = V8Proxy::retrieve(impl->document()->frame());

    // Enter the node's context and create the wrapper in that context.
    v8::Handle<v8::Context> context;
    if (proxy && !proxy->matchesCurrentContext()) {
        // For performance, we enter the context only if the currently running context
        // is different from the context that we are about to enter.
        context = proxy->context();
        if (!context.IsEmpty())
            context->Enter();
    }
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    // Exit the node's context if it was entered.
    if (!context.IsEmpty())
        context->Exit();
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    wrapperHandle.SetWrapperClassId(v8DOMSubtreeClassId);
    V8DOMWrapper::setJSWrapperForDOMNode(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8SVGLinearGradientElement::derefObject(void* object)
{
    static_cast<SVGLinearGradientElement*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(SVG)
