/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8SVGRadialGradientElement.h"

#if ENABLE(SVG)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8SVGAnimatedLength.h"
#include "V8SVGGradientElement.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8SVGRadialGradientElement::info = { V8SVGRadialGradientElement::GetTemplate, V8SVGRadialGradientElement::derefObject, 0, 0, &V8SVGGradientElement::info, WrapperTypeObjectPrototype };

namespace SVGRadialGradientElementV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> cxAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRadialGradientElement.cx._get");
    SVGRadialGradientElement* imp = V8SVGRadialGradientElement::toNative(info.Holder());
    return toV8(imp->cxAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> cyAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRadialGradientElement.cy._get");
    SVGRadialGradientElement* imp = V8SVGRadialGradientElement::toNative(info.Holder());
    return toV8(imp->cyAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> rAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRadialGradientElement.r._get");
    SVGRadialGradientElement* imp = V8SVGRadialGradientElement::toNative(info.Holder());
    return toV8(imp->rAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> fxAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRadialGradientElement.fx._get");
    SVGRadialGradientElement* imp = V8SVGRadialGradientElement::toNative(info.Holder());
    return toV8(imp->fxAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> fyAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRadialGradientElement.fy._get");
    SVGRadialGradientElement* imp = V8SVGRadialGradientElement::toNative(info.Holder());
    return toV8(imp->fyAnimated(), info.GetIsolate());
}

} // namespace SVGRadialGradientElementV8Internal

static const BatchedAttribute SVGRadialGradientElementAttrs[] = {
    // Attribute 'cx' (Type: 'readonly attribute' ExtAttr: '')
    {"cx", SVGRadialGradientElementV8Internal::cxAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'cy' (Type: 'readonly attribute' ExtAttr: '')
    {"cy", SVGRadialGradientElementV8Internal::cyAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'r' (Type: 'readonly attribute' ExtAttr: '')
    {"r", SVGRadialGradientElementV8Internal::rAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'fx' (Type: 'readonly attribute' ExtAttr: '')
    {"fx", SVGRadialGradientElementV8Internal::fxAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'fy' (Type: 'readonly attribute' ExtAttr: '')
    {"fy", SVGRadialGradientElementV8Internal::fyAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8SVGRadialGradientElementTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "SVGRadialGradientElement", V8SVGGradientElement::GetTemplate(), V8SVGRadialGradientElement::internalFieldCount,
        SVGRadialGradientElementAttrs, WTF_ARRAY_LENGTH(SVGRadialGradientElementAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8SVGRadialGradientElement::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8SVGRadialGradientElement::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8SVGRadialGradientElementTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8SVGRadialGradientElement::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8SVGRadialGradientElement::wrapSlow(PassRefPtr<SVGRadialGradientElement> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = V8Proxy::retrieve(impl->document()->frame());

    // Enter the node's context and create the wrapper in that context.
    v8::Handle<v8::Context> context;
    if (proxy && !proxy->matchesCurrentContext()) {
        // For performance, we enter the context only if the currently running context
        // is different from the context that we are about to enter.
        context = proxy->context();
        if (!context.IsEmpty())
            context->Enter();
    }
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    // Exit the node's context if it was entered.
    if (!context.IsEmpty())
        context->Exit();
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    wrapperHandle.SetWrapperClassId(v8DOMSubtreeClassId);
    V8DOMWrapper::setJSWrapperForDOMNode(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8SVGRadialGradientElement::derefObject(void* object)
{
    static_cast<SVGRadialGradientElement*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(SVG)
