/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8SVGRect.h"

#if ENABLE(SVG)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "SVGAnimatedPropertyTearOff.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8SVGRect::info = { V8SVGRect::GetTemplate, V8SVGRect::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace SVGRectV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> xAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRect.x._get");
    SVGPropertyTearOff<FloatRect>* wrapper = V8SVGRect::toNative(info.Holder());
    FloatRect& impInstance = wrapper->propertyReference();
    FloatRect* imp = &impInstance;
    return v8::Number::New(imp->x());
}

static void xAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRect.x._set");
    SVGPropertyTearOff<FloatRect>* wrapper = V8SVGRect::toNative(info.Holder());
    if (wrapper->isReadOnly()) {
        V8Proxy::setDOMException(NO_MODIFICATION_ALLOWED_ERR, info.GetIsolate());
        return;
    }
    FloatRect& impInstance = wrapper->propertyReference();
    FloatRect* imp = &impInstance;
    float v = static_cast<float>(value->NumberValue());
    imp->setX(v);
    wrapper->commitChange();
    return;
}

static v8::Handle<v8::Value> yAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRect.y._get");
    SVGPropertyTearOff<FloatRect>* wrapper = V8SVGRect::toNative(info.Holder());
    FloatRect& impInstance = wrapper->propertyReference();
    FloatRect* imp = &impInstance;
    return v8::Number::New(imp->y());
}

static void yAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRect.y._set");
    SVGPropertyTearOff<FloatRect>* wrapper = V8SVGRect::toNative(info.Holder());
    if (wrapper->isReadOnly()) {
        V8Proxy::setDOMException(NO_MODIFICATION_ALLOWED_ERR, info.GetIsolate());
        return;
    }
    FloatRect& impInstance = wrapper->propertyReference();
    FloatRect* imp = &impInstance;
    float v = static_cast<float>(value->NumberValue());
    imp->setY(v);
    wrapper->commitChange();
    return;
}

static v8::Handle<v8::Value> widthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRect.width._get");
    SVGPropertyTearOff<FloatRect>* wrapper = V8SVGRect::toNative(info.Holder());
    FloatRect& impInstance = wrapper->propertyReference();
    FloatRect* imp = &impInstance;
    return v8::Number::New(imp->width());
}

static void widthAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRect.width._set");
    SVGPropertyTearOff<FloatRect>* wrapper = V8SVGRect::toNative(info.Holder());
    if (wrapper->isReadOnly()) {
        V8Proxy::setDOMException(NO_MODIFICATION_ALLOWED_ERR, info.GetIsolate());
        return;
    }
    FloatRect& impInstance = wrapper->propertyReference();
    FloatRect* imp = &impInstance;
    float v = static_cast<float>(value->NumberValue());
    imp->setWidth(v);
    wrapper->commitChange();
    return;
}

static v8::Handle<v8::Value> heightAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRect.height._get");
    SVGPropertyTearOff<FloatRect>* wrapper = V8SVGRect::toNative(info.Holder());
    FloatRect& impInstance = wrapper->propertyReference();
    FloatRect* imp = &impInstance;
    return v8::Number::New(imp->height());
}

static void heightAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGRect.height._set");
    SVGPropertyTearOff<FloatRect>* wrapper = V8SVGRect::toNative(info.Holder());
    if (wrapper->isReadOnly()) {
        V8Proxy::setDOMException(NO_MODIFICATION_ALLOWED_ERR, info.GetIsolate());
        return;
    }
    FloatRect& impInstance = wrapper->propertyReference();
    FloatRect* imp = &impInstance;
    float v = static_cast<float>(value->NumberValue());
    imp->setHeight(v);
    wrapper->commitChange();
    return;
}

} // namespace SVGRectV8Internal

static const BatchedAttribute SVGRectAttrs[] = {
    // Attribute 'x' (Type: 'attribute' ExtAttr: 'StrictTypeChecking')
    {"x", SVGRectV8Internal::xAttrGetter, SVGRectV8Internal::xAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'y' (Type: 'attribute' ExtAttr: 'StrictTypeChecking')
    {"y", SVGRectV8Internal::yAttrGetter, SVGRectV8Internal::yAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'width' (Type: 'attribute' ExtAttr: 'StrictTypeChecking')
    {"width", SVGRectV8Internal::widthAttrGetter, SVGRectV8Internal::widthAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'height' (Type: 'attribute' ExtAttr: 'StrictTypeChecking')
    {"height", SVGRectV8Internal::heightAttrGetter, SVGRectV8Internal::heightAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8SVGRectTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "SVGRect", v8::Persistent<v8::FunctionTemplate>(), V8SVGRect::internalFieldCount,
        SVGRectAttrs, WTF_ARRAY_LENGTH(SVGRectAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8SVGRect::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8SVGRect::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8SVGRectTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8SVGRect::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8SVGRect::wrapSlow(PassRefPtr<SVGPropertyTearOff<FloatRect> > impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8SVGRect::derefObject(void* object)
{
    static_cast<SVGPropertyTearOff<FloatRect>*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(SVG)
