/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8SVGTransform.h"

#if ENABLE(SVG)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "SVGAnimatedPropertyTearOff.h"
#include "SVGPropertyTearOff.h"
#include "SVGStaticPropertyWithParentTearOff.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8SVGMatrix.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8SVGTransform::info = { V8SVGTransform::GetTemplate, V8SVGTransform::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace SVGTransformV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> typeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGTransform.type._get");
    SVGPropertyTearOff<SVGTransform>* wrapper = V8SVGTransform::toNative(info.Holder());
    SVGTransform& impInstance = wrapper->propertyReference();
    SVGTransform* imp = &impInstance;
    return v8Integer(imp->type(), info.GetIsolate());
}

static v8::Handle<v8::Value> matrixAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGTransform.matrix._get");
    SVGPropertyTearOff<SVGTransform>* wrapper = V8SVGTransform::toNative(info.Holder());
    SVGTransform& impInstance = wrapper->propertyReference();
    SVGTransform* imp = &impInstance;
    return toV8(WTF::getPtr(SVGStaticPropertyWithParentTearOff<SVGTransform, SVGMatrix>::create(wrapper, imp->svgMatrix(), &SVGTransform::updateMatrix)), info.GetIsolate());
}

static v8::Handle<v8::Value> angleAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGTransform.angle._get");
    SVGPropertyTearOff<SVGTransform>* wrapper = V8SVGTransform::toNative(info.Holder());
    SVGTransform& impInstance = wrapper->propertyReference();
    SVGTransform* imp = &impInstance;
    return v8::Number::New(imp->angle());
}

static v8::Handle<v8::Value> setMatrixCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGTransform.setMatrix");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    RefPtr<SVGPropertyTearOff<SVGTransform> > wrapper = V8SVGTransform::toNative(args.Holder());
    if (wrapper->isReadOnly())
        return V8Proxy::setDOMException(NO_MODIFICATION_ALLOWED_ERR, args.GetIsolate());
    SVGTransform& impInstance = wrapper->propertyReference();
    SVGTransform* imp = &impInstance;
    if (args.Length() > 0 && !isUndefinedOrNull(args[0]) && !V8SVGMatrix::HasInstance(args[0]))
        return V8Proxy::throwTypeError(0, args.GetIsolate());
    EXCEPTION_BLOCK(RefPtr<SVGPropertyTearOff<SVGMatrix> >, matrix, V8SVGMatrix::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8SVGMatrix::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    if (!matrix)
        return V8Proxy::setDOMException(WebCore::TYPE_MISMATCH_ERR, args.GetIsolate());
    imp->setMatrix(matrix->propertyReference());
    wrapper->commitChange();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> setTranslateCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGTransform.setTranslate");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    RefPtr<SVGPropertyTearOff<SVGTransform> > wrapper = V8SVGTransform::toNative(args.Holder());
    if (wrapper->isReadOnly())
        return V8Proxy::setDOMException(NO_MODIFICATION_ALLOWED_ERR, args.GetIsolate());
    SVGTransform& impInstance = wrapper->propertyReference();
    SVGTransform* imp = &impInstance;
    EXCEPTION_BLOCK(float, tx, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, ty, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)->NumberValue()));
    imp->setTranslate(tx, ty);
    wrapper->commitChange();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> setScaleCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGTransform.setScale");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    RefPtr<SVGPropertyTearOff<SVGTransform> > wrapper = V8SVGTransform::toNative(args.Holder());
    if (wrapper->isReadOnly())
        return V8Proxy::setDOMException(NO_MODIFICATION_ALLOWED_ERR, args.GetIsolate());
    SVGTransform& impInstance = wrapper->propertyReference();
    SVGTransform* imp = &impInstance;
    EXCEPTION_BLOCK(float, sx, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, sy, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)->NumberValue()));
    imp->setScale(sx, sy);
    wrapper->commitChange();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> setRotateCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGTransform.setRotate");
    if (args.Length() < 3)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    RefPtr<SVGPropertyTearOff<SVGTransform> > wrapper = V8SVGTransform::toNative(args.Holder());
    if (wrapper->isReadOnly())
        return V8Proxy::setDOMException(NO_MODIFICATION_ALLOWED_ERR, args.GetIsolate());
    SVGTransform& impInstance = wrapper->propertyReference();
    SVGTransform* imp = &impInstance;
    EXCEPTION_BLOCK(float, angle, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, cx, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)->NumberValue()));
    EXCEPTION_BLOCK(float, cy, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)->NumberValue()));
    imp->setRotate(angle, cx, cy);
    wrapper->commitChange();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> setSkewXCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGTransform.setSkewX");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    RefPtr<SVGPropertyTearOff<SVGTransform> > wrapper = V8SVGTransform::toNative(args.Holder());
    if (wrapper->isReadOnly())
        return V8Proxy::setDOMException(NO_MODIFICATION_ALLOWED_ERR, args.GetIsolate());
    SVGTransform& impInstance = wrapper->propertyReference();
    SVGTransform* imp = &impInstance;
    EXCEPTION_BLOCK(float, angle, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    imp->setSkewX(angle);
    wrapper->commitChange();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> setSkewYCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SVGTransform.setSkewY");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    RefPtr<SVGPropertyTearOff<SVGTransform> > wrapper = V8SVGTransform::toNative(args.Holder());
    if (wrapper->isReadOnly())
        return V8Proxy::setDOMException(NO_MODIFICATION_ALLOWED_ERR, args.GetIsolate());
    SVGTransform& impInstance = wrapper->propertyReference();
    SVGTransform* imp = &impInstance;
    EXCEPTION_BLOCK(float, angle, static_cast<float>(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)->NumberValue()));
    imp->setSkewY(angle);
    wrapper->commitChange();
    return v8::Handle<v8::Value>();
}

} // namespace SVGTransformV8Internal

static const BatchedAttribute SVGTransformAttrs[] = {
    // Attribute 'type' (Type: 'readonly attribute' ExtAttr: '')
    {"type", SVGTransformV8Internal::typeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'matrix' (Type: 'readonly attribute' ExtAttr: '')
    {"matrix", SVGTransformV8Internal::matrixAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'angle' (Type: 'readonly attribute' ExtAttr: '')
    {"angle", SVGTransformV8Internal::angleAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback SVGTransformCallbacks[] = {
    {"setMatrix", SVGTransformV8Internal::setMatrixCallback},
    {"setTranslate", SVGTransformV8Internal::setTranslateCallback},
    {"setScale", SVGTransformV8Internal::setScaleCallback},
    {"setRotate", SVGTransformV8Internal::setRotateCallback},
    {"setSkewX", SVGTransformV8Internal::setSkewXCallback},
    {"setSkewY", SVGTransformV8Internal::setSkewYCallback},
};

static const BatchedConstant SVGTransformConsts[] = {
    {"SVG_TRANSFORM_UNKNOWN", static_cast<signed int>(0)},
    {"SVG_TRANSFORM_MATRIX", static_cast<signed int>(1)},
    {"SVG_TRANSFORM_TRANSLATE", static_cast<signed int>(2)},
    {"SVG_TRANSFORM_SCALE", static_cast<signed int>(3)},
    {"SVG_TRANSFORM_ROTATE", static_cast<signed int>(4)},
    {"SVG_TRANSFORM_SKEWX", static_cast<signed int>(5)},
    {"SVG_TRANSFORM_SKEWY", static_cast<signed int>(6)},
};


COMPILE_ASSERT(0 == SVGTransform::SVG_TRANSFORM_UNKNOWN, SVGTransformEnumSVG_TRANSFORM_UNKNOWNIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(1 == SVGTransform::SVG_TRANSFORM_MATRIX, SVGTransformEnumSVG_TRANSFORM_MATRIXIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(2 == SVGTransform::SVG_TRANSFORM_TRANSLATE, SVGTransformEnumSVG_TRANSFORM_TRANSLATEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(3 == SVGTransform::SVG_TRANSFORM_SCALE, SVGTransformEnumSVG_TRANSFORM_SCALEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(4 == SVGTransform::SVG_TRANSFORM_ROTATE, SVGTransformEnumSVG_TRANSFORM_ROTATEIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(5 == SVGTransform::SVG_TRANSFORM_SKEWX, SVGTransformEnumSVG_TRANSFORM_SKEWXIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(6 == SVGTransform::SVG_TRANSFORM_SKEWY, SVGTransformEnumSVG_TRANSFORM_SKEWYIsWrongUseDoNotCheckConstants);

static v8::Persistent<v8::FunctionTemplate> ConfigureV8SVGTransformTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "SVGTransform", v8::Persistent<v8::FunctionTemplate>(), V8SVGTransform::internalFieldCount,
        SVGTransformAttrs, WTF_ARRAY_LENGTH(SVGTransformAttrs),
        SVGTransformCallbacks, WTF_ARRAY_LENGTH(SVGTransformCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    batchConfigureConstants(desc, proto, SVGTransformConsts, WTF_ARRAY_LENGTH(SVGTransformConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8SVGTransform::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8SVGTransform::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8SVGTransformTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8SVGTransform::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8SVGTransform::wrapSlow(PassRefPtr<SVGPropertyTearOff<SVGTransform> > impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8SVGTransform::derefObject(void* object)
{
    static_cast<SVGPropertyTearOff<SVGTransform>*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(SVG)
