/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8SVGViewSpec.h"

#if ENABLE(SVG)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8SVGAnimatedPreserveAspectRatio.h"
#include "V8SVGAnimatedRect.h"
#include "V8SVGElement.h"
#include "V8SVGTransformList.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8SVGViewSpec::info = { V8SVGViewSpec::GetTemplate, V8SVGViewSpec::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace SVGViewSpecV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> transformAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGViewSpec.transform._get");
    SVGViewSpec* imp = V8SVGViewSpec::toNative(info.Holder());
    return toV8(static_cast<SVGTransformListPropertyTearOff*>(imp->transform()), info.GetIsolate());
}

static v8::Handle<v8::Value> viewTargetAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGViewSpec.viewTarget._get");
    SVGViewSpec* imp = V8SVGViewSpec::toNative(info.Holder());
    return toV8(imp->viewTarget(), info.GetIsolate());
}

static v8::Handle<v8::Value> viewBoxStringAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGViewSpec.viewBoxString._get");
    SVGViewSpec* imp = V8SVGViewSpec::toNative(info.Holder());
    return v8String(imp->viewBoxString(), info.GetIsolate());
}

static v8::Handle<v8::Value> preserveAspectRatioStringAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGViewSpec.preserveAspectRatioString._get");
    SVGViewSpec* imp = V8SVGViewSpec::toNative(info.Holder());
    return v8String(imp->preserveAspectRatioString(), info.GetIsolate());
}

static v8::Handle<v8::Value> transformStringAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGViewSpec.transformString._get");
    SVGViewSpec* imp = V8SVGViewSpec::toNative(info.Holder());
    return v8String(imp->transformString(), info.GetIsolate());
}

static v8::Handle<v8::Value> viewTargetStringAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGViewSpec.viewTargetString._get");
    SVGViewSpec* imp = V8SVGViewSpec::toNative(info.Holder());
    return v8String(imp->viewTargetString(), info.GetIsolate());
}

static v8::Handle<v8::Value> zoomAndPanAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGViewSpec.zoomAndPan._get");
    SVGViewSpec* imp = V8SVGViewSpec::toNative(info.Holder());
    return v8Integer(imp->zoomAndPan(), info.GetIsolate());
}

static void zoomAndPanAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGViewSpec.zoomAndPan._set");
    SVGViewSpec* imp = V8SVGViewSpec::toNative(info.Holder());
    int v = toUInt32(value);
    ExceptionCode ec = 0;
    imp->setZoomAndPan(v, ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> viewBoxAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGViewSpec.viewBox._get");
    SVGViewSpec* imp = V8SVGViewSpec::toNative(info.Holder());
    return toV8(imp->viewBoxAnimated(), info.GetIsolate());
}

static v8::Handle<v8::Value> preserveAspectRatioAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SVGViewSpec.preserveAspectRatio._get");
    SVGViewSpec* imp = V8SVGViewSpec::toNative(info.Holder());
    return toV8(imp->preserveAspectRatioAnimated(), info.GetIsolate());
}

} // namespace SVGViewSpecV8Internal

static const BatchedAttribute SVGViewSpecAttrs[] = {
    // Attribute 'transform' (Type: 'readonly attribute' ExtAttr: '')
    {"transform", SVGViewSpecV8Internal::transformAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'viewTarget' (Type: 'readonly attribute' ExtAttr: '')
    {"viewTarget", SVGViewSpecV8Internal::viewTargetAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'viewBoxString' (Type: 'readonly attribute' ExtAttr: '')
    {"viewBoxString", SVGViewSpecV8Internal::viewBoxStringAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'preserveAspectRatioString' (Type: 'readonly attribute' ExtAttr: '')
    {"preserveAspectRatioString", SVGViewSpecV8Internal::preserveAspectRatioStringAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'transformString' (Type: 'readonly attribute' ExtAttr: '')
    {"transformString", SVGViewSpecV8Internal::transformStringAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'viewTargetString' (Type: 'readonly attribute' ExtAttr: '')
    {"viewTargetString", SVGViewSpecV8Internal::viewTargetStringAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'zoomAndPan' (Type: 'attribute' ExtAttr: '')
    {"zoomAndPan", SVGViewSpecV8Internal::zoomAndPanAttrGetter, SVGViewSpecV8Internal::zoomAndPanAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'viewBox' (Type: 'readonly attribute' ExtAttr: '')
    {"viewBox", SVGViewSpecV8Internal::viewBoxAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'preserveAspectRatio' (Type: 'readonly attribute' ExtAttr: '')
    {"preserveAspectRatio", SVGViewSpecV8Internal::preserveAspectRatioAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8SVGViewSpecTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "SVGViewSpec", v8::Persistent<v8::FunctionTemplate>(), V8SVGViewSpec::internalFieldCount,
        SVGViewSpecAttrs, WTF_ARRAY_LENGTH(SVGViewSpecAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8SVGViewSpec::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8SVGViewSpec::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8SVGViewSpecTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8SVGViewSpec::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8SVGViewSpec::wrapSlow(PassRefPtr<SVGViewSpec> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8SVGViewSpec::derefObject(void* object)
{
    static_cast<SVGViewSpec*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(SVG)
