/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8Screen.h"

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8Screen::info = { V8Screen::GetTemplate, V8Screen::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace ScreenV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> heightAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Screen.height._get");
    Screen* imp = V8Screen::toNative(info.Holder());
    return v8UnsignedInteger(imp->height(), info.GetIsolate());
}

static v8::Handle<v8::Value> widthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Screen.width._get");
    Screen* imp = V8Screen::toNative(info.Holder());
    return v8UnsignedInteger(imp->width(), info.GetIsolate());
}

static v8::Handle<v8::Value> colorDepthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Screen.colorDepth._get");
    Screen* imp = V8Screen::toNative(info.Holder());
    return v8UnsignedInteger(imp->colorDepth(), info.GetIsolate());
}

static v8::Handle<v8::Value> pixelDepthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Screen.pixelDepth._get");
    Screen* imp = V8Screen::toNative(info.Holder());
    return v8UnsignedInteger(imp->pixelDepth(), info.GetIsolate());
}

static v8::Handle<v8::Value> availLeftAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Screen.availLeft._get");
    Screen* imp = V8Screen::toNative(info.Holder());
    return v8Integer(imp->availLeft(), info.GetIsolate());
}

static v8::Handle<v8::Value> availTopAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Screen.availTop._get");
    Screen* imp = V8Screen::toNative(info.Holder());
    return v8Integer(imp->availTop(), info.GetIsolate());
}

static v8::Handle<v8::Value> availHeightAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Screen.availHeight._get");
    Screen* imp = V8Screen::toNative(info.Holder());
    return v8UnsignedInteger(imp->availHeight(), info.GetIsolate());
}

static v8::Handle<v8::Value> availWidthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Screen.availWidth._get");
    Screen* imp = V8Screen::toNative(info.Holder());
    return v8UnsignedInteger(imp->availWidth(), info.GetIsolate());
}

} // namespace ScreenV8Internal

static const BatchedAttribute ScreenAttrs[] = {
    // Attribute 'height' (Type: 'readonly attribute' ExtAttr: '')
    {"height", ScreenV8Internal::heightAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'width' (Type: 'readonly attribute' ExtAttr: '')
    {"width", ScreenV8Internal::widthAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'colorDepth' (Type: 'readonly attribute' ExtAttr: '')
    {"colorDepth", ScreenV8Internal::colorDepthAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'pixelDepth' (Type: 'readonly attribute' ExtAttr: '')
    {"pixelDepth", ScreenV8Internal::pixelDepthAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'availLeft' (Type: 'readonly attribute' ExtAttr: '')
    {"availLeft", ScreenV8Internal::availLeftAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'availTop' (Type: 'readonly attribute' ExtAttr: '')
    {"availTop", ScreenV8Internal::availTopAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'availHeight' (Type: 'readonly attribute' ExtAttr: '')
    {"availHeight", ScreenV8Internal::availHeightAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'availWidth' (Type: 'readonly attribute' ExtAttr: '')
    {"availWidth", ScreenV8Internal::availWidthAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8ScreenTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "Screen", v8::Persistent<v8::FunctionTemplate>(), V8Screen::internalFieldCount,
        ScreenAttrs, WTF_ARRAY_LENGTH(ScreenAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8Screen::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8Screen::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8ScreenTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8Screen::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8Screen::wrapSlow(PassRefPtr<Screen> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8Screen::derefObject(void* object)
{
    static_cast<Screen*>(object)->deref();
}

} // namespace WebCore
