/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8ShadowRoot.h"

#if ENABLE(SHADOW_DOM)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMSelection.h"
#include "V8DOMWrapper.h"
#include "V8DocumentFragment.h"
#include "V8Element.h"
#include "V8IsolatedContext.h"
#include "V8NodeList.h"
#include "V8Proxy.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8ShadowRoot::info = { V8ShadowRoot::GetTemplate, V8ShadowRoot::derefObject, 0, 0, &V8DocumentFragment::info, WrapperTypeObjectPrototype };

namespace ShadowRootV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> activeElementAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ShadowRoot.activeElement._get");
    ShadowRoot* imp = V8ShadowRoot::toNative(info.Holder());
    return toV8(imp->activeElement(), info.GetIsolate());
}

static v8::Handle<v8::Value> applyAuthorStylesAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ShadowRoot.applyAuthorStyles._get");
    ShadowRoot* imp = V8ShadowRoot::toNative(info.Holder());
    return v8Boolean(imp->applyAuthorStyles(), info.GetIsolate());
}

static void applyAuthorStylesAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ShadowRoot.applyAuthorStyles._set");
    ShadowRoot* imp = V8ShadowRoot::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setApplyAuthorStyles(v);
    return;
}

static v8::Handle<v8::Value> resetStyleInheritanceAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ShadowRoot.resetStyleInheritance._get");
    ShadowRoot* imp = V8ShadowRoot::toNative(info.Holder());
    return v8Boolean(imp->resetStyleInheritance(), info.GetIsolate());
}

static void resetStyleInheritanceAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ShadowRoot.resetStyleInheritance._set");
    ShadowRoot* imp = V8ShadowRoot::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setResetStyleInheritance(v);
    return;
}

static v8::Handle<v8::Value> innerHTMLAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ShadowRoot.innerHTML._get");
    ShadowRoot* imp = V8ShadowRoot::toNative(info.Holder());
    return v8String(imp->innerHTML(), info.GetIsolate());
}

static void innerHTMLAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ShadowRoot.innerHTML._set");
    ShadowRoot* imp = V8ShadowRoot::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<WithNullCheck>, v, value);
    ExceptionCode ec = 0;
    imp->setInnerHTML(v, ec);
    if (UNLIKELY(ec))
        V8Proxy::setDOMException(ec, info.GetIsolate());
    return;
}

static v8::Handle<v8::Value> getSelectionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.ShadowRoot.getSelection");
    ShadowRoot* imp = V8ShadowRoot::toNative(args.Holder());
    return toV8(imp->getSelection(), args.GetIsolate());
}

static v8::Handle<v8::Value> getElementByIdCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.ShadowRoot.getElementById");
    ShadowRoot* imp = V8ShadowRoot::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, elementId, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return toV8(imp->getElementById(elementId), args.GetIsolate());
}

static v8::Handle<v8::Value> getElementsByClassNameCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.ShadowRoot.getElementsByClassName");
    ShadowRoot* imp = V8ShadowRoot::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, className, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return toV8(imp->getElementsByClassName(className), args.GetIsolate());
}

static v8::Handle<v8::Value> getElementsByTagNameCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.ShadowRoot.getElementsByTagName");
    ShadowRoot* imp = V8ShadowRoot::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, tagName, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return toV8(imp->getElementsByTagName(tagName), args.GetIsolate());
}

static v8::Handle<v8::Value> getElementsByTagNameNSCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.ShadowRoot.getElementsByTagNameNS");
    ShadowRoot* imp = V8ShadowRoot::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithNullCheck>, namespaceURI, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, localName, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    return toV8(imp->getElementsByTagNameNS(namespaceURI, localName), args.GetIsolate());
}

} // namespace ShadowRootV8Internal

static const BatchedAttribute ShadowRootAttrs[] = {
    // Attribute 'activeElement' (Type: 'readonly attribute' ExtAttr: '')
    {"activeElement", ShadowRootV8Internal::activeElementAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'applyAuthorStyles' (Type: 'attribute' ExtAttr: '')
    {"applyAuthorStyles", ShadowRootV8Internal::applyAuthorStylesAttrGetter, ShadowRootV8Internal::applyAuthorStylesAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'resetStyleInheritance' (Type: 'attribute' ExtAttr: '')
    {"resetStyleInheritance", ShadowRootV8Internal::resetStyleInheritanceAttrGetter, ShadowRootV8Internal::resetStyleInheritanceAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'innerHTML' (Type: 'attribute' ExtAttr: 'TreatNullAs')
    {"innerHTML", ShadowRootV8Internal::innerHTMLAttrGetter, ShadowRootV8Internal::innerHTMLAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback ShadowRootCallbacks[] = {
    {"getSelection", ShadowRootV8Internal::getSelectionCallback},
    {"getElementById", ShadowRootV8Internal::getElementByIdCallback},
    {"getElementsByClassName", ShadowRootV8Internal::getElementsByClassNameCallback},
    {"getElementsByTagName", ShadowRootV8Internal::getElementsByTagNameCallback},
    {"getElementsByTagNameNS", ShadowRootV8Internal::getElementsByTagNameNSCallback},
};

v8::Handle<v8::Value> V8ShadowRoot::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.ShadowRoot.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());

    ExceptionCode ec = 0;
    EXCEPTION_BLOCK(Element*, host, V8Element::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Element::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);

    RefPtr<ShadowRoot> impl = ShadowRoot::create(host, ec);
    v8::Handle<v8::Object> wrapper = args.Holder();
    if (ec)
        goto fail;

    V8DOMWrapper::setDOMWrapper(wrapper, &info, impl.get());
    V8DOMWrapper::setJSWrapperForDOMNode(impl.release(), v8::Persistent<v8::Object>::New(wrapper), args.GetIsolate());
    return args.Holder();
  fail:
    return throwError(ec, args.GetIsolate());
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8ShadowRootTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "ShadowRoot", V8DocumentFragment::GetTemplate(), V8ShadowRoot::internalFieldCount,
        ShadowRootAttrs, WTF_ARRAY_LENGTH(ShadowRootAttrs),
        ShadowRootCallbacks, WTF_ARRAY_LENGTH(ShadowRootCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8ShadowRoot::constructorCallback);
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8ShadowRoot::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8ShadowRoot::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8ShadowRootTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8ShadowRoot::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8ShadowRoot::wrapSlow(PassRefPtr<ShadowRoot> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = V8Proxy::retrieve(impl->document()->frame());

    // Enter the node's context and create the wrapper in that context.
    v8::Handle<v8::Context> context;
    if (proxy && !proxy->matchesCurrentContext()) {
        // For performance, we enter the context only if the currently running context
        // is different from the context that we are about to enter.
        context = proxy->context();
        if (!context.IsEmpty())
            context->Enter();
    }
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    // Exit the node's context if it was entered.
    if (!context.IsEmpty())
        context->Exit();
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    wrapperHandle.SetWrapperClassId(v8DOMSubtreeClassId);
    V8DOMWrapper::setJSWrapperForDOMNode(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8ShadowRoot::derefObject(void* object)
{
    static_cast<ShadowRoot*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(SHADOW_DOM)
