/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8SpeechRecognition.h"

#if ENABLE(SCRIPTED_SPEECH)

#include "ContextFeatures.h"
#include "EventListener.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8AbstractEventListener.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8Event.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8SpeechGrammarList.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8SpeechRecognition::info = { V8SpeechRecognition::GetTemplate, V8SpeechRecognition::derefObject, V8SpeechRecognition::toActiveDOMObject, 0, 0, WrapperTypeObjectPrototype };

namespace SpeechRecognitionV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> grammarsAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.grammars._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return toV8(imp->grammars(), info.GetIsolate());
}

static void grammarsAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.grammars._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    SpeechGrammarList* v = V8SpeechGrammarList::HasInstance(value) ? V8SpeechGrammarList::toNative(v8::Handle<v8::Object>::Cast(value)) : 0;
    imp->setGrammars(WTF::getPtr(v));
    return;
}

static v8::Handle<v8::Value> langAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.lang._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return v8String(imp->lang(), info.GetIsolate());
}

static void langAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.lang._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK_VOID(V8Parameter<>, v, value);
    imp->setLang(v);
    return;
}

static v8::Handle<v8::Value> continuousAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.continuous._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return v8Boolean(imp->continuous(), info.GetIsolate());
}

static void continuousAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.continuous._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setContinuous(v);
    return;
}

static v8::Handle<v8::Value> maxAlternativesAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.maxAlternatives._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return v8UnsignedInteger(imp->maxAlternatives(), info.GetIsolate());
}

static void maxAlternativesAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.maxAlternatives._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    unsigned v = toUInt32(value);
    imp->setMaxAlternatives(v);
    return;
}

static v8::Handle<v8::Value> onaudiostartAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onaudiostart._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onaudiostart() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onaudiostart())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onaudiostartAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onaudiostart._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onaudiostart(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnaudiostart(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onsoundstartAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onsoundstart._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onsoundstart() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onsoundstart())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onsoundstartAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onsoundstart._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onsoundstart(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnsoundstart(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onspeechstartAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onspeechstart._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onspeechstart() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onspeechstart())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onspeechstartAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onspeechstart._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onspeechstart(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnspeechstart(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onspeechendAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onspeechend._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onspeechend() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onspeechend())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onspeechendAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onspeechend._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onspeechend(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnspeechend(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onsoundendAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onsoundend._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onsoundend() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onsoundend())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onsoundendAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onsoundend._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onsoundend(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnsoundend(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onaudioendAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onaudioend._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onaudioend() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onaudioend())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onaudioendAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onaudioend._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onaudioend(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnaudioend(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onresultAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onresult._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onresult() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onresult())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onresultAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onresult._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onresult(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnresult(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onnomatchAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onnomatch._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onnomatch() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onnomatch())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onnomatchAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onnomatch._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onnomatch(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnnomatch(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onresultdeletedAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onresultdeleted._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onresultdeleted() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onresultdeleted())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onresultdeletedAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onresultdeleted._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onresultdeleted(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnresultdeleted(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onerrorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onerror._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onerror() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onerror())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onerrorAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onerror._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onerror(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnerror(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onstartAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onstart._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onstart() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onstart())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onstartAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onstart._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onstart(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnstart(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> onendAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onend._get");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    return imp->onend() ? v8::Handle<v8::Value>(static_cast<V8AbstractEventListener*>(imp->onend())->getListenerObject(imp->scriptExecutionContext())) : v8::Handle<v8::Value>(v8::Null(info.GetIsolate()));
}

static void onendAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognition.onend._set");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(info.Holder());
    transferHiddenDependency(info.Holder(), imp->onend(), value, V8SpeechRecognition::eventListenerCacheIndex);
    imp->setOnend(V8DOMWrapper::getEventListener(value, true, ListenerFindOrCreate));
    return;
}

static v8::Handle<v8::Value> startCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SpeechRecognition.start");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(args.Holder());
    imp->start();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> stopCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SpeechRecognition.stop");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(args.Holder());
    imp->stopFunction();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> abortCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SpeechRecognition.abort");
    SpeechRecognition* imp = V8SpeechRecognition::toNative(args.Holder());
    imp->abort();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> addEventListenerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SpeechRecognition.addEventListener()");
    RefPtr<EventListener> listener = V8DOMWrapper::getEventListener(args[1], false, ListenerFindOrCreate);
    if (listener) {
        V8SpeechRecognition::toNative(args.Holder())->addEventListener(v8ValueToAtomicWebCoreString(args[0]), listener, args[2]->BooleanValue());
        createHiddenDependency(args.Holder(), args[1], V8SpeechRecognition::eventListenerCacheIndex);
    }
    return v8::Undefined();
}

static v8::Handle<v8::Value> removeEventListenerCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SpeechRecognition.removeEventListener()");
    RefPtr<EventListener> listener = V8DOMWrapper::getEventListener(args[1], false, ListenerFindOnly);
    if (listener) {
        V8SpeechRecognition::toNative(args.Holder())->removeEventListener(v8ValueToAtomicWebCoreString(args[0]), listener.get(), args[2]->BooleanValue());
        removeHiddenDependency(args.Holder(), args[1], V8SpeechRecognition::eventListenerCacheIndex);
    }
    return v8::Undefined();
}

static v8::Handle<v8::Value> dispatchEventCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SpeechRecognition.dispatchEvent");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    SpeechRecognition* imp = V8SpeechRecognition::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Event*, evt, V8Event::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Event::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    bool result = imp->dispatchEvent(evt, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8Boolean(result, args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace SpeechRecognitionV8Internal

static const BatchedAttribute SpeechRecognitionAttrs[] = {
    // Attribute 'grammars' (Type: 'attribute' ExtAttr: '')
    {"grammars", SpeechRecognitionV8Internal::grammarsAttrGetter, SpeechRecognitionV8Internal::grammarsAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'lang' (Type: 'attribute' ExtAttr: '')
    {"lang", SpeechRecognitionV8Internal::langAttrGetter, SpeechRecognitionV8Internal::langAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'continuous' (Type: 'attribute' ExtAttr: '')
    {"continuous", SpeechRecognitionV8Internal::continuousAttrGetter, SpeechRecognitionV8Internal::continuousAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'maxAlternatives' (Type: 'attribute' ExtAttr: '')
    {"maxAlternatives", SpeechRecognitionV8Internal::maxAlternativesAttrGetter, SpeechRecognitionV8Internal::maxAlternativesAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onaudiostart' (Type: 'attribute' ExtAttr: '')
    {"onaudiostart", SpeechRecognitionV8Internal::onaudiostartAttrGetter, SpeechRecognitionV8Internal::onaudiostartAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onsoundstart' (Type: 'attribute' ExtAttr: '')
    {"onsoundstart", SpeechRecognitionV8Internal::onsoundstartAttrGetter, SpeechRecognitionV8Internal::onsoundstartAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onspeechstart' (Type: 'attribute' ExtAttr: '')
    {"onspeechstart", SpeechRecognitionV8Internal::onspeechstartAttrGetter, SpeechRecognitionV8Internal::onspeechstartAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onspeechend' (Type: 'attribute' ExtAttr: '')
    {"onspeechend", SpeechRecognitionV8Internal::onspeechendAttrGetter, SpeechRecognitionV8Internal::onspeechendAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onsoundend' (Type: 'attribute' ExtAttr: '')
    {"onsoundend", SpeechRecognitionV8Internal::onsoundendAttrGetter, SpeechRecognitionV8Internal::onsoundendAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onaudioend' (Type: 'attribute' ExtAttr: '')
    {"onaudioend", SpeechRecognitionV8Internal::onaudioendAttrGetter, SpeechRecognitionV8Internal::onaudioendAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onresult' (Type: 'attribute' ExtAttr: '')
    {"onresult", SpeechRecognitionV8Internal::onresultAttrGetter, SpeechRecognitionV8Internal::onresultAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onnomatch' (Type: 'attribute' ExtAttr: '')
    {"onnomatch", SpeechRecognitionV8Internal::onnomatchAttrGetter, SpeechRecognitionV8Internal::onnomatchAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onresultdeleted' (Type: 'attribute' ExtAttr: '')
    {"onresultdeleted", SpeechRecognitionV8Internal::onresultdeletedAttrGetter, SpeechRecognitionV8Internal::onresultdeletedAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onerror' (Type: 'attribute' ExtAttr: '')
    {"onerror", SpeechRecognitionV8Internal::onerrorAttrGetter, SpeechRecognitionV8Internal::onerrorAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onstart' (Type: 'attribute' ExtAttr: '')
    {"onstart", SpeechRecognitionV8Internal::onstartAttrGetter, SpeechRecognitionV8Internal::onstartAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onend' (Type: 'attribute' ExtAttr: '')
    {"onend", SpeechRecognitionV8Internal::onendAttrGetter, SpeechRecognitionV8Internal::onendAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback SpeechRecognitionCallbacks[] = {
    {"start", SpeechRecognitionV8Internal::startCallback},
    {"stop", SpeechRecognitionV8Internal::stopCallback},
    {"abort", SpeechRecognitionV8Internal::abortCallback},
    {"addEventListener", SpeechRecognitionV8Internal::addEventListenerCallback},
    {"removeEventListener", SpeechRecognitionV8Internal::removeEventListenerCallback},
};

v8::Handle<v8::Value> V8SpeechRecognition::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SpeechRecognition.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();

    ScriptExecutionContext* context = getScriptExecutionContext();
    if (!context)
        return V8Proxy::throwError(V8Proxy::ReferenceError, "SpeechRecognition constructor's associated context is not available", args.GetIsolate());

    RefPtr<SpeechRecognition> impl = SpeechRecognition::create(context);
    v8::Handle<v8::Object> wrapper = args.Holder();

    V8DOMWrapper::setDOMWrapper(wrapper, &info, impl.get());
    V8DOMWrapper::setJSWrapperForActiveDOMObject(impl.release(), v8::Persistent<v8::Object>::New(wrapper), args.GetIsolate());
    return args.Holder();
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8SpeechRecognitionTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "SpeechRecognition", v8::Persistent<v8::FunctionTemplate>(), V8SpeechRecognition::internalFieldCount,
        SpeechRecognitionAttrs, WTF_ARRAY_LENGTH(SpeechRecognitionAttrs),
        SpeechRecognitionCallbacks, WTF_ARRAY_LENGTH(SpeechRecognitionCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8SpeechRecognition::constructorCallback);
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'dispatchEvent'
    const int dispatchEventArgc = 1;
    v8::Handle<v8::FunctionTemplate> dispatchEventArgv[dispatchEventArgc] = { V8Event::GetRawTemplate() };
    v8::Handle<v8::Signature> dispatchEventSignature = v8::Signature::New(desc, dispatchEventArgc, dispatchEventArgv);
    proto->Set(v8::String::New("dispatchEvent"), v8::FunctionTemplate::New(SpeechRecognitionV8Internal::dispatchEventCallback, v8::Handle<v8::Value>(), dispatchEventSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8SpeechRecognition::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8SpeechRecognition::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8SpeechRecognitionTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8SpeechRecognition::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}

ActiveDOMObject* V8SpeechRecognition::toActiveDOMObject(v8::Handle<v8::Object> object)
{
    return toNative(object);
}      

v8::Handle<v8::Object> V8SpeechRecognition::wrapSlow(PassRefPtr<SpeechRecognition> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForActiveDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8SpeechRecognition::derefObject(void* object)
{
    static_cast<SpeechRecognition*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(SCRIPTED_SPEECH)
