/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8SpeechRecognitionError.h"

#if ENABLE(SCRIPTED_SPEECH)

#include "ContextFeatures.h"
#include "Dictionary.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8Event.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8SpeechRecognitionError::info = { V8SpeechRecognitionError::GetTemplate, V8SpeechRecognitionError::derefObject, 0, 0, &V8Event::info, WrapperTypeObjectPrototype };

namespace SpeechRecognitionErrorV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> codeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognitionError.code._get");
    SpeechRecognitionError* imp = V8SpeechRecognitionError::toNative(info.Holder());
    return v8Integer(imp->code(), info.GetIsolate());
}

static v8::Handle<v8::Value> messageAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognitionError.message._get");
    SpeechRecognitionError* imp = V8SpeechRecognitionError::toNative(info.Holder());
    return v8String(imp->message(), info.GetIsolate());
}

} // namespace SpeechRecognitionErrorV8Internal

static const BatchedAttribute SpeechRecognitionErrorAttrs[] = {
    // Attribute 'code' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"code", SpeechRecognitionErrorV8Internal::codeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'message' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"message", SpeechRecognitionErrorV8Internal::messageAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedConstant SpeechRecognitionErrorConsts[] = {
    {"OTHER", static_cast<signed int>(0)},
    {"NO_SPEECH", static_cast<signed int>(1)},
    {"ABORTED", static_cast<signed int>(2)},
    {"AUDIO_CAPTURE", static_cast<signed int>(3)},
    {"NETWORK", static_cast<signed int>(4)},
    {"NOT_ALLOWED", static_cast<signed int>(5)},
    {"SERVICE_NOT_ALLOWED", static_cast<signed int>(6)},
    {"BAD_GRAMMAR", static_cast<signed int>(7)},
    {"LANGUAGE_NOT_SUPPORTED", static_cast<signed int>(8)},
};


COMPILE_ASSERT(0 == SpeechRecognitionError::OTHER, SpeechRecognitionErrorEnumOTHERIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(1 == SpeechRecognitionError::NO_SPEECH, SpeechRecognitionErrorEnumNO_SPEECHIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(2 == SpeechRecognitionError::ABORTED, SpeechRecognitionErrorEnumABORTEDIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(3 == SpeechRecognitionError::AUDIO_CAPTURE, SpeechRecognitionErrorEnumAUDIO_CAPTUREIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(4 == SpeechRecognitionError::NETWORK, SpeechRecognitionErrorEnumNETWORKIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(5 == SpeechRecognitionError::NOT_ALLOWED, SpeechRecognitionErrorEnumNOT_ALLOWEDIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(6 == SpeechRecognitionError::SERVICE_NOT_ALLOWED, SpeechRecognitionErrorEnumSERVICE_NOT_ALLOWEDIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(7 == SpeechRecognitionError::BAD_GRAMMAR, SpeechRecognitionErrorEnumBAD_GRAMMARIsWrongUseDoNotCheckConstants);
COMPILE_ASSERT(8 == SpeechRecognitionError::LANGUAGE_NOT_SUPPORTED, SpeechRecognitionErrorEnumLANGUAGE_NOT_SUPPORTEDIsWrongUseDoNotCheckConstants);

v8::Handle<v8::Value> V8SpeechRecognitionError::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SpeechRecognitionError.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();

    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());

    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, type, args[0]);
    SpeechRecognitionErrorInit eventInit;
    if (args.Length() >= 2) {
        EXCEPTION_BLOCK(Dictionary, options, args[1]);
        if (!fillSpeechRecognitionErrorInit(eventInit, options))
            return v8::Undefined();
    }

    RefPtr<SpeechRecognitionError> event = SpeechRecognitionError::create(type, eventInit);

    V8DOMWrapper::setDOMWrapper(args.Holder(), &info, event.get());
    V8DOMWrapper::setJSWrapperForDOMObject(event.release(), v8::Persistent<v8::Object>::New(args.Holder()), args.GetIsolate());
    return args.Holder();
}

bool fillSpeechRecognitionErrorInit(SpeechRecognitionErrorInit& eventInit, const Dictionary& options)
{
    if (!fillEventInit(eventInit, options))
        return false;

    options.get("code", eventInit.code);
    options.get("message", eventInit.message);
    return true;
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8SpeechRecognitionErrorTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "SpeechRecognitionError", V8Event::GetTemplate(), V8SpeechRecognitionError::internalFieldCount,
        SpeechRecognitionErrorAttrs, WTF_ARRAY_LENGTH(SpeechRecognitionErrorAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8SpeechRecognitionError::constructorCallback);
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    batchConfigureConstants(desc, proto, SpeechRecognitionErrorConsts, WTF_ARRAY_LENGTH(SpeechRecognitionErrorConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8SpeechRecognitionError::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8SpeechRecognitionError::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8SpeechRecognitionErrorTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8SpeechRecognitionError::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8SpeechRecognitionError::wrapSlow(PassRefPtr<SpeechRecognitionError> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8SpeechRecognitionError::derefObject(void* object)
{
    static_cast<SpeechRecognitionError*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(SCRIPTED_SPEECH)
