/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8SpeechRecognitionEvent.h"

#if ENABLE(SCRIPTED_SPEECH)

#include "ContextFeatures.h"
#include "Dictionary.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8Event.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8SpeechRecognitionResult.h"
#include "V8SpeechRecognitionResultList.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8SpeechRecognitionEvent::info = { V8SpeechRecognitionEvent::GetTemplate, V8SpeechRecognitionEvent::derefObject, 0, 0, &V8Event::info, WrapperTypeObjectPrototype };

namespace SpeechRecognitionEventV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> resultAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognitionEvent.result._get");
    SpeechRecognitionEvent* imp = V8SpeechRecognitionEvent::toNative(info.Holder());
    RefPtr<SpeechRecognitionResult> result = imp->result();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "result", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> resultIndexAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognitionEvent.resultIndex._get");
    SpeechRecognitionEvent* imp = V8SpeechRecognitionEvent::toNative(info.Holder());
    return v8Integer(imp->resultIndex(), info.GetIsolate());
}

static v8::Handle<v8::Value> resultHistoryAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.SpeechRecognitionEvent.resultHistory._get");
    SpeechRecognitionEvent* imp = V8SpeechRecognitionEvent::toNative(info.Holder());
    RefPtr<SpeechRecognitionResultList> result = imp->resultHistory();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "resultHistory", wrapper);
    }
    return wrapper;
}

} // namespace SpeechRecognitionEventV8Internal

static const BatchedAttribute SpeechRecognitionEventAttrs[] = {
    // Attribute 'result' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"result", SpeechRecognitionEventV8Internal::resultAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'resultIndex' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"resultIndex", SpeechRecognitionEventV8Internal::resultIndexAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'resultHistory' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"resultHistory", SpeechRecognitionEventV8Internal::resultHistoryAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

v8::Handle<v8::Value> V8SpeechRecognitionEvent::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.SpeechRecognitionEvent.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();

    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());

    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, type, args[0]);
    SpeechRecognitionEventInit eventInit;
    if (args.Length() >= 2) {
        EXCEPTION_BLOCK(Dictionary, options, args[1]);
        if (!fillSpeechRecognitionEventInit(eventInit, options))
            return v8::Undefined();
    }

    RefPtr<SpeechRecognitionEvent> event = SpeechRecognitionEvent::create(type, eventInit);

    V8DOMWrapper::setDOMWrapper(args.Holder(), &info, event.get());
    V8DOMWrapper::setJSWrapperForDOMObject(event.release(), v8::Persistent<v8::Object>::New(args.Holder()), args.GetIsolate());
    return args.Holder();
}

bool fillSpeechRecognitionEventInit(SpeechRecognitionEventInit& eventInit, const Dictionary& options)
{
    if (!fillEventInit(eventInit, options))
        return false;

    options.get("result", eventInit.result);
    options.get("resultIndex", eventInit.resultIndex);
    options.get("resultHistory", eventInit.resultHistory);
    return true;
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8SpeechRecognitionEventTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "SpeechRecognitionEvent", V8Event::GetTemplate(), V8SpeechRecognitionEvent::internalFieldCount,
        SpeechRecognitionEventAttrs, WTF_ARRAY_LENGTH(SpeechRecognitionEventAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8SpeechRecognitionEvent::constructorCallback);
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8SpeechRecognitionEvent::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8SpeechRecognitionEvent::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8SpeechRecognitionEventTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8SpeechRecognitionEvent::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8SpeechRecognitionEvent::wrapSlow(PassRefPtr<SpeechRecognitionEvent> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8SpeechRecognitionEvent::derefObject(void* object)
{
    static_cast<SpeechRecognitionEvent*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(SCRIPTED_SPEECH)
