/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8StorageEvent.h"

#include "ContextFeatures.h"
#include "Dictionary.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8Event.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include "V8Storage.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8StorageEvent::info = { V8StorageEvent::GetTemplate, V8StorageEvent::derefObject, 0, 0, &V8Event::info, WrapperTypeObjectPrototype };

namespace StorageEventV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> keyAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.StorageEvent.key._get");
    StorageEvent* imp = V8StorageEvent::toNative(info.Holder());
    return v8String(imp->key(), info.GetIsolate());
}

static v8::Handle<v8::Value> oldValueAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.StorageEvent.oldValue._get");
    StorageEvent* imp = V8StorageEvent::toNative(info.Holder());
    return v8StringOrNull(imp->oldValue(), info.GetIsolate());
}

static v8::Handle<v8::Value> newValueAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.StorageEvent.newValue._get");
    StorageEvent* imp = V8StorageEvent::toNative(info.Holder());
    return v8StringOrNull(imp->newValue(), info.GetIsolate());
}

static v8::Handle<v8::Value> urlAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.StorageEvent.url._get");
    StorageEvent* imp = V8StorageEvent::toNative(info.Holder());
    return v8String(imp->url(), info.GetIsolate());
}

static v8::Handle<v8::Value> storageAreaAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.StorageEvent.storageArea._get");
    StorageEvent* imp = V8StorageEvent::toNative(info.Holder());
    RefPtr<Storage> result = imp->storageArea();
    v8::Handle<v8::Value> wrapper = result.get() ? getDOMObjectMap(info.GetIsolate()).get(result.get()) : v8::Handle<v8::Object>();
    if (wrapper.IsEmpty()) {
        wrapper = toV8(result.get(), info.GetIsolate());
        if (!wrapper.IsEmpty())
            V8DOMWrapper::setNamedHiddenReference(info.Holder(), "storageArea", wrapper);
    }
    return wrapper;
}

static v8::Handle<v8::Value> initStorageEventCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.StorageEvent.initStorageEvent");
    StorageEvent* imp = V8StorageEvent::toNative(args.Holder());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, typeArg, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    EXCEPTION_BLOCK(bool, canBubbleArg, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(bool, cancelableArg, MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)->BooleanValue());
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, keyArg, MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithNullCheck>, oldValueArg, MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithNullCheck>, newValueArg, MAYBE_MISSING_PARAMETER(args, 5, DefaultIsUndefined));
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, urlArg, MAYBE_MISSING_PARAMETER(args, 6, DefaultIsUndefined));
    EXCEPTION_BLOCK(Storage*, storageAreaArg, V8Storage::HasInstance(MAYBE_MISSING_PARAMETER(args, 7, DefaultIsUndefined)) ? V8Storage::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 7, DefaultIsUndefined))) : 0);
    imp->initStorageEvent(typeArg, canBubbleArg, cancelableArg, keyArg, oldValueArg, newValueArg, urlArg, storageAreaArg);
    return v8::Handle<v8::Value>();
}

} // namespace StorageEventV8Internal

static const BatchedAttribute StorageEventAttrs[] = {
    // Attribute 'key' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"key", StorageEventV8Internal::keyAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'oldValue' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor TreatReturnedNullStringAs')
    {"oldValue", StorageEventV8Internal::oldValueAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'newValue' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor TreatReturnedNullStringAs')
    {"newValue", StorageEventV8Internal::newValueAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'url' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"url", StorageEventV8Internal::urlAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'storageArea' (Type: 'readonly attribute' ExtAttr: 'InitializedByEventConstructor')
    {"storageArea", StorageEventV8Internal::storageAreaAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

v8::Handle<v8::Value> V8StorageEvent::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.StorageEvent.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();

    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());

    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, type, args[0]);
    StorageEventInit eventInit;
    if (args.Length() >= 2) {
        EXCEPTION_BLOCK(Dictionary, options, args[1]);
        if (!fillStorageEventInit(eventInit, options))
            return v8::Undefined();
    }

    RefPtr<StorageEvent> event = StorageEvent::create(type, eventInit);

    V8DOMWrapper::setDOMWrapper(args.Holder(), &info, event.get());
    V8DOMWrapper::setJSWrapperForDOMObject(event.release(), v8::Persistent<v8::Object>::New(args.Holder()), args.GetIsolate());
    return args.Holder();
}

bool fillStorageEventInit(StorageEventInit& eventInit, const Dictionary& options)
{
    if (!fillEventInit(eventInit, options))
        return false;

    options.get("key", eventInit.key);
    options.get("oldValue", eventInit.oldValue);
    options.get("newValue", eventInit.newValue);
    options.get("url", eventInit.url);
    options.get("storageArea", eventInit.storageArea);
    return true;
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8StorageEventTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "StorageEvent", V8Event::GetTemplate(), V8StorageEvent::internalFieldCount,
        StorageEventAttrs, WTF_ARRAY_LENGTH(StorageEventAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8StorageEvent::constructorCallback);
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'initStorageEvent'
    const int initStorageEventArgc = 8;
    v8::Handle<v8::FunctionTemplate> initStorageEventArgv[initStorageEventArgc] = { v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), V8Storage::GetRawTemplate() };
    v8::Handle<v8::Signature> initStorageEventSignature = v8::Signature::New(desc, initStorageEventArgc, initStorageEventArgv);
    proto->Set(v8::String::New("initStorageEvent"), v8::FunctionTemplate::New(StorageEventV8Internal::initStorageEventCallback, v8::Handle<v8::Value>(), initStorageEventSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8StorageEvent::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8StorageEvent::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8StorageEventTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8StorageEvent::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8StorageEvent::wrapSlow(PassRefPtr<StorageEvent> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8StorageEvent::derefObject(void* object)
{
    static_cast<StorageEvent*>(object)->deref();
}

} // namespace WebCore
