/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8Touch.h"

#if ENABLE(TOUCH_EVENTS)

#include "ContextFeatures.h"
#include "EventTarget.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8Touch::info = { V8Touch::GetTemplate, V8Touch::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace TouchV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> clientXAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.clientX._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return v8Integer(imp->clientX(), info.GetIsolate());
}

static v8::Handle<v8::Value> clientYAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.clientY._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return v8Integer(imp->clientY(), info.GetIsolate());
}

static v8::Handle<v8::Value> screenXAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.screenX._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return v8Integer(imp->screenX(), info.GetIsolate());
}

static v8::Handle<v8::Value> screenYAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.screenY._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return v8Integer(imp->screenY(), info.GetIsolate());
}

static v8::Handle<v8::Value> pageXAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.pageX._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return v8Integer(imp->pageX(), info.GetIsolate());
}

static v8::Handle<v8::Value> pageYAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.pageY._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return v8Integer(imp->pageY(), info.GetIsolate());
}

static v8::Handle<v8::Value> targetAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.target._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return V8DOMWrapper::convertEventTargetToV8Object(imp->target(), info.GetIsolate());
}

static v8::Handle<v8::Value> identifierAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.identifier._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return v8UnsignedInteger(imp->identifier(), info.GetIsolate());
}

static v8::Handle<v8::Value> webkitRadiusXAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.webkitRadiusX._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return v8Integer(imp->webkitRadiusX(), info.GetIsolate());
}

static v8::Handle<v8::Value> webkitRadiusYAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.webkitRadiusY._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return v8Integer(imp->webkitRadiusY(), info.GetIsolate());
}

static v8::Handle<v8::Value> webkitRotationAngleAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.webkitRotationAngle._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return v8::Number::New(imp->webkitRotationAngle());
}

static v8::Handle<v8::Value> webkitForceAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.Touch.webkitForce._get");
    Touch* imp = V8Touch::toNative(info.Holder());
    return v8::Number::New(imp->webkitForce());
}

} // namespace TouchV8Internal

static const BatchedAttribute TouchAttrs[] = {
    // Attribute 'clientX' (Type: 'readonly attribute' ExtAttr: '')
    {"clientX", TouchV8Internal::clientXAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'clientY' (Type: 'readonly attribute' ExtAttr: '')
    {"clientY", TouchV8Internal::clientYAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'screenX' (Type: 'readonly attribute' ExtAttr: '')
    {"screenX", TouchV8Internal::screenXAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'screenY' (Type: 'readonly attribute' ExtAttr: '')
    {"screenY", TouchV8Internal::screenYAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'pageX' (Type: 'readonly attribute' ExtAttr: '')
    {"pageX", TouchV8Internal::pageXAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'pageY' (Type: 'readonly attribute' ExtAttr: '')
    {"pageY", TouchV8Internal::pageYAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'target' (Type: 'readonly attribute' ExtAttr: '')
    {"target", TouchV8Internal::targetAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'identifier' (Type: 'readonly attribute' ExtAttr: '')
    {"identifier", TouchV8Internal::identifierAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'webkitRadiusX' (Type: 'readonly attribute' ExtAttr: '')
    {"webkitRadiusX", TouchV8Internal::webkitRadiusXAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'webkitRadiusY' (Type: 'readonly attribute' ExtAttr: '')
    {"webkitRadiusY", TouchV8Internal::webkitRadiusYAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'webkitRotationAngle' (Type: 'readonly attribute' ExtAttr: '')
    {"webkitRotationAngle", TouchV8Internal::webkitRotationAngleAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'webkitForce' (Type: 'readonly attribute' ExtAttr: '')
    {"webkitForce", TouchV8Internal::webkitForceAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8TouchTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "Touch", v8::Persistent<v8::FunctionTemplate>(), V8Touch::internalFieldCount,
        TouchAttrs, WTF_ARRAY_LENGTH(TouchAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8Touch::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8Touch::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8TouchTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8Touch::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8Touch::wrapSlow(PassRefPtr<Touch> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8Touch::derefObject(void* object)
{
    static_cast<Touch*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(TOUCH_EVENTS)
