/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8UndoManager.h"

#if ENABLE(UNDO_MANAGER)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8UndoManager::info = { V8UndoManager::GetTemplate, V8UndoManager::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace UndoManagerV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> undoCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.UndoManager.undo");
    UndoManager* imp = V8UndoManager::toNative(args.Holder());
    imp->undo();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> redoCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.UndoManager.redo");
    UndoManager* imp = V8UndoManager::toNative(args.Holder());
    imp->redo();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> clearUndoCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.UndoManager.clearUndo");
    UndoManager* imp = V8UndoManager::toNative(args.Holder());
    imp->clearUndo();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> clearRedoCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.UndoManager.clearRedo");
    UndoManager* imp = V8UndoManager::toNative(args.Holder());
    imp->clearRedo();
    return v8::Handle<v8::Value>();
}

} // namespace UndoManagerV8Internal

static const BatchedCallback UndoManagerCallbacks[] = {
    {"undo", UndoManagerV8Internal::undoCallback},
    {"redo", UndoManagerV8Internal::redoCallback},
    {"clearUndo", UndoManagerV8Internal::clearUndoCallback},
    {"clearRedo", UndoManagerV8Internal::clearRedoCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8UndoManagerTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "UndoManager", v8::Persistent<v8::FunctionTemplate>(), V8UndoManager::internalFieldCount,
        0, 0,
        UndoManagerCallbacks, WTF_ARRAY_LENGTH(UndoManagerCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8UndoManager::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8UndoManager::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8UndoManagerTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8UndoManager::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8UndoManager::wrapSlow(PassRefPtr<UndoManager> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8UndoManager::derefObject(void* object)
{
    static_cast<UndoManager*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(UNDO_MANAGER)
