/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8ValidityState.h"

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8ValidityState::info = { V8ValidityState::GetTemplate, V8ValidityState::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace ValidityStateV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> valueMissingAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ValidityState.valueMissing._get");
    ValidityState* imp = V8ValidityState::toNative(info.Holder());
    return v8Boolean(imp->valueMissing(), info.GetIsolate());
}

static v8::Handle<v8::Value> typeMismatchAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ValidityState.typeMismatch._get");
    ValidityState* imp = V8ValidityState::toNative(info.Holder());
    return v8Boolean(imp->typeMismatch(), info.GetIsolate());
}

static v8::Handle<v8::Value> patternMismatchAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ValidityState.patternMismatch._get");
    ValidityState* imp = V8ValidityState::toNative(info.Holder());
    return v8Boolean(imp->patternMismatch(), info.GetIsolate());
}

static v8::Handle<v8::Value> tooLongAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ValidityState.tooLong._get");
    ValidityState* imp = V8ValidityState::toNative(info.Holder());
    return v8Boolean(imp->tooLong(), info.GetIsolate());
}

static v8::Handle<v8::Value> rangeUnderflowAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ValidityState.rangeUnderflow._get");
    ValidityState* imp = V8ValidityState::toNative(info.Holder());
    return v8Boolean(imp->rangeUnderflow(), info.GetIsolate());
}

static v8::Handle<v8::Value> rangeOverflowAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ValidityState.rangeOverflow._get");
    ValidityState* imp = V8ValidityState::toNative(info.Holder());
    return v8Boolean(imp->rangeOverflow(), info.GetIsolate());
}

static v8::Handle<v8::Value> stepMismatchAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ValidityState.stepMismatch._get");
    ValidityState* imp = V8ValidityState::toNative(info.Holder());
    return v8Boolean(imp->stepMismatch(), info.GetIsolate());
}

static v8::Handle<v8::Value> customErrorAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ValidityState.customError._get");
    ValidityState* imp = V8ValidityState::toNative(info.Holder());
    return v8Boolean(imp->customError(), info.GetIsolate());
}

static v8::Handle<v8::Value> validAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.ValidityState.valid._get");
    ValidityState* imp = V8ValidityState::toNative(info.Holder());
    return v8Boolean(imp->valid(), info.GetIsolate());
}

} // namespace ValidityStateV8Internal

static const BatchedAttribute ValidityStateAttrs[] = {
    // Attribute 'valueMissing' (Type: 'readonly attribute' ExtAttr: '')
    {"valueMissing", ValidityStateV8Internal::valueMissingAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'typeMismatch' (Type: 'readonly attribute' ExtAttr: '')
    {"typeMismatch", ValidityStateV8Internal::typeMismatchAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'patternMismatch' (Type: 'readonly attribute' ExtAttr: '')
    {"patternMismatch", ValidityStateV8Internal::patternMismatchAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'tooLong' (Type: 'readonly attribute' ExtAttr: '')
    {"tooLong", ValidityStateV8Internal::tooLongAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'rangeUnderflow' (Type: 'readonly attribute' ExtAttr: '')
    {"rangeUnderflow", ValidityStateV8Internal::rangeUnderflowAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'rangeOverflow' (Type: 'readonly attribute' ExtAttr: '')
    {"rangeOverflow", ValidityStateV8Internal::rangeOverflowAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'stepMismatch' (Type: 'readonly attribute' ExtAttr: '')
    {"stepMismatch", ValidityStateV8Internal::stepMismatchAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'customError' (Type: 'readonly attribute' ExtAttr: '')
    {"customError", ValidityStateV8Internal::customErrorAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'valid' (Type: 'readonly attribute' ExtAttr: '')
    {"valid", ValidityStateV8Internal::validAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8ValidityStateTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "ValidityState", v8::Persistent<v8::FunctionTemplate>(), V8ValidityState::internalFieldCount,
        ValidityStateAttrs, WTF_ARRAY_LENGTH(ValidityStateAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8ValidityState::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8ValidityState::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8ValidityStateTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8ValidityState::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8ValidityState::wrapSlow(PassRefPtr<ValidityState> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8ValidityState::derefObject(void* object)
{
    static_cast<ValidityState*>(object)->deref();
}

} // namespace WebCore
