/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8WebGLCompressedTextureS3TC.h"

#if ENABLE(WEBGL)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8WebGLCompressedTextureS3TC::info = { V8WebGLCompressedTextureS3TC::GetTemplate, V8WebGLCompressedTextureS3TC::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace WebGLCompressedTextureS3TCV8Internal {

template <typename T> void V8_USE(T) { }

} // namespace WebGLCompressedTextureS3TCV8Internal

static const BatchedConstant WebGLCompressedTextureS3TCConsts[] = {
    {"COMPRESSED_RGB_S3TC_DXT1_EXT", static_cast<signed int>(0x83F0)},
    {"COMPRESSED_RGBA_S3TC_DXT1_EXT", static_cast<signed int>(0x83F1)},
    {"COMPRESSED_RGBA_S3TC_DXT3_EXT", static_cast<signed int>(0x83F2)},
    {"COMPRESSED_RGBA_S3TC_DXT5_EXT", static_cast<signed int>(0x83F3)},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8WebGLCompressedTextureS3TCTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "WebGLCompressedTextureS3TC", v8::Persistent<v8::FunctionTemplate>(), V8WebGLCompressedTextureS3TC::internalFieldCount,
        0, 0,
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    batchConfigureConstants(desc, proto, WebGLCompressedTextureS3TCConsts, WTF_ARRAY_LENGTH(WebGLCompressedTextureS3TCConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8WebGLCompressedTextureS3TC::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8WebGLCompressedTextureS3TC::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8WebGLCompressedTextureS3TCTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8WebGLCompressedTextureS3TC::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8WebGLCompressedTextureS3TC::wrapSlow(PassRefPtr<WebGLCompressedTextureS3TC> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8WebGLCompressedTextureS3TC::derefObject(void* object)
{
    static_cast<WebGLCompressedTextureS3TC*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(WEBGL)
