/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8WebGLContextAttributes.h"

#if ENABLE(WEBGL)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8WebGLContextAttributes::info = { V8WebGLContextAttributes::GetTemplate, V8WebGLContextAttributes::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace WebGLContextAttributesV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> alphaAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.alpha._get");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    return v8Boolean(imp->alpha(), info.GetIsolate());
}

static void alphaAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.alpha._set");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setAlpha(v);
    return;
}

static v8::Handle<v8::Value> depthAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.depth._get");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    return v8Boolean(imp->depth(), info.GetIsolate());
}

static void depthAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.depth._set");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setDepth(v);
    return;
}

static v8::Handle<v8::Value> stencilAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.stencil._get");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    return v8Boolean(imp->stencil(), info.GetIsolate());
}

static void stencilAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.stencil._set");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setStencil(v);
    return;
}

static v8::Handle<v8::Value> antialiasAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.antialias._get");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    return v8Boolean(imp->antialias(), info.GetIsolate());
}

static void antialiasAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.antialias._set");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setAntialias(v);
    return;
}

static v8::Handle<v8::Value> premultipliedAlphaAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.premultipliedAlpha._get");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    return v8Boolean(imp->premultipliedAlpha(), info.GetIsolate());
}

static void premultipliedAlphaAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.premultipliedAlpha._set");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setPremultipliedAlpha(v);
    return;
}

static v8::Handle<v8::Value> preserveDrawingBufferAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.preserveDrawingBuffer._get");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    return v8Boolean(imp->preserveDrawingBuffer(), info.GetIsolate());
}

static void preserveDrawingBufferAttrSetter(v8::Local<v8::String> name, v8::Local<v8::Value> value, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebGLContextAttributes.preserveDrawingBuffer._set");
    WebGLContextAttributes* imp = V8WebGLContextAttributes::toNative(info.Holder());
    bool v = value->BooleanValue();
    imp->setPreserveDrawingBuffer(v);
    return;
}

} // namespace WebGLContextAttributesV8Internal

static const BatchedAttribute WebGLContextAttributesAttrs[] = {
    // Attribute 'alpha' (Type: 'attribute' ExtAttr: '')
    {"alpha", WebGLContextAttributesV8Internal::alphaAttrGetter, WebGLContextAttributesV8Internal::alphaAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'depth' (Type: 'attribute' ExtAttr: '')
    {"depth", WebGLContextAttributesV8Internal::depthAttrGetter, WebGLContextAttributesV8Internal::depthAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'stencil' (Type: 'attribute' ExtAttr: '')
    {"stencil", WebGLContextAttributesV8Internal::stencilAttrGetter, WebGLContextAttributesV8Internal::stencilAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'antialias' (Type: 'attribute' ExtAttr: '')
    {"antialias", WebGLContextAttributesV8Internal::antialiasAttrGetter, WebGLContextAttributesV8Internal::antialiasAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'premultipliedAlpha' (Type: 'attribute' ExtAttr: '')
    {"premultipliedAlpha", WebGLContextAttributesV8Internal::premultipliedAlphaAttrGetter, WebGLContextAttributesV8Internal::premultipliedAlphaAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'preserveDrawingBuffer' (Type: 'attribute' ExtAttr: '')
    {"preserveDrawingBuffer", WebGLContextAttributesV8Internal::preserveDrawingBufferAttrGetter, WebGLContextAttributesV8Internal::preserveDrawingBufferAttrSetter, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8WebGLContextAttributesTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "WebGLContextAttributes", v8::Persistent<v8::FunctionTemplate>(), V8WebGLContextAttributes::internalFieldCount,
        WebGLContextAttributesAttrs, WTF_ARRAY_LENGTH(WebGLContextAttributesAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8WebGLContextAttributes::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8WebGLContextAttributes::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8WebGLContextAttributesTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8WebGLContextAttributes::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8WebGLContextAttributes::wrapSlow(PassRefPtr<WebGLContextAttributes> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8WebGLContextAttributes::derefObject(void* object)
{
    static_cast<WebGLContextAttributes*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(WEBGL)
