/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8WebKitBlobBuilder.h"

#if ENABLE(LEGACY_WEBKIT_BLOB_BUILDER)

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8ArrayBuffer.h"
#include "V8ArrayBufferView.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8Blob.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/ArrayBuffer.h>
#include <wtf/ArrayBufferView.h>
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8WebKitBlobBuilder::info = { V8WebKitBlobBuilder::GetTemplate, V8WebKitBlobBuilder::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace WebKitBlobBuilderV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> getBlobCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitBlobBuilder.getBlob");
    WebKitBlobBuilder* imp = V8WebKitBlobBuilder::toNative(args.Holder());
    if (args.Length() <= 0) {
        return toV8(imp->getBlob(), args.GetIsolate());
    }
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithUndefinedOrNullCheck>, contentType, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    return toV8(imp->getBlob(contentType), args.GetIsolate());
}

static v8::Handle<v8::Value> append1Callback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitBlobBuilder.append1");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    WebKitBlobBuilder* imp = V8WebKitBlobBuilder::toNative(args.Holder());
    EXCEPTION_BLOCK(Blob*, blob, V8Blob::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Blob::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->append(blob);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> append2Callback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitBlobBuilder.append2");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    WebKitBlobBuilder* imp = V8WebKitBlobBuilder::toNative(args.Holder());
    EXCEPTION_BLOCK(ArrayBuffer*, arrayBuffer, V8ArrayBuffer::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8ArrayBuffer::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    ScriptExecutionContext* scriptContext = getScriptExecutionContext();
    if (!scriptContext)
        return v8::Undefined();
    imp->append(scriptContext, arrayBuffer);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> append3Callback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitBlobBuilder.append3");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    WebKitBlobBuilder* imp = V8WebKitBlobBuilder::toNative(args.Holder());
    EXCEPTION_BLOCK(ArrayBufferView*, arrayBufferView, V8ArrayBufferView::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8ArrayBufferView::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    imp->append(arrayBufferView);
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> append4Callback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitBlobBuilder.append4");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    WebKitBlobBuilder* imp = V8WebKitBlobBuilder::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, value, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    if (args.Length() <= 1) {
        imp->append(value, ec);
        if (UNLIKELY(ec))
            goto fail;
        return v8::Handle<v8::Value>();
    }
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<WithUndefinedOrNullCheck>, endings, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    imp->append(value, endings, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> appendCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitBlobBuilder.append");
    if ((args.Length() == 1 && (args[0]->IsNull() || V8Blob::HasInstance(args[0]))))
        return append1Callback(args);
    if ((args.Length() == 1 && (args[0]->IsNull() || V8ArrayBuffer::HasInstance(args[0]))))
        return append2Callback(args);
    if ((args.Length() == 1 && (args[0]->IsNull() || V8ArrayBufferView::HasInstance(args[0]))))
        return append3Callback(args);
    if ((args.Length() == 1 && (args[0]->IsNull() || args[0]->IsUndefined() || args[0]->IsString() || args[0]->IsObject())) || (args.Length() == 2 && (args[0]->IsNull() || args[0]->IsUndefined() || args[0]->IsString() || args[0]->IsObject()) && (args[1]->IsNull() || args[1]->IsUndefined() || args[1]->IsString() || args[1]->IsObject())))
        return append4Callback(args);
    return V8Proxy::throwTypeError(0, args.GetIsolate());
}

} // namespace WebKitBlobBuilderV8Internal

static const BatchedCallback WebKitBlobBuilderCallbacks[] = {
    {"getBlob", WebKitBlobBuilderV8Internal::getBlobCallback},
    {"append", WebKitBlobBuilderV8Internal::appendCallback},
};

v8::Handle<v8::Value> V8WebKitBlobBuilder::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitBlobBuilder.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();

    ScriptExecutionContext* context = getScriptExecutionContext();
    if (!context)
        return V8Proxy::throwError(V8Proxy::ReferenceError, "WebKitBlobBuilder constructor's associated context is not available", args.GetIsolate());

    RefPtr<WebKitBlobBuilder> impl = WebKitBlobBuilder::create(context);
    v8::Handle<v8::Object> wrapper = args.Holder();

    V8DOMWrapper::setDOMWrapper(wrapper, &info, impl.get());
    V8DOMWrapper::setJSWrapperForDOMObject(impl.release(), v8::Persistent<v8::Object>::New(wrapper), args.GetIsolate());
    return args.Holder();
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8WebKitBlobBuilderTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "WebKitBlobBuilder", v8::Persistent<v8::FunctionTemplate>(), V8WebKitBlobBuilder::internalFieldCount,
        0, 0,
        WebKitBlobBuilderCallbacks, WTF_ARRAY_LENGTH(WebKitBlobBuilderCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8WebKitBlobBuilder::constructorCallback);
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8WebKitBlobBuilder::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8WebKitBlobBuilder::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8WebKitBlobBuilderTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8WebKitBlobBuilder::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8WebKitBlobBuilder::wrapSlow(PassRefPtr<WebKitBlobBuilder> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8WebKitBlobBuilder::derefObject(void* object)
{
    static_cast<WebKitBlobBuilder*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(LEGACY_WEBKIT_BLOB_BUILDER)
