/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8WebKitCSSFilterValue.h"

#if ENABLE(CSS_FILTERS)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8CSSValue.h"
#include "V8CSSValueList.h"
#include "V8Collection.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8WebKitCSSFilterValue::info = { V8WebKitCSSFilterValue::GetTemplate, V8WebKitCSSFilterValue::derefObject, 0, 0, &V8CSSValueList::info, WrapperTypeObjectPrototype };

namespace WebKitCSSFilterValueV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> operationTypeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebKitCSSFilterValue.operationType._get");
    WebKitCSSFilterValue* imp = V8WebKitCSSFilterValue::toNative(info.Holder());
    return v8Integer(imp->operationType(), info.GetIsolate());
}

} // namespace WebKitCSSFilterValueV8Internal

static const BatchedAttribute WebKitCSSFilterValueAttrs[] = {
    // Attribute 'operationType' (Type: 'readonly attribute' ExtAttr: '')
    {"operationType", WebKitCSSFilterValueV8Internal::operationTypeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedConstant WebKitCSSFilterValueConsts[] = {
    {"CSS_FILTER_REFERENCE", static_cast<signed int>(1)},
    {"CSS_FILTER_GRAYSCALE", static_cast<signed int>(2)},
    {"CSS_FILTER_SEPIA", static_cast<signed int>(3)},
    {"CSS_FILTER_SATURATE", static_cast<signed int>(4)},
    {"CSS_FILTER_HUE_ROTATE", static_cast<signed int>(5)},
    {"CSS_FILTER_INVERT", static_cast<signed int>(6)},
    {"CSS_FILTER_OPACITY", static_cast<signed int>(7)},
    {"CSS_FILTER_BRIGHTNESS", static_cast<signed int>(8)},
    {"CSS_FILTER_CONTRAST", static_cast<signed int>(9)},
    {"CSS_FILTER_BLUR", static_cast<signed int>(10)},
    {"CSS_FILTER_DROP_SHADOW", static_cast<signed int>(11)},
    {"CSS_FILTER_CUSTOM", static_cast<signed int>(12)},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8WebKitCSSFilterValueTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "WebKitCSSFilterValue", V8CSSValueList::GetTemplate(), V8WebKitCSSFilterValue::internalFieldCount,
        WebKitCSSFilterValueAttrs, WTF_ARRAY_LENGTH(WebKitCSSFilterValueAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    setCollectionIndexedGetter<WebKitCSSFilterValue, CSSValue>(desc);
    batchConfigureConstants(desc, proto, WebKitCSSFilterValueConsts, WTF_ARRAY_LENGTH(WebKitCSSFilterValueConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8WebKitCSSFilterValue::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8WebKitCSSFilterValue::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8WebKitCSSFilterValueTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8WebKitCSSFilterValue::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8WebKitCSSFilterValue::wrapSlow(PassRefPtr<WebKitCSSFilterValue> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8WebKitCSSFilterValue::derefObject(void* object)
{
    static_cast<WebKitCSSFilterValue*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(CSS_FILTERS)
