/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8WebKitCSSTransformValue.h"

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8CSSValue.h"
#include "V8CSSValueList.h"
#include "V8Collection.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8WebKitCSSTransformValue::info = { V8WebKitCSSTransformValue::GetTemplate, V8WebKitCSSTransformValue::derefObject, 0, 0, &V8CSSValueList::info, WrapperTypeObjectPrototype };

namespace WebKitCSSTransformValueV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> operationTypeAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebKitCSSTransformValue.operationType._get");
    WebKitCSSTransformValue* imp = V8WebKitCSSTransformValue::toNative(info.Holder());
    return v8Integer(imp->operationType(), info.GetIsolate());
}

} // namespace WebKitCSSTransformValueV8Internal

static const BatchedAttribute WebKitCSSTransformValueAttrs[] = {
    // Attribute 'operationType' (Type: 'readonly attribute' ExtAttr: '')
    {"operationType", WebKitCSSTransformValueV8Internal::operationTypeAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedConstant WebKitCSSTransformValueConsts[] = {
    {"CSS_TRANSLATE", static_cast<signed int>(1)},
    {"CSS_TRANSLATEX", static_cast<signed int>(2)},
    {"CSS_TRANSLATEY", static_cast<signed int>(3)},
    {"CSS_ROTATE", static_cast<signed int>(4)},
    {"CSS_SCALE", static_cast<signed int>(5)},
    {"CSS_SCALEX", static_cast<signed int>(6)},
    {"CSS_SCALEY", static_cast<signed int>(7)},
    {"CSS_SKEW", static_cast<signed int>(8)},
    {"CSS_SKEWX", static_cast<signed int>(9)},
    {"CSS_SKEWY", static_cast<signed int>(10)},
    {"CSS_MATRIX", static_cast<signed int>(11)},
    {"CSS_TRANSLATEZ", static_cast<signed int>(12)},
    {"CSS_TRANSLATE3D", static_cast<signed int>(13)},
    {"CSS_ROTATEX", static_cast<signed int>(14)},
    {"CSS_ROTATEY", static_cast<signed int>(15)},
    {"CSS_ROTATEZ", static_cast<signed int>(16)},
    {"CSS_ROTATE3D", static_cast<signed int>(17)},
    {"CSS_SCALEZ", static_cast<signed int>(18)},
    {"CSS_SCALE3D", static_cast<signed int>(19)},
    {"CSS_PERSPECTIVE", static_cast<signed int>(20)},
    {"CSS_MATRIX3D", static_cast<signed int>(21)},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8WebKitCSSTransformValueTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "WebKitCSSTransformValue", V8CSSValueList::GetTemplate(), V8WebKitCSSTransformValue::internalFieldCount,
        WebKitCSSTransformValueAttrs, WTF_ARRAY_LENGTH(WebKitCSSTransformValueAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    
    setCollectionIndexedGetter<WebKitCSSTransformValue, CSSValue>(desc);
    batchConfigureConstants(desc, proto, WebKitCSSTransformValueConsts, WTF_ARRAY_LENGTH(WebKitCSSTransformValueConsts));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8WebKitCSSTransformValue::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8WebKitCSSTransformValue::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8WebKitCSSTransformValueTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8WebKitCSSTransformValue::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8WebKitCSSTransformValue::wrapSlow(PassRefPtr<WebKitCSSTransformValue> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8WebKitCSSTransformValue::derefObject(void* object)
{
    static_cast<WebKitCSSTransformValue*>(object)->deref();
}

} // namespace WebCore
