/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8WebKitMutationObserver.h"

#if ENABLE(MUTATION_OBSERVERS)

#include "ContextFeatures.h"
#include "Dictionary.h"
#include "ExceptionCode.h"
#include "MutationRecord.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8MutationRecord.h"
#include "V8Node.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8WebKitMutationObserver::info = { V8WebKitMutationObserver::GetTemplate, V8WebKitMutationObserver::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace WebKitMutationObserverV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> observeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitMutationObserver.observe");
    if (args.Length() < 2)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    WebKitMutationObserver* imp = V8WebKitMutationObserver::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    EXCEPTION_BLOCK(Node*, target, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(Dictionary, options, MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined));
    if (!options.isUndefinedOrNull() && !options.isObject())
        return V8Proxy::throwTypeError("Not an object.", args.GetIsolate());
    imp->observe(target, options, ec);
    if (UNLIKELY(ec))
        goto fail;
    return v8::Handle<v8::Value>();
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> takeRecordsCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitMutationObserver.takeRecords");
    WebKitMutationObserver* imp = V8WebKitMutationObserver::toNative(args.Holder());
    return v8Array(imp->takeRecords(), args.GetIsolate());
}

static v8::Handle<v8::Value> disconnectCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitMutationObserver.disconnect");
    WebKitMutationObserver* imp = V8WebKitMutationObserver::toNative(args.Holder());
    imp->disconnect();
    return v8::Handle<v8::Value>();
}

} // namespace WebKitMutationObserverV8Internal

static const BatchedCallback WebKitMutationObserverCallbacks[] = {
    {"takeRecords", WebKitMutationObserverV8Internal::takeRecordsCallback},
    {"disconnect", WebKitMutationObserverV8Internal::disconnectCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8WebKitMutationObserverTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "WebKitMutationObserver", v8::Persistent<v8::FunctionTemplate>(), V8WebKitMutationObserver::internalFieldCount,
        0, 0,
        WebKitMutationObserverCallbacks, WTF_ARRAY_LENGTH(WebKitMutationObserverCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8WebKitMutationObserver::constructorCallback);
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'observe'
    const int observeArgc = 2;
    v8::Handle<v8::FunctionTemplate> observeArgv[observeArgc] = { V8Node::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> observeSignature = v8::Signature::New(desc, observeArgc, observeArgv);
    proto->Set(v8::String::New("observe"), v8::FunctionTemplate::New(WebKitMutationObserverV8Internal::observeCallback, v8::Handle<v8::Value>(), observeSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8WebKitMutationObserver::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8WebKitMutationObserver::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8WebKitMutationObserverTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8WebKitMutationObserver::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8WebKitMutationObserver::wrapSlow(PassRefPtr<WebKitMutationObserver> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8WebKitMutationObserver::derefObject(void* object)
{
    static_cast<WebKitMutationObserver*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(MUTATION_OBSERVERS)
