/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8WebKitNamedFlow.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Node.h"
#include "V8NodeList.h"
#include "V8Proxy.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8WebKitNamedFlow::info = { V8WebKitNamedFlow::GetTemplate, V8WebKitNamedFlow::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace WebKitNamedFlowV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> nameAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebKitNamedFlow.name._get");
    WebKitNamedFlow* imp = V8WebKitNamedFlow::toNative(info.Holder());
    return v8String(imp->name(), info.GetIsolate());
}

static v8::Handle<v8::Value> oversetAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WebKitNamedFlow.overset._get");
    WebKitNamedFlow* imp = V8WebKitNamedFlow::toNative(info.Holder());
    return v8Boolean(imp->overset(), info.GetIsolate());
}

static v8::Handle<v8::Value> getRegionsByContentNodeCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitNamedFlow.getRegionsByContentNode");
    if (args.Length() < 1)
        return V8Proxy::throwNotEnoughArgumentsError(args.GetIsolate());
    WebKitNamedFlow* imp = V8WebKitNamedFlow::toNative(args.Holder());
    EXCEPTION_BLOCK(Node*, contentNode, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    return toV8(imp->getRegionsByContentNode(contentNode), args.GetIsolate());
}

static v8::Handle<v8::Value> getContentCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.WebKitNamedFlow.getContent");
    WebKitNamedFlow* imp = V8WebKitNamedFlow::toNative(args.Holder());
    return toV8(imp->getContent(), args.GetIsolate());
}

} // namespace WebKitNamedFlowV8Internal

static const BatchedAttribute WebKitNamedFlowAttrs[] = {
    // Attribute 'name' (Type: 'readonly attribute' ExtAttr: '')
    {"name", WebKitNamedFlowV8Internal::nameAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'overset' (Type: 'readonly attribute' ExtAttr: '')
    {"overset", WebKitNamedFlowV8Internal::oversetAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static const BatchedCallback WebKitNamedFlowCallbacks[] = {
    {"getContent", WebKitNamedFlowV8Internal::getContentCallback},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8WebKitNamedFlowTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "WebKitNamedFlow", v8::Persistent<v8::FunctionTemplate>(), V8WebKitNamedFlow::internalFieldCount,
        WebKitNamedFlowAttrs, WTF_ARRAY_LENGTH(WebKitNamedFlowAttrs),
        WebKitNamedFlowCallbacks, WTF_ARRAY_LENGTH(WebKitNamedFlowCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'getRegionsByContentNode'
    const int getRegionsByContentNodeArgc = 1;
    v8::Handle<v8::FunctionTemplate> getRegionsByContentNodeArgv[getRegionsByContentNodeArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> getRegionsByContentNodeSignature = v8::Signature::New(desc, getRegionsByContentNodeArgc, getRegionsByContentNodeArgv);
    proto->Set(v8::String::New("getRegionsByContentNode"), v8::FunctionTemplate::New(WebKitNamedFlowV8Internal::getRegionsByContentNodeCallback, v8::Handle<v8::Value>(), getRegionsByContentNodeSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8WebKitNamedFlow::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8WebKitNamedFlow::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8WebKitNamedFlowTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8WebKitNamedFlow::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8WebKitNamedFlow::wrapSlow(PassRefPtr<WebKitNamedFlow> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8WebKitNamedFlow::derefObject(void* object)
{
    static_cast<WebKitNamedFlow*>(object)->deref();
}

} // namespace WebCore
