/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8WheelEvent.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWindow.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8MouseEvent.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8WheelEvent::info = { V8WheelEvent::GetTemplate, V8WheelEvent::derefObject, 0, 0, &V8MouseEvent::info, WrapperTypeObjectPrototype };

namespace WheelEventV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> wheelDeltaAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WheelEvent.wheelDelta._get");
    WheelEvent* imp = V8WheelEvent::toNative(info.Holder());
    return v8Integer(imp->wheelDelta(), info.GetIsolate());
}

static v8::Handle<v8::Value> wheelDeltaXAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WheelEvent.wheelDeltaX._get");
    WheelEvent* imp = V8WheelEvent::toNative(info.Holder());
    return v8Integer(imp->wheelDeltaX(), info.GetIsolate());
}

static v8::Handle<v8::Value> wheelDeltaYAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WheelEvent.wheelDeltaY._get");
    WheelEvent* imp = V8WheelEvent::toNative(info.Holder());
    return v8Integer(imp->wheelDeltaY(), info.GetIsolate());
}

static v8::Handle<v8::Value> webkitDirectionInvertedFromDeviceAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WheelEvent.webkitDirectionInvertedFromDevice._get");
    WheelEvent* imp = V8WheelEvent::toNative(info.Holder());
    return v8Boolean(imp->webkitDirectionInvertedFromDevice(), info.GetIsolate());
}

static v8::Handle<v8::Value> initWebKitWheelEventCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.WheelEvent.initWebKitWheelEvent");
    WheelEvent* imp = V8WheelEvent::toNative(args.Holder());
    EXCEPTION_BLOCK(int, wheelDeltaX, toInt32(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, wheelDeltaY, toInt32(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    EXCEPTION_BLOCK(DOMWindow*, view, V8DOMWindow::HasInstance(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)) ? V8DOMWindow::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(int, screenX, toInt32(MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, screenY, toInt32(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, clientX, toInt32(MAYBE_MISSING_PARAMETER(args, 5, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, clientY, toInt32(MAYBE_MISSING_PARAMETER(args, 6, DefaultIsUndefined)));
    EXCEPTION_BLOCK(bool, ctrlKey, MAYBE_MISSING_PARAMETER(args, 7, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(bool, altKey, MAYBE_MISSING_PARAMETER(args, 8, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(bool, shiftKey, MAYBE_MISSING_PARAMETER(args, 9, DefaultIsUndefined)->BooleanValue());
    EXCEPTION_BLOCK(bool, metaKey, MAYBE_MISSING_PARAMETER(args, 10, DefaultIsUndefined)->BooleanValue());
    imp->initWebKitWheelEvent(wheelDeltaX, wheelDeltaY, view, screenX, screenY, clientX, clientY, ctrlKey, altKey, shiftKey, metaKey);
    return v8::Handle<v8::Value>();
}

} // namespace WheelEventV8Internal

static const BatchedAttribute WheelEventAttrs[] = {
    // Attribute 'wheelDelta' (Type: 'readonly attribute' ExtAttr: '')
    {"wheelDelta", WheelEventV8Internal::wheelDeltaAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'wheelDeltaX' (Type: 'readonly attribute' ExtAttr: '')
    {"wheelDeltaX", WheelEventV8Internal::wheelDeltaXAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'wheelDeltaY' (Type: 'readonly attribute' ExtAttr: '')
    {"wheelDeltaY", WheelEventV8Internal::wheelDeltaYAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'webkitDirectionInvertedFromDevice' (Type: 'readonly attribute' ExtAttr: '')
    {"webkitDirectionInvertedFromDevice", WheelEventV8Internal::webkitDirectionInvertedFromDeviceAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8WheelEventTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "WheelEvent", V8MouseEvent::GetTemplate(), V8WheelEvent::internalFieldCount,
        WheelEventAttrs, WTF_ARRAY_LENGTH(WheelEventAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'initWebKitWheelEvent'
    const int initWebKitWheelEventArgc = 11;
    v8::Handle<v8::FunctionTemplate> initWebKitWheelEventArgv[initWebKitWheelEventArgc] = { v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), V8DOMWindow::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> initWebKitWheelEventSignature = v8::Signature::New(desc, initWebKitWheelEventArgc, initWebKitWheelEventArgv);
    proto->Set(v8::String::New("initWebKitWheelEvent"), v8::FunctionTemplate::New(WheelEventV8Internal::initWebKitWheelEventCallback, v8::Handle<v8::Value>(), initWebKitWheelEventSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8WheelEvent::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8WheelEvent::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8WheelEventTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8WheelEvent::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8WheelEvent::wrapSlow(PassRefPtr<WheelEvent> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8WheelEvent::derefObject(void* object)
{
    static_cast<WheelEvent*>(object)->deref();
}

} // namespace WebCore
