/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8WorkerNavigator.h"

#if ENABLE(WORKERS)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8WorkerNavigator::info = { V8WorkerNavigator::GetTemplate, V8WorkerNavigator::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace WorkerNavigatorV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> appNameAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WorkerNavigator.appName._get");
    WorkerNavigator* imp = V8WorkerNavigator::toNative(info.Holder());
    return v8String(imp->appName(), info.GetIsolate());
}

static v8::Handle<v8::Value> appVersionAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WorkerNavigator.appVersion._get");
    WorkerNavigator* imp = V8WorkerNavigator::toNative(info.Holder());
    return v8String(imp->appVersion(), info.GetIsolate());
}

static v8::Handle<v8::Value> platformAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WorkerNavigator.platform._get");
    WorkerNavigator* imp = V8WorkerNavigator::toNative(info.Holder());
    return v8String(imp->platform(), info.GetIsolate());
}

static v8::Handle<v8::Value> userAgentAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WorkerNavigator.userAgent._get");
    WorkerNavigator* imp = V8WorkerNavigator::toNative(info.Holder());
    return v8String(imp->userAgent(), info.GetIsolate());
}

static v8::Handle<v8::Value> onLineAttrGetter(v8::Local<v8::String> name, const v8::AccessorInfo& info)
{
    INC_STATS("DOM.WorkerNavigator.onLine._get");
    WorkerNavigator* imp = V8WorkerNavigator::toNative(info.Holder());
    return v8Boolean(imp->onLine(), info.GetIsolate());
}

} // namespace WorkerNavigatorV8Internal

static const BatchedAttribute WorkerNavigatorAttrs[] = {
    // Attribute 'appName' (Type: 'readonly attribute' ExtAttr: '')
    {"appName", WorkerNavigatorV8Internal::appNameAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'appVersion' (Type: 'readonly attribute' ExtAttr: '')
    {"appVersion", WorkerNavigatorV8Internal::appVersionAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'platform' (Type: 'readonly attribute' ExtAttr: '')
    {"platform", WorkerNavigatorV8Internal::platformAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'userAgent' (Type: 'readonly attribute' ExtAttr: '')
    {"userAgent", WorkerNavigatorV8Internal::userAgentAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
    // Attribute 'onLine' (Type: 'readonly attribute' ExtAttr: '')
    {"onLine", WorkerNavigatorV8Internal::onLineAttrGetter, 0, 0 /* no data */, static_cast<v8::AccessControl>(v8::DEFAULT), static_cast<v8::PropertyAttribute>(v8::None), 0 /* on instance */},
};

static v8::Persistent<v8::FunctionTemplate> ConfigureV8WorkerNavigatorTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "WorkerNavigator", v8::Persistent<v8::FunctionTemplate>(), V8WorkerNavigator::internalFieldCount,
        WorkerNavigatorAttrs, WTF_ARRAY_LENGTH(WorkerNavigatorAttrs),
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8WorkerNavigator::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8WorkerNavigator::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8WorkerNavigatorTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8WorkerNavigator::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8WorkerNavigator::wrapSlow(PassRefPtr<WorkerNavigator> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8WorkerNavigator::derefObject(void* object)
{
    static_cast<WorkerNavigator*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(WORKERS)
