/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8XPathEvaluator.h"

#include "ContextFeatures.h"
#include "ExceptionCode.h"
#include "PlatformString.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingMacros.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Node.h"
#include "V8Proxy.h"
#include "V8XPathExpression.h"
#include "V8XPathNSResolver.h"
#include "V8XPathResult.h"
#include <wtf/GetPtr.h>
#include <wtf/RefCounted.h>
#include <wtf/RefPtr.h>
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8XPathEvaluator::info = { V8XPathEvaluator::GetTemplate, V8XPathEvaluator::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace XPathEvaluatorV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> createExpressionCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.XPathEvaluator.createExpression");
    XPathEvaluator* imp = V8XPathEvaluator::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, expression, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    EXCEPTION_BLOCK(RefPtr<XPathNSResolver>, resolver, V8DOMWrapper::getXPathNSResolver(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)));
    RefPtr<XPathExpression> result = imp->createExpression(expression, resolver.get(), ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

static v8::Handle<v8::Value> createNSResolverCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.XPathEvaluator.createNSResolver");
    XPathEvaluator* imp = V8XPathEvaluator::toNative(args.Holder());
    EXCEPTION_BLOCK(Node*, nodeResolver, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined))) : 0);
    return toV8(imp->createNSResolver(nodeResolver), args.GetIsolate());
}

static v8::Handle<v8::Value> evaluateCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.XPathEvaluator.evaluate");
    XPathEvaluator* imp = V8XPathEvaluator::toNative(args.Holder());
    ExceptionCode ec = 0;
    {
    STRING_TO_V8PARAMETER_EXCEPTION_BLOCK(V8Parameter<>, expression, MAYBE_MISSING_PARAMETER(args, 0, DefaultIsUndefined));
    EXCEPTION_BLOCK(Node*, contextNode, V8Node::HasInstance(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined)) ? V8Node::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 1, DefaultIsUndefined))) : 0);
    EXCEPTION_BLOCK(RefPtr<XPathNSResolver>, resolver, V8DOMWrapper::getXPathNSResolver(MAYBE_MISSING_PARAMETER(args, 2, DefaultIsUndefined)));
    EXCEPTION_BLOCK(int, type, toUInt32(MAYBE_MISSING_PARAMETER(args, 3, DefaultIsUndefined)));
    EXCEPTION_BLOCK(XPathResult*, inResult, V8XPathResult::HasInstance(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined)) ? V8XPathResult::toNative(v8::Handle<v8::Object>::Cast(MAYBE_MISSING_PARAMETER(args, 4, DefaultIsUndefined))) : 0);
    RefPtr<XPathResult> result = imp->evaluate(expression, contextNode, resolver.get(), type, inResult, ec);
    if (UNLIKELY(ec))
        goto fail;
    return toV8(result.release(), args.GetIsolate());
    }
    fail:
    return V8Proxy::setDOMException(ec, args.GetIsolate());
}

} // namespace XPathEvaluatorV8Internal

v8::Handle<v8::Value> V8XPathEvaluator::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.XPathEvaluator.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();

    RefPtr<XPathEvaluator> impl = XPathEvaluator::create();
    v8::Handle<v8::Object> wrapper = args.Holder();

    V8DOMWrapper::setDOMWrapper(wrapper, &info, impl.get());
    V8DOMWrapper::setJSWrapperForDOMObject(impl.release(), v8::Persistent<v8::Object>::New(wrapper), args.GetIsolate());
    return args.Holder();
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8XPathEvaluatorTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "XPathEvaluator", v8::Persistent<v8::FunctionTemplate>(), V8XPathEvaluator::internalFieldCount,
        0, 0,
        0, 0);
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8XPathEvaluator::constructorCallback);
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom Signature 'createExpression'
    const int createExpressionArgc = 2;
    v8::Handle<v8::FunctionTemplate> createExpressionArgv[createExpressionArgc] = { v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>() };
    v8::Handle<v8::Signature> createExpressionSignature = v8::Signature::New(desc, createExpressionArgc, createExpressionArgv);
    proto->Set(v8::String::New("createExpression"), v8::FunctionTemplate::New(XPathEvaluatorV8Internal::createExpressionCallback, v8::Handle<v8::Value>(), createExpressionSignature));

    // Custom Signature 'createNSResolver'
    const int createNSResolverArgc = 1;
    v8::Handle<v8::FunctionTemplate> createNSResolverArgv[createNSResolverArgc] = { V8Node::GetRawTemplate() };
    v8::Handle<v8::Signature> createNSResolverSignature = v8::Signature::New(desc, createNSResolverArgc, createNSResolverArgv);
    proto->Set(v8::String::New("createNSResolver"), v8::FunctionTemplate::New(XPathEvaluatorV8Internal::createNSResolverCallback, v8::Handle<v8::Value>(), createNSResolverSignature));

    // Custom Signature 'evaluate'
    const int evaluateArgc = 5;
    v8::Handle<v8::FunctionTemplate> evaluateArgv[evaluateArgc] = { v8::Handle<v8::FunctionTemplate>(), V8Node::GetRawTemplate(), v8::Handle<v8::FunctionTemplate>(), v8::Handle<v8::FunctionTemplate>(), V8XPathResult::GetRawTemplate() };
    v8::Handle<v8::Signature> evaluateSignature = v8::Signature::New(desc, evaluateArgc, evaluateArgv);
    proto->Set(v8::String::New("evaluate"), v8::FunctionTemplate::New(XPathEvaluatorV8Internal::evaluateCallback, v8::Handle<v8::Value>(), evaluateSignature));

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8XPathEvaluator::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8XPathEvaluator::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8XPathEvaluatorTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8XPathEvaluator::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8XPathEvaluator::wrapSlow(PassRefPtr<XPathEvaluator> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8XPathEvaluator::derefObject(void* object)
{
    static_cast<XPathEvaluator*>(object)->deref();
}

} // namespace WebCore
