/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#include "config.h"
#include "V8XSLTProcessor.h"

#if ENABLE(XSLT)

#include "ContextFeatures.h"
#include "RuntimeEnabledFeatures.h"
#include "V8Binding.h"
#include "V8BindingState.h"
#include "V8DOMWrapper.h"
#include "V8IsolatedContext.h"
#include "V8Proxy.h"
#include <wtf/UnusedParam.h>

namespace WebCore {

WrapperTypeInfo V8XSLTProcessor::info = { V8XSLTProcessor::GetTemplate, V8XSLTProcessor::derefObject, 0, 0, 0, WrapperTypeObjectPrototype };

namespace XSLTProcessorV8Internal {

template <typename T> void V8_USE(T) { }

static v8::Handle<v8::Value> clearParametersCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.XSLTProcessor.clearParameters");
    XSLTProcessor* imp = V8XSLTProcessor::toNative(args.Holder());
    imp->clearParameters();
    return v8::Handle<v8::Value>();
}

static v8::Handle<v8::Value> resetCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.XSLTProcessor.reset");
    XSLTProcessor* imp = V8XSLTProcessor::toNative(args.Holder());
    imp->reset();
    return v8::Handle<v8::Value>();
}

} // namespace XSLTProcessorV8Internal

static const BatchedCallback XSLTProcessorCallbacks[] = {
    {"importStylesheet", V8XSLTProcessor::importStylesheetCallback},
    {"transformToFragment", V8XSLTProcessor::transformToFragmentCallback},
    {"transformToDocument", V8XSLTProcessor::transformToDocumentCallback},
    {"setParameter", V8XSLTProcessor::setParameterCallback},
    {"getParameter", V8XSLTProcessor::getParameterCallback},
    {"removeParameter", V8XSLTProcessor::removeParameterCallback},
    {"clearParameters", XSLTProcessorV8Internal::clearParametersCallback},
    {"reset", XSLTProcessorV8Internal::resetCallback},
};

v8::Handle<v8::Value> V8XSLTProcessor::constructorCallback(const v8::Arguments& args)
{
    INC_STATS("DOM.XSLTProcessor.Constructor");

    if (!args.IsConstructCall())
        return V8Proxy::throwTypeError("DOM object constructor cannot be called as a function.");

    if (ConstructorMode::current() == ConstructorMode::WrapExistingObject)
        return args.Holder();

    RefPtr<XSLTProcessor> impl = XSLTProcessor::create();
    v8::Handle<v8::Object> wrapper = args.Holder();

    V8DOMWrapper::setDOMWrapper(wrapper, &info, impl.get());
    V8DOMWrapper::setJSWrapperForDOMObject(impl.release(), v8::Persistent<v8::Object>::New(wrapper), args.GetIsolate());
    return args.Holder();
}

static v8::Persistent<v8::FunctionTemplate> ConfigureV8XSLTProcessorTemplate(v8::Persistent<v8::FunctionTemplate> desc)
{
    desc->ReadOnlyPrototype();

    v8::Local<v8::Signature> defaultSignature;
    defaultSignature = configureTemplate(desc, "XSLTProcessor", v8::Persistent<v8::FunctionTemplate>(), V8XSLTProcessor::internalFieldCount,
        0, 0,
        XSLTProcessorCallbacks, WTF_ARRAY_LENGTH(XSLTProcessorCallbacks));
    UNUSED_PARAM(defaultSignature); // In some cases, it will not be used.
    desc->SetCallHandler(V8XSLTProcessor::constructorCallback);
    v8::Local<v8::ObjectTemplate> instance = desc->InstanceTemplate();
    v8::Local<v8::ObjectTemplate> proto = desc->PrototypeTemplate();
    UNUSED_PARAM(instance); // In some cases, it will not be used.
    UNUSED_PARAM(proto); // In some cases, it will not be used.
    

    // Custom toString template
    desc->Set(getToStringName(), getToStringTemplate());
    return desc;
}

v8::Persistent<v8::FunctionTemplate> V8XSLTProcessor::GetRawTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->rawTemplateMap().find(&info);
    if (result != data->rawTemplateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ = createRawTemplate();
    data->rawTemplateMap().add(&info, templ);
    return templ;
}

v8::Persistent<v8::FunctionTemplate> V8XSLTProcessor::GetTemplate()
{
    V8BindingPerIsolateData* data = V8BindingPerIsolateData::current();
    V8BindingPerIsolateData::TemplateMap::iterator result = data->templateMap().find(&info);
    if (result != data->templateMap().end())
        return result->second;

    v8::HandleScope handleScope;
    v8::Persistent<v8::FunctionTemplate> templ =
        ConfigureV8XSLTProcessorTemplate(GetRawTemplate());
    data->templateMap().add(&info, templ);
    return templ;
}

bool V8XSLTProcessor::HasInstance(v8::Handle<v8::Value> value)
{
    return GetRawTemplate()->HasInstance(value);
}


v8::Handle<v8::Object> V8XSLTProcessor::wrapSlow(PassRefPtr<XSLTProcessor> impl, v8::Isolate* isolate)
{
    v8::Handle<v8::Object> wrapper;
    V8Proxy* proxy = 0;
    wrapper = V8DOMWrapper::instantiateV8Object(proxy, &info, impl.get());
    if (UNLIKELY(wrapper.IsEmpty()))
        return wrapper;

    v8::Persistent<v8::Object> wrapperHandle = v8::Persistent<v8::Object>::New(wrapper);

    if (!hasDependentLifetime)
        wrapperHandle.MarkIndependent();
    V8DOMWrapper::setJSWrapperForDOMObject(impl, wrapperHandle, isolate);
    return wrapper;
}

void V8XSLTProcessor::derefObject(void* object)
{
    static_cast<XSLTProcessor*>(object)->deref();
}

} // namespace WebCore

#endif // ENABLE(XSLT)
