/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef V8Document_h
#define V8Document_h

#include "Document.h"
#include "V8Binding.h"
#include "V8DOMWrapper.h"
#include "V8Node.h"
#include "WrapperTypeInfo.h"
#include <v8.h>
#include <wtf/HashMap.h>
#include <wtf/text/StringHash.h>

namespace WebCore {

class V8Document {
public:
    static const bool hasDependentLifetime = V8Node::hasDependentLifetime;
    static bool HasInstance(v8::Handle<v8::Value>);
    static v8::Persistent<v8::FunctionTemplate> GetRawTemplate();
    static v8::Persistent<v8::FunctionTemplate> GetTemplate();
    static Document* toNative(v8::Handle<v8::Object> object)
    {
        return reinterpret_cast<Document*>(object->GetPointerFromInternalField(v8DOMWrapperObjectIndex));
    }
    inline static v8::Handle<v8::Object> wrap(Document*, v8::Isolate* = 0, bool forceNewObject = false);
    static void derefObject(void*);
    static void visitDOMWrapper(DOMDataStore*, void*, v8::Persistent<v8::Object>);
    static WrapperTypeInfo info;
    static v8::Handle<v8::Value> evaluateCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getCSSCanvasContextCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> createTouchListCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> locationAccessorGetter(v8::Local<v8::String> name, const v8::AccessorInfo&);
    static void locationAccessorSetter(v8::Local<v8::String> name, v8::Local<v8::Value>, const v8::AccessorInfo&);
    static const int internalFieldCount = v8DefaultWrapperInternalFieldCount + 0;
private:
    static v8::Handle<v8::Object> wrapSlow(PassRefPtr<Document>, v8::Isolate*);
};

v8::Handle<v8::Object> V8Document::wrap(Document* impl, v8::Isolate* isolate, bool forceNewObject)
{
    if (!forceNewObject) {
        v8::Handle<v8::Object> wrapper = V8DOMWrapper::getCachedWrapper(impl);
        if (!wrapper.IsEmpty())
            return wrapper;
    }
    return V8Document::wrapSlow(impl, isolate);
}

v8::Handle<v8::Value> toV8(Document*, v8::Isolate* = 0, bool forceNewObject = false);
inline v8::Handle<v8::Value> toV8(PassRefPtr< Document > impl, v8::Isolate* isolate = 0, bool forceNewObject = false)
{
    return toV8(impl.get(), isolate, forceNewObject);
}

}

#endif // V8Document_h
