/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#if ENABLE(WEBGL)

#ifndef V8WebGLRenderingContext_h
#define V8WebGLRenderingContext_h

#include "V8Binding.h"
#include "V8CanvasRenderingContext.h"
#include "V8DOMWrapper.h"
#include "WebGLRenderingContext.h"
#include "WrapperTypeInfo.h"
#include <v8.h>
#include <wtf/HashMap.h>
#include <wtf/text/StringHash.h>

namespace WebCore {

class V8WebGLRenderingContext {
public:
    static const bool hasDependentLifetime = V8CanvasRenderingContext::hasDependentLifetime;
    static bool HasInstance(v8::Handle<v8::Value>);
    static v8::Persistent<v8::FunctionTemplate> GetRawTemplate();
    static v8::Persistent<v8::FunctionTemplate> GetTemplate();
    static WebGLRenderingContext* toNative(v8::Handle<v8::Object> object)
    {
        return reinterpret_cast<WebGLRenderingContext*>(object->GetPointerFromInternalField(v8DOMWrapperObjectIndex));
    }
    inline static v8::Handle<v8::Object> wrap(WebGLRenderingContext*, v8::Isolate* = 0);
    static void derefObject(void*);
    static void visitDOMWrapper(DOMDataStore*, void*, v8::Persistent<v8::Object>);
    static WrapperTypeInfo info;
    static v8::Handle<v8::Value> getAttachedShadersCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getBufferParameterCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getExtensionCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getFramebufferAttachmentParameterCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getParameterCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getProgramParameterCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getRenderbufferParameterCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getShaderParameterCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getSupportedExtensionsCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getTexParameterCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getUniformCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> getVertexAttribCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> uniform1fvCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> uniform1ivCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> uniform2fvCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> uniform2ivCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> uniform3fvCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> uniform3ivCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> uniform4fvCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> uniform4ivCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> uniformMatrix2fvCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> uniformMatrix3fvCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> uniformMatrix4fvCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> vertexAttrib1fvCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> vertexAttrib2fvCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> vertexAttrib3fvCallback(const v8::Arguments&);
    static v8::Handle<v8::Value> vertexAttrib4fvCallback(const v8::Arguments&);
    static const int internalFieldCount = v8DefaultWrapperInternalFieldCount + 0;
private:
    static v8::Handle<v8::Object> wrapSlow(PassRefPtr<WebGLRenderingContext>, v8::Isolate*);
};

v8::Handle<v8::Object> V8WebGLRenderingContext::wrap(WebGLRenderingContext* impl, v8::Isolate* isolate)
{
        v8::Handle<v8::Object> wrapper = getDOMObjectMap(isolate).get(impl);
        if (!wrapper.IsEmpty())
            return wrapper;
    return V8WebGLRenderingContext::wrapSlow(impl, isolate);
}

inline v8::Handle<v8::Value> toV8(WebGLRenderingContext* impl, v8::Isolate* isolate = 0)
{
    if (!impl)
        return v8NullWithCheck(isolate);
    return V8WebGLRenderingContext::wrap(impl, isolate);
}
inline v8::Handle<v8::Value> toV8(PassRefPtr< WebGLRenderingContext > impl, v8::Isolate* isolate = 0)
{
    return toV8(impl.get(), isolate);
}

}

#endif // V8WebGLRenderingContext_h
#endif // ENABLE(WEBGL)

