// Copyright (c) 2011 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file is automatically generated.

#include <string>
#include "gpu/command_buffer/common/gles2_cmd_utils.h"
#include "ui/gl/gl_bindings.h"
#include "ui/gl/gl_context.h"
#include "ui/gl/gl_implementation.h"

using gpu::gles2::GLES2Util;

namespace gfx {
bool g_GL_NV_fence;
bool g_GL_ANGLE_translated_shader_source;
bool g_GL_ANGLE_framebuffer_blit;
bool g_GL_ANGLE_framebuffer_multisample;
bool g_GL_ANGLE_instanced_arrays;
bool g_GL_EXT_multisampled_render_to_texture;
bool g_GL_EXT_framebuffer_multisample;
bool g_GL_EXT_occlusion_query_boolean;
bool g_GL_EXT_framebuffer_object;
bool g_GL_EXT_framebuffer_blit;
bool g_GL_EXT_texture_storage;
bool g_GL_OES_mapbuffer;
bool g_GL_OES_EGL_image;
bool g_GL_ARB_instanced_arrays;
bool g_GL_ARB_blend_func_extended;
bool g_GL_ARB_sync;
bool g_GL_ARB_robustness;
bool g_GL_ARB_timer_query;
bool g_GL_ARB_draw_instanced;
bool g_GL_ARB_vertex_buffer_object;
bool g_GL_ARB_framebuffer_object;
bool g_GL_ARB_occlusion_query;
bool g_GL_ARB_ES2_compatibility;
bool g_GL_ARB_draw_buffers;

static bool g_debugBindingsInitialized;
static void UpdateDebugGLExtensionBindings();

glActiveTextureProc g_glActiveTexture;
glAttachShaderProc g_glAttachShader;
glBeginQueryProc g_glBeginQuery;
glBeginQueryARBProc g_glBeginQueryARB;
glBindAttribLocationProc g_glBindAttribLocation;
glBindBufferProc g_glBindBuffer;
glBindFragDataLocationProc g_glBindFragDataLocation;
glBindFragDataLocationIndexedProc g_glBindFragDataLocationIndexed;
glBindFramebufferEXTProc g_glBindFramebufferEXT;
glBindRenderbufferEXTProc g_glBindRenderbufferEXT;
glBindTextureProc g_glBindTexture;
glBlendColorProc g_glBlendColor;
glBlendEquationProc g_glBlendEquation;
glBlendEquationSeparateProc g_glBlendEquationSeparate;
glBlendFuncProc g_glBlendFunc;
glBlendFuncSeparateProc g_glBlendFuncSeparate;
glBlitFramebufferEXTProc g_glBlitFramebufferEXT;
glBlitFramebufferANGLEProc g_glBlitFramebufferANGLE;
glBufferDataProc g_glBufferData;
glBufferSubDataProc g_glBufferSubData;
glCheckFramebufferStatusEXTProc g_glCheckFramebufferStatusEXT;
glClearProc g_glClear;
glClearColorProc g_glClearColor;
glClearDepthProc g_glClearDepth;
glClearDepthfProc g_glClearDepthf;
glClearStencilProc g_glClearStencil;
glColorMaskProc g_glColorMask;
glCompileShaderProc g_glCompileShader;
glCompressedTexImage2DProc g_glCompressedTexImage2D;
glCompressedTexSubImage2DProc g_glCompressedTexSubImage2D;
glCopyTexImage2DProc g_glCopyTexImage2D;
glCopyTexSubImage2DProc g_glCopyTexSubImage2D;
glCreateProgramProc g_glCreateProgram;
glCreateShaderProc g_glCreateShader;
glCullFaceProc g_glCullFace;
glDeleteBuffersARBProc g_glDeleteBuffersARB;
glDeleteFramebuffersEXTProc g_glDeleteFramebuffersEXT;
glDeleteProgramProc g_glDeleteProgram;
glDeleteQueriesProc g_glDeleteQueries;
glDeleteQueriesARBProc g_glDeleteQueriesARB;
glDeleteRenderbuffersEXTProc g_glDeleteRenderbuffersEXT;
glDeleteShaderProc g_glDeleteShader;
glDeleteTexturesProc g_glDeleteTextures;
glDepthFuncProc g_glDepthFunc;
glDepthMaskProc g_glDepthMask;
glDepthRangeProc g_glDepthRange;
glDepthRangefProc g_glDepthRangef;
glDetachShaderProc g_glDetachShader;
glDisableProc g_glDisable;
glDisableVertexAttribArrayProc g_glDisableVertexAttribArray;
glDrawArraysProc g_glDrawArrays;
glDrawBufferProc g_glDrawBuffer;
glDrawBuffersARBProc g_glDrawBuffersARB;
glDrawElementsProc g_glDrawElements;
glEGLImageTargetTexture2DOESProc g_glEGLImageTargetTexture2DOES;
glEGLImageTargetRenderbufferStorageOESProc g_glEGLImageTargetRenderbufferStorageOES;
glEnableProc g_glEnable;
glEnableVertexAttribArrayProc g_glEnableVertexAttribArray;
glEndQueryProc g_glEndQuery;
glEndQueryARBProc g_glEndQueryARB;
glFinishProc g_glFinish;
glFlushProc g_glFlush;
glFramebufferRenderbufferEXTProc g_glFramebufferRenderbufferEXT;
glFramebufferTexture2DEXTProc g_glFramebufferTexture2DEXT;
glFrontFaceProc g_glFrontFace;
glGenBuffersARBProc g_glGenBuffersARB;
glGenQueriesProc g_glGenQueries;
glGenQueriesARBProc g_glGenQueriesARB;
glGenerateMipmapEXTProc g_glGenerateMipmapEXT;
glGenFramebuffersEXTProc g_glGenFramebuffersEXT;
glGenRenderbuffersEXTProc g_glGenRenderbuffersEXT;
glGenTexturesProc g_glGenTextures;
glGetActiveAttribProc g_glGetActiveAttrib;
glGetActiveUniformProc g_glGetActiveUniform;
glGetAttachedShadersProc g_glGetAttachedShaders;
glGetAttribLocationProc g_glGetAttribLocation;
glGetBooleanvProc g_glGetBooleanv;
glGetBufferParameterivProc g_glGetBufferParameteriv;
glGetErrorProc g_glGetError;
glGetFloatvProc g_glGetFloatv;
glGetFramebufferAttachmentParameterivEXTProc g_glGetFramebufferAttachmentParameterivEXT;
glGetGraphicsResetStatusARBProc g_glGetGraphicsResetStatusARB;
glGetIntegervProc g_glGetIntegerv;
glGetProgramivProc g_glGetProgramiv;
glGetProgramInfoLogProc g_glGetProgramInfoLog;
glGetQueryivProc g_glGetQueryiv;
glGetQueryivARBProc g_glGetQueryivARB;
glGetQueryObjecti64vProc g_glGetQueryObjecti64v;
glGetQueryObjectivProc g_glGetQueryObjectiv;
glGetQueryObjectui64vProc g_glGetQueryObjectui64v;
glGetQueryObjectuivProc g_glGetQueryObjectuiv;
glGetQueryObjectuivARBProc g_glGetQueryObjectuivARB;
glGetRenderbufferParameterivEXTProc g_glGetRenderbufferParameterivEXT;
glGetShaderivProc g_glGetShaderiv;
glGetShaderInfoLogProc g_glGetShaderInfoLog;
glGetShaderPrecisionFormatProc g_glGetShaderPrecisionFormat;
glGetShaderSourceProc g_glGetShaderSource;
glGetStringProc g_glGetString;
glGetTexLevelParameterfvProc g_glGetTexLevelParameterfv;
glGetTexLevelParameterivProc g_glGetTexLevelParameteriv;
glGetTexParameterfvProc g_glGetTexParameterfv;
glGetTexParameterivProc g_glGetTexParameteriv;
glGetTranslatedShaderSourceANGLEProc g_glGetTranslatedShaderSourceANGLE;
glGetUniformfvProc g_glGetUniformfv;
glGetUniformivProc g_glGetUniformiv;
glGetUniformLocationProc g_glGetUniformLocation;
glGetVertexAttribfvProc g_glGetVertexAttribfv;
glGetVertexAttribivProc g_glGetVertexAttribiv;
glGetVertexAttribPointervProc g_glGetVertexAttribPointerv;
glHintProc g_glHint;
glIsBufferProc g_glIsBuffer;
glIsEnabledProc g_glIsEnabled;
glIsFramebufferEXTProc g_glIsFramebufferEXT;
glIsProgramProc g_glIsProgram;
glIsQueryARBProc g_glIsQueryARB;
glIsRenderbufferEXTProc g_glIsRenderbufferEXT;
glIsShaderProc g_glIsShader;
glIsTextureProc g_glIsTexture;
glLineWidthProc g_glLineWidth;
glLinkProgramProc g_glLinkProgram;
glMapBufferProc g_glMapBuffer;
glPixelStoreiProc g_glPixelStorei;
glPointParameteriProc g_glPointParameteri;
glPolygonOffsetProc g_glPolygonOffset;
glQueryCounterProc g_glQueryCounter;
glReadBufferProc g_glReadBuffer;
glReadPixelsProc g_glReadPixels;
glReleaseShaderCompilerProc g_glReleaseShaderCompiler;
glRenderbufferStorageMultisampleEXTProc g_glRenderbufferStorageMultisampleEXT;
glRenderbufferStorageMultisampleANGLEProc g_glRenderbufferStorageMultisampleANGLE;
glRenderbufferStorageEXTProc g_glRenderbufferStorageEXT;
glSampleCoverageProc g_glSampleCoverage;
glScissorProc g_glScissor;
glShaderBinaryProc g_glShaderBinary;
glShaderSourceProc g_glShaderSource;
glStencilFuncProc g_glStencilFunc;
glStencilFuncSeparateProc g_glStencilFuncSeparate;
glStencilMaskProc g_glStencilMask;
glStencilMaskSeparateProc g_glStencilMaskSeparate;
glStencilOpProc g_glStencilOp;
glStencilOpSeparateProc g_glStencilOpSeparate;
glTexImage2DProc g_glTexImage2D;
glTexParameterfProc g_glTexParameterf;
glTexParameterfvProc g_glTexParameterfv;
glTexParameteriProc g_glTexParameteri;
glTexParameterivProc g_glTexParameteriv;
glTexStorage2DEXTProc g_glTexStorage2DEXT;
glTexSubImage2DProc g_glTexSubImage2D;
glUniform1fProc g_glUniform1f;
glUniform1fvProc g_glUniform1fv;
glUniform1iProc g_glUniform1i;
glUniform1ivProc g_glUniform1iv;
glUniform2fProc g_glUniform2f;
glUniform2fvProc g_glUniform2fv;
glUniform2iProc g_glUniform2i;
glUniform2ivProc g_glUniform2iv;
glUniform3fProc g_glUniform3f;
glUniform3fvProc g_glUniform3fv;
glUniform3iProc g_glUniform3i;
glUniform3ivProc g_glUniform3iv;
glUniform4fProc g_glUniform4f;
glUniform4fvProc g_glUniform4fv;
glUniform4iProc g_glUniform4i;
glUniform4ivProc g_glUniform4iv;
glUniformMatrix2fvProc g_glUniformMatrix2fv;
glUniformMatrix3fvProc g_glUniformMatrix3fv;
glUniformMatrix4fvProc g_glUniformMatrix4fv;
glUnmapBufferProc g_glUnmapBuffer;
glUseProgramProc g_glUseProgram;
glValidateProgramProc g_glValidateProgram;
glVertexAttrib1fProc g_glVertexAttrib1f;
glVertexAttrib1fvProc g_glVertexAttrib1fv;
glVertexAttrib2fProc g_glVertexAttrib2f;
glVertexAttrib2fvProc g_glVertexAttrib2fv;
glVertexAttrib3fProc g_glVertexAttrib3f;
glVertexAttrib3fvProc g_glVertexAttrib3fv;
glVertexAttrib4fProc g_glVertexAttrib4f;
glVertexAttrib4fvProc g_glVertexAttrib4fv;
glVertexAttribPointerProc g_glVertexAttribPointer;
glViewportProc g_glViewport;
glGenFencesNVProc g_glGenFencesNV;
glDeleteFencesNVProc g_glDeleteFencesNV;
glSetFenceNVProc g_glSetFenceNV;
glTestFenceNVProc g_glTestFenceNV;
glFinishFenceNVProc g_glFinishFenceNV;
glIsFenceNVProc g_glIsFenceNV;
glGetFenceivNVProc g_glGetFenceivNV;
glFenceSyncProc g_glFenceSync;
glDeleteSyncProc g_glDeleteSync;
glGetSyncivProc g_glGetSynciv;
glDrawArraysInstancedANGLEProc g_glDrawArraysInstancedANGLE;
glDrawElementsInstancedANGLEProc g_glDrawElementsInstancedANGLE;
glVertexAttribDivisorANGLEProc g_glVertexAttribDivisorANGLE;

static glActiveTextureProc g_debug_glActiveTexture;
static glAttachShaderProc g_debug_glAttachShader;
static glBeginQueryProc g_debug_glBeginQuery;
static glBeginQueryARBProc g_debug_glBeginQueryARB;
static glBindAttribLocationProc g_debug_glBindAttribLocation;
static glBindBufferProc g_debug_glBindBuffer;
static glBindFragDataLocationProc g_debug_glBindFragDataLocation;
static glBindFragDataLocationIndexedProc g_debug_glBindFragDataLocationIndexed;
static glBindFramebufferEXTProc g_debug_glBindFramebufferEXT;
static glBindRenderbufferEXTProc g_debug_glBindRenderbufferEXT;
static glBindTextureProc g_debug_glBindTexture;
static glBlendColorProc g_debug_glBlendColor;
static glBlendEquationProc g_debug_glBlendEquation;
static glBlendEquationSeparateProc g_debug_glBlendEquationSeparate;
static glBlendFuncProc g_debug_glBlendFunc;
static glBlendFuncSeparateProc g_debug_glBlendFuncSeparate;
static glBlitFramebufferEXTProc g_debug_glBlitFramebufferEXT;
static glBlitFramebufferANGLEProc g_debug_glBlitFramebufferANGLE;
static glBufferDataProc g_debug_glBufferData;
static glBufferSubDataProc g_debug_glBufferSubData;
static glCheckFramebufferStatusEXTProc g_debug_glCheckFramebufferStatusEXT;
static glClearProc g_debug_glClear;
static glClearColorProc g_debug_glClearColor;
static glClearDepthProc g_debug_glClearDepth;
static glClearDepthfProc g_debug_glClearDepthf;
static glClearStencilProc g_debug_glClearStencil;
static glColorMaskProc g_debug_glColorMask;
static glCompileShaderProc g_debug_glCompileShader;
static glCompressedTexImage2DProc g_debug_glCompressedTexImage2D;
static glCompressedTexSubImage2DProc g_debug_glCompressedTexSubImage2D;
static glCopyTexImage2DProc g_debug_glCopyTexImage2D;
static glCopyTexSubImage2DProc g_debug_glCopyTexSubImage2D;
static glCreateProgramProc g_debug_glCreateProgram;
static glCreateShaderProc g_debug_glCreateShader;
static glCullFaceProc g_debug_glCullFace;
static glDeleteBuffersARBProc g_debug_glDeleteBuffersARB;
static glDeleteFramebuffersEXTProc g_debug_glDeleteFramebuffersEXT;
static glDeleteProgramProc g_debug_glDeleteProgram;
static glDeleteQueriesProc g_debug_glDeleteQueries;
static glDeleteQueriesARBProc g_debug_glDeleteQueriesARB;
static glDeleteRenderbuffersEXTProc g_debug_glDeleteRenderbuffersEXT;
static glDeleteShaderProc g_debug_glDeleteShader;
static glDeleteTexturesProc g_debug_glDeleteTextures;
static glDepthFuncProc g_debug_glDepthFunc;
static glDepthMaskProc g_debug_glDepthMask;
static glDepthRangeProc g_debug_glDepthRange;
static glDepthRangefProc g_debug_glDepthRangef;
static glDetachShaderProc g_debug_glDetachShader;
static glDisableProc g_debug_glDisable;
static glDisableVertexAttribArrayProc g_debug_glDisableVertexAttribArray;
static glDrawArraysProc g_debug_glDrawArrays;
static glDrawBufferProc g_debug_glDrawBuffer;
static glDrawBuffersARBProc g_debug_glDrawBuffersARB;
static glDrawElementsProc g_debug_glDrawElements;
static glEGLImageTargetTexture2DOESProc g_debug_glEGLImageTargetTexture2DOES;
static glEGLImageTargetRenderbufferStorageOESProc g_debug_glEGLImageTargetRenderbufferStorageOES;
static glEnableProc g_debug_glEnable;
static glEnableVertexAttribArrayProc g_debug_glEnableVertexAttribArray;
static glEndQueryProc g_debug_glEndQuery;
static glEndQueryARBProc g_debug_glEndQueryARB;
static glFinishProc g_debug_glFinish;
static glFlushProc g_debug_glFlush;
static glFramebufferRenderbufferEXTProc g_debug_glFramebufferRenderbufferEXT;
static glFramebufferTexture2DEXTProc g_debug_glFramebufferTexture2DEXT;
static glFrontFaceProc g_debug_glFrontFace;
static glGenBuffersARBProc g_debug_glGenBuffersARB;
static glGenQueriesProc g_debug_glGenQueries;
static glGenQueriesARBProc g_debug_glGenQueriesARB;
static glGenerateMipmapEXTProc g_debug_glGenerateMipmapEXT;
static glGenFramebuffersEXTProc g_debug_glGenFramebuffersEXT;
static glGenRenderbuffersEXTProc g_debug_glGenRenderbuffersEXT;
static glGenTexturesProc g_debug_glGenTextures;
static glGetActiveAttribProc g_debug_glGetActiveAttrib;
static glGetActiveUniformProc g_debug_glGetActiveUniform;
static glGetAttachedShadersProc g_debug_glGetAttachedShaders;
static glGetAttribLocationProc g_debug_glGetAttribLocation;
static glGetBooleanvProc g_debug_glGetBooleanv;
static glGetBufferParameterivProc g_debug_glGetBufferParameteriv;
static glGetErrorProc g_debug_glGetError;
static glGetFloatvProc g_debug_glGetFloatv;
static glGetFramebufferAttachmentParameterivEXTProc g_debug_glGetFramebufferAttachmentParameterivEXT;
static glGetGraphicsResetStatusARBProc g_debug_glGetGraphicsResetStatusARB;
static glGetIntegervProc g_debug_glGetIntegerv;
static glGetProgramivProc g_debug_glGetProgramiv;
static glGetProgramInfoLogProc g_debug_glGetProgramInfoLog;
static glGetQueryivProc g_debug_glGetQueryiv;
static glGetQueryivARBProc g_debug_glGetQueryivARB;
static glGetQueryObjecti64vProc g_debug_glGetQueryObjecti64v;
static glGetQueryObjectivProc g_debug_glGetQueryObjectiv;
static glGetQueryObjectui64vProc g_debug_glGetQueryObjectui64v;
static glGetQueryObjectuivProc g_debug_glGetQueryObjectuiv;
static glGetQueryObjectuivARBProc g_debug_glGetQueryObjectuivARB;
static glGetRenderbufferParameterivEXTProc g_debug_glGetRenderbufferParameterivEXT;
static glGetShaderivProc g_debug_glGetShaderiv;
static glGetShaderInfoLogProc g_debug_glGetShaderInfoLog;
static glGetShaderPrecisionFormatProc g_debug_glGetShaderPrecisionFormat;
static glGetShaderSourceProc g_debug_glGetShaderSource;
static glGetStringProc g_debug_glGetString;
static glGetTexLevelParameterfvProc g_debug_glGetTexLevelParameterfv;
static glGetTexLevelParameterivProc g_debug_glGetTexLevelParameteriv;
static glGetTexParameterfvProc g_debug_glGetTexParameterfv;
static glGetTexParameterivProc g_debug_glGetTexParameteriv;
static glGetTranslatedShaderSourceANGLEProc g_debug_glGetTranslatedShaderSourceANGLE;
static glGetUniformfvProc g_debug_glGetUniformfv;
static glGetUniformivProc g_debug_glGetUniformiv;
static glGetUniformLocationProc g_debug_glGetUniformLocation;
static glGetVertexAttribfvProc g_debug_glGetVertexAttribfv;
static glGetVertexAttribivProc g_debug_glGetVertexAttribiv;
static glGetVertexAttribPointervProc g_debug_glGetVertexAttribPointerv;
static glHintProc g_debug_glHint;
static glIsBufferProc g_debug_glIsBuffer;
static glIsEnabledProc g_debug_glIsEnabled;
static glIsFramebufferEXTProc g_debug_glIsFramebufferEXT;
static glIsProgramProc g_debug_glIsProgram;
static glIsQueryARBProc g_debug_glIsQueryARB;
static glIsRenderbufferEXTProc g_debug_glIsRenderbufferEXT;
static glIsShaderProc g_debug_glIsShader;
static glIsTextureProc g_debug_glIsTexture;
static glLineWidthProc g_debug_glLineWidth;
static glLinkProgramProc g_debug_glLinkProgram;
static glMapBufferProc g_debug_glMapBuffer;
static glPixelStoreiProc g_debug_glPixelStorei;
static glPointParameteriProc g_debug_glPointParameteri;
static glPolygonOffsetProc g_debug_glPolygonOffset;
static glQueryCounterProc g_debug_glQueryCounter;
static glReadBufferProc g_debug_glReadBuffer;
static glReadPixelsProc g_debug_glReadPixels;
static glReleaseShaderCompilerProc g_debug_glReleaseShaderCompiler;
static glRenderbufferStorageMultisampleEXTProc g_debug_glRenderbufferStorageMultisampleEXT;
static glRenderbufferStorageMultisampleANGLEProc g_debug_glRenderbufferStorageMultisampleANGLE;
static glRenderbufferStorageEXTProc g_debug_glRenderbufferStorageEXT;
static glSampleCoverageProc g_debug_glSampleCoverage;
static glScissorProc g_debug_glScissor;
static glShaderBinaryProc g_debug_glShaderBinary;
static glShaderSourceProc g_debug_glShaderSource;
static glStencilFuncProc g_debug_glStencilFunc;
static glStencilFuncSeparateProc g_debug_glStencilFuncSeparate;
static glStencilMaskProc g_debug_glStencilMask;
static glStencilMaskSeparateProc g_debug_glStencilMaskSeparate;
static glStencilOpProc g_debug_glStencilOp;
static glStencilOpSeparateProc g_debug_glStencilOpSeparate;
static glTexImage2DProc g_debug_glTexImage2D;
static glTexParameterfProc g_debug_glTexParameterf;
static glTexParameterfvProc g_debug_glTexParameterfv;
static glTexParameteriProc g_debug_glTexParameteri;
static glTexParameterivProc g_debug_glTexParameteriv;
static glTexStorage2DEXTProc g_debug_glTexStorage2DEXT;
static glTexSubImage2DProc g_debug_glTexSubImage2D;
static glUniform1fProc g_debug_glUniform1f;
static glUniform1fvProc g_debug_glUniform1fv;
static glUniform1iProc g_debug_glUniform1i;
static glUniform1ivProc g_debug_glUniform1iv;
static glUniform2fProc g_debug_glUniform2f;
static glUniform2fvProc g_debug_glUniform2fv;
static glUniform2iProc g_debug_glUniform2i;
static glUniform2ivProc g_debug_glUniform2iv;
static glUniform3fProc g_debug_glUniform3f;
static glUniform3fvProc g_debug_glUniform3fv;
static glUniform3iProc g_debug_glUniform3i;
static glUniform3ivProc g_debug_glUniform3iv;
static glUniform4fProc g_debug_glUniform4f;
static glUniform4fvProc g_debug_glUniform4fv;
static glUniform4iProc g_debug_glUniform4i;
static glUniform4ivProc g_debug_glUniform4iv;
static glUniformMatrix2fvProc g_debug_glUniformMatrix2fv;
static glUniformMatrix3fvProc g_debug_glUniformMatrix3fv;
static glUniformMatrix4fvProc g_debug_glUniformMatrix4fv;
static glUnmapBufferProc g_debug_glUnmapBuffer;
static glUseProgramProc g_debug_glUseProgram;
static glValidateProgramProc g_debug_glValidateProgram;
static glVertexAttrib1fProc g_debug_glVertexAttrib1f;
static glVertexAttrib1fvProc g_debug_glVertexAttrib1fv;
static glVertexAttrib2fProc g_debug_glVertexAttrib2f;
static glVertexAttrib2fvProc g_debug_glVertexAttrib2fv;
static glVertexAttrib3fProc g_debug_glVertexAttrib3f;
static glVertexAttrib3fvProc g_debug_glVertexAttrib3fv;
static glVertexAttrib4fProc g_debug_glVertexAttrib4f;
static glVertexAttrib4fvProc g_debug_glVertexAttrib4fv;
static glVertexAttribPointerProc g_debug_glVertexAttribPointer;
static glViewportProc g_debug_glViewport;
static glGenFencesNVProc g_debug_glGenFencesNV;
static glDeleteFencesNVProc g_debug_glDeleteFencesNV;
static glSetFenceNVProc g_debug_glSetFenceNV;
static glTestFenceNVProc g_debug_glTestFenceNV;
static glFinishFenceNVProc g_debug_glFinishFenceNV;
static glIsFenceNVProc g_debug_glIsFenceNV;
static glGetFenceivNVProc g_debug_glGetFenceivNV;
static glFenceSyncProc g_debug_glFenceSync;
static glDeleteSyncProc g_debug_glDeleteSync;
static glGetSyncivProc g_debug_glGetSynciv;
static glDrawArraysInstancedANGLEProc g_debug_glDrawArraysInstancedANGLE;
static glDrawElementsInstancedANGLEProc g_debug_glDrawElementsInstancedANGLE;
static glVertexAttribDivisorANGLEProc g_debug_glVertexAttribDivisorANGLE;

void InitializeGLBindingsGL() {
  g_glActiveTexture = reinterpret_cast<glActiveTextureProc>(GetGLCoreProcAddress("glActiveTexture"));
  g_glAttachShader = reinterpret_cast<glAttachShaderProc>(GetGLCoreProcAddress("glAttachShader"));
  g_glBeginQuery = reinterpret_cast<glBeginQueryProc>(GetGLCoreProcAddress("glBeginQuery"));
  g_glBeginQueryARB = reinterpret_cast<glBeginQueryARBProc>(GetGLCoreProcAddress("glBeginQueryARB"));
  if (!g_glBeginQueryARB)
    g_glBeginQueryARB = reinterpret_cast<glBeginQueryARBProc>(GetGLCoreProcAddress("glBeginQueryEXT"));
  g_glBindAttribLocation = reinterpret_cast<glBindAttribLocationProc>(GetGLCoreProcAddress("glBindAttribLocation"));
  g_glBindBuffer = reinterpret_cast<glBindBufferProc>(GetGLCoreProcAddress("glBindBuffer"));
  g_glBindFragDataLocation = reinterpret_cast<glBindFragDataLocationProc>(GetGLCoreProcAddress("glBindFragDataLocation"));
  g_glBindFragDataLocationIndexed = reinterpret_cast<glBindFragDataLocationIndexedProc>(GetGLCoreProcAddress("glBindFragDataLocationIndexed"));
  g_glBindFramebufferEXT = reinterpret_cast<glBindFramebufferEXTProc>(GetGLCoreProcAddress("glBindFramebufferEXT"));
  if (!g_glBindFramebufferEXT)
    g_glBindFramebufferEXT = reinterpret_cast<glBindFramebufferEXTProc>(GetGLCoreProcAddress("glBindFramebuffer"));
  g_glBindRenderbufferEXT = reinterpret_cast<glBindRenderbufferEXTProc>(GetGLCoreProcAddress("glBindRenderbufferEXT"));
  if (!g_glBindRenderbufferEXT)
    g_glBindRenderbufferEXT = reinterpret_cast<glBindRenderbufferEXTProc>(GetGLCoreProcAddress("glBindRenderbuffer"));
  g_glBindTexture = reinterpret_cast<glBindTextureProc>(GetGLCoreProcAddress("glBindTexture"));
  g_glBlendColor = reinterpret_cast<glBlendColorProc>(GetGLCoreProcAddress("glBlendColor"));
  g_glBlendEquation = reinterpret_cast<glBlendEquationProc>(GetGLCoreProcAddress("glBlendEquation"));
  g_glBlendEquationSeparate = reinterpret_cast<glBlendEquationSeparateProc>(GetGLCoreProcAddress("glBlendEquationSeparate"));
  g_glBlendFunc = reinterpret_cast<glBlendFuncProc>(GetGLCoreProcAddress("glBlendFunc"));
  g_glBlendFuncSeparate = reinterpret_cast<glBlendFuncSeparateProc>(GetGLCoreProcAddress("glBlendFuncSeparate"));
  g_glBlitFramebufferEXT = reinterpret_cast<glBlitFramebufferEXTProc>(GetGLCoreProcAddress("glBlitFramebufferEXT"));
  if (!g_glBlitFramebufferEXT)
    g_glBlitFramebufferEXT = reinterpret_cast<glBlitFramebufferEXTProc>(GetGLCoreProcAddress("glBlitFramebuffer"));
  g_glBlitFramebufferANGLE = reinterpret_cast<glBlitFramebufferANGLEProc>(GetGLCoreProcAddress("glBlitFramebufferANGLE"));
  if (!g_glBlitFramebufferANGLE)
    g_glBlitFramebufferANGLE = reinterpret_cast<glBlitFramebufferANGLEProc>(GetGLCoreProcAddress("glBlitFramebuffer"));
  g_glBufferData = reinterpret_cast<glBufferDataProc>(GetGLCoreProcAddress("glBufferData"));
  g_glBufferSubData = reinterpret_cast<glBufferSubDataProc>(GetGLCoreProcAddress("glBufferSubData"));
  g_glCheckFramebufferStatusEXT = reinterpret_cast<glCheckFramebufferStatusEXTProc>(GetGLCoreProcAddress("glCheckFramebufferStatusEXT"));
  if (!g_glCheckFramebufferStatusEXT)
    g_glCheckFramebufferStatusEXT = reinterpret_cast<glCheckFramebufferStatusEXTProc>(GetGLCoreProcAddress("glCheckFramebufferStatus"));
  g_glClear = reinterpret_cast<glClearProc>(GetGLCoreProcAddress("glClear"));
  g_glClearColor = reinterpret_cast<glClearColorProc>(GetGLCoreProcAddress("glClearColor"));
  g_glClearDepth = reinterpret_cast<glClearDepthProc>(GetGLCoreProcAddress("glClearDepth"));
  g_glClearDepthf = reinterpret_cast<glClearDepthfProc>(GetGLCoreProcAddress("glClearDepthf"));
  g_glClearStencil = reinterpret_cast<glClearStencilProc>(GetGLCoreProcAddress("glClearStencil"));
  g_glColorMask = reinterpret_cast<glColorMaskProc>(GetGLCoreProcAddress("glColorMask"));
  g_glCompileShader = reinterpret_cast<glCompileShaderProc>(GetGLCoreProcAddress("glCompileShader"));
  g_glCompressedTexImage2D = reinterpret_cast<glCompressedTexImage2DProc>(GetGLCoreProcAddress("glCompressedTexImage2D"));
  g_glCompressedTexSubImage2D = reinterpret_cast<glCompressedTexSubImage2DProc>(GetGLCoreProcAddress("glCompressedTexSubImage2D"));
  g_glCopyTexImage2D = reinterpret_cast<glCopyTexImage2DProc>(GetGLCoreProcAddress("glCopyTexImage2D"));
  g_glCopyTexSubImage2D = reinterpret_cast<glCopyTexSubImage2DProc>(GetGLCoreProcAddress("glCopyTexSubImage2D"));
  g_glCreateProgram = reinterpret_cast<glCreateProgramProc>(GetGLCoreProcAddress("glCreateProgram"));
  g_glCreateShader = reinterpret_cast<glCreateShaderProc>(GetGLCoreProcAddress("glCreateShader"));
  g_glCullFace = reinterpret_cast<glCullFaceProc>(GetGLCoreProcAddress("glCullFace"));
  g_glDeleteBuffersARB = reinterpret_cast<glDeleteBuffersARBProc>(GetGLCoreProcAddress("glDeleteBuffersARB"));
  if (!g_glDeleteBuffersARB)
    g_glDeleteBuffersARB = reinterpret_cast<glDeleteBuffersARBProc>(GetGLCoreProcAddress("glDeleteBuffers"));
  g_glDeleteFramebuffersEXT = reinterpret_cast<glDeleteFramebuffersEXTProc>(GetGLCoreProcAddress("glDeleteFramebuffersEXT"));
  if (!g_glDeleteFramebuffersEXT)
    g_glDeleteFramebuffersEXT = reinterpret_cast<glDeleteFramebuffersEXTProc>(GetGLCoreProcAddress("glDeleteFramebuffers"));
  g_glDeleteProgram = reinterpret_cast<glDeleteProgramProc>(GetGLCoreProcAddress("glDeleteProgram"));
  g_glDeleteQueries = reinterpret_cast<glDeleteQueriesProc>(GetGLCoreProcAddress("glDeleteQueries"));
  g_glDeleteQueriesARB = reinterpret_cast<glDeleteQueriesARBProc>(GetGLCoreProcAddress("glDeleteQueriesARB"));
  if (!g_glDeleteQueriesARB)
    g_glDeleteQueriesARB = reinterpret_cast<glDeleteQueriesARBProc>(GetGLCoreProcAddress("glDeleteQueriesEXT"));
  g_glDeleteRenderbuffersEXT = reinterpret_cast<glDeleteRenderbuffersEXTProc>(GetGLCoreProcAddress("glDeleteRenderbuffersEXT"));
  if (!g_glDeleteRenderbuffersEXT)
    g_glDeleteRenderbuffersEXT = reinterpret_cast<glDeleteRenderbuffersEXTProc>(GetGLCoreProcAddress("glDeleteRenderbuffers"));
  g_glDeleteShader = reinterpret_cast<glDeleteShaderProc>(GetGLCoreProcAddress("glDeleteShader"));
  g_glDeleteTextures = reinterpret_cast<glDeleteTexturesProc>(GetGLCoreProcAddress("glDeleteTextures"));
  g_glDepthFunc = reinterpret_cast<glDepthFuncProc>(GetGLCoreProcAddress("glDepthFunc"));
  g_glDepthMask = reinterpret_cast<glDepthMaskProc>(GetGLCoreProcAddress("glDepthMask"));
  g_glDepthRange = reinterpret_cast<glDepthRangeProc>(GetGLCoreProcAddress("glDepthRange"));
  g_glDepthRangef = reinterpret_cast<glDepthRangefProc>(GetGLCoreProcAddress("glDepthRangef"));
  g_glDetachShader = reinterpret_cast<glDetachShaderProc>(GetGLCoreProcAddress("glDetachShader"));
  g_glDisable = reinterpret_cast<glDisableProc>(GetGLCoreProcAddress("glDisable"));
  g_glDisableVertexAttribArray = reinterpret_cast<glDisableVertexAttribArrayProc>(GetGLCoreProcAddress("glDisableVertexAttribArray"));
  g_glDrawArrays = reinterpret_cast<glDrawArraysProc>(GetGLCoreProcAddress("glDrawArrays"));
  g_glDrawBuffer = reinterpret_cast<glDrawBufferProc>(GetGLCoreProcAddress("glDrawBuffer"));
  g_glDrawBuffersARB = reinterpret_cast<glDrawBuffersARBProc>(GetGLCoreProcAddress("glDrawBuffersARB"));
  g_glDrawElements = reinterpret_cast<glDrawElementsProc>(GetGLCoreProcAddress("glDrawElements"));
  g_glEGLImageTargetTexture2DOES = reinterpret_cast<glEGLImageTargetTexture2DOESProc>(GetGLCoreProcAddress("glEGLImageTargetTexture2DOES"));
  g_glEGLImageTargetRenderbufferStorageOES = reinterpret_cast<glEGLImageTargetRenderbufferStorageOESProc>(GetGLCoreProcAddress("glEGLImageTargetRenderbufferStorageOES"));
  g_glEnable = reinterpret_cast<glEnableProc>(GetGLCoreProcAddress("glEnable"));
  g_glEnableVertexAttribArray = reinterpret_cast<glEnableVertexAttribArrayProc>(GetGLCoreProcAddress("glEnableVertexAttribArray"));
  g_glEndQuery = reinterpret_cast<glEndQueryProc>(GetGLCoreProcAddress("glEndQuery"));
  g_glEndQueryARB = reinterpret_cast<glEndQueryARBProc>(GetGLCoreProcAddress("glEndQueryARB"));
  if (!g_glEndQueryARB)
    g_glEndQueryARB = reinterpret_cast<glEndQueryARBProc>(GetGLCoreProcAddress("glEndQueryEXT"));
  g_glFinish = reinterpret_cast<glFinishProc>(GetGLCoreProcAddress("glFinish"));
  g_glFlush = reinterpret_cast<glFlushProc>(GetGLCoreProcAddress("glFlush"));
  g_glFramebufferRenderbufferEXT = reinterpret_cast<glFramebufferRenderbufferEXTProc>(GetGLCoreProcAddress("glFramebufferRenderbufferEXT"));
  if (!g_glFramebufferRenderbufferEXT)
    g_glFramebufferRenderbufferEXT = reinterpret_cast<glFramebufferRenderbufferEXTProc>(GetGLCoreProcAddress("glFramebufferRenderbuffer"));
  g_glFramebufferTexture2DEXT = reinterpret_cast<glFramebufferTexture2DEXTProc>(GetGLCoreProcAddress("glFramebufferTexture2DEXT"));
  if (!g_glFramebufferTexture2DEXT)
    g_glFramebufferTexture2DEXT = reinterpret_cast<glFramebufferTexture2DEXTProc>(GetGLCoreProcAddress("glFramebufferTexture2D"));
  g_glFrontFace = reinterpret_cast<glFrontFaceProc>(GetGLCoreProcAddress("glFrontFace"));
  g_glGenBuffersARB = reinterpret_cast<glGenBuffersARBProc>(GetGLCoreProcAddress("glGenBuffersARB"));
  if (!g_glGenBuffersARB)
    g_glGenBuffersARB = reinterpret_cast<glGenBuffersARBProc>(GetGLCoreProcAddress("glGenBuffers"));
  g_glGenQueries = reinterpret_cast<glGenQueriesProc>(GetGLCoreProcAddress("glGenQueries"));
  g_glGenQueriesARB = reinterpret_cast<glGenQueriesARBProc>(GetGLCoreProcAddress("glGenQueriesARB"));
  if (!g_glGenQueriesARB)
    g_glGenQueriesARB = reinterpret_cast<glGenQueriesARBProc>(GetGLCoreProcAddress("glGenQueriesEXT"));
  g_glGenerateMipmapEXT = reinterpret_cast<glGenerateMipmapEXTProc>(GetGLCoreProcAddress("glGenerateMipmapEXT"));
  if (!g_glGenerateMipmapEXT)
    g_glGenerateMipmapEXT = reinterpret_cast<glGenerateMipmapEXTProc>(GetGLCoreProcAddress("glGenerateMipmap"));
  g_glGenFramebuffersEXT = reinterpret_cast<glGenFramebuffersEXTProc>(GetGLCoreProcAddress("glGenFramebuffersEXT"));
  if (!g_glGenFramebuffersEXT)
    g_glGenFramebuffersEXT = reinterpret_cast<glGenFramebuffersEXTProc>(GetGLCoreProcAddress("glGenFramebuffers"));
  g_glGenRenderbuffersEXT = reinterpret_cast<glGenRenderbuffersEXTProc>(GetGLCoreProcAddress("glGenRenderbuffersEXT"));
  if (!g_glGenRenderbuffersEXT)
    g_glGenRenderbuffersEXT = reinterpret_cast<glGenRenderbuffersEXTProc>(GetGLCoreProcAddress("glGenRenderbuffers"));
  g_glGenTextures = reinterpret_cast<glGenTexturesProc>(GetGLCoreProcAddress("glGenTextures"));
  g_glGetActiveAttrib = reinterpret_cast<glGetActiveAttribProc>(GetGLCoreProcAddress("glGetActiveAttrib"));
  g_glGetActiveUniform = reinterpret_cast<glGetActiveUniformProc>(GetGLCoreProcAddress("glGetActiveUniform"));
  g_glGetAttachedShaders = reinterpret_cast<glGetAttachedShadersProc>(GetGLCoreProcAddress("glGetAttachedShaders"));
  g_glGetAttribLocation = reinterpret_cast<glGetAttribLocationProc>(GetGLCoreProcAddress("glGetAttribLocation"));
  g_glGetBooleanv = reinterpret_cast<glGetBooleanvProc>(GetGLCoreProcAddress("glGetBooleanv"));
  g_glGetBufferParameteriv = reinterpret_cast<glGetBufferParameterivProc>(GetGLCoreProcAddress("glGetBufferParameteriv"));
  g_glGetError = reinterpret_cast<glGetErrorProc>(GetGLCoreProcAddress("glGetError"));
  g_glGetFloatv = reinterpret_cast<glGetFloatvProc>(GetGLCoreProcAddress("glGetFloatv"));
  g_glGetFramebufferAttachmentParameterivEXT = reinterpret_cast<glGetFramebufferAttachmentParameterivEXTProc>(GetGLCoreProcAddress("glGetFramebufferAttachmentParameterivEXT"));
  if (!g_glGetFramebufferAttachmentParameterivEXT)
    g_glGetFramebufferAttachmentParameterivEXT = reinterpret_cast<glGetFramebufferAttachmentParameterivEXTProc>(GetGLCoreProcAddress("glGetFramebufferAttachmentParameteriv"));
  g_glGetGraphicsResetStatusARB = reinterpret_cast<glGetGraphicsResetStatusARBProc>(GetGLCoreProcAddress("glGetGraphicsResetStatusARB"));
  g_glGetIntegerv = reinterpret_cast<glGetIntegervProc>(GetGLCoreProcAddress("glGetIntegerv"));
  g_glGetProgramiv = reinterpret_cast<glGetProgramivProc>(GetGLCoreProcAddress("glGetProgramiv"));
  g_glGetProgramInfoLog = reinterpret_cast<glGetProgramInfoLogProc>(GetGLCoreProcAddress("glGetProgramInfoLog"));
  g_glGetQueryiv = reinterpret_cast<glGetQueryivProc>(GetGLCoreProcAddress("glGetQueryiv"));
  g_glGetQueryivARB = reinterpret_cast<glGetQueryivARBProc>(GetGLCoreProcAddress("glGetQueryivARB"));
  if (!g_glGetQueryivARB)
    g_glGetQueryivARB = reinterpret_cast<glGetQueryivARBProc>(GetGLCoreProcAddress("glGetQueryivEXT"));
  g_glGetQueryObjecti64v = reinterpret_cast<glGetQueryObjecti64vProc>(GetGLCoreProcAddress("glGetQueryObjecti64v"));
  g_glGetQueryObjectiv = reinterpret_cast<glGetQueryObjectivProc>(GetGLCoreProcAddress("glGetQueryObjectiv"));
  g_glGetQueryObjectui64v = reinterpret_cast<glGetQueryObjectui64vProc>(GetGLCoreProcAddress("glGetQueryObjectui64v"));
  g_glGetQueryObjectuiv = reinterpret_cast<glGetQueryObjectuivProc>(GetGLCoreProcAddress("glGetQueryObjectuiv"));
  g_glGetQueryObjectuivARB = reinterpret_cast<glGetQueryObjectuivARBProc>(GetGLCoreProcAddress("glGetQueryObjectuivARB"));
  if (!g_glGetQueryObjectuivARB)
    g_glGetQueryObjectuivARB = reinterpret_cast<glGetQueryObjectuivARBProc>(GetGLCoreProcAddress("glGetQueryObjectuivEXT"));
  g_glGetRenderbufferParameterivEXT = reinterpret_cast<glGetRenderbufferParameterivEXTProc>(GetGLCoreProcAddress("glGetRenderbufferParameterivEXT"));
  if (!g_glGetRenderbufferParameterivEXT)
    g_glGetRenderbufferParameterivEXT = reinterpret_cast<glGetRenderbufferParameterivEXTProc>(GetGLCoreProcAddress("glGetRenderbufferParameteriv"));
  g_glGetShaderiv = reinterpret_cast<glGetShaderivProc>(GetGLCoreProcAddress("glGetShaderiv"));
  g_glGetShaderInfoLog = reinterpret_cast<glGetShaderInfoLogProc>(GetGLCoreProcAddress("glGetShaderInfoLog"));
  g_glGetShaderPrecisionFormat = reinterpret_cast<glGetShaderPrecisionFormatProc>(GetGLCoreProcAddress("glGetShaderPrecisionFormat"));
  g_glGetShaderSource = reinterpret_cast<glGetShaderSourceProc>(GetGLCoreProcAddress("glGetShaderSource"));
  g_glGetString = reinterpret_cast<glGetStringProc>(GetGLCoreProcAddress("glGetString"));
  g_glGetTexLevelParameterfv = reinterpret_cast<glGetTexLevelParameterfvProc>(GetGLCoreProcAddress("glGetTexLevelParameterfv"));
  g_glGetTexLevelParameteriv = reinterpret_cast<glGetTexLevelParameterivProc>(GetGLCoreProcAddress("glGetTexLevelParameteriv"));
  g_glGetTexParameterfv = reinterpret_cast<glGetTexParameterfvProc>(GetGLCoreProcAddress("glGetTexParameterfv"));
  g_glGetTexParameteriv = reinterpret_cast<glGetTexParameterivProc>(GetGLCoreProcAddress("glGetTexParameteriv"));
  g_glGetTranslatedShaderSourceANGLE = reinterpret_cast<glGetTranslatedShaderSourceANGLEProc>(GetGLCoreProcAddress("glGetTranslatedShaderSourceANGLE"));
  g_glGetUniformfv = reinterpret_cast<glGetUniformfvProc>(GetGLCoreProcAddress("glGetUniformfv"));
  g_glGetUniformiv = reinterpret_cast<glGetUniformivProc>(GetGLCoreProcAddress("glGetUniformiv"));
  g_glGetUniformLocation = reinterpret_cast<glGetUniformLocationProc>(GetGLCoreProcAddress("glGetUniformLocation"));
  g_glGetVertexAttribfv = reinterpret_cast<glGetVertexAttribfvProc>(GetGLCoreProcAddress("glGetVertexAttribfv"));
  g_glGetVertexAttribiv = reinterpret_cast<glGetVertexAttribivProc>(GetGLCoreProcAddress("glGetVertexAttribiv"));
  g_glGetVertexAttribPointerv = reinterpret_cast<glGetVertexAttribPointervProc>(GetGLCoreProcAddress("glGetVertexAttribPointerv"));
  g_glHint = reinterpret_cast<glHintProc>(GetGLCoreProcAddress("glHint"));
  g_glIsBuffer = reinterpret_cast<glIsBufferProc>(GetGLCoreProcAddress("glIsBuffer"));
  g_glIsEnabled = reinterpret_cast<glIsEnabledProc>(GetGLCoreProcAddress("glIsEnabled"));
  g_glIsFramebufferEXT = reinterpret_cast<glIsFramebufferEXTProc>(GetGLCoreProcAddress("glIsFramebufferEXT"));
  if (!g_glIsFramebufferEXT)
    g_glIsFramebufferEXT = reinterpret_cast<glIsFramebufferEXTProc>(GetGLCoreProcAddress("glIsFramebuffer"));
  g_glIsProgram = reinterpret_cast<glIsProgramProc>(GetGLCoreProcAddress("glIsProgram"));
  g_glIsQueryARB = reinterpret_cast<glIsQueryARBProc>(GetGLCoreProcAddress("glIsQueryARB"));
  if (!g_glIsQueryARB)
    g_glIsQueryARB = reinterpret_cast<glIsQueryARBProc>(GetGLCoreProcAddress("glIsQueryEXT"));
  g_glIsRenderbufferEXT = reinterpret_cast<glIsRenderbufferEXTProc>(GetGLCoreProcAddress("glIsRenderbufferEXT"));
  if (!g_glIsRenderbufferEXT)
    g_glIsRenderbufferEXT = reinterpret_cast<glIsRenderbufferEXTProc>(GetGLCoreProcAddress("glIsRenderbuffer"));
  g_glIsShader = reinterpret_cast<glIsShaderProc>(GetGLCoreProcAddress("glIsShader"));
  g_glIsTexture = reinterpret_cast<glIsTextureProc>(GetGLCoreProcAddress("glIsTexture"));
  g_glLineWidth = reinterpret_cast<glLineWidthProc>(GetGLCoreProcAddress("glLineWidth"));
  g_glLinkProgram = reinterpret_cast<glLinkProgramProc>(GetGLCoreProcAddress("glLinkProgram"));
  g_glMapBuffer = reinterpret_cast<glMapBufferProc>(GetGLCoreProcAddress("glMapBuffer"));
  if (!g_glMapBuffer)
    g_glMapBuffer = reinterpret_cast<glMapBufferProc>(GetGLCoreProcAddress("glMapBufferOES"));
  g_glPixelStorei = reinterpret_cast<glPixelStoreiProc>(GetGLCoreProcAddress("glPixelStorei"));
  g_glPointParameteri = reinterpret_cast<glPointParameteriProc>(GetGLCoreProcAddress("glPointParameteri"));
  g_glPolygonOffset = reinterpret_cast<glPolygonOffsetProc>(GetGLCoreProcAddress("glPolygonOffset"));
  g_glQueryCounter = reinterpret_cast<glQueryCounterProc>(GetGLCoreProcAddress("glQueryCounter"));
  g_glReadBuffer = reinterpret_cast<glReadBufferProc>(GetGLCoreProcAddress("glReadBuffer"));
  g_glReadPixels = reinterpret_cast<glReadPixelsProc>(GetGLCoreProcAddress("glReadPixels"));
  g_glReleaseShaderCompiler = reinterpret_cast<glReleaseShaderCompilerProc>(GetGLCoreProcAddress("glReleaseShaderCompiler"));
  g_glRenderbufferStorageMultisampleEXT = reinterpret_cast<glRenderbufferStorageMultisampleEXTProc>(GetGLCoreProcAddress("glRenderbufferStorageMultisampleEXT"));
  if (!g_glRenderbufferStorageMultisampleEXT)
    g_glRenderbufferStorageMultisampleEXT = reinterpret_cast<glRenderbufferStorageMultisampleEXTProc>(GetGLCoreProcAddress("glRenderbufferStorageMultisample"));
  g_glRenderbufferStorageMultisampleANGLE = reinterpret_cast<glRenderbufferStorageMultisampleANGLEProc>(GetGLCoreProcAddress("glRenderbufferStorageMultisampleANGLE"));
  if (!g_glRenderbufferStorageMultisampleANGLE)
    g_glRenderbufferStorageMultisampleANGLE = reinterpret_cast<glRenderbufferStorageMultisampleANGLEProc>(GetGLCoreProcAddress("glRenderbufferStorageMultisample"));
  g_glRenderbufferStorageEXT = reinterpret_cast<glRenderbufferStorageEXTProc>(GetGLCoreProcAddress("glRenderbufferStorageEXT"));
  if (!g_glRenderbufferStorageEXT)
    g_glRenderbufferStorageEXT = reinterpret_cast<glRenderbufferStorageEXTProc>(GetGLCoreProcAddress("glRenderbufferStorage"));
  g_glSampleCoverage = reinterpret_cast<glSampleCoverageProc>(GetGLCoreProcAddress("glSampleCoverage"));
  g_glScissor = reinterpret_cast<glScissorProc>(GetGLCoreProcAddress("glScissor"));
  g_glShaderBinary = reinterpret_cast<glShaderBinaryProc>(GetGLCoreProcAddress("glShaderBinary"));
  g_glShaderSource = reinterpret_cast<glShaderSourceProc>(GetGLCoreProcAddress("glShaderSource"));
  g_glStencilFunc = reinterpret_cast<glStencilFuncProc>(GetGLCoreProcAddress("glStencilFunc"));
  g_glStencilFuncSeparate = reinterpret_cast<glStencilFuncSeparateProc>(GetGLCoreProcAddress("glStencilFuncSeparate"));
  g_glStencilMask = reinterpret_cast<glStencilMaskProc>(GetGLCoreProcAddress("glStencilMask"));
  g_glStencilMaskSeparate = reinterpret_cast<glStencilMaskSeparateProc>(GetGLCoreProcAddress("glStencilMaskSeparate"));
  g_glStencilOp = reinterpret_cast<glStencilOpProc>(GetGLCoreProcAddress("glStencilOp"));
  g_glStencilOpSeparate = reinterpret_cast<glStencilOpSeparateProc>(GetGLCoreProcAddress("glStencilOpSeparate"));
  g_glTexImage2D = reinterpret_cast<glTexImage2DProc>(GetGLCoreProcAddress("glTexImage2D"));
  g_glTexParameterf = reinterpret_cast<glTexParameterfProc>(GetGLCoreProcAddress("glTexParameterf"));
  g_glTexParameterfv = reinterpret_cast<glTexParameterfvProc>(GetGLCoreProcAddress("glTexParameterfv"));
  g_glTexParameteri = reinterpret_cast<glTexParameteriProc>(GetGLCoreProcAddress("glTexParameteri"));
  g_glTexParameteriv = reinterpret_cast<glTexParameterivProc>(GetGLCoreProcAddress("glTexParameteriv"));
  g_glTexStorage2DEXT = reinterpret_cast<glTexStorage2DEXTProc>(GetGLCoreProcAddress("glTexStorage2DEXT"));
  g_glTexSubImage2D = reinterpret_cast<glTexSubImage2DProc>(GetGLCoreProcAddress("glTexSubImage2D"));
  g_glUniform1f = reinterpret_cast<glUniform1fProc>(GetGLCoreProcAddress("glUniform1f"));
  g_glUniform1fv = reinterpret_cast<glUniform1fvProc>(GetGLCoreProcAddress("glUniform1fv"));
  g_glUniform1i = reinterpret_cast<glUniform1iProc>(GetGLCoreProcAddress("glUniform1i"));
  g_glUniform1iv = reinterpret_cast<glUniform1ivProc>(GetGLCoreProcAddress("glUniform1iv"));
  g_glUniform2f = reinterpret_cast<glUniform2fProc>(GetGLCoreProcAddress("glUniform2f"));
  g_glUniform2fv = reinterpret_cast<glUniform2fvProc>(GetGLCoreProcAddress("glUniform2fv"));
  g_glUniform2i = reinterpret_cast<glUniform2iProc>(GetGLCoreProcAddress("glUniform2i"));
  g_glUniform2iv = reinterpret_cast<glUniform2ivProc>(GetGLCoreProcAddress("glUniform2iv"));
  g_glUniform3f = reinterpret_cast<glUniform3fProc>(GetGLCoreProcAddress("glUniform3f"));
  g_glUniform3fv = reinterpret_cast<glUniform3fvProc>(GetGLCoreProcAddress("glUniform3fv"));
  g_glUniform3i = reinterpret_cast<glUniform3iProc>(GetGLCoreProcAddress("glUniform3i"));
  g_glUniform3iv = reinterpret_cast<glUniform3ivProc>(GetGLCoreProcAddress("glUniform3iv"));
  g_glUniform4f = reinterpret_cast<glUniform4fProc>(GetGLCoreProcAddress("glUniform4f"));
  g_glUniform4fv = reinterpret_cast<glUniform4fvProc>(GetGLCoreProcAddress("glUniform4fv"));
  g_glUniform4i = reinterpret_cast<glUniform4iProc>(GetGLCoreProcAddress("glUniform4i"));
  g_glUniform4iv = reinterpret_cast<glUniform4ivProc>(GetGLCoreProcAddress("glUniform4iv"));
  g_glUniformMatrix2fv = reinterpret_cast<glUniformMatrix2fvProc>(GetGLCoreProcAddress("glUniformMatrix2fv"));
  g_glUniformMatrix3fv = reinterpret_cast<glUniformMatrix3fvProc>(GetGLCoreProcAddress("glUniformMatrix3fv"));
  g_glUniformMatrix4fv = reinterpret_cast<glUniformMatrix4fvProc>(GetGLCoreProcAddress("glUniformMatrix4fv"));
  g_glUnmapBuffer = reinterpret_cast<glUnmapBufferProc>(GetGLCoreProcAddress("glUnmapBuffer"));
  if (!g_glUnmapBuffer)
    g_glUnmapBuffer = reinterpret_cast<glUnmapBufferProc>(GetGLCoreProcAddress("glUnmapBufferOES"));
  g_glUseProgram = reinterpret_cast<glUseProgramProc>(GetGLCoreProcAddress("glUseProgram"));
  g_glValidateProgram = reinterpret_cast<glValidateProgramProc>(GetGLCoreProcAddress("glValidateProgram"));
  g_glVertexAttrib1f = reinterpret_cast<glVertexAttrib1fProc>(GetGLCoreProcAddress("glVertexAttrib1f"));
  g_glVertexAttrib1fv = reinterpret_cast<glVertexAttrib1fvProc>(GetGLCoreProcAddress("glVertexAttrib1fv"));
  g_glVertexAttrib2f = reinterpret_cast<glVertexAttrib2fProc>(GetGLCoreProcAddress("glVertexAttrib2f"));
  g_glVertexAttrib2fv = reinterpret_cast<glVertexAttrib2fvProc>(GetGLCoreProcAddress("glVertexAttrib2fv"));
  g_glVertexAttrib3f = reinterpret_cast<glVertexAttrib3fProc>(GetGLCoreProcAddress("glVertexAttrib3f"));
  g_glVertexAttrib3fv = reinterpret_cast<glVertexAttrib3fvProc>(GetGLCoreProcAddress("glVertexAttrib3fv"));
  g_glVertexAttrib4f = reinterpret_cast<glVertexAttrib4fProc>(GetGLCoreProcAddress("glVertexAttrib4f"));
  g_glVertexAttrib4fv = reinterpret_cast<glVertexAttrib4fvProc>(GetGLCoreProcAddress("glVertexAttrib4fv"));
  g_glVertexAttribPointer = reinterpret_cast<glVertexAttribPointerProc>(GetGLCoreProcAddress("glVertexAttribPointer"));
  g_glViewport = reinterpret_cast<glViewportProc>(GetGLCoreProcAddress("glViewport"));
  g_glGenFencesNV = reinterpret_cast<glGenFencesNVProc>(GetGLCoreProcAddress("glGenFencesNV"));
  g_glDeleteFencesNV = reinterpret_cast<glDeleteFencesNVProc>(GetGLCoreProcAddress("glDeleteFencesNV"));
  g_glSetFenceNV = reinterpret_cast<glSetFenceNVProc>(GetGLCoreProcAddress("glSetFenceNV"));
  g_glTestFenceNV = reinterpret_cast<glTestFenceNVProc>(GetGLCoreProcAddress("glTestFenceNV"));
  g_glFinishFenceNV = reinterpret_cast<glFinishFenceNVProc>(GetGLCoreProcAddress("glFinishFenceNV"));
  g_glIsFenceNV = reinterpret_cast<glIsFenceNVProc>(GetGLCoreProcAddress("glIsFenceNV"));
  g_glGetFenceivNV = reinterpret_cast<glGetFenceivNVProc>(GetGLCoreProcAddress("glGetFenceivNV"));
  g_glFenceSync = reinterpret_cast<glFenceSyncProc>(GetGLCoreProcAddress("glFenceSync"));
  g_glDeleteSync = reinterpret_cast<glDeleteSyncProc>(GetGLCoreProcAddress("glDeleteSync"));
  g_glGetSynciv = reinterpret_cast<glGetSyncivProc>(GetGLCoreProcAddress("glGetSynciv"));
  g_glDrawArraysInstancedANGLE = reinterpret_cast<glDrawArraysInstancedANGLEProc>(GetGLCoreProcAddress("glDrawArraysInstancedANGLE"));
  if (!g_glDrawArraysInstancedANGLE)
    g_glDrawArraysInstancedANGLE = reinterpret_cast<glDrawArraysInstancedANGLEProc>(GetGLCoreProcAddress("glDrawArraysInstancedARB"));
  g_glDrawElementsInstancedANGLE = reinterpret_cast<glDrawElementsInstancedANGLEProc>(GetGLCoreProcAddress("glDrawElementsInstancedANGLE"));
  if (!g_glDrawElementsInstancedANGLE)
    g_glDrawElementsInstancedANGLE = reinterpret_cast<glDrawElementsInstancedANGLEProc>(GetGLCoreProcAddress("glDrawElementsInstancedARB"));
  g_glVertexAttribDivisorANGLE = reinterpret_cast<glVertexAttribDivisorANGLEProc>(GetGLCoreProcAddress("glVertexAttribDivisorANGLE"));
  if (!g_glVertexAttribDivisorANGLE)
    g_glVertexAttribDivisorANGLE = reinterpret_cast<glVertexAttribDivisorANGLEProc>(GetGLCoreProcAddress("glVertexAttribDivisorARB"));
}

void InitializeGLExtensionBindingsGL(GLContext* context) {
  DCHECK(context && context->IsCurrent(NULL));
  g_GL_NV_fence = context->HasExtension("GL_NV_fence");
  if (g_GL_NV_fence) {
    g_glGenFencesNV = reinterpret_cast<glGenFencesNVProc>(GetGLProcAddress("glGenFencesNV"));
    g_glDeleteFencesNV = reinterpret_cast<glDeleteFencesNVProc>(GetGLProcAddress("glDeleteFencesNV"));
    g_glSetFenceNV = reinterpret_cast<glSetFenceNVProc>(GetGLProcAddress("glSetFenceNV"));
    g_glTestFenceNV = reinterpret_cast<glTestFenceNVProc>(GetGLProcAddress("glTestFenceNV"));
    g_glFinishFenceNV = reinterpret_cast<glFinishFenceNVProc>(GetGLProcAddress("glFinishFenceNV"));
    g_glIsFenceNV = reinterpret_cast<glIsFenceNVProc>(GetGLProcAddress("glIsFenceNV"));
    g_glGetFenceivNV = reinterpret_cast<glGetFenceivNVProc>(GetGLProcAddress("glGetFenceivNV"));
  }
  g_GL_ANGLE_translated_shader_source = context->HasExtension("GL_ANGLE_translated_shader_source");
  if (g_GL_ANGLE_translated_shader_source) {
    g_glGetTranslatedShaderSourceANGLE = reinterpret_cast<glGetTranslatedShaderSourceANGLEProc>(GetGLProcAddress("glGetTranslatedShaderSourceANGLE"));
  }
  g_GL_ANGLE_framebuffer_blit = context->HasExtension("GL_ANGLE_framebuffer_blit");
  if (g_GL_ANGLE_framebuffer_blit) {
    g_glBlitFramebufferANGLE = reinterpret_cast<glBlitFramebufferANGLEProc>(GetGLProcAddress("glBlitFramebufferANGLE"));
  }
  g_GL_ANGLE_framebuffer_multisample = context->HasExtension("GL_ANGLE_framebuffer_multisample");
  if (g_GL_ANGLE_framebuffer_multisample) {
    g_glRenderbufferStorageMultisampleANGLE = reinterpret_cast<glRenderbufferStorageMultisampleANGLEProc>(GetGLProcAddress("glRenderbufferStorageMultisampleANGLE"));
  }
  g_GL_ANGLE_instanced_arrays = context->HasExtension("GL_ANGLE_instanced_arrays");
  if (g_GL_ANGLE_instanced_arrays) {
    g_glDrawArraysInstancedANGLE = reinterpret_cast<glDrawArraysInstancedANGLEProc>(GetGLProcAddress("glDrawArraysInstancedANGLE"));
    g_glDrawElementsInstancedANGLE = reinterpret_cast<glDrawElementsInstancedANGLEProc>(GetGLProcAddress("glDrawElementsInstancedANGLE"));
    g_glVertexAttribDivisorANGLE = reinterpret_cast<glVertexAttribDivisorANGLEProc>(GetGLProcAddress("glVertexAttribDivisorANGLE"));
  }
  g_GL_EXT_multisampled_render_to_texture = context->HasExtension("GL_EXT_multisampled_render_to_texture");
  if (g_GL_EXT_multisampled_render_to_texture) {
    g_glRenderbufferStorageMultisampleEXT = reinterpret_cast<glRenderbufferStorageMultisampleEXTProc>(GetGLProcAddress("glRenderbufferStorageMultisampleEXT"));
  }
  g_GL_EXT_framebuffer_multisample = context->HasExtension("GL_EXT_framebuffer_multisample");
  if (g_GL_EXT_framebuffer_multisample) {
    g_glRenderbufferStorageMultisampleEXT = reinterpret_cast<glRenderbufferStorageMultisampleEXTProc>(GetGLProcAddress("glRenderbufferStorageMultisampleEXT"));
  }
  g_GL_EXT_occlusion_query_boolean = context->HasExtension("GL_EXT_occlusion_query_boolean");
  if (g_GL_EXT_occlusion_query_boolean) {
    g_glBeginQueryARB = reinterpret_cast<glBeginQueryARBProc>(GetGLProcAddress("glBeginQueryEXT"));
    g_glDeleteQueriesARB = reinterpret_cast<glDeleteQueriesARBProc>(GetGLProcAddress("glDeleteQueriesEXT"));
    g_glEndQueryARB = reinterpret_cast<glEndQueryARBProc>(GetGLProcAddress("glEndQueryEXT"));
    g_glGenQueriesARB = reinterpret_cast<glGenQueriesARBProc>(GetGLProcAddress("glGenQueriesEXT"));
    g_glGetQueryivARB = reinterpret_cast<glGetQueryivARBProc>(GetGLProcAddress("glGetQueryivEXT"));
    g_glGetQueryObjectuivARB = reinterpret_cast<glGetQueryObjectuivARBProc>(GetGLProcAddress("glGetQueryObjectuivEXT"));
    g_glIsQueryARB = reinterpret_cast<glIsQueryARBProc>(GetGLProcAddress("glIsQueryEXT"));
  }
  g_GL_EXT_framebuffer_object = context->HasExtension("GL_EXT_framebuffer_object");
  if (g_GL_EXT_framebuffer_object) {
    g_glBindFramebufferEXT = reinterpret_cast<glBindFramebufferEXTProc>(GetGLProcAddress("glBindFramebufferEXT"));
    g_glBindRenderbufferEXT = reinterpret_cast<glBindRenderbufferEXTProc>(GetGLProcAddress("glBindRenderbufferEXT"));
    g_glCheckFramebufferStatusEXT = reinterpret_cast<glCheckFramebufferStatusEXTProc>(GetGLProcAddress("glCheckFramebufferStatusEXT"));
    g_glDeleteFramebuffersEXT = reinterpret_cast<glDeleteFramebuffersEXTProc>(GetGLProcAddress("glDeleteFramebuffersEXT"));
    g_glDeleteRenderbuffersEXT = reinterpret_cast<glDeleteRenderbuffersEXTProc>(GetGLProcAddress("glDeleteRenderbuffersEXT"));
    g_glFramebufferRenderbufferEXT = reinterpret_cast<glFramebufferRenderbufferEXTProc>(GetGLProcAddress("glFramebufferRenderbufferEXT"));
    g_glFramebufferTexture2DEXT = reinterpret_cast<glFramebufferTexture2DEXTProc>(GetGLProcAddress("glFramebufferTexture2DEXT"));
    g_glGenerateMipmapEXT = reinterpret_cast<glGenerateMipmapEXTProc>(GetGLProcAddress("glGenerateMipmapEXT"));
    g_glGenFramebuffersEXT = reinterpret_cast<glGenFramebuffersEXTProc>(GetGLProcAddress("glGenFramebuffersEXT"));
    g_glGenRenderbuffersEXT = reinterpret_cast<glGenRenderbuffersEXTProc>(GetGLProcAddress("glGenRenderbuffersEXT"));
    g_glGetFramebufferAttachmentParameterivEXT = reinterpret_cast<glGetFramebufferAttachmentParameterivEXTProc>(GetGLProcAddress("glGetFramebufferAttachmentParameterivEXT"));
    g_glGetRenderbufferParameterivEXT = reinterpret_cast<glGetRenderbufferParameterivEXTProc>(GetGLProcAddress("glGetRenderbufferParameterivEXT"));
    g_glIsFramebufferEXT = reinterpret_cast<glIsFramebufferEXTProc>(GetGLProcAddress("glIsFramebufferEXT"));
    g_glIsRenderbufferEXT = reinterpret_cast<glIsRenderbufferEXTProc>(GetGLProcAddress("glIsRenderbufferEXT"));
    g_glRenderbufferStorageEXT = reinterpret_cast<glRenderbufferStorageEXTProc>(GetGLProcAddress("glRenderbufferStorageEXT"));
  }
  g_GL_EXT_framebuffer_blit = context->HasExtension("GL_EXT_framebuffer_blit");
  if (g_GL_EXT_framebuffer_blit) {
    g_glBlitFramebufferEXT = reinterpret_cast<glBlitFramebufferEXTProc>(GetGLProcAddress("glBlitFramebufferEXT"));
  }
  g_GL_EXT_texture_storage = context->HasExtension("GL_EXT_texture_storage");
  if (g_GL_EXT_texture_storage) {
    g_glTexStorage2DEXT = reinterpret_cast<glTexStorage2DEXTProc>(GetGLProcAddress("glTexStorage2DEXT"));
  }
  g_GL_OES_mapbuffer = context->HasExtension("GL_OES_mapbuffer");
  if (g_GL_OES_mapbuffer) {
    g_glMapBuffer = reinterpret_cast<glMapBufferProc>(GetGLProcAddress("glMapBufferOES"));
    g_glUnmapBuffer = reinterpret_cast<glUnmapBufferProc>(GetGLProcAddress("glUnmapBufferOES"));
  }
  g_GL_OES_EGL_image = context->HasExtension("GL_OES_EGL_image");
  if (g_GL_OES_EGL_image) {
    g_glEGLImageTargetTexture2DOES = reinterpret_cast<glEGLImageTargetTexture2DOESProc>(GetGLProcAddress("glEGLImageTargetTexture2DOES"));
    g_glEGLImageTargetRenderbufferStorageOES = reinterpret_cast<glEGLImageTargetRenderbufferStorageOESProc>(GetGLProcAddress("glEGLImageTargetRenderbufferStorageOES"));
  }
  g_GL_ARB_instanced_arrays = context->HasExtension("GL_ARB_instanced_arrays");
  if (g_GL_ARB_instanced_arrays) {
    g_glVertexAttribDivisorANGLE = reinterpret_cast<glVertexAttribDivisorANGLEProc>(GetGLProcAddress("glVertexAttribDivisorARB"));
  }
  g_GL_ARB_blend_func_extended = context->HasExtension("GL_ARB_blend_func_extended");
  if (g_GL_ARB_blend_func_extended) {
    g_glBindFragDataLocationIndexed = reinterpret_cast<glBindFragDataLocationIndexedProc>(GetGLProcAddress("glBindFragDataLocationIndexed"));
  }
  g_GL_ARB_sync = context->HasExtension("GL_ARB_sync");
  if (g_GL_ARB_sync) {
    g_glFenceSync = reinterpret_cast<glFenceSyncProc>(GetGLProcAddress("glFenceSync"));
    g_glDeleteSync = reinterpret_cast<glDeleteSyncProc>(GetGLProcAddress("glDeleteSync"));
    g_glGetSynciv = reinterpret_cast<glGetSyncivProc>(GetGLProcAddress("glGetSynciv"));
  }
  g_GL_ARB_robustness = context->HasExtension("GL_ARB_robustness");
  if (g_GL_ARB_robustness) {
    g_glGetGraphicsResetStatusARB = reinterpret_cast<glGetGraphicsResetStatusARBProc>(GetGLProcAddress("glGetGraphicsResetStatusARB"));
  }
  g_GL_ARB_timer_query = context->HasExtension("GL_ARB_timer_query");
  if (g_GL_ARB_timer_query) {
    g_glGetQueryObjecti64v = reinterpret_cast<glGetQueryObjecti64vProc>(GetGLProcAddress("glGetQueryObjecti64v"));
    g_glGetQueryObjectui64v = reinterpret_cast<glGetQueryObjectui64vProc>(GetGLProcAddress("glGetQueryObjectui64v"));
    g_glQueryCounter = reinterpret_cast<glQueryCounterProc>(GetGLProcAddress("glQueryCounter"));
  }
  g_GL_ARB_draw_instanced = context->HasExtension("GL_ARB_draw_instanced");
  if (g_GL_ARB_draw_instanced) {
    g_glDrawArraysInstancedANGLE = reinterpret_cast<glDrawArraysInstancedANGLEProc>(GetGLProcAddress("glDrawArraysInstancedARB"));
    g_glDrawElementsInstancedANGLE = reinterpret_cast<glDrawElementsInstancedANGLEProc>(GetGLProcAddress("glDrawElementsInstancedARB"));
  }
  g_GL_ARB_vertex_buffer_object = context->HasExtension("GL_ARB_vertex_buffer_object");
  if (g_GL_ARB_vertex_buffer_object) {
    g_glDeleteBuffersARB = reinterpret_cast<glDeleteBuffersARBProc>(GetGLProcAddress("glDeleteBuffersARB"));
    g_glGenBuffersARB = reinterpret_cast<glGenBuffersARBProc>(GetGLProcAddress("glGenBuffersARB"));
  }
  g_GL_ARB_framebuffer_object = context->HasExtension("GL_ARB_framebuffer_object");
  if (g_GL_ARB_framebuffer_object) {
    g_glBindFramebufferEXT = reinterpret_cast<glBindFramebufferEXTProc>(GetGLProcAddress("glBindFramebuffer"));
    g_glBindRenderbufferEXT = reinterpret_cast<glBindRenderbufferEXTProc>(GetGLProcAddress("glBindRenderbuffer"));
    g_glBlitFramebufferEXT = reinterpret_cast<glBlitFramebufferEXTProc>(GetGLProcAddress("glBlitFramebuffer"));
    g_glBlitFramebufferANGLE = reinterpret_cast<glBlitFramebufferANGLEProc>(GetGLProcAddress("glBlitFramebuffer"));
    g_glCheckFramebufferStatusEXT = reinterpret_cast<glCheckFramebufferStatusEXTProc>(GetGLProcAddress("glCheckFramebufferStatus"));
    g_glDeleteFramebuffersEXT = reinterpret_cast<glDeleteFramebuffersEXTProc>(GetGLProcAddress("glDeleteFramebuffers"));
    g_glDeleteRenderbuffersEXT = reinterpret_cast<glDeleteRenderbuffersEXTProc>(GetGLProcAddress("glDeleteRenderbuffers"));
    g_glFramebufferRenderbufferEXT = reinterpret_cast<glFramebufferRenderbufferEXTProc>(GetGLProcAddress("glFramebufferRenderbuffer"));
    g_glFramebufferTexture2DEXT = reinterpret_cast<glFramebufferTexture2DEXTProc>(GetGLProcAddress("glFramebufferTexture2D"));
    g_glGenerateMipmapEXT = reinterpret_cast<glGenerateMipmapEXTProc>(GetGLProcAddress("glGenerateMipmap"));
    g_glGenFramebuffersEXT = reinterpret_cast<glGenFramebuffersEXTProc>(GetGLProcAddress("glGenFramebuffers"));
    g_glGenRenderbuffersEXT = reinterpret_cast<glGenRenderbuffersEXTProc>(GetGLProcAddress("glGenRenderbuffers"));
    g_glGetFramebufferAttachmentParameterivEXT = reinterpret_cast<glGetFramebufferAttachmentParameterivEXTProc>(GetGLProcAddress("glGetFramebufferAttachmentParameteriv"));
    g_glGetRenderbufferParameterivEXT = reinterpret_cast<glGetRenderbufferParameterivEXTProc>(GetGLProcAddress("glGetRenderbufferParameteriv"));
    g_glIsFramebufferEXT = reinterpret_cast<glIsFramebufferEXTProc>(GetGLProcAddress("glIsFramebuffer"));
    g_glIsRenderbufferEXT = reinterpret_cast<glIsRenderbufferEXTProc>(GetGLProcAddress("glIsRenderbuffer"));
    g_glRenderbufferStorageMultisampleEXT = reinterpret_cast<glRenderbufferStorageMultisampleEXTProc>(GetGLProcAddress("glRenderbufferStorageMultisample"));
    g_glRenderbufferStorageMultisampleANGLE = reinterpret_cast<glRenderbufferStorageMultisampleANGLEProc>(GetGLProcAddress("glRenderbufferStorageMultisample"));
    g_glRenderbufferStorageEXT = reinterpret_cast<glRenderbufferStorageEXTProc>(GetGLProcAddress("glRenderbufferStorage"));
  }
  g_GL_ARB_occlusion_query = context->HasExtension("GL_ARB_occlusion_query");
  if (g_GL_ARB_occlusion_query) {
    g_glBeginQueryARB = reinterpret_cast<glBeginQueryARBProc>(GetGLProcAddress("glBeginQueryARB"));
    g_glDeleteQueriesARB = reinterpret_cast<glDeleteQueriesARBProc>(GetGLProcAddress("glDeleteQueriesARB"));
    g_glEndQueryARB = reinterpret_cast<glEndQueryARBProc>(GetGLProcAddress("glEndQueryARB"));
    g_glGenQueriesARB = reinterpret_cast<glGenQueriesARBProc>(GetGLProcAddress("glGenQueriesARB"));
    g_glGetQueryivARB = reinterpret_cast<glGetQueryivARBProc>(GetGLProcAddress("glGetQueryivARB"));
    g_glGetQueryObjectuivARB = reinterpret_cast<glGetQueryObjectuivARBProc>(GetGLProcAddress("glGetQueryObjectuivARB"));
    g_glIsQueryARB = reinterpret_cast<glIsQueryARBProc>(GetGLProcAddress("glIsQueryARB"));
  }
  g_GL_ARB_ES2_compatibility = context->HasExtension("GL_ARB_ES2_compatibility");
  if (g_GL_ARB_ES2_compatibility) {
    g_glClearDepthf = reinterpret_cast<glClearDepthfProc>(GetGLProcAddress("glClearDepthf"));
    g_glDepthRangef = reinterpret_cast<glDepthRangefProc>(GetGLProcAddress("glDepthRangef"));
    g_glGetShaderPrecisionFormat = reinterpret_cast<glGetShaderPrecisionFormatProc>(GetGLProcAddress("glGetShaderPrecisionFormat"));
    g_glReleaseShaderCompiler = reinterpret_cast<glReleaseShaderCompilerProc>(GetGLProcAddress("glReleaseShaderCompiler"));
    g_glShaderBinary = reinterpret_cast<glShaderBinaryProc>(GetGLProcAddress("glShaderBinary"));
  }
  g_GL_ARB_draw_buffers = context->HasExtension("GL_ARB_draw_buffers");
  if (g_GL_ARB_draw_buffers) {
    g_glDrawBuffersARB = reinterpret_cast<glDrawBuffersARBProc>(GetGLProcAddress("glDrawBuffersARB"));
  }
  if (g_debugBindingsInitialized)
    UpdateDebugGLExtensionBindings();
}

extern "C" {

static void GL_BINDING_CALL Debug_glActiveTexture(GLenum texture) {
  GL_SERVICE_LOG("glActiveTexture" << "("  << GLES2Util::GetStringEnum(texture) << ")");
  g_debug_glActiveTexture(texture);
}

static void GL_BINDING_CALL Debug_glAttachShader(GLuint program, GLuint shader) {
  GL_SERVICE_LOG("glAttachShader" << "("  << program << ", " << shader << ")");
  g_debug_glAttachShader(program, shader);
}

static void GL_BINDING_CALL Debug_glBeginQuery(GLenum target, GLuint id) {
  GL_SERVICE_LOG("glBeginQuery" << "("  << GLES2Util::GetStringEnum(target) << ", " << id << ")");
  g_debug_glBeginQuery(target, id);
}

static void GL_BINDING_CALL Debug_glBeginQueryARB(GLenum target, GLuint id) {
  GL_SERVICE_LOG("glBeginQueryARB" << "("  << GLES2Util::GetStringEnum(target) << ", " << id << ")");
  g_debug_glBeginQueryARB(target, id);
}

static void GL_BINDING_CALL Debug_glBindAttribLocation(GLuint program, GLuint index, const char* name) {
  GL_SERVICE_LOG("glBindAttribLocation" << "("  << program << ", " << index << ", " << name << ")");
  g_debug_glBindAttribLocation(program, index, name);
}

static void GL_BINDING_CALL Debug_glBindBuffer(GLenum target, GLuint buffer) {
  GL_SERVICE_LOG("glBindBuffer" << "("  << GLES2Util::GetStringEnum(target) << ", " << buffer << ")");
  g_debug_glBindBuffer(target, buffer);
}

static void GL_BINDING_CALL Debug_glBindFragDataLocation(GLuint program, GLuint colorNumber, const char* name) {
  GL_SERVICE_LOG("glBindFragDataLocation" << "("  << program << ", " << colorNumber << ", " << name << ")");
  g_debug_glBindFragDataLocation(program, colorNumber, name);
}

static void GL_BINDING_CALL Debug_glBindFragDataLocationIndexed(GLuint program, GLuint colorNumber, GLuint index, const char* name) {
  GL_SERVICE_LOG("glBindFragDataLocationIndexed" << "("  << program << ", " << colorNumber << ", " << index << ", " << name << ")");
  g_debug_glBindFragDataLocationIndexed(program, colorNumber, index, name);
}

static void GL_BINDING_CALL Debug_glBindFramebufferEXT(GLenum target, GLuint framebuffer) {
  GL_SERVICE_LOG("glBindFramebufferEXT" << "("  << GLES2Util::GetStringEnum(target) << ", " << framebuffer << ")");
  g_debug_glBindFramebufferEXT(target, framebuffer);
}

static void GL_BINDING_CALL Debug_glBindRenderbufferEXT(GLenum target, GLuint renderbuffer) {
  GL_SERVICE_LOG("glBindRenderbufferEXT" << "("  << GLES2Util::GetStringEnum(target) << ", " << renderbuffer << ")");
  g_debug_glBindRenderbufferEXT(target, renderbuffer);
}

static void GL_BINDING_CALL Debug_glBindTexture(GLenum target, GLuint texture) {
  GL_SERVICE_LOG("glBindTexture" << "("  << GLES2Util::GetStringEnum(target) << ", " << texture << ")");
  g_debug_glBindTexture(target, texture);
}

static void GL_BINDING_CALL Debug_glBlendColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha) {
  GL_SERVICE_LOG("glBlendColor" << "("  << red << ", " << green << ", " << blue << ", " << alpha << ")");
  g_debug_glBlendColor(red, green, blue, alpha);
}

static void GL_BINDING_CALL Debug_glBlendEquation( GLenum mode ) {
  GL_SERVICE_LOG("glBlendEquation" << "("  <<  GLES2Util::GetStringEnum(mode)  << ")");
  g_debug_glBlendEquation( mode );
}

static void GL_BINDING_CALL Debug_glBlendEquationSeparate(GLenum modeRGB, GLenum modeAlpha) {
  GL_SERVICE_LOG("glBlendEquationSeparate" << "("  << GLES2Util::GetStringEnum(modeRGB) << ", " << GLES2Util::GetStringEnum(modeAlpha) << ")");
  g_debug_glBlendEquationSeparate(modeRGB, modeAlpha);
}

static void GL_BINDING_CALL Debug_glBlendFunc(GLenum sfactor, GLenum dfactor) {
  GL_SERVICE_LOG("glBlendFunc" << "("  << GLES2Util::GetStringEnum(sfactor) << ", " << GLES2Util::GetStringEnum(dfactor) << ")");
  g_debug_glBlendFunc(sfactor, dfactor);
}

static void GL_BINDING_CALL Debug_glBlendFuncSeparate(GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha) {
  GL_SERVICE_LOG("glBlendFuncSeparate" << "("  << GLES2Util::GetStringEnum(srcRGB) << ", " << GLES2Util::GetStringEnum(dstRGB) << ", " << GLES2Util::GetStringEnum(srcAlpha) << ", " << GLES2Util::GetStringEnum(dstAlpha) << ")");
  g_debug_glBlendFuncSeparate(srcRGB, dstRGB, srcAlpha, dstAlpha);
}

static void GL_BINDING_CALL Debug_glBlitFramebufferEXT(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter) {
  GL_SERVICE_LOG("glBlitFramebufferEXT" << "("  << srcX0 << ", " << srcY0 << ", " << srcX1 << ", " << srcY1 << ", " << dstX0 << ", " << dstY0 << ", " << dstX1 << ", " << dstY1 << ", " << mask << ", " << GLES2Util::GetStringEnum(filter) << ")");
  g_debug_glBlitFramebufferEXT(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
}

static void GL_BINDING_CALL Debug_glBlitFramebufferANGLE(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter) {
  GL_SERVICE_LOG("glBlitFramebufferANGLE" << "("  << srcX0 << ", " << srcY0 << ", " << srcX1 << ", " << srcY1 << ", " << dstX0 << ", " << dstY0 << ", " << dstX1 << ", " << dstY1 << ", " << mask << ", " << GLES2Util::GetStringEnum(filter) << ")");
  g_debug_glBlitFramebufferANGLE(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
}

static void GL_BINDING_CALL Debug_glBufferData(GLenum target, GLsizei size, const void* data, GLenum usage) {
  GL_SERVICE_LOG("glBufferData" << "("  << GLES2Util::GetStringEnum(target) << ", " << size << ", " << static_cast<const void*>(data) << ", " << GLES2Util::GetStringEnum(usage) << ")");
  g_debug_glBufferData(target, size, data, usage);
}

static void GL_BINDING_CALL Debug_glBufferSubData(GLenum target, GLint offset, GLsizei size, const void* data) {
  GL_SERVICE_LOG("glBufferSubData" << "("  << GLES2Util::GetStringEnum(target) << ", " << offset << ", " << size << ", " << static_cast<const void*>(data) << ")");
  g_debug_glBufferSubData(target, offset, size, data);
}

static GLenum GL_BINDING_CALL Debug_glCheckFramebufferStatusEXT(GLenum target) {
  GL_SERVICE_LOG("glCheckFramebufferStatusEXT" << "("  << GLES2Util::GetStringEnum(target) << ")");
  GLenum result = g_debug_glCheckFramebufferStatusEXT(target);

  GL_SERVICE_LOG("GL_RESULT: " << GLES2Util::GetStringEnum(result));

  return result;
}

static void GL_BINDING_CALL Debug_glClear(GLbitfield mask) {
  GL_SERVICE_LOG("glClear" << "("  << mask << ")");
  g_debug_glClear(mask);
}

static void GL_BINDING_CALL Debug_glClearColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha) {
  GL_SERVICE_LOG("glClearColor" << "("  << red << ", " << green << ", " << blue << ", " << alpha << ")");
  g_debug_glClearColor(red, green, blue, alpha);
}

static void GL_BINDING_CALL Debug_glClearDepth(GLclampd depth) {
  GL_SERVICE_LOG("glClearDepth" << "("  << depth << ")");
  g_debug_glClearDepth(depth);
}

static void GL_BINDING_CALL Debug_glClearDepthf(GLclampf depth) {
  GL_SERVICE_LOG("glClearDepthf" << "("  << depth << ")");
  g_debug_glClearDepthf(depth);
}

static void GL_BINDING_CALL Debug_glClearStencil(GLint s) {
  GL_SERVICE_LOG("glClearStencil" << "("  << s << ")");
  g_debug_glClearStencil(s);
}

static void GL_BINDING_CALL Debug_glColorMask(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha) {
  GL_SERVICE_LOG("glColorMask" << "("  << GLES2Util::GetStringBool(red) << ", " << GLES2Util::GetStringBool(green) << ", " << GLES2Util::GetStringBool(blue) << ", " << GLES2Util::GetStringBool(alpha) << ")");
  g_debug_glColorMask(red, green, blue, alpha);
}

static void GL_BINDING_CALL Debug_glCompileShader(GLuint shader) {
  GL_SERVICE_LOG("glCompileShader" << "("  << shader << ")");
  g_debug_glCompileShader(shader);
}

static void GL_BINDING_CALL Debug_glCompressedTexImage2D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const void* data) {
  GL_SERVICE_LOG("glCompressedTexImage2D" << "("  << GLES2Util::GetStringEnum(target) << ", " << level << ", " << GLES2Util::GetStringEnum(internalformat) << ", " << width << ", " << height << ", " << border << ", " << imageSize << ", " << static_cast<const void*>(data) << ")");
  g_debug_glCompressedTexImage2D(target, level, internalformat, width, height, border, imageSize, data);
}

static void GL_BINDING_CALL Debug_glCompressedTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const void* data) {
  GL_SERVICE_LOG("glCompressedTexSubImage2D" << "("  << GLES2Util::GetStringEnum(target) << ", " << level << ", " << xoffset << ", " << yoffset << ", " << width << ", " << height << ", " << GLES2Util::GetStringEnum(format) << ", " << imageSize << ", " << static_cast<const void*>(data) << ")");
  g_debug_glCompressedTexSubImage2D(target, level, xoffset, yoffset, width, height, format, imageSize, data);
}

static void GL_BINDING_CALL Debug_glCopyTexImage2D(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border) {
  GL_SERVICE_LOG("glCopyTexImage2D" << "("  << GLES2Util::GetStringEnum(target) << ", " << level << ", " << GLES2Util::GetStringEnum(internalformat) << ", " << x << ", " << y << ", " << width << ", " << height << ", " << border << ")");
  g_debug_glCopyTexImage2D(target, level, internalformat, x, y, width, height, border);
}

static void GL_BINDING_CALL Debug_glCopyTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height) {
  GL_SERVICE_LOG("glCopyTexSubImage2D" << "("  << GLES2Util::GetStringEnum(target) << ", " << level << ", " << xoffset << ", " << yoffset << ", " << x << ", " << y << ", " << width << ", " << height << ")");
  g_debug_glCopyTexSubImage2D(target, level, xoffset, yoffset, x, y, width, height);
}

static GLuint GL_BINDING_CALL Debug_glCreateProgram(void) {
  GL_SERVICE_LOG("glCreateProgram" << "("  << ")");
  GLuint result = g_debug_glCreateProgram();
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static GLuint GL_BINDING_CALL Debug_glCreateShader(GLenum type) {
  GL_SERVICE_LOG("glCreateShader" << "("  << GLES2Util::GetStringEnum(type) << ")");
  GLuint result = g_debug_glCreateShader(type);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static void GL_BINDING_CALL Debug_glCullFace(GLenum mode) {
  GL_SERVICE_LOG("glCullFace" << "("  << GLES2Util::GetStringEnum(mode) << ")");
  g_debug_glCullFace(mode);
}

static void GL_BINDING_CALL Debug_glDeleteBuffersARB(GLsizei n, const GLuint* buffers) {
  GL_SERVICE_LOG("glDeleteBuffersARB" << "("  << n << ", " << static_cast<const void*>(buffers) << ")");
  g_debug_glDeleteBuffersARB(n, buffers);
}

static void GL_BINDING_CALL Debug_glDeleteFramebuffersEXT(GLsizei n, const GLuint* framebuffers) {
  GL_SERVICE_LOG("glDeleteFramebuffersEXT" << "("  << n << ", " << static_cast<const void*>(framebuffers) << ")");
  g_debug_glDeleteFramebuffersEXT(n, framebuffers);
}

static void GL_BINDING_CALL Debug_glDeleteProgram(GLuint program) {
  GL_SERVICE_LOG("glDeleteProgram" << "("  << program << ")");
  g_debug_glDeleteProgram(program);
}

static void GL_BINDING_CALL Debug_glDeleteQueries(GLsizei n, const GLuint* ids) {
  GL_SERVICE_LOG("glDeleteQueries" << "("  << n << ", " << static_cast<const void*>(ids) << ")");
  g_debug_glDeleteQueries(n, ids);
}

static void GL_BINDING_CALL Debug_glDeleteQueriesARB(GLsizei n, const GLuint* ids) {
  GL_SERVICE_LOG("glDeleteQueriesARB" << "("  << n << ", " << static_cast<const void*>(ids) << ")");
  g_debug_glDeleteQueriesARB(n, ids);
}

static void GL_BINDING_CALL Debug_glDeleteRenderbuffersEXT(GLsizei n, const GLuint* renderbuffers) {
  GL_SERVICE_LOG("glDeleteRenderbuffersEXT" << "("  << n << ", " << static_cast<const void*>(renderbuffers) << ")");
  g_debug_glDeleteRenderbuffersEXT(n, renderbuffers);
}

static void GL_BINDING_CALL Debug_glDeleteShader(GLuint shader) {
  GL_SERVICE_LOG("glDeleteShader" << "("  << shader << ")");
  g_debug_glDeleteShader(shader);
}

static void GL_BINDING_CALL Debug_glDeleteTextures(GLsizei n, const GLuint* textures) {
  GL_SERVICE_LOG("glDeleteTextures" << "("  << n << ", " << static_cast<const void*>(textures) << ")");
  g_debug_glDeleteTextures(n, textures);
}

static void GL_BINDING_CALL Debug_glDepthFunc(GLenum func) {
  GL_SERVICE_LOG("glDepthFunc" << "("  << GLES2Util::GetStringEnum(func) << ")");
  g_debug_glDepthFunc(func);
}

static void GL_BINDING_CALL Debug_glDepthMask(GLboolean flag) {
  GL_SERVICE_LOG("glDepthMask" << "("  << GLES2Util::GetStringBool(flag) << ")");
  g_debug_glDepthMask(flag);
}

static void GL_BINDING_CALL Debug_glDepthRange(GLclampd zNear, GLclampd zFar) {
  GL_SERVICE_LOG("glDepthRange" << "("  << zNear << ", " << zFar << ")");
  g_debug_glDepthRange(zNear, zFar);
}

static void GL_BINDING_CALL Debug_glDepthRangef(GLclampf zNear, GLclampf zFar) {
  GL_SERVICE_LOG("glDepthRangef" << "("  << zNear << ", " << zFar << ")");
  g_debug_glDepthRangef(zNear, zFar);
}

static void GL_BINDING_CALL Debug_glDetachShader(GLuint program, GLuint shader) {
  GL_SERVICE_LOG("glDetachShader" << "("  << program << ", " << shader << ")");
  g_debug_glDetachShader(program, shader);
}

static void GL_BINDING_CALL Debug_glDisable(GLenum cap) {
  GL_SERVICE_LOG("glDisable" << "("  << GLES2Util::GetStringEnum(cap) << ")");
  g_debug_glDisable(cap);
}

static void GL_BINDING_CALL Debug_glDisableVertexAttribArray(GLuint index) {
  GL_SERVICE_LOG("glDisableVertexAttribArray" << "("  << index << ")");
  g_debug_glDisableVertexAttribArray(index);
}

static void GL_BINDING_CALL Debug_glDrawArrays(GLenum mode, GLint first, GLsizei count) {
  GL_SERVICE_LOG("glDrawArrays" << "("  << GLES2Util::GetStringEnum(mode) << ", " << first << ", " << count << ")");
  g_debug_glDrawArrays(mode, first, count);
}

static void GL_BINDING_CALL Debug_glDrawBuffer(GLenum mode) {
  GL_SERVICE_LOG("glDrawBuffer" << "("  << GLES2Util::GetStringEnum(mode) << ")");
  g_debug_glDrawBuffer(mode);
}

static void GL_BINDING_CALL Debug_glDrawBuffersARB(GLsizei n, const GLenum* bufs) {
  GL_SERVICE_LOG("glDrawBuffersARB" << "("  << n << ", " << static_cast<const void*>(bufs) << ")");
  g_debug_glDrawBuffersARB(n, bufs);
}

static void GL_BINDING_CALL Debug_glDrawElements(GLenum mode, GLsizei count, GLenum type, const void* indices) {
  GL_SERVICE_LOG("glDrawElements" << "("  << GLES2Util::GetStringEnum(mode) << ", " << count << ", " << GLES2Util::GetStringEnum(type) << ", " << static_cast<const void*>(indices) << ")");
  g_debug_glDrawElements(mode, count, type, indices);
}

static void GL_BINDING_CALL Debug_glEGLImageTargetTexture2DOES(GLenum target, GLeglImageOES image) {
  GL_SERVICE_LOG("glEGLImageTargetTexture2DOES" << "("  << GLES2Util::GetStringEnum(target) << ", " << image << ")");
  g_debug_glEGLImageTargetTexture2DOES(target, image);
}

static void GL_BINDING_CALL Debug_glEGLImageTargetRenderbufferStorageOES(GLenum target, GLeglImageOES image) {
  GL_SERVICE_LOG("glEGLImageTargetRenderbufferStorageOES" << "("  << GLES2Util::GetStringEnum(target) << ", " << image << ")");
  g_debug_glEGLImageTargetRenderbufferStorageOES(target, image);
}

static void GL_BINDING_CALL Debug_glEnable(GLenum cap) {
  GL_SERVICE_LOG("glEnable" << "("  << GLES2Util::GetStringEnum(cap) << ")");
  g_debug_glEnable(cap);
}

static void GL_BINDING_CALL Debug_glEnableVertexAttribArray(GLuint index) {
  GL_SERVICE_LOG("glEnableVertexAttribArray" << "("  << index << ")");
  g_debug_glEnableVertexAttribArray(index);
}

static void GL_BINDING_CALL Debug_glEndQuery(GLenum target) {
  GL_SERVICE_LOG("glEndQuery" << "("  << GLES2Util::GetStringEnum(target) << ")");
  g_debug_glEndQuery(target);
}

static void GL_BINDING_CALL Debug_glEndQueryARB(GLenum target) {
  GL_SERVICE_LOG("glEndQueryARB" << "("  << GLES2Util::GetStringEnum(target) << ")");
  g_debug_glEndQueryARB(target);
}

static void GL_BINDING_CALL Debug_glFinish(void) {
  GL_SERVICE_LOG("glFinish" << "("  << ")");
  g_debug_glFinish();
}

static void GL_BINDING_CALL Debug_glFlush(void) {
  GL_SERVICE_LOG("glFlush" << "("  << ")");
  g_debug_glFlush();
}

static void GL_BINDING_CALL Debug_glFramebufferRenderbufferEXT(GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer) {
  GL_SERVICE_LOG("glFramebufferRenderbufferEXT" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(attachment) << ", " << GLES2Util::GetStringEnum(renderbuffertarget) << ", " << renderbuffer << ")");
  g_debug_glFramebufferRenderbufferEXT(target, attachment, renderbuffertarget, renderbuffer);
}

static void GL_BINDING_CALL Debug_glFramebufferTexture2DEXT(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level) {
  GL_SERVICE_LOG("glFramebufferTexture2DEXT" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(attachment) << ", " << GLES2Util::GetStringEnum(textarget) << ", " << texture << ", " << level << ")");
  g_debug_glFramebufferTexture2DEXT(target, attachment, textarget, texture, level);
}

static void GL_BINDING_CALL Debug_glFrontFace(GLenum mode) {
  GL_SERVICE_LOG("glFrontFace" << "("  << GLES2Util::GetStringEnum(mode) << ")");
  g_debug_glFrontFace(mode);
}

static void GL_BINDING_CALL Debug_glGenBuffersARB(GLsizei n, GLuint* buffers) {
  GL_SERVICE_LOG("glGenBuffersARB" << "("  << n << ", " << static_cast<const void*>(buffers) << ")");
  g_debug_glGenBuffersARB(n, buffers);
}

static void GL_BINDING_CALL Debug_glGenQueries(GLsizei n, GLuint* ids) {
  GL_SERVICE_LOG("glGenQueries" << "("  << n << ", " << static_cast<const void*>(ids) << ")");
  g_debug_glGenQueries(n, ids);
}

static void GL_BINDING_CALL Debug_glGenQueriesARB(GLsizei n, GLuint* ids) {
  GL_SERVICE_LOG("glGenQueriesARB" << "("  << n << ", " << static_cast<const void*>(ids) << ")");
  g_debug_glGenQueriesARB(n, ids);
}

static void GL_BINDING_CALL Debug_glGenerateMipmapEXT(GLenum target) {
  GL_SERVICE_LOG("glGenerateMipmapEXT" << "("  << GLES2Util::GetStringEnum(target) << ")");
  g_debug_glGenerateMipmapEXT(target);
}

static void GL_BINDING_CALL Debug_glGenFramebuffersEXT(GLsizei n, GLuint* framebuffers) {
  GL_SERVICE_LOG("glGenFramebuffersEXT" << "("  << n << ", " << static_cast<const void*>(framebuffers) << ")");
  g_debug_glGenFramebuffersEXT(n, framebuffers);
}

static void GL_BINDING_CALL Debug_glGenRenderbuffersEXT(GLsizei n, GLuint* renderbuffers) {
  GL_SERVICE_LOG("glGenRenderbuffersEXT" << "("  << n << ", " << static_cast<const void*>(renderbuffers) << ")");
  g_debug_glGenRenderbuffersEXT(n, renderbuffers);
}

static void GL_BINDING_CALL Debug_glGenTextures(GLsizei n, GLuint* textures) {
  GL_SERVICE_LOG("glGenTextures" << "("  << n << ", " << static_cast<const void*>(textures) << ")");
  g_debug_glGenTextures(n, textures);
}

static void GL_BINDING_CALL Debug_glGetActiveAttrib(GLuint program, GLuint index, GLsizei bufsize, GLsizei* length, GLint* size, GLenum* type, char* name) {
  GL_SERVICE_LOG("glGetActiveAttrib" << "("  << program << ", " << index << ", " << bufsize << ", " << static_cast<const void*>(length) << ", " << static_cast<const void*>(size) << ", " << static_cast<const void*>(type) << ", " << static_cast<const void*>(name) << ")");
  g_debug_glGetActiveAttrib(program, index, bufsize, length, size, type, name);
}

static void GL_BINDING_CALL Debug_glGetActiveUniform(GLuint program, GLuint index, GLsizei bufsize, GLsizei* length, GLint* size, GLenum* type, char* name) {
  GL_SERVICE_LOG("glGetActiveUniform" << "("  << program << ", " << index << ", " << bufsize << ", " << static_cast<const void*>(length) << ", " << static_cast<const void*>(size) << ", " << static_cast<const void*>(type) << ", " << static_cast<const void*>(name) << ")");
  g_debug_glGetActiveUniform(program, index, bufsize, length, size, type, name);
}

static void GL_BINDING_CALL Debug_glGetAttachedShaders(GLuint program, GLsizei maxcount, GLsizei* count, GLuint* shaders) {
  GL_SERVICE_LOG("glGetAttachedShaders" << "("  << program << ", " << maxcount << ", " << static_cast<const void*>(count) << ", " << static_cast<const void*>(shaders) << ")");
  g_debug_glGetAttachedShaders(program, maxcount, count, shaders);
}

static GLint GL_BINDING_CALL Debug_glGetAttribLocation(GLuint program, const char* name) {
  GL_SERVICE_LOG("glGetAttribLocation" << "("  << program << ", " << name << ")");
  GLint result = g_debug_glGetAttribLocation(program, name);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static void GL_BINDING_CALL Debug_glGetBooleanv(GLenum pname, GLboolean* params) {
  GL_SERVICE_LOG("glGetBooleanv" << "("  << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetBooleanv(pname, params);
}

static void GL_BINDING_CALL Debug_glGetBufferParameteriv(GLenum target, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetBufferParameteriv" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetBufferParameteriv(target, pname, params);
}

static GLenum GL_BINDING_CALL Debug_glGetError(void) {
  GL_SERVICE_LOG("glGetError" << "("  << ")");
  GLenum result = g_debug_glGetError();

  GL_SERVICE_LOG("GL_RESULT: " << GLES2Util::GetStringError(result));

  return result;
}

static void GL_BINDING_CALL Debug_glGetFloatv(GLenum pname, GLfloat* params) {
  GL_SERVICE_LOG("glGetFloatv" << "("  << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetFloatv(pname, params);
}

static void GL_BINDING_CALL Debug_glGetFramebufferAttachmentParameterivEXT(GLenum target, GLenum attachment, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetFramebufferAttachmentParameterivEXT" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(attachment) << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetFramebufferAttachmentParameterivEXT(target, attachment, pname, params);
}

static GLenum GL_BINDING_CALL Debug_glGetGraphicsResetStatusARB(void) {
  GL_SERVICE_LOG("glGetGraphicsResetStatusARB" << "("  << ")");
  GLenum result = g_debug_glGetGraphicsResetStatusARB();
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static void GL_BINDING_CALL Debug_glGetIntegerv(GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetIntegerv" << "("  << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetIntegerv(pname, params);
}

static void GL_BINDING_CALL Debug_glGetProgramiv(GLuint program, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetProgramiv" << "("  << program << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetProgramiv(program, pname, params);
}

static void GL_BINDING_CALL Debug_glGetProgramInfoLog(GLuint program, GLsizei bufsize, GLsizei* length, char* infolog) {
  GL_SERVICE_LOG("glGetProgramInfoLog" << "("  << program << ", " << bufsize << ", " << static_cast<const void*>(length) << ", " << static_cast<const void*>(infolog) << ")");
  g_debug_glGetProgramInfoLog(program, bufsize, length, infolog);
}

static void GL_BINDING_CALL Debug_glGetQueryiv(GLenum target, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetQueryiv" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetQueryiv(target, pname, params);
}

static void GL_BINDING_CALL Debug_glGetQueryivARB(GLenum target, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetQueryivARB" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetQueryivARB(target, pname, params);
}

static void GL_BINDING_CALL Debug_glGetQueryObjecti64v(GLuint id, GLenum pname, GLint64* params) {
  GL_SERVICE_LOG("glGetQueryObjecti64v" << "("  << id << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetQueryObjecti64v(id, pname, params);
}

static void GL_BINDING_CALL Debug_glGetQueryObjectiv(GLuint id, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetQueryObjectiv" << "("  << id << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetQueryObjectiv(id, pname, params);
}

static void GL_BINDING_CALL Debug_glGetQueryObjectui64v(GLuint id, GLenum pname, GLuint64* params) {
  GL_SERVICE_LOG("glGetQueryObjectui64v" << "("  << id << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetQueryObjectui64v(id, pname, params);
}

static void GL_BINDING_CALL Debug_glGetQueryObjectuiv(GLuint id, GLenum pname, GLuint* params) {
  GL_SERVICE_LOG("glGetQueryObjectuiv" << "("  << id << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetQueryObjectuiv(id, pname, params);
}

static void GL_BINDING_CALL Debug_glGetQueryObjectuivARB(GLuint id, GLenum pname, GLuint* params) {
  GL_SERVICE_LOG("glGetQueryObjectuivARB" << "("  << id << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetQueryObjectuivARB(id, pname, params);
}

static void GL_BINDING_CALL Debug_glGetRenderbufferParameterivEXT(GLenum target, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetRenderbufferParameterivEXT" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetRenderbufferParameterivEXT(target, pname, params);
}

static void GL_BINDING_CALL Debug_glGetShaderiv(GLuint shader, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetShaderiv" << "("  << shader << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetShaderiv(shader, pname, params);
}

static void GL_BINDING_CALL Debug_glGetShaderInfoLog(GLuint shader, GLsizei bufsize, GLsizei* length, char* infolog) {
  GL_SERVICE_LOG("glGetShaderInfoLog" << "("  << shader << ", " << bufsize << ", " << static_cast<const void*>(length) << ", " << static_cast<const void*>(infolog) << ")");
  g_debug_glGetShaderInfoLog(shader, bufsize, length, infolog);
}

static void GL_BINDING_CALL Debug_glGetShaderPrecisionFormat(GLenum shadertype, GLenum precisiontype, GLint* range, GLint* precision) {
  GL_SERVICE_LOG("glGetShaderPrecisionFormat" << "("  << GLES2Util::GetStringEnum(shadertype) << ", " << GLES2Util::GetStringEnum(precisiontype) << ", " << static_cast<const void*>(range) << ", " << static_cast<const void*>(precision) << ")");
  g_debug_glGetShaderPrecisionFormat(shadertype, precisiontype, range, precision);
}

static void GL_BINDING_CALL Debug_glGetShaderSource(GLuint shader, GLsizei bufsize, GLsizei* length, char* source) {
  GL_SERVICE_LOG("glGetShaderSource" << "("  << shader << ", " << bufsize << ", " << static_cast<const void*>(length) << ", " << static_cast<const void*>(source) << ")");
  g_debug_glGetShaderSource(shader, bufsize, length, source);
}

static const GLubyte* GL_BINDING_CALL Debug_glGetString(GLenum name) {
  GL_SERVICE_LOG("glGetString" << "("  << GLES2Util::GetStringEnum(name) << ")");
  const GLubyte* result = g_debug_glGetString(name);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static void GL_BINDING_CALL Debug_glGetTexLevelParameterfv(GLenum target, GLint level, GLenum pname, GLfloat* params) {
  GL_SERVICE_LOG("glGetTexLevelParameterfv" << "("  << GLES2Util::GetStringEnum(target) << ", " << level << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetTexLevelParameterfv(target, level, pname, params);
}

static void GL_BINDING_CALL Debug_glGetTexLevelParameteriv(GLenum target, GLint level, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetTexLevelParameteriv" << "("  << GLES2Util::GetStringEnum(target) << ", " << level << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetTexLevelParameteriv(target, level, pname, params);
}

static void GL_BINDING_CALL Debug_glGetTexParameterfv(GLenum target, GLenum pname, GLfloat* params) {
  GL_SERVICE_LOG("glGetTexParameterfv" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetTexParameterfv(target, pname, params);
}

static void GL_BINDING_CALL Debug_glGetTexParameteriv(GLenum target, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetTexParameteriv" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetTexParameteriv(target, pname, params);
}

static void GL_BINDING_CALL Debug_glGetTranslatedShaderSourceANGLE(GLuint shader, GLsizei bufsize, GLsizei* length, char* source) {
  GL_SERVICE_LOG("glGetTranslatedShaderSourceANGLE" << "("  << shader << ", " << bufsize << ", " << static_cast<const void*>(length) << ", " << static_cast<const void*>(source) << ")");
  g_debug_glGetTranslatedShaderSourceANGLE(shader, bufsize, length, source);
}

static void GL_BINDING_CALL Debug_glGetUniformfv(GLuint program, GLint location, GLfloat* params) {
  GL_SERVICE_LOG("glGetUniformfv" << "("  << program << ", " << location << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetUniformfv(program, location, params);
}

static void GL_BINDING_CALL Debug_glGetUniformiv(GLuint program, GLint location, GLint* params) {
  GL_SERVICE_LOG("glGetUniformiv" << "("  << program << ", " << location << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetUniformiv(program, location, params);
}

static GLint GL_BINDING_CALL Debug_glGetUniformLocation(GLuint program, const char* name) {
  GL_SERVICE_LOG("glGetUniformLocation" << "("  << program << ", " << name << ")");
  GLint result = g_debug_glGetUniformLocation(program, name);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static void GL_BINDING_CALL Debug_glGetVertexAttribfv(GLuint index, GLenum pname, GLfloat* params) {
  GL_SERVICE_LOG("glGetVertexAttribfv" << "("  << index << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetVertexAttribfv(index, pname, params);
}

static void GL_BINDING_CALL Debug_glGetVertexAttribiv(GLuint index, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetVertexAttribiv" << "("  << index << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetVertexAttribiv(index, pname, params);
}

static void GL_BINDING_CALL Debug_glGetVertexAttribPointerv(GLuint index, GLenum pname, void** pointer) {
  GL_SERVICE_LOG("glGetVertexAttribPointerv" << "("  << index << ", " << GLES2Util::GetStringEnum(pname) << ", " << pointer << ")");
  g_debug_glGetVertexAttribPointerv(index, pname, pointer);
}

static void GL_BINDING_CALL Debug_glHint(GLenum target, GLenum mode) {
  GL_SERVICE_LOG("glHint" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(mode) << ")");
  g_debug_glHint(target, mode);
}

static GLboolean GL_BINDING_CALL Debug_glIsBuffer(GLuint buffer) {
  GL_SERVICE_LOG("glIsBuffer" << "("  << buffer << ")");
  GLboolean result = g_debug_glIsBuffer(buffer);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static GLboolean GL_BINDING_CALL Debug_glIsEnabled(GLenum cap) {
  GL_SERVICE_LOG("glIsEnabled" << "("  << GLES2Util::GetStringEnum(cap) << ")");
  GLboolean result = g_debug_glIsEnabled(cap);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static GLboolean GL_BINDING_CALL Debug_glIsFramebufferEXT(GLuint framebuffer) {
  GL_SERVICE_LOG("glIsFramebufferEXT" << "("  << framebuffer << ")");
  GLboolean result = g_debug_glIsFramebufferEXT(framebuffer);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static GLboolean GL_BINDING_CALL Debug_glIsProgram(GLuint program) {
  GL_SERVICE_LOG("glIsProgram" << "("  << program << ")");
  GLboolean result = g_debug_glIsProgram(program);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static GLboolean GL_BINDING_CALL Debug_glIsQueryARB(GLuint query) {
  GL_SERVICE_LOG("glIsQueryARB" << "("  << query << ")");
  GLboolean result = g_debug_glIsQueryARB(query);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static GLboolean GL_BINDING_CALL Debug_glIsRenderbufferEXT(GLuint renderbuffer) {
  GL_SERVICE_LOG("glIsRenderbufferEXT" << "("  << renderbuffer << ")");
  GLboolean result = g_debug_glIsRenderbufferEXT(renderbuffer);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static GLboolean GL_BINDING_CALL Debug_glIsShader(GLuint shader) {
  GL_SERVICE_LOG("glIsShader" << "("  << shader << ")");
  GLboolean result = g_debug_glIsShader(shader);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static GLboolean GL_BINDING_CALL Debug_glIsTexture(GLuint texture) {
  GL_SERVICE_LOG("glIsTexture" << "("  << texture << ")");
  GLboolean result = g_debug_glIsTexture(texture);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static void GL_BINDING_CALL Debug_glLineWidth(GLfloat width) {
  GL_SERVICE_LOG("glLineWidth" << "("  << width << ")");
  g_debug_glLineWidth(width);
}

static void GL_BINDING_CALL Debug_glLinkProgram(GLuint program) {
  GL_SERVICE_LOG("glLinkProgram" << "("  << program << ")");
  g_debug_glLinkProgram(program);
}

static void* GL_BINDING_CALL Debug_glMapBuffer(GLenum target, GLenum access) {
  GL_SERVICE_LOG("glMapBuffer" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(access) << ")");
  void* result = g_debug_glMapBuffer(target, access);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static void GL_BINDING_CALL Debug_glPixelStorei(GLenum pname, GLint param) {
  GL_SERVICE_LOG("glPixelStorei" << "("  << GLES2Util::GetStringEnum(pname) << ", " << param << ")");
  g_debug_glPixelStorei(pname, param);
}

static void GL_BINDING_CALL Debug_glPointParameteri(GLenum pname, GLint param) {
  GL_SERVICE_LOG("glPointParameteri" << "("  << GLES2Util::GetStringEnum(pname) << ", " << param << ")");
  g_debug_glPointParameteri(pname, param);
}

static void GL_BINDING_CALL Debug_glPolygonOffset(GLfloat factor, GLfloat units) {
  GL_SERVICE_LOG("glPolygonOffset" << "("  << factor << ", " << units << ")");
  g_debug_glPolygonOffset(factor, units);
}

static void GL_BINDING_CALL Debug_glQueryCounter(GLuint id, GLenum target) {
  GL_SERVICE_LOG("glQueryCounter" << "("  << id << ", " << GLES2Util::GetStringEnum(target) << ")");
  g_debug_glQueryCounter(id, target);
}

static void GL_BINDING_CALL Debug_glReadBuffer(GLenum src) {
  GL_SERVICE_LOG("glReadBuffer" << "("  << GLES2Util::GetStringEnum(src) << ")");
  g_debug_glReadBuffer(src);
}

static void GL_BINDING_CALL Debug_glReadPixels(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, void* pixels) {
  GL_SERVICE_LOG("glReadPixels" << "("  << x << ", " << y << ", " << width << ", " << height << ", " << GLES2Util::GetStringEnum(format) << ", " << GLES2Util::GetStringEnum(type) << ", " << static_cast<const void*>(pixels) << ")");
  g_debug_glReadPixels(x, y, width, height, format, type, pixels);
}

static void GL_BINDING_CALL Debug_glReleaseShaderCompiler(void) {
  GL_SERVICE_LOG("glReleaseShaderCompiler" << "("  << ")");
  g_debug_glReleaseShaderCompiler();
}

static void GL_BINDING_CALL Debug_glRenderbufferStorageMultisampleEXT(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height) {
  GL_SERVICE_LOG("glRenderbufferStorageMultisampleEXT" << "("  << GLES2Util::GetStringEnum(target) << ", " << samples << ", " << GLES2Util::GetStringEnum(internalformat) << ", " << width << ", " << height << ")");
  g_debug_glRenderbufferStorageMultisampleEXT(target, samples, internalformat, width, height);
}

static void GL_BINDING_CALL Debug_glRenderbufferStorageMultisampleANGLE(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height) {
  GL_SERVICE_LOG("glRenderbufferStorageMultisampleANGLE" << "("  << GLES2Util::GetStringEnum(target) << ", " << samples << ", " << GLES2Util::GetStringEnum(internalformat) << ", " << width << ", " << height << ")");
  g_debug_glRenderbufferStorageMultisampleANGLE(target, samples, internalformat, width, height);
}

static void GL_BINDING_CALL Debug_glRenderbufferStorageEXT(GLenum target, GLenum internalformat, GLsizei width, GLsizei height) {
  GL_SERVICE_LOG("glRenderbufferStorageEXT" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(internalformat) << ", " << width << ", " << height << ")");
  g_debug_glRenderbufferStorageEXT(target, internalformat, width, height);
}

static void GL_BINDING_CALL Debug_glSampleCoverage(GLclampf value, GLboolean invert) {
  GL_SERVICE_LOG("glSampleCoverage" << "("  << value << ", " << GLES2Util::GetStringBool(invert) << ")");
  g_debug_glSampleCoverage(value, invert);
}

static void GL_BINDING_CALL Debug_glScissor(GLint x, GLint y, GLsizei width, GLsizei height) {
  GL_SERVICE_LOG("glScissor" << "("  << x << ", " << y << ", " << width << ", " << height << ")");
  g_debug_glScissor(x, y, width, height);
}

static void GL_BINDING_CALL Debug_glShaderBinary(GLsizei n, const GLuint* shaders, GLenum binaryformat, const void* binary, GLsizei length) {
  GL_SERVICE_LOG("glShaderBinary" << "("  << n << ", " << static_cast<const void*>(shaders) << ", " << GLES2Util::GetStringEnum(binaryformat) << ", " << static_cast<const void*>(binary) << ", " << length << ")");
  g_debug_glShaderBinary(n, shaders, binaryformat, binary, length);
}

static void GL_BINDING_CALL Debug_glShaderSource(GLuint shader, GLsizei count, const char** str, const GLint* length) {
  GL_SERVICE_LOG("glShaderSource" << "("  << shader << ", " << count << ", " << str << ", " << static_cast<const void*>(length) << ")");
  g_debug_glShaderSource(shader, count, str, length);

  GL_SERVICE_LOG_CODE_BLOCK({
    for (GLsizei ii = 0; ii < count; ++ii) {
      if (str[ii]) {
        if (length && length[ii] >= 0) {
          std::string source(str[ii], length[ii]);
          GL_SERVICE_LOG("  " << ii << ": ---\n" << source << "\n---");
        } else {
          GL_SERVICE_LOG("  " << ii << ": ---\n" << str[ii] << "\n---");
        }
      } else {
        GL_SERVICE_LOG("  " << ii << ": NULL");
      }
    }
  });

}

static void GL_BINDING_CALL Debug_glStencilFunc(GLenum func, GLint ref, GLuint mask) {
  GL_SERVICE_LOG("glStencilFunc" << "("  << GLES2Util::GetStringEnum(func) << ", " << ref << ", " << mask << ")");
  g_debug_glStencilFunc(func, ref, mask);
}

static void GL_BINDING_CALL Debug_glStencilFuncSeparate(GLenum face, GLenum func, GLint ref, GLuint mask) {
  GL_SERVICE_LOG("glStencilFuncSeparate" << "("  << GLES2Util::GetStringEnum(face) << ", " << GLES2Util::GetStringEnum(func) << ", " << ref << ", " << mask << ")");
  g_debug_glStencilFuncSeparate(face, func, ref, mask);
}

static void GL_BINDING_CALL Debug_glStencilMask(GLuint mask) {
  GL_SERVICE_LOG("glStencilMask" << "("  << mask << ")");
  g_debug_glStencilMask(mask);
}

static void GL_BINDING_CALL Debug_glStencilMaskSeparate(GLenum face, GLuint mask) {
  GL_SERVICE_LOG("glStencilMaskSeparate" << "("  << GLES2Util::GetStringEnum(face) << ", " << mask << ")");
  g_debug_glStencilMaskSeparate(face, mask);
}

static void GL_BINDING_CALL Debug_glStencilOp(GLenum fail, GLenum zfail, GLenum zpass) {
  GL_SERVICE_LOG("glStencilOp" << "("  << GLES2Util::GetStringEnum(fail) << ", " << GLES2Util::GetStringEnum(zfail) << ", " << GLES2Util::GetStringEnum(zpass) << ")");
  g_debug_glStencilOp(fail, zfail, zpass);
}

static void GL_BINDING_CALL Debug_glStencilOpSeparate(GLenum face, GLenum fail, GLenum zfail, GLenum zpass) {
  GL_SERVICE_LOG("glStencilOpSeparate" << "("  << GLES2Util::GetStringEnum(face) << ", " << GLES2Util::GetStringEnum(fail) << ", " << GLES2Util::GetStringEnum(zfail) << ", " << GLES2Util::GetStringEnum(zpass) << ")");
  g_debug_glStencilOpSeparate(face, fail, zfail, zpass);
}

static void GL_BINDING_CALL Debug_glTexImage2D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const void* pixels) {
  GL_SERVICE_LOG("glTexImage2D" << "("  << GLES2Util::GetStringEnum(target) << ", " << level << ", " << internalformat << ", " << width << ", " << height << ", " << border << ", " << GLES2Util::GetStringEnum(format) << ", " << GLES2Util::GetStringEnum(type) << ", " << static_cast<const void*>(pixels) << ")");
  g_debug_glTexImage2D(target, level, internalformat, width, height, border, format, type, pixels);
}

static void GL_BINDING_CALL Debug_glTexParameterf(GLenum target, GLenum pname, GLfloat param) {
  GL_SERVICE_LOG("glTexParameterf" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(pname) << ", " << param << ")");
  g_debug_glTexParameterf(target, pname, param);
}

static void GL_BINDING_CALL Debug_glTexParameterfv(GLenum target, GLenum pname, const GLfloat* params) {
  GL_SERVICE_LOG("glTexParameterfv" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glTexParameterfv(target, pname, params);
}

static void GL_BINDING_CALL Debug_glTexParameteri(GLenum target, GLenum pname, GLint param) {
  GL_SERVICE_LOG("glTexParameteri" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(pname) << ", " << param << ")");
  g_debug_glTexParameteri(target, pname, param);
}

static void GL_BINDING_CALL Debug_glTexParameteriv(GLenum target, GLenum pname, const GLint* params) {
  GL_SERVICE_LOG("glTexParameteriv" << "("  << GLES2Util::GetStringEnum(target) << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glTexParameteriv(target, pname, params);
}

static void GL_BINDING_CALL Debug_glTexStorage2DEXT(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height) {
  GL_SERVICE_LOG("glTexStorage2DEXT" << "("  << GLES2Util::GetStringEnum(target) << ", " << levels << ", " << GLES2Util::GetStringEnum(internalformat) << ", " << width << ", " << height << ")");
  g_debug_glTexStorage2DEXT(target, levels, internalformat, width, height);
}

static void GL_BINDING_CALL Debug_glTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const void* pixels) {
  GL_SERVICE_LOG("glTexSubImage2D" << "("  << GLES2Util::GetStringEnum(target) << ", " << level << ", " << xoffset << ", " << yoffset << ", " << width << ", " << height << ", " << GLES2Util::GetStringEnum(format) << ", " << GLES2Util::GetStringEnum(type) << ", " << static_cast<const void*>(pixels) << ")");
  g_debug_glTexSubImage2D(target, level, xoffset, yoffset, width, height, format, type, pixels);
}

static void GL_BINDING_CALL Debug_glUniform1f(GLint location, GLfloat x) {
  GL_SERVICE_LOG("glUniform1f" << "("  << location << ", " << x << ")");
  g_debug_glUniform1f(location, x);
}

static void GL_BINDING_CALL Debug_glUniform1fv(GLint location, GLsizei count, const GLfloat* v) {
  GL_SERVICE_LOG("glUniform1fv" << "("  << location << ", " << count << ", " << static_cast<const void*>(v) << ")");
  g_debug_glUniform1fv(location, count, v);
}

static void GL_BINDING_CALL Debug_glUniform1i(GLint location, GLint x) {
  GL_SERVICE_LOG("glUniform1i" << "("  << location << ", " << x << ")");
  g_debug_glUniform1i(location, x);
}

static void GL_BINDING_CALL Debug_glUniform1iv(GLint location, GLsizei count, const GLint* v) {
  GL_SERVICE_LOG("glUniform1iv" << "("  << location << ", " << count << ", " << static_cast<const void*>(v) << ")");
  g_debug_glUniform1iv(location, count, v);
}

static void GL_BINDING_CALL Debug_glUniform2f(GLint location, GLfloat x, GLfloat y) {
  GL_SERVICE_LOG("glUniform2f" << "("  << location << ", " << x << ", " << y << ")");
  g_debug_glUniform2f(location, x, y);
}

static void GL_BINDING_CALL Debug_glUniform2fv(GLint location, GLsizei count, const GLfloat* v) {
  GL_SERVICE_LOG("glUniform2fv" << "("  << location << ", " << count << ", " << static_cast<const void*>(v) << ")");
  g_debug_glUniform2fv(location, count, v);
}

static void GL_BINDING_CALL Debug_glUniform2i(GLint location, GLint x, GLint y) {
  GL_SERVICE_LOG("glUniform2i" << "("  << location << ", " << x << ", " << y << ")");
  g_debug_glUniform2i(location, x, y);
}

static void GL_BINDING_CALL Debug_glUniform2iv(GLint location, GLsizei count, const GLint* v) {
  GL_SERVICE_LOG("glUniform2iv" << "("  << location << ", " << count << ", " << static_cast<const void*>(v) << ")");
  g_debug_glUniform2iv(location, count, v);
}

static void GL_BINDING_CALL Debug_glUniform3f(GLint location, GLfloat x, GLfloat y, GLfloat z) {
  GL_SERVICE_LOG("glUniform3f" << "("  << location << ", " << x << ", " << y << ", " << z << ")");
  g_debug_glUniform3f(location, x, y, z);
}

static void GL_BINDING_CALL Debug_glUniform3fv(GLint location, GLsizei count, const GLfloat* v) {
  GL_SERVICE_LOG("glUniform3fv" << "("  << location << ", " << count << ", " << static_cast<const void*>(v) << ")");
  g_debug_glUniform3fv(location, count, v);
}

static void GL_BINDING_CALL Debug_glUniform3i(GLint location, GLint x, GLint y, GLint z) {
  GL_SERVICE_LOG("glUniform3i" << "("  << location << ", " << x << ", " << y << ", " << z << ")");
  g_debug_glUniform3i(location, x, y, z);
}

static void GL_BINDING_CALL Debug_glUniform3iv(GLint location, GLsizei count, const GLint* v) {
  GL_SERVICE_LOG("glUniform3iv" << "("  << location << ", " << count << ", " << static_cast<const void*>(v) << ")");
  g_debug_glUniform3iv(location, count, v);
}

static void GL_BINDING_CALL Debug_glUniform4f(GLint location, GLfloat x, GLfloat y, GLfloat z, GLfloat w) {
  GL_SERVICE_LOG("glUniform4f" << "("  << location << ", " << x << ", " << y << ", " << z << ", " << w << ")");
  g_debug_glUniform4f(location, x, y, z, w);
}

static void GL_BINDING_CALL Debug_glUniform4fv(GLint location, GLsizei count, const GLfloat* v) {
  GL_SERVICE_LOG("glUniform4fv" << "("  << location << ", " << count << ", " << static_cast<const void*>(v) << ")");
  g_debug_glUniform4fv(location, count, v);
}

static void GL_BINDING_CALL Debug_glUniform4i(GLint location, GLint x, GLint y, GLint z, GLint w) {
  GL_SERVICE_LOG("glUniform4i" << "("  << location << ", " << x << ", " << y << ", " << z << ", " << w << ")");
  g_debug_glUniform4i(location, x, y, z, w);
}

static void GL_BINDING_CALL Debug_glUniform4iv(GLint location, GLsizei count, const GLint* v) {
  GL_SERVICE_LOG("glUniform4iv" << "("  << location << ", " << count << ", " << static_cast<const void*>(v) << ")");
  g_debug_glUniform4iv(location, count, v);
}

static void GL_BINDING_CALL Debug_glUniformMatrix2fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value) {
  GL_SERVICE_LOG("glUniformMatrix2fv" << "("  << location << ", " << count << ", " << GLES2Util::GetStringBool(transpose) << ", " << static_cast<const void*>(value) << ")");
  g_debug_glUniformMatrix2fv(location, count, transpose, value);
}

static void GL_BINDING_CALL Debug_glUniformMatrix3fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value) {
  GL_SERVICE_LOG("glUniformMatrix3fv" << "("  << location << ", " << count << ", " << GLES2Util::GetStringBool(transpose) << ", " << static_cast<const void*>(value) << ")");
  g_debug_glUniformMatrix3fv(location, count, transpose, value);
}

static void GL_BINDING_CALL Debug_glUniformMatrix4fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat* value) {
  GL_SERVICE_LOG("glUniformMatrix4fv" << "("  << location << ", " << count << ", " << GLES2Util::GetStringBool(transpose) << ", " << static_cast<const void*>(value) << ")");
  g_debug_glUniformMatrix4fv(location, count, transpose, value);
}

static GLboolean GL_BINDING_CALL Debug_glUnmapBuffer(GLenum target) {
  GL_SERVICE_LOG("glUnmapBuffer" << "("  << GLES2Util::GetStringEnum(target) << ")");
  GLboolean result = g_debug_glUnmapBuffer(target);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static void GL_BINDING_CALL Debug_glUseProgram(GLuint program) {
  GL_SERVICE_LOG("glUseProgram" << "("  << program << ")");
  g_debug_glUseProgram(program);
}

static void GL_BINDING_CALL Debug_glValidateProgram(GLuint program) {
  GL_SERVICE_LOG("glValidateProgram" << "("  << program << ")");
  g_debug_glValidateProgram(program);
}

static void GL_BINDING_CALL Debug_glVertexAttrib1f(GLuint indx, GLfloat x) {
  GL_SERVICE_LOG("glVertexAttrib1f" << "("  << indx << ", " << x << ")");
  g_debug_glVertexAttrib1f(indx, x);
}

static void GL_BINDING_CALL Debug_glVertexAttrib1fv(GLuint indx, const GLfloat* values) {
  GL_SERVICE_LOG("glVertexAttrib1fv" << "("  << indx << ", " << static_cast<const void*>(values) << ")");
  g_debug_glVertexAttrib1fv(indx, values);
}

static void GL_BINDING_CALL Debug_glVertexAttrib2f(GLuint indx, GLfloat x, GLfloat y) {
  GL_SERVICE_LOG("glVertexAttrib2f" << "("  << indx << ", " << x << ", " << y << ")");
  g_debug_glVertexAttrib2f(indx, x, y);
}

static void GL_BINDING_CALL Debug_glVertexAttrib2fv(GLuint indx, const GLfloat* values) {
  GL_SERVICE_LOG("glVertexAttrib2fv" << "("  << indx << ", " << static_cast<const void*>(values) << ")");
  g_debug_glVertexAttrib2fv(indx, values);
}

static void GL_BINDING_CALL Debug_glVertexAttrib3f(GLuint indx, GLfloat x, GLfloat y, GLfloat z) {
  GL_SERVICE_LOG("glVertexAttrib3f" << "("  << indx << ", " << x << ", " << y << ", " << z << ")");
  g_debug_glVertexAttrib3f(indx, x, y, z);
}

static void GL_BINDING_CALL Debug_glVertexAttrib3fv(GLuint indx, const GLfloat* values) {
  GL_SERVICE_LOG("glVertexAttrib3fv" << "("  << indx << ", " << static_cast<const void*>(values) << ")");
  g_debug_glVertexAttrib3fv(indx, values);
}

static void GL_BINDING_CALL Debug_glVertexAttrib4f(GLuint indx, GLfloat x, GLfloat y, GLfloat z, GLfloat w) {
  GL_SERVICE_LOG("glVertexAttrib4f" << "("  << indx << ", " << x << ", " << y << ", " << z << ", " << w << ")");
  g_debug_glVertexAttrib4f(indx, x, y, z, w);
}

static void GL_BINDING_CALL Debug_glVertexAttrib4fv(GLuint indx, const GLfloat* values) {
  GL_SERVICE_LOG("glVertexAttrib4fv" << "("  << indx << ", " << static_cast<const void*>(values) << ")");
  g_debug_glVertexAttrib4fv(indx, values);
}

static void GL_BINDING_CALL Debug_glVertexAttribPointer(GLuint indx, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const void* ptr) {
  GL_SERVICE_LOG("glVertexAttribPointer" << "("  << indx << ", " << size << ", " << GLES2Util::GetStringEnum(type) << ", " << GLES2Util::GetStringBool(normalized) << ", " << stride << ", " << static_cast<const void*>(ptr) << ")");
  g_debug_glVertexAttribPointer(indx, size, type, normalized, stride, ptr);
}

static void GL_BINDING_CALL Debug_glViewport(GLint x, GLint y, GLsizei width, GLsizei height) {
  GL_SERVICE_LOG("glViewport" << "("  << x << ", " << y << ", " << width << ", " << height << ")");
  g_debug_glViewport(x, y, width, height);
}

static void GL_BINDING_CALL Debug_glGenFencesNV(GLsizei n, GLuint* fences) {
  GL_SERVICE_LOG("glGenFencesNV" << "("  << n << ", " << static_cast<const void*>(fences) << ")");
  g_debug_glGenFencesNV(n, fences);
}

static void GL_BINDING_CALL Debug_glDeleteFencesNV(GLsizei n, const GLuint* fences) {
  GL_SERVICE_LOG("glDeleteFencesNV" << "("  << n << ", " << static_cast<const void*>(fences) << ")");
  g_debug_glDeleteFencesNV(n, fences);
}

static void GL_BINDING_CALL Debug_glSetFenceNV(GLuint fence, GLenum condition) {
  GL_SERVICE_LOG("glSetFenceNV" << "("  << fence << ", " << GLES2Util::GetStringEnum(condition) << ")");
  g_debug_glSetFenceNV(fence, condition);
}

static GLboolean GL_BINDING_CALL Debug_glTestFenceNV(GLuint fence) {
  GL_SERVICE_LOG("glTestFenceNV" << "("  << fence << ")");
  GLboolean result = g_debug_glTestFenceNV(fence);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static void GL_BINDING_CALL Debug_glFinishFenceNV(GLuint fence) {
  GL_SERVICE_LOG("glFinishFenceNV" << "("  << fence << ")");
  g_debug_glFinishFenceNV(fence);
}

static GLboolean GL_BINDING_CALL Debug_glIsFenceNV(GLuint fence) {
  GL_SERVICE_LOG("glIsFenceNV" << "("  << fence << ")");
  GLboolean result = g_debug_glIsFenceNV(fence);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static void GL_BINDING_CALL Debug_glGetFenceivNV(GLuint fence, GLenum pname, GLint* params) {
  GL_SERVICE_LOG("glGetFenceivNV" << "("  << fence << ", " << GLES2Util::GetStringEnum(pname) << ", " << static_cast<const void*>(params) << ")");
  g_debug_glGetFenceivNV(fence, pname, params);
}

static GLsync GL_BINDING_CALL Debug_glFenceSync(GLenum condition, GLbitfield flags) {
  GL_SERVICE_LOG("glFenceSync" << "("  << GLES2Util::GetStringEnum(condition) << ", " << flags << ")");
  GLsync result = g_debug_glFenceSync(condition, flags);
  GL_SERVICE_LOG("GL_RESULT: " << result);
  return result;
}

static void GL_BINDING_CALL Debug_glDeleteSync(GLsync sync) {
  GL_SERVICE_LOG("glDeleteSync" << "("  << sync << ")");
  g_debug_glDeleteSync(sync);
}

static void GL_BINDING_CALL Debug_glGetSynciv(GLsync sync, GLenum pname, GLsizei bufSize, GLsizei* length,GLint* values) {
  GL_SERVICE_LOG("glGetSynciv" << "("  << sync << ", " << GLES2Util::GetStringEnum(pname) << ", " << bufSize << ", " << static_cast<const void*>(length) << ", " <<static_cast<const void*>(values) << ")");
  g_debug_glGetSynciv(sync, pname, bufSize, length,values);
}

static void GL_BINDING_CALL Debug_glDrawArraysInstancedANGLE(GLenum mode, GLint first, GLsizei count, GLsizei primcount) {
  GL_SERVICE_LOG("glDrawArraysInstancedANGLE" << "("  << GLES2Util::GetStringEnum(mode) << ", " << first << ", " << count << ", " << primcount << ")");
  g_debug_glDrawArraysInstancedANGLE(mode, first, count, primcount);
}

static void GL_BINDING_CALL Debug_glDrawElementsInstancedANGLE(GLenum mode, GLsizei count, GLenum type, const void* indices, GLsizei primcount) {
  GL_SERVICE_LOG("glDrawElementsInstancedANGLE" << "("  << GLES2Util::GetStringEnum(mode) << ", " << count << ", " << GLES2Util::GetStringEnum(type) << ", " << static_cast<const void*>(indices) << ", " << primcount << ")");
  g_debug_glDrawElementsInstancedANGLE(mode, count, type, indices, primcount);
}

static void GL_BINDING_CALL Debug_glVertexAttribDivisorANGLE(GLuint index, GLuint divisor) {
  GL_SERVICE_LOG("glVertexAttribDivisorANGLE" << "("  << index << ", " << divisor << ")");
  g_debug_glVertexAttribDivisorANGLE(index, divisor);
}
}  // extern "C"

void InitializeDebugGLBindingsGL() {
  if (!g_debug_glActiveTexture) {
    g_debug_glActiveTexture = g_glActiveTexture;
    g_glActiveTexture = Debug_glActiveTexture;
  }
  if (!g_debug_glAttachShader) {
    g_debug_glAttachShader = g_glAttachShader;
    g_glAttachShader = Debug_glAttachShader;
  }
  if (!g_debug_glBeginQuery) {
    g_debug_glBeginQuery = g_glBeginQuery;
    g_glBeginQuery = Debug_glBeginQuery;
  }
  if (!g_debug_glBeginQueryARB) {
    g_debug_glBeginQueryARB = g_glBeginQueryARB;
    g_glBeginQueryARB = Debug_glBeginQueryARB;
  }
  if (!g_debug_glBindAttribLocation) {
    g_debug_glBindAttribLocation = g_glBindAttribLocation;
    g_glBindAttribLocation = Debug_glBindAttribLocation;
  }
  if (!g_debug_glBindBuffer) {
    g_debug_glBindBuffer = g_glBindBuffer;
    g_glBindBuffer = Debug_glBindBuffer;
  }
  if (!g_debug_glBindFragDataLocation) {
    g_debug_glBindFragDataLocation = g_glBindFragDataLocation;
    g_glBindFragDataLocation = Debug_glBindFragDataLocation;
  }
  if (!g_debug_glBindFragDataLocationIndexed) {
    g_debug_glBindFragDataLocationIndexed = g_glBindFragDataLocationIndexed;
    g_glBindFragDataLocationIndexed = Debug_glBindFragDataLocationIndexed;
  }
  if (!g_debug_glBindFramebufferEXT) {
    g_debug_glBindFramebufferEXT = g_glBindFramebufferEXT;
    g_glBindFramebufferEXT = Debug_glBindFramebufferEXT;
  }
  if (!g_debug_glBindRenderbufferEXT) {
    g_debug_glBindRenderbufferEXT = g_glBindRenderbufferEXT;
    g_glBindRenderbufferEXT = Debug_glBindRenderbufferEXT;
  }
  if (!g_debug_glBindTexture) {
    g_debug_glBindTexture = g_glBindTexture;
    g_glBindTexture = Debug_glBindTexture;
  }
  if (!g_debug_glBlendColor) {
    g_debug_glBlendColor = g_glBlendColor;
    g_glBlendColor = Debug_glBlendColor;
  }
  if (!g_debug_glBlendEquation) {
    g_debug_glBlendEquation = g_glBlendEquation;
    g_glBlendEquation = Debug_glBlendEquation;
  }
  if (!g_debug_glBlendEquationSeparate) {
    g_debug_glBlendEquationSeparate = g_glBlendEquationSeparate;
    g_glBlendEquationSeparate = Debug_glBlendEquationSeparate;
  }
  if (!g_debug_glBlendFunc) {
    g_debug_glBlendFunc = g_glBlendFunc;
    g_glBlendFunc = Debug_glBlendFunc;
  }
  if (!g_debug_glBlendFuncSeparate) {
    g_debug_glBlendFuncSeparate = g_glBlendFuncSeparate;
    g_glBlendFuncSeparate = Debug_glBlendFuncSeparate;
  }
  if (!g_debug_glBlitFramebufferEXT) {
    g_debug_glBlitFramebufferEXT = g_glBlitFramebufferEXT;
    g_glBlitFramebufferEXT = Debug_glBlitFramebufferEXT;
  }
  if (!g_debug_glBlitFramebufferANGLE) {
    g_debug_glBlitFramebufferANGLE = g_glBlitFramebufferANGLE;
    g_glBlitFramebufferANGLE = Debug_glBlitFramebufferANGLE;
  }
  if (!g_debug_glBufferData) {
    g_debug_glBufferData = g_glBufferData;
    g_glBufferData = Debug_glBufferData;
  }
  if (!g_debug_glBufferSubData) {
    g_debug_glBufferSubData = g_glBufferSubData;
    g_glBufferSubData = Debug_glBufferSubData;
  }
  if (!g_debug_glCheckFramebufferStatusEXT) {
    g_debug_glCheckFramebufferStatusEXT = g_glCheckFramebufferStatusEXT;
    g_glCheckFramebufferStatusEXT = Debug_glCheckFramebufferStatusEXT;
  }
  if (!g_debug_glClear) {
    g_debug_glClear = g_glClear;
    g_glClear = Debug_glClear;
  }
  if (!g_debug_glClearColor) {
    g_debug_glClearColor = g_glClearColor;
    g_glClearColor = Debug_glClearColor;
  }
  if (!g_debug_glClearDepth) {
    g_debug_glClearDepth = g_glClearDepth;
    g_glClearDepth = Debug_glClearDepth;
  }
  if (!g_debug_glClearDepthf) {
    g_debug_glClearDepthf = g_glClearDepthf;
    g_glClearDepthf = Debug_glClearDepthf;
  }
  if (!g_debug_glClearStencil) {
    g_debug_glClearStencil = g_glClearStencil;
    g_glClearStencil = Debug_glClearStencil;
  }
  if (!g_debug_glColorMask) {
    g_debug_glColorMask = g_glColorMask;
    g_glColorMask = Debug_glColorMask;
  }
  if (!g_debug_glCompileShader) {
    g_debug_glCompileShader = g_glCompileShader;
    g_glCompileShader = Debug_glCompileShader;
  }
  if (!g_debug_glCompressedTexImage2D) {
    g_debug_glCompressedTexImage2D = g_glCompressedTexImage2D;
    g_glCompressedTexImage2D = Debug_glCompressedTexImage2D;
  }
  if (!g_debug_glCompressedTexSubImage2D) {
    g_debug_glCompressedTexSubImage2D = g_glCompressedTexSubImage2D;
    g_glCompressedTexSubImage2D = Debug_glCompressedTexSubImage2D;
  }
  if (!g_debug_glCopyTexImage2D) {
    g_debug_glCopyTexImage2D = g_glCopyTexImage2D;
    g_glCopyTexImage2D = Debug_glCopyTexImage2D;
  }
  if (!g_debug_glCopyTexSubImage2D) {
    g_debug_glCopyTexSubImage2D = g_glCopyTexSubImage2D;
    g_glCopyTexSubImage2D = Debug_glCopyTexSubImage2D;
  }
  if (!g_debug_glCreateProgram) {
    g_debug_glCreateProgram = g_glCreateProgram;
    g_glCreateProgram = Debug_glCreateProgram;
  }
  if (!g_debug_glCreateShader) {
    g_debug_glCreateShader = g_glCreateShader;
    g_glCreateShader = Debug_glCreateShader;
  }
  if (!g_debug_glCullFace) {
    g_debug_glCullFace = g_glCullFace;
    g_glCullFace = Debug_glCullFace;
  }
  if (!g_debug_glDeleteBuffersARB) {
    g_debug_glDeleteBuffersARB = g_glDeleteBuffersARB;
    g_glDeleteBuffersARB = Debug_glDeleteBuffersARB;
  }
  if (!g_debug_glDeleteFramebuffersEXT) {
    g_debug_glDeleteFramebuffersEXT = g_glDeleteFramebuffersEXT;
    g_glDeleteFramebuffersEXT = Debug_glDeleteFramebuffersEXT;
  }
  if (!g_debug_glDeleteProgram) {
    g_debug_glDeleteProgram = g_glDeleteProgram;
    g_glDeleteProgram = Debug_glDeleteProgram;
  }
  if (!g_debug_glDeleteQueries) {
    g_debug_glDeleteQueries = g_glDeleteQueries;
    g_glDeleteQueries = Debug_glDeleteQueries;
  }
  if (!g_debug_glDeleteQueriesARB) {
    g_debug_glDeleteQueriesARB = g_glDeleteQueriesARB;
    g_glDeleteQueriesARB = Debug_glDeleteQueriesARB;
  }
  if (!g_debug_glDeleteRenderbuffersEXT) {
    g_debug_glDeleteRenderbuffersEXT = g_glDeleteRenderbuffersEXT;
    g_glDeleteRenderbuffersEXT = Debug_glDeleteRenderbuffersEXT;
  }
  if (!g_debug_glDeleteShader) {
    g_debug_glDeleteShader = g_glDeleteShader;
    g_glDeleteShader = Debug_glDeleteShader;
  }
  if (!g_debug_glDeleteTextures) {
    g_debug_glDeleteTextures = g_glDeleteTextures;
    g_glDeleteTextures = Debug_glDeleteTextures;
  }
  if (!g_debug_glDepthFunc) {
    g_debug_glDepthFunc = g_glDepthFunc;
    g_glDepthFunc = Debug_glDepthFunc;
  }
  if (!g_debug_glDepthMask) {
    g_debug_glDepthMask = g_glDepthMask;
    g_glDepthMask = Debug_glDepthMask;
  }
  if (!g_debug_glDepthRange) {
    g_debug_glDepthRange = g_glDepthRange;
    g_glDepthRange = Debug_glDepthRange;
  }
  if (!g_debug_glDepthRangef) {
    g_debug_glDepthRangef = g_glDepthRangef;
    g_glDepthRangef = Debug_glDepthRangef;
  }
  if (!g_debug_glDetachShader) {
    g_debug_glDetachShader = g_glDetachShader;
    g_glDetachShader = Debug_glDetachShader;
  }
  if (!g_debug_glDisable) {
    g_debug_glDisable = g_glDisable;
    g_glDisable = Debug_glDisable;
  }
  if (!g_debug_glDisableVertexAttribArray) {
    g_debug_glDisableVertexAttribArray = g_glDisableVertexAttribArray;
    g_glDisableVertexAttribArray = Debug_glDisableVertexAttribArray;
  }
  if (!g_debug_glDrawArrays) {
    g_debug_glDrawArrays = g_glDrawArrays;
    g_glDrawArrays = Debug_glDrawArrays;
  }
  if (!g_debug_glDrawBuffer) {
    g_debug_glDrawBuffer = g_glDrawBuffer;
    g_glDrawBuffer = Debug_glDrawBuffer;
  }
  if (!g_debug_glDrawBuffersARB) {
    g_debug_glDrawBuffersARB = g_glDrawBuffersARB;
    g_glDrawBuffersARB = Debug_glDrawBuffersARB;
  }
  if (!g_debug_glDrawElements) {
    g_debug_glDrawElements = g_glDrawElements;
    g_glDrawElements = Debug_glDrawElements;
  }
  if (!g_debug_glEGLImageTargetTexture2DOES) {
    g_debug_glEGLImageTargetTexture2DOES = g_glEGLImageTargetTexture2DOES;
    g_glEGLImageTargetTexture2DOES = Debug_glEGLImageTargetTexture2DOES;
  }
  if (!g_debug_glEGLImageTargetRenderbufferStorageOES) {
    g_debug_glEGLImageTargetRenderbufferStorageOES = g_glEGLImageTargetRenderbufferStorageOES;
    g_glEGLImageTargetRenderbufferStorageOES = Debug_glEGLImageTargetRenderbufferStorageOES;
  }
  if (!g_debug_glEnable) {
    g_debug_glEnable = g_glEnable;
    g_glEnable = Debug_glEnable;
  }
  if (!g_debug_glEnableVertexAttribArray) {
    g_debug_glEnableVertexAttribArray = g_glEnableVertexAttribArray;
    g_glEnableVertexAttribArray = Debug_glEnableVertexAttribArray;
  }
  if (!g_debug_glEndQuery) {
    g_debug_glEndQuery = g_glEndQuery;
    g_glEndQuery = Debug_glEndQuery;
  }
  if (!g_debug_glEndQueryARB) {
    g_debug_glEndQueryARB = g_glEndQueryARB;
    g_glEndQueryARB = Debug_glEndQueryARB;
  }
  if (!g_debug_glFinish) {
    g_debug_glFinish = g_glFinish;
    g_glFinish = Debug_glFinish;
  }
  if (!g_debug_glFlush) {
    g_debug_glFlush = g_glFlush;
    g_glFlush = Debug_glFlush;
  }
  if (!g_debug_glFramebufferRenderbufferEXT) {
    g_debug_glFramebufferRenderbufferEXT = g_glFramebufferRenderbufferEXT;
    g_glFramebufferRenderbufferEXT = Debug_glFramebufferRenderbufferEXT;
  }
  if (!g_debug_glFramebufferTexture2DEXT) {
    g_debug_glFramebufferTexture2DEXT = g_glFramebufferTexture2DEXT;
    g_glFramebufferTexture2DEXT = Debug_glFramebufferTexture2DEXT;
  }
  if (!g_debug_glFrontFace) {
    g_debug_glFrontFace = g_glFrontFace;
    g_glFrontFace = Debug_glFrontFace;
  }
  if (!g_debug_glGenBuffersARB) {
    g_debug_glGenBuffersARB = g_glGenBuffersARB;
    g_glGenBuffersARB = Debug_glGenBuffersARB;
  }
  if (!g_debug_glGenQueries) {
    g_debug_glGenQueries = g_glGenQueries;
    g_glGenQueries = Debug_glGenQueries;
  }
  if (!g_debug_glGenQueriesARB) {
    g_debug_glGenQueriesARB = g_glGenQueriesARB;
    g_glGenQueriesARB = Debug_glGenQueriesARB;
  }
  if (!g_debug_glGenerateMipmapEXT) {
    g_debug_glGenerateMipmapEXT = g_glGenerateMipmapEXT;
    g_glGenerateMipmapEXT = Debug_glGenerateMipmapEXT;
  }
  if (!g_debug_glGenFramebuffersEXT) {
    g_debug_glGenFramebuffersEXT = g_glGenFramebuffersEXT;
    g_glGenFramebuffersEXT = Debug_glGenFramebuffersEXT;
  }
  if (!g_debug_glGenRenderbuffersEXT) {
    g_debug_glGenRenderbuffersEXT = g_glGenRenderbuffersEXT;
    g_glGenRenderbuffersEXT = Debug_glGenRenderbuffersEXT;
  }
  if (!g_debug_glGenTextures) {
    g_debug_glGenTextures = g_glGenTextures;
    g_glGenTextures = Debug_glGenTextures;
  }
  if (!g_debug_glGetActiveAttrib) {
    g_debug_glGetActiveAttrib = g_glGetActiveAttrib;
    g_glGetActiveAttrib = Debug_glGetActiveAttrib;
  }
  if (!g_debug_glGetActiveUniform) {
    g_debug_glGetActiveUniform = g_glGetActiveUniform;
    g_glGetActiveUniform = Debug_glGetActiveUniform;
  }
  if (!g_debug_glGetAttachedShaders) {
    g_debug_glGetAttachedShaders = g_glGetAttachedShaders;
    g_glGetAttachedShaders = Debug_glGetAttachedShaders;
  }
  if (!g_debug_glGetAttribLocation) {
    g_debug_glGetAttribLocation = g_glGetAttribLocation;
    g_glGetAttribLocation = Debug_glGetAttribLocation;
  }
  if (!g_debug_glGetBooleanv) {
    g_debug_glGetBooleanv = g_glGetBooleanv;
    g_glGetBooleanv = Debug_glGetBooleanv;
  }
  if (!g_debug_glGetBufferParameteriv) {
    g_debug_glGetBufferParameteriv = g_glGetBufferParameteriv;
    g_glGetBufferParameteriv = Debug_glGetBufferParameteriv;
  }
  if (!g_debug_glGetError) {
    g_debug_glGetError = g_glGetError;
    g_glGetError = Debug_glGetError;
  }
  if (!g_debug_glGetFloatv) {
    g_debug_glGetFloatv = g_glGetFloatv;
    g_glGetFloatv = Debug_glGetFloatv;
  }
  if (!g_debug_glGetFramebufferAttachmentParameterivEXT) {
    g_debug_glGetFramebufferAttachmentParameterivEXT = g_glGetFramebufferAttachmentParameterivEXT;
    g_glGetFramebufferAttachmentParameterivEXT = Debug_glGetFramebufferAttachmentParameterivEXT;
  }
  if (!g_debug_glGetGraphicsResetStatusARB) {
    g_debug_glGetGraphicsResetStatusARB = g_glGetGraphicsResetStatusARB;
    g_glGetGraphicsResetStatusARB = Debug_glGetGraphicsResetStatusARB;
  }
  if (!g_debug_glGetIntegerv) {
    g_debug_glGetIntegerv = g_glGetIntegerv;
    g_glGetIntegerv = Debug_glGetIntegerv;
  }
  if (!g_debug_glGetProgramiv) {
    g_debug_glGetProgramiv = g_glGetProgramiv;
    g_glGetProgramiv = Debug_glGetProgramiv;
  }
  if (!g_debug_glGetProgramInfoLog) {
    g_debug_glGetProgramInfoLog = g_glGetProgramInfoLog;
    g_glGetProgramInfoLog = Debug_glGetProgramInfoLog;
  }
  if (!g_debug_glGetQueryiv) {
    g_debug_glGetQueryiv = g_glGetQueryiv;
    g_glGetQueryiv = Debug_glGetQueryiv;
  }
  if (!g_debug_glGetQueryivARB) {
    g_debug_glGetQueryivARB = g_glGetQueryivARB;
    g_glGetQueryivARB = Debug_glGetQueryivARB;
  }
  if (!g_debug_glGetQueryObjecti64v) {
    g_debug_glGetQueryObjecti64v = g_glGetQueryObjecti64v;
    g_glGetQueryObjecti64v = Debug_glGetQueryObjecti64v;
  }
  if (!g_debug_glGetQueryObjectiv) {
    g_debug_glGetQueryObjectiv = g_glGetQueryObjectiv;
    g_glGetQueryObjectiv = Debug_glGetQueryObjectiv;
  }
  if (!g_debug_glGetQueryObjectui64v) {
    g_debug_glGetQueryObjectui64v = g_glGetQueryObjectui64v;
    g_glGetQueryObjectui64v = Debug_glGetQueryObjectui64v;
  }
  if (!g_debug_glGetQueryObjectuiv) {
    g_debug_glGetQueryObjectuiv = g_glGetQueryObjectuiv;
    g_glGetQueryObjectuiv = Debug_glGetQueryObjectuiv;
  }
  if (!g_debug_glGetQueryObjectuivARB) {
    g_debug_glGetQueryObjectuivARB = g_glGetQueryObjectuivARB;
    g_glGetQueryObjectuivARB = Debug_glGetQueryObjectuivARB;
  }
  if (!g_debug_glGetRenderbufferParameterivEXT) {
    g_debug_glGetRenderbufferParameterivEXT = g_glGetRenderbufferParameterivEXT;
    g_glGetRenderbufferParameterivEXT = Debug_glGetRenderbufferParameterivEXT;
  }
  if (!g_debug_glGetShaderiv) {
    g_debug_glGetShaderiv = g_glGetShaderiv;
    g_glGetShaderiv = Debug_glGetShaderiv;
  }
  if (!g_debug_glGetShaderInfoLog) {
    g_debug_glGetShaderInfoLog = g_glGetShaderInfoLog;
    g_glGetShaderInfoLog = Debug_glGetShaderInfoLog;
  }
  if (!g_debug_glGetShaderPrecisionFormat) {
    g_debug_glGetShaderPrecisionFormat = g_glGetShaderPrecisionFormat;
    g_glGetShaderPrecisionFormat = Debug_glGetShaderPrecisionFormat;
  }
  if (!g_debug_glGetShaderSource) {
    g_debug_glGetShaderSource = g_glGetShaderSource;
    g_glGetShaderSource = Debug_glGetShaderSource;
  }
  if (!g_debug_glGetString) {
    g_debug_glGetString = g_glGetString;
    g_glGetString = Debug_glGetString;
  }
  if (!g_debug_glGetTexLevelParameterfv) {
    g_debug_glGetTexLevelParameterfv = g_glGetTexLevelParameterfv;
    g_glGetTexLevelParameterfv = Debug_glGetTexLevelParameterfv;
  }
  if (!g_debug_glGetTexLevelParameteriv) {
    g_debug_glGetTexLevelParameteriv = g_glGetTexLevelParameteriv;
    g_glGetTexLevelParameteriv = Debug_glGetTexLevelParameteriv;
  }
  if (!g_debug_glGetTexParameterfv) {
    g_debug_glGetTexParameterfv = g_glGetTexParameterfv;
    g_glGetTexParameterfv = Debug_glGetTexParameterfv;
  }
  if (!g_debug_glGetTexParameteriv) {
    g_debug_glGetTexParameteriv = g_glGetTexParameteriv;
    g_glGetTexParameteriv = Debug_glGetTexParameteriv;
  }
  if (!g_debug_glGetTranslatedShaderSourceANGLE) {
    g_debug_glGetTranslatedShaderSourceANGLE = g_glGetTranslatedShaderSourceANGLE;
    g_glGetTranslatedShaderSourceANGLE = Debug_glGetTranslatedShaderSourceANGLE;
  }
  if (!g_debug_glGetUniformfv) {
    g_debug_glGetUniformfv = g_glGetUniformfv;
    g_glGetUniformfv = Debug_glGetUniformfv;
  }
  if (!g_debug_glGetUniformiv) {
    g_debug_glGetUniformiv = g_glGetUniformiv;
    g_glGetUniformiv = Debug_glGetUniformiv;
  }
  if (!g_debug_glGetUniformLocation) {
    g_debug_glGetUniformLocation = g_glGetUniformLocation;
    g_glGetUniformLocation = Debug_glGetUniformLocation;
  }
  if (!g_debug_glGetVertexAttribfv) {
    g_debug_glGetVertexAttribfv = g_glGetVertexAttribfv;
    g_glGetVertexAttribfv = Debug_glGetVertexAttribfv;
  }
  if (!g_debug_glGetVertexAttribiv) {
    g_debug_glGetVertexAttribiv = g_glGetVertexAttribiv;
    g_glGetVertexAttribiv = Debug_glGetVertexAttribiv;
  }
  if (!g_debug_glGetVertexAttribPointerv) {
    g_debug_glGetVertexAttribPointerv = g_glGetVertexAttribPointerv;
    g_glGetVertexAttribPointerv = Debug_glGetVertexAttribPointerv;
  }
  if (!g_debug_glHint) {
    g_debug_glHint = g_glHint;
    g_glHint = Debug_glHint;
  }
  if (!g_debug_glIsBuffer) {
    g_debug_glIsBuffer = g_glIsBuffer;
    g_glIsBuffer = Debug_glIsBuffer;
  }
  if (!g_debug_glIsEnabled) {
    g_debug_glIsEnabled = g_glIsEnabled;
    g_glIsEnabled = Debug_glIsEnabled;
  }
  if (!g_debug_glIsFramebufferEXT) {
    g_debug_glIsFramebufferEXT = g_glIsFramebufferEXT;
    g_glIsFramebufferEXT = Debug_glIsFramebufferEXT;
  }
  if (!g_debug_glIsProgram) {
    g_debug_glIsProgram = g_glIsProgram;
    g_glIsProgram = Debug_glIsProgram;
  }
  if (!g_debug_glIsQueryARB) {
    g_debug_glIsQueryARB = g_glIsQueryARB;
    g_glIsQueryARB = Debug_glIsQueryARB;
  }
  if (!g_debug_glIsRenderbufferEXT) {
    g_debug_glIsRenderbufferEXT = g_glIsRenderbufferEXT;
    g_glIsRenderbufferEXT = Debug_glIsRenderbufferEXT;
  }
  if (!g_debug_glIsShader) {
    g_debug_glIsShader = g_glIsShader;
    g_glIsShader = Debug_glIsShader;
  }
  if (!g_debug_glIsTexture) {
    g_debug_glIsTexture = g_glIsTexture;
    g_glIsTexture = Debug_glIsTexture;
  }
  if (!g_debug_glLineWidth) {
    g_debug_glLineWidth = g_glLineWidth;
    g_glLineWidth = Debug_glLineWidth;
  }
  if (!g_debug_glLinkProgram) {
    g_debug_glLinkProgram = g_glLinkProgram;
    g_glLinkProgram = Debug_glLinkProgram;
  }
  if (!g_debug_glMapBuffer) {
    g_debug_glMapBuffer = g_glMapBuffer;
    g_glMapBuffer = Debug_glMapBuffer;
  }
  if (!g_debug_glPixelStorei) {
    g_debug_glPixelStorei = g_glPixelStorei;
    g_glPixelStorei = Debug_glPixelStorei;
  }
  if (!g_debug_glPointParameteri) {
    g_debug_glPointParameteri = g_glPointParameteri;
    g_glPointParameteri = Debug_glPointParameteri;
  }
  if (!g_debug_glPolygonOffset) {
    g_debug_glPolygonOffset = g_glPolygonOffset;
    g_glPolygonOffset = Debug_glPolygonOffset;
  }
  if (!g_debug_glQueryCounter) {
    g_debug_glQueryCounter = g_glQueryCounter;
    g_glQueryCounter = Debug_glQueryCounter;
  }
  if (!g_debug_glReadBuffer) {
    g_debug_glReadBuffer = g_glReadBuffer;
    g_glReadBuffer = Debug_glReadBuffer;
  }
  if (!g_debug_glReadPixels) {
    g_debug_glReadPixels = g_glReadPixels;
    g_glReadPixels = Debug_glReadPixels;
  }
  if (!g_debug_glReleaseShaderCompiler) {
    g_debug_glReleaseShaderCompiler = g_glReleaseShaderCompiler;
    g_glReleaseShaderCompiler = Debug_glReleaseShaderCompiler;
  }
  if (!g_debug_glRenderbufferStorageMultisampleEXT) {
    g_debug_glRenderbufferStorageMultisampleEXT = g_glRenderbufferStorageMultisampleEXT;
    g_glRenderbufferStorageMultisampleEXT = Debug_glRenderbufferStorageMultisampleEXT;
  }
  if (!g_debug_glRenderbufferStorageMultisampleANGLE) {
    g_debug_glRenderbufferStorageMultisampleANGLE = g_glRenderbufferStorageMultisampleANGLE;
    g_glRenderbufferStorageMultisampleANGLE = Debug_glRenderbufferStorageMultisampleANGLE;
  }
  if (!g_debug_glRenderbufferStorageEXT) {
    g_debug_glRenderbufferStorageEXT = g_glRenderbufferStorageEXT;
    g_glRenderbufferStorageEXT = Debug_glRenderbufferStorageEXT;
  }
  if (!g_debug_glSampleCoverage) {
    g_debug_glSampleCoverage = g_glSampleCoverage;
    g_glSampleCoverage = Debug_glSampleCoverage;
  }
  if (!g_debug_glScissor) {
    g_debug_glScissor = g_glScissor;
    g_glScissor = Debug_glScissor;
  }
  if (!g_debug_glShaderBinary) {
    g_debug_glShaderBinary = g_glShaderBinary;
    g_glShaderBinary = Debug_glShaderBinary;
  }
  if (!g_debug_glShaderSource) {
    g_debug_glShaderSource = g_glShaderSource;
    g_glShaderSource = Debug_glShaderSource;
  }
  if (!g_debug_glStencilFunc) {
    g_debug_glStencilFunc = g_glStencilFunc;
    g_glStencilFunc = Debug_glStencilFunc;
  }
  if (!g_debug_glStencilFuncSeparate) {
    g_debug_glStencilFuncSeparate = g_glStencilFuncSeparate;
    g_glStencilFuncSeparate = Debug_glStencilFuncSeparate;
  }
  if (!g_debug_glStencilMask) {
    g_debug_glStencilMask = g_glStencilMask;
    g_glStencilMask = Debug_glStencilMask;
  }
  if (!g_debug_glStencilMaskSeparate) {
    g_debug_glStencilMaskSeparate = g_glStencilMaskSeparate;
    g_glStencilMaskSeparate = Debug_glStencilMaskSeparate;
  }
  if (!g_debug_glStencilOp) {
    g_debug_glStencilOp = g_glStencilOp;
    g_glStencilOp = Debug_glStencilOp;
  }
  if (!g_debug_glStencilOpSeparate) {
    g_debug_glStencilOpSeparate = g_glStencilOpSeparate;
    g_glStencilOpSeparate = Debug_glStencilOpSeparate;
  }
  if (!g_debug_glTexImage2D) {
    g_debug_glTexImage2D = g_glTexImage2D;
    g_glTexImage2D = Debug_glTexImage2D;
  }
  if (!g_debug_glTexParameterf) {
    g_debug_glTexParameterf = g_glTexParameterf;
    g_glTexParameterf = Debug_glTexParameterf;
  }
  if (!g_debug_glTexParameterfv) {
    g_debug_glTexParameterfv = g_glTexParameterfv;
    g_glTexParameterfv = Debug_glTexParameterfv;
  }
  if (!g_debug_glTexParameteri) {
    g_debug_glTexParameteri = g_glTexParameteri;
    g_glTexParameteri = Debug_glTexParameteri;
  }
  if (!g_debug_glTexParameteriv) {
    g_debug_glTexParameteriv = g_glTexParameteriv;
    g_glTexParameteriv = Debug_glTexParameteriv;
  }
  if (!g_debug_glTexStorage2DEXT) {
    g_debug_glTexStorage2DEXT = g_glTexStorage2DEXT;
    g_glTexStorage2DEXT = Debug_glTexStorage2DEXT;
  }
  if (!g_debug_glTexSubImage2D) {
    g_debug_glTexSubImage2D = g_glTexSubImage2D;
    g_glTexSubImage2D = Debug_glTexSubImage2D;
  }
  if (!g_debug_glUniform1f) {
    g_debug_glUniform1f = g_glUniform1f;
    g_glUniform1f = Debug_glUniform1f;
  }
  if (!g_debug_glUniform1fv) {
    g_debug_glUniform1fv = g_glUniform1fv;
    g_glUniform1fv = Debug_glUniform1fv;
  }
  if (!g_debug_glUniform1i) {
    g_debug_glUniform1i = g_glUniform1i;
    g_glUniform1i = Debug_glUniform1i;
  }
  if (!g_debug_glUniform1iv) {
    g_debug_glUniform1iv = g_glUniform1iv;
    g_glUniform1iv = Debug_glUniform1iv;
  }
  if (!g_debug_glUniform2f) {
    g_debug_glUniform2f = g_glUniform2f;
    g_glUniform2f = Debug_glUniform2f;
  }
  if (!g_debug_glUniform2fv) {
    g_debug_glUniform2fv = g_glUniform2fv;
    g_glUniform2fv = Debug_glUniform2fv;
  }
  if (!g_debug_glUniform2i) {
    g_debug_glUniform2i = g_glUniform2i;
    g_glUniform2i = Debug_glUniform2i;
  }
  if (!g_debug_glUniform2iv) {
    g_debug_glUniform2iv = g_glUniform2iv;
    g_glUniform2iv = Debug_glUniform2iv;
  }
  if (!g_debug_glUniform3f) {
    g_debug_glUniform3f = g_glUniform3f;
    g_glUniform3f = Debug_glUniform3f;
  }
  if (!g_debug_glUniform3fv) {
    g_debug_glUniform3fv = g_glUniform3fv;
    g_glUniform3fv = Debug_glUniform3fv;
  }
  if (!g_debug_glUniform3i) {
    g_debug_glUniform3i = g_glUniform3i;
    g_glUniform3i = Debug_glUniform3i;
  }
  if (!g_debug_glUniform3iv) {
    g_debug_glUniform3iv = g_glUniform3iv;
    g_glUniform3iv = Debug_glUniform3iv;
  }
  if (!g_debug_glUniform4f) {
    g_debug_glUniform4f = g_glUniform4f;
    g_glUniform4f = Debug_glUniform4f;
  }
  if (!g_debug_glUniform4fv) {
    g_debug_glUniform4fv = g_glUniform4fv;
    g_glUniform4fv = Debug_glUniform4fv;
  }
  if (!g_debug_glUniform4i) {
    g_debug_glUniform4i = g_glUniform4i;
    g_glUniform4i = Debug_glUniform4i;
  }
  if (!g_debug_glUniform4iv) {
    g_debug_glUniform4iv = g_glUniform4iv;
    g_glUniform4iv = Debug_glUniform4iv;
  }
  if (!g_debug_glUniformMatrix2fv) {
    g_debug_glUniformMatrix2fv = g_glUniformMatrix2fv;
    g_glUniformMatrix2fv = Debug_glUniformMatrix2fv;
  }
  if (!g_debug_glUniformMatrix3fv) {
    g_debug_glUniformMatrix3fv = g_glUniformMatrix3fv;
    g_glUniformMatrix3fv = Debug_glUniformMatrix3fv;
  }
  if (!g_debug_glUniformMatrix4fv) {
    g_debug_glUniformMatrix4fv = g_glUniformMatrix4fv;
    g_glUniformMatrix4fv = Debug_glUniformMatrix4fv;
  }
  if (!g_debug_glUnmapBuffer) {
    g_debug_glUnmapBuffer = g_glUnmapBuffer;
    g_glUnmapBuffer = Debug_glUnmapBuffer;
  }
  if (!g_debug_glUseProgram) {
    g_debug_glUseProgram = g_glUseProgram;
    g_glUseProgram = Debug_glUseProgram;
  }
  if (!g_debug_glValidateProgram) {
    g_debug_glValidateProgram = g_glValidateProgram;
    g_glValidateProgram = Debug_glValidateProgram;
  }
  if (!g_debug_glVertexAttrib1f) {
    g_debug_glVertexAttrib1f = g_glVertexAttrib1f;
    g_glVertexAttrib1f = Debug_glVertexAttrib1f;
  }
  if (!g_debug_glVertexAttrib1fv) {
    g_debug_glVertexAttrib1fv = g_glVertexAttrib1fv;
    g_glVertexAttrib1fv = Debug_glVertexAttrib1fv;
  }
  if (!g_debug_glVertexAttrib2f) {
    g_debug_glVertexAttrib2f = g_glVertexAttrib2f;
    g_glVertexAttrib2f = Debug_glVertexAttrib2f;
  }
  if (!g_debug_glVertexAttrib2fv) {
    g_debug_glVertexAttrib2fv = g_glVertexAttrib2fv;
    g_glVertexAttrib2fv = Debug_glVertexAttrib2fv;
  }
  if (!g_debug_glVertexAttrib3f) {
    g_debug_glVertexAttrib3f = g_glVertexAttrib3f;
    g_glVertexAttrib3f = Debug_glVertexAttrib3f;
  }
  if (!g_debug_glVertexAttrib3fv) {
    g_debug_glVertexAttrib3fv = g_glVertexAttrib3fv;
    g_glVertexAttrib3fv = Debug_glVertexAttrib3fv;
  }
  if (!g_debug_glVertexAttrib4f) {
    g_debug_glVertexAttrib4f = g_glVertexAttrib4f;
    g_glVertexAttrib4f = Debug_glVertexAttrib4f;
  }
  if (!g_debug_glVertexAttrib4fv) {
    g_debug_glVertexAttrib4fv = g_glVertexAttrib4fv;
    g_glVertexAttrib4fv = Debug_glVertexAttrib4fv;
  }
  if (!g_debug_glVertexAttribPointer) {
    g_debug_glVertexAttribPointer = g_glVertexAttribPointer;
    g_glVertexAttribPointer = Debug_glVertexAttribPointer;
  }
  if (!g_debug_glViewport) {
    g_debug_glViewport = g_glViewport;
    g_glViewport = Debug_glViewport;
  }
  if (!g_debug_glGenFencesNV) {
    g_debug_glGenFencesNV = g_glGenFencesNV;
    g_glGenFencesNV = Debug_glGenFencesNV;
  }
  if (!g_debug_glDeleteFencesNV) {
    g_debug_glDeleteFencesNV = g_glDeleteFencesNV;
    g_glDeleteFencesNV = Debug_glDeleteFencesNV;
  }
  if (!g_debug_glSetFenceNV) {
    g_debug_glSetFenceNV = g_glSetFenceNV;
    g_glSetFenceNV = Debug_glSetFenceNV;
  }
  if (!g_debug_glTestFenceNV) {
    g_debug_glTestFenceNV = g_glTestFenceNV;
    g_glTestFenceNV = Debug_glTestFenceNV;
  }
  if (!g_debug_glFinishFenceNV) {
    g_debug_glFinishFenceNV = g_glFinishFenceNV;
    g_glFinishFenceNV = Debug_glFinishFenceNV;
  }
  if (!g_debug_glIsFenceNV) {
    g_debug_glIsFenceNV = g_glIsFenceNV;
    g_glIsFenceNV = Debug_glIsFenceNV;
  }
  if (!g_debug_glGetFenceivNV) {
    g_debug_glGetFenceivNV = g_glGetFenceivNV;
    g_glGetFenceivNV = Debug_glGetFenceivNV;
  }
  if (!g_debug_glFenceSync) {
    g_debug_glFenceSync = g_glFenceSync;
    g_glFenceSync = Debug_glFenceSync;
  }
  if (!g_debug_glDeleteSync) {
    g_debug_glDeleteSync = g_glDeleteSync;
    g_glDeleteSync = Debug_glDeleteSync;
  }
  if (!g_debug_glGetSynciv) {
    g_debug_glGetSynciv = g_glGetSynciv;
    g_glGetSynciv = Debug_glGetSynciv;
  }
  if (!g_debug_glDrawArraysInstancedANGLE) {
    g_debug_glDrawArraysInstancedANGLE = g_glDrawArraysInstancedANGLE;
    g_glDrawArraysInstancedANGLE = Debug_glDrawArraysInstancedANGLE;
  }
  if (!g_debug_glDrawElementsInstancedANGLE) {
    g_debug_glDrawElementsInstancedANGLE = g_glDrawElementsInstancedANGLE;
    g_glDrawElementsInstancedANGLE = Debug_glDrawElementsInstancedANGLE;
  }
  if (!g_debug_glVertexAttribDivisorANGLE) {
    g_debug_glVertexAttribDivisorANGLE = g_glVertexAttribDivisorANGLE;
    g_glVertexAttribDivisorANGLE = Debug_glVertexAttribDivisorANGLE;
  }
  g_debugBindingsInitialized = true;
}

static void UpdateDebugGLExtensionBindings() {
  if (g_debug_glGenFencesNV != g_glGenFencesNV &&
      g_glGenFencesNV != Debug_glGenFencesNV) {
    g_debug_glGenFencesNV = g_glGenFencesNV;
    g_glGenFencesNV = Debug_glGenFencesNV;
  }
  if (g_debug_glDeleteFencesNV != g_glDeleteFencesNV &&
      g_glDeleteFencesNV != Debug_glDeleteFencesNV) {
    g_debug_glDeleteFencesNV = g_glDeleteFencesNV;
    g_glDeleteFencesNV = Debug_glDeleteFencesNV;
  }
  if (g_debug_glSetFenceNV != g_glSetFenceNV &&
      g_glSetFenceNV != Debug_glSetFenceNV) {
    g_debug_glSetFenceNV = g_glSetFenceNV;
    g_glSetFenceNV = Debug_glSetFenceNV;
  }
  if (g_debug_glTestFenceNV != g_glTestFenceNV &&
      g_glTestFenceNV != Debug_glTestFenceNV) {
    g_debug_glTestFenceNV = g_glTestFenceNV;
    g_glTestFenceNV = Debug_glTestFenceNV;
  }
  if (g_debug_glFinishFenceNV != g_glFinishFenceNV &&
      g_glFinishFenceNV != Debug_glFinishFenceNV) {
    g_debug_glFinishFenceNV = g_glFinishFenceNV;
    g_glFinishFenceNV = Debug_glFinishFenceNV;
  }
  if (g_debug_glIsFenceNV != g_glIsFenceNV &&
      g_glIsFenceNV != Debug_glIsFenceNV) {
    g_debug_glIsFenceNV = g_glIsFenceNV;
    g_glIsFenceNV = Debug_glIsFenceNV;
  }
  if (g_debug_glGetFenceivNV != g_glGetFenceivNV &&
      g_glGetFenceivNV != Debug_glGetFenceivNV) {
    g_debug_glGetFenceivNV = g_glGetFenceivNV;
    g_glGetFenceivNV = Debug_glGetFenceivNV;
  }
  if (g_debug_glGetTranslatedShaderSourceANGLE != g_glGetTranslatedShaderSourceANGLE &&
      g_glGetTranslatedShaderSourceANGLE != Debug_glGetTranslatedShaderSourceANGLE) {
    g_debug_glGetTranslatedShaderSourceANGLE = g_glGetTranslatedShaderSourceANGLE;
    g_glGetTranslatedShaderSourceANGLE = Debug_glGetTranslatedShaderSourceANGLE;
  }
  if (g_debug_glBlitFramebufferANGLE != g_glBlitFramebufferANGLE &&
      g_glBlitFramebufferANGLE != Debug_glBlitFramebufferANGLE) {
    g_debug_glBlitFramebufferANGLE = g_glBlitFramebufferANGLE;
    g_glBlitFramebufferANGLE = Debug_glBlitFramebufferANGLE;
  }
  if (g_debug_glRenderbufferStorageMultisampleANGLE != g_glRenderbufferStorageMultisampleANGLE &&
      g_glRenderbufferStorageMultisampleANGLE != Debug_glRenderbufferStorageMultisampleANGLE) {
    g_debug_glRenderbufferStorageMultisampleANGLE = g_glRenderbufferStorageMultisampleANGLE;
    g_glRenderbufferStorageMultisampleANGLE = Debug_glRenderbufferStorageMultisampleANGLE;
  }
  if (g_debug_glDrawArraysInstancedANGLE != g_glDrawArraysInstancedANGLE &&
      g_glDrawArraysInstancedANGLE != Debug_glDrawArraysInstancedANGLE) {
    g_debug_glDrawArraysInstancedANGLE = g_glDrawArraysInstancedANGLE;
    g_glDrawArraysInstancedANGLE = Debug_glDrawArraysInstancedANGLE;
  }
  if (g_debug_glDrawElementsInstancedANGLE != g_glDrawElementsInstancedANGLE &&
      g_glDrawElementsInstancedANGLE != Debug_glDrawElementsInstancedANGLE) {
    g_debug_glDrawElementsInstancedANGLE = g_glDrawElementsInstancedANGLE;
    g_glDrawElementsInstancedANGLE = Debug_glDrawElementsInstancedANGLE;
  }
  if (g_debug_glVertexAttribDivisorANGLE != g_glVertexAttribDivisorANGLE &&
      g_glVertexAttribDivisorANGLE != Debug_glVertexAttribDivisorANGLE) {
    g_debug_glVertexAttribDivisorANGLE = g_glVertexAttribDivisorANGLE;
    g_glVertexAttribDivisorANGLE = Debug_glVertexAttribDivisorANGLE;
  }
  if (g_debug_glRenderbufferStorageMultisampleEXT != g_glRenderbufferStorageMultisampleEXT &&
      g_glRenderbufferStorageMultisampleEXT != Debug_glRenderbufferStorageMultisampleEXT) {
    g_debug_glRenderbufferStorageMultisampleEXT = g_glRenderbufferStorageMultisampleEXT;
    g_glRenderbufferStorageMultisampleEXT = Debug_glRenderbufferStorageMultisampleEXT;
  }
  if (g_debug_glRenderbufferStorageMultisampleEXT != g_glRenderbufferStorageMultisampleEXT &&
      g_glRenderbufferStorageMultisampleEXT != Debug_glRenderbufferStorageMultisampleEXT) {
    g_debug_glRenderbufferStorageMultisampleEXT = g_glRenderbufferStorageMultisampleEXT;
    g_glRenderbufferStorageMultisampleEXT = Debug_glRenderbufferStorageMultisampleEXT;
  }
  if (g_debug_glBeginQueryARB != g_glBeginQueryARB &&
      g_glBeginQueryARB != Debug_glBeginQueryARB) {
    g_debug_glBeginQueryARB = g_glBeginQueryARB;
    g_glBeginQueryARB = Debug_glBeginQueryARB;
  }
  if (g_debug_glDeleteQueriesARB != g_glDeleteQueriesARB &&
      g_glDeleteQueriesARB != Debug_glDeleteQueriesARB) {
    g_debug_glDeleteQueriesARB = g_glDeleteQueriesARB;
    g_glDeleteQueriesARB = Debug_glDeleteQueriesARB;
  }
  if (g_debug_glEndQueryARB != g_glEndQueryARB &&
      g_glEndQueryARB != Debug_glEndQueryARB) {
    g_debug_glEndQueryARB = g_glEndQueryARB;
    g_glEndQueryARB = Debug_glEndQueryARB;
  }
  if (g_debug_glGenQueriesARB != g_glGenQueriesARB &&
      g_glGenQueriesARB != Debug_glGenQueriesARB) {
    g_debug_glGenQueriesARB = g_glGenQueriesARB;
    g_glGenQueriesARB = Debug_glGenQueriesARB;
  }
  if (g_debug_glGetQueryivARB != g_glGetQueryivARB &&
      g_glGetQueryivARB != Debug_glGetQueryivARB) {
    g_debug_glGetQueryivARB = g_glGetQueryivARB;
    g_glGetQueryivARB = Debug_glGetQueryivARB;
  }
  if (g_debug_glGetQueryObjectuivARB != g_glGetQueryObjectuivARB &&
      g_glGetQueryObjectuivARB != Debug_glGetQueryObjectuivARB) {
    g_debug_glGetQueryObjectuivARB = g_glGetQueryObjectuivARB;
    g_glGetQueryObjectuivARB = Debug_glGetQueryObjectuivARB;
  }
  if (g_debug_glIsQueryARB != g_glIsQueryARB &&
      g_glIsQueryARB != Debug_glIsQueryARB) {
    g_debug_glIsQueryARB = g_glIsQueryARB;
    g_glIsQueryARB = Debug_glIsQueryARB;
  }
  if (g_debug_glBindFramebufferEXT != g_glBindFramebufferEXT &&
      g_glBindFramebufferEXT != Debug_glBindFramebufferEXT) {
    g_debug_glBindFramebufferEXT = g_glBindFramebufferEXT;
    g_glBindFramebufferEXT = Debug_glBindFramebufferEXT;
  }
  if (g_debug_glBindRenderbufferEXT != g_glBindRenderbufferEXT &&
      g_glBindRenderbufferEXT != Debug_glBindRenderbufferEXT) {
    g_debug_glBindRenderbufferEXT = g_glBindRenderbufferEXT;
    g_glBindRenderbufferEXT = Debug_glBindRenderbufferEXT;
  }
  if (g_debug_glCheckFramebufferStatusEXT != g_glCheckFramebufferStatusEXT &&
      g_glCheckFramebufferStatusEXT != Debug_glCheckFramebufferStatusEXT) {
    g_debug_glCheckFramebufferStatusEXT = g_glCheckFramebufferStatusEXT;
    g_glCheckFramebufferStatusEXT = Debug_glCheckFramebufferStatusEXT;
  }
  if (g_debug_glDeleteFramebuffersEXT != g_glDeleteFramebuffersEXT &&
      g_glDeleteFramebuffersEXT != Debug_glDeleteFramebuffersEXT) {
    g_debug_glDeleteFramebuffersEXT = g_glDeleteFramebuffersEXT;
    g_glDeleteFramebuffersEXT = Debug_glDeleteFramebuffersEXT;
  }
  if (g_debug_glDeleteRenderbuffersEXT != g_glDeleteRenderbuffersEXT &&
      g_glDeleteRenderbuffersEXT != Debug_glDeleteRenderbuffersEXT) {
    g_debug_glDeleteRenderbuffersEXT = g_glDeleteRenderbuffersEXT;
    g_glDeleteRenderbuffersEXT = Debug_glDeleteRenderbuffersEXT;
  }
  if (g_debug_glFramebufferRenderbufferEXT != g_glFramebufferRenderbufferEXT &&
      g_glFramebufferRenderbufferEXT != Debug_glFramebufferRenderbufferEXT) {
    g_debug_glFramebufferRenderbufferEXT = g_glFramebufferRenderbufferEXT;
    g_glFramebufferRenderbufferEXT = Debug_glFramebufferRenderbufferEXT;
  }
  if (g_debug_glFramebufferTexture2DEXT != g_glFramebufferTexture2DEXT &&
      g_glFramebufferTexture2DEXT != Debug_glFramebufferTexture2DEXT) {
    g_debug_glFramebufferTexture2DEXT = g_glFramebufferTexture2DEXT;
    g_glFramebufferTexture2DEXT = Debug_glFramebufferTexture2DEXT;
  }
  if (g_debug_glGenerateMipmapEXT != g_glGenerateMipmapEXT &&
      g_glGenerateMipmapEXT != Debug_glGenerateMipmapEXT) {
    g_debug_glGenerateMipmapEXT = g_glGenerateMipmapEXT;
    g_glGenerateMipmapEXT = Debug_glGenerateMipmapEXT;
  }
  if (g_debug_glGenFramebuffersEXT != g_glGenFramebuffersEXT &&
      g_glGenFramebuffersEXT != Debug_glGenFramebuffersEXT) {
    g_debug_glGenFramebuffersEXT = g_glGenFramebuffersEXT;
    g_glGenFramebuffersEXT = Debug_glGenFramebuffersEXT;
  }
  if (g_debug_glGenRenderbuffersEXT != g_glGenRenderbuffersEXT &&
      g_glGenRenderbuffersEXT != Debug_glGenRenderbuffersEXT) {
    g_debug_glGenRenderbuffersEXT = g_glGenRenderbuffersEXT;
    g_glGenRenderbuffersEXT = Debug_glGenRenderbuffersEXT;
  }
  if (g_debug_glGetFramebufferAttachmentParameterivEXT != g_glGetFramebufferAttachmentParameterivEXT &&
      g_glGetFramebufferAttachmentParameterivEXT != Debug_glGetFramebufferAttachmentParameterivEXT) {
    g_debug_glGetFramebufferAttachmentParameterivEXT = g_glGetFramebufferAttachmentParameterivEXT;
    g_glGetFramebufferAttachmentParameterivEXT = Debug_glGetFramebufferAttachmentParameterivEXT;
  }
  if (g_debug_glGetRenderbufferParameterivEXT != g_glGetRenderbufferParameterivEXT &&
      g_glGetRenderbufferParameterivEXT != Debug_glGetRenderbufferParameterivEXT) {
    g_debug_glGetRenderbufferParameterivEXT = g_glGetRenderbufferParameterivEXT;
    g_glGetRenderbufferParameterivEXT = Debug_glGetRenderbufferParameterivEXT;
  }
  if (g_debug_glIsFramebufferEXT != g_glIsFramebufferEXT &&
      g_glIsFramebufferEXT != Debug_glIsFramebufferEXT) {
    g_debug_glIsFramebufferEXT = g_glIsFramebufferEXT;
    g_glIsFramebufferEXT = Debug_glIsFramebufferEXT;
  }
  if (g_debug_glIsRenderbufferEXT != g_glIsRenderbufferEXT &&
      g_glIsRenderbufferEXT != Debug_glIsRenderbufferEXT) {
    g_debug_glIsRenderbufferEXT = g_glIsRenderbufferEXT;
    g_glIsRenderbufferEXT = Debug_glIsRenderbufferEXT;
  }
  if (g_debug_glRenderbufferStorageEXT != g_glRenderbufferStorageEXT &&
      g_glRenderbufferStorageEXT != Debug_glRenderbufferStorageEXT) {
    g_debug_glRenderbufferStorageEXT = g_glRenderbufferStorageEXT;
    g_glRenderbufferStorageEXT = Debug_glRenderbufferStorageEXT;
  }
  if (g_debug_glBlitFramebufferEXT != g_glBlitFramebufferEXT &&
      g_glBlitFramebufferEXT != Debug_glBlitFramebufferEXT) {
    g_debug_glBlitFramebufferEXT = g_glBlitFramebufferEXT;
    g_glBlitFramebufferEXT = Debug_glBlitFramebufferEXT;
  }
  if (g_debug_glTexStorage2DEXT != g_glTexStorage2DEXT &&
      g_glTexStorage2DEXT != Debug_glTexStorage2DEXT) {
    g_debug_glTexStorage2DEXT = g_glTexStorage2DEXT;
    g_glTexStorage2DEXT = Debug_glTexStorage2DEXT;
  }
  if (g_debug_glMapBuffer != g_glMapBuffer &&
      g_glMapBuffer != Debug_glMapBuffer) {
    g_debug_glMapBuffer = g_glMapBuffer;
    g_glMapBuffer = Debug_glMapBuffer;
  }
  if (g_debug_glUnmapBuffer != g_glUnmapBuffer &&
      g_glUnmapBuffer != Debug_glUnmapBuffer) {
    g_debug_glUnmapBuffer = g_glUnmapBuffer;
    g_glUnmapBuffer = Debug_glUnmapBuffer;
  }
  if (g_debug_glEGLImageTargetTexture2DOES != g_glEGLImageTargetTexture2DOES &&
      g_glEGLImageTargetTexture2DOES != Debug_glEGLImageTargetTexture2DOES) {
    g_debug_glEGLImageTargetTexture2DOES = g_glEGLImageTargetTexture2DOES;
    g_glEGLImageTargetTexture2DOES = Debug_glEGLImageTargetTexture2DOES;
  }
  if (g_debug_glEGLImageTargetRenderbufferStorageOES != g_glEGLImageTargetRenderbufferStorageOES &&
      g_glEGLImageTargetRenderbufferStorageOES != Debug_glEGLImageTargetRenderbufferStorageOES) {
    g_debug_glEGLImageTargetRenderbufferStorageOES = g_glEGLImageTargetRenderbufferStorageOES;
    g_glEGLImageTargetRenderbufferStorageOES = Debug_glEGLImageTargetRenderbufferStorageOES;
  }
  if (g_debug_glVertexAttribDivisorANGLE != g_glVertexAttribDivisorANGLE &&
      g_glVertexAttribDivisorANGLE != Debug_glVertexAttribDivisorANGLE) {
    g_debug_glVertexAttribDivisorANGLE = g_glVertexAttribDivisorANGLE;
    g_glVertexAttribDivisorANGLE = Debug_glVertexAttribDivisorANGLE;
  }
  if (g_debug_glBindFragDataLocationIndexed != g_glBindFragDataLocationIndexed &&
      g_glBindFragDataLocationIndexed != Debug_glBindFragDataLocationIndexed) {
    g_debug_glBindFragDataLocationIndexed = g_glBindFragDataLocationIndexed;
    g_glBindFragDataLocationIndexed = Debug_glBindFragDataLocationIndexed;
  }
  if (g_debug_glFenceSync != g_glFenceSync &&
      g_glFenceSync != Debug_glFenceSync) {
    g_debug_glFenceSync = g_glFenceSync;
    g_glFenceSync = Debug_glFenceSync;
  }
  if (g_debug_glDeleteSync != g_glDeleteSync &&
      g_glDeleteSync != Debug_glDeleteSync) {
    g_debug_glDeleteSync = g_glDeleteSync;
    g_glDeleteSync = Debug_glDeleteSync;
  }
  if (g_debug_glGetSynciv != g_glGetSynciv &&
      g_glGetSynciv != Debug_glGetSynciv) {
    g_debug_glGetSynciv = g_glGetSynciv;
    g_glGetSynciv = Debug_glGetSynciv;
  }
  if (g_debug_glGetGraphicsResetStatusARB != g_glGetGraphicsResetStatusARB &&
      g_glGetGraphicsResetStatusARB != Debug_glGetGraphicsResetStatusARB) {
    g_debug_glGetGraphicsResetStatusARB = g_glGetGraphicsResetStatusARB;
    g_glGetGraphicsResetStatusARB = Debug_glGetGraphicsResetStatusARB;
  }
  if (g_debug_glGetQueryObjecti64v != g_glGetQueryObjecti64v &&
      g_glGetQueryObjecti64v != Debug_glGetQueryObjecti64v) {
    g_debug_glGetQueryObjecti64v = g_glGetQueryObjecti64v;
    g_glGetQueryObjecti64v = Debug_glGetQueryObjecti64v;
  }
  if (g_debug_glGetQueryObjectui64v != g_glGetQueryObjectui64v &&
      g_glGetQueryObjectui64v != Debug_glGetQueryObjectui64v) {
    g_debug_glGetQueryObjectui64v = g_glGetQueryObjectui64v;
    g_glGetQueryObjectui64v = Debug_glGetQueryObjectui64v;
  }
  if (g_debug_glQueryCounter != g_glQueryCounter &&
      g_glQueryCounter != Debug_glQueryCounter) {
    g_debug_glQueryCounter = g_glQueryCounter;
    g_glQueryCounter = Debug_glQueryCounter;
  }
  if (g_debug_glDrawArraysInstancedANGLE != g_glDrawArraysInstancedANGLE &&
      g_glDrawArraysInstancedANGLE != Debug_glDrawArraysInstancedANGLE) {
    g_debug_glDrawArraysInstancedANGLE = g_glDrawArraysInstancedANGLE;
    g_glDrawArraysInstancedANGLE = Debug_glDrawArraysInstancedANGLE;
  }
  if (g_debug_glDrawElementsInstancedANGLE != g_glDrawElementsInstancedANGLE &&
      g_glDrawElementsInstancedANGLE != Debug_glDrawElementsInstancedANGLE) {
    g_debug_glDrawElementsInstancedANGLE = g_glDrawElementsInstancedANGLE;
    g_glDrawElementsInstancedANGLE = Debug_glDrawElementsInstancedANGLE;
  }
  if (g_debug_glDeleteBuffersARB != g_glDeleteBuffersARB &&
      g_glDeleteBuffersARB != Debug_glDeleteBuffersARB) {
    g_debug_glDeleteBuffersARB = g_glDeleteBuffersARB;
    g_glDeleteBuffersARB = Debug_glDeleteBuffersARB;
  }
  if (g_debug_glGenBuffersARB != g_glGenBuffersARB &&
      g_glGenBuffersARB != Debug_glGenBuffersARB) {
    g_debug_glGenBuffersARB = g_glGenBuffersARB;
    g_glGenBuffersARB = Debug_glGenBuffersARB;
  }
  if (g_debug_glBindFramebufferEXT != g_glBindFramebufferEXT &&
      g_glBindFramebufferEXT != Debug_glBindFramebufferEXT) {
    g_debug_glBindFramebufferEXT = g_glBindFramebufferEXT;
    g_glBindFramebufferEXT = Debug_glBindFramebufferEXT;
  }
  if (g_debug_glBindRenderbufferEXT != g_glBindRenderbufferEXT &&
      g_glBindRenderbufferEXT != Debug_glBindRenderbufferEXT) {
    g_debug_glBindRenderbufferEXT = g_glBindRenderbufferEXT;
    g_glBindRenderbufferEXT = Debug_glBindRenderbufferEXT;
  }
  if (g_debug_glBlitFramebufferEXT != g_glBlitFramebufferEXT &&
      g_glBlitFramebufferEXT != Debug_glBlitFramebufferEXT) {
    g_debug_glBlitFramebufferEXT = g_glBlitFramebufferEXT;
    g_glBlitFramebufferEXT = Debug_glBlitFramebufferEXT;
  }
  if (g_debug_glBlitFramebufferANGLE != g_glBlitFramebufferANGLE &&
      g_glBlitFramebufferANGLE != Debug_glBlitFramebufferANGLE) {
    g_debug_glBlitFramebufferANGLE = g_glBlitFramebufferANGLE;
    g_glBlitFramebufferANGLE = Debug_glBlitFramebufferANGLE;
  }
  if (g_debug_glCheckFramebufferStatusEXT != g_glCheckFramebufferStatusEXT &&
      g_glCheckFramebufferStatusEXT != Debug_glCheckFramebufferStatusEXT) {
    g_debug_glCheckFramebufferStatusEXT = g_glCheckFramebufferStatusEXT;
    g_glCheckFramebufferStatusEXT = Debug_glCheckFramebufferStatusEXT;
  }
  if (g_debug_glDeleteFramebuffersEXT != g_glDeleteFramebuffersEXT &&
      g_glDeleteFramebuffersEXT != Debug_glDeleteFramebuffersEXT) {
    g_debug_glDeleteFramebuffersEXT = g_glDeleteFramebuffersEXT;
    g_glDeleteFramebuffersEXT = Debug_glDeleteFramebuffersEXT;
  }
  if (g_debug_glDeleteRenderbuffersEXT != g_glDeleteRenderbuffersEXT &&
      g_glDeleteRenderbuffersEXT != Debug_glDeleteRenderbuffersEXT) {
    g_debug_glDeleteRenderbuffersEXT = g_glDeleteRenderbuffersEXT;
    g_glDeleteRenderbuffersEXT = Debug_glDeleteRenderbuffersEXT;
  }
  if (g_debug_glFramebufferRenderbufferEXT != g_glFramebufferRenderbufferEXT &&
      g_glFramebufferRenderbufferEXT != Debug_glFramebufferRenderbufferEXT) {
    g_debug_glFramebufferRenderbufferEXT = g_glFramebufferRenderbufferEXT;
    g_glFramebufferRenderbufferEXT = Debug_glFramebufferRenderbufferEXT;
  }
  if (g_debug_glFramebufferTexture2DEXT != g_glFramebufferTexture2DEXT &&
      g_glFramebufferTexture2DEXT != Debug_glFramebufferTexture2DEXT) {
    g_debug_glFramebufferTexture2DEXT = g_glFramebufferTexture2DEXT;
    g_glFramebufferTexture2DEXT = Debug_glFramebufferTexture2DEXT;
  }
  if (g_debug_glGenerateMipmapEXT != g_glGenerateMipmapEXT &&
      g_glGenerateMipmapEXT != Debug_glGenerateMipmapEXT) {
    g_debug_glGenerateMipmapEXT = g_glGenerateMipmapEXT;
    g_glGenerateMipmapEXT = Debug_glGenerateMipmapEXT;
  }
  if (g_debug_glGenFramebuffersEXT != g_glGenFramebuffersEXT &&
      g_glGenFramebuffersEXT != Debug_glGenFramebuffersEXT) {
    g_debug_glGenFramebuffersEXT = g_glGenFramebuffersEXT;
    g_glGenFramebuffersEXT = Debug_glGenFramebuffersEXT;
  }
  if (g_debug_glGenRenderbuffersEXT != g_glGenRenderbuffersEXT &&
      g_glGenRenderbuffersEXT != Debug_glGenRenderbuffersEXT) {
    g_debug_glGenRenderbuffersEXT = g_glGenRenderbuffersEXT;
    g_glGenRenderbuffersEXT = Debug_glGenRenderbuffersEXT;
  }
  if (g_debug_glGetFramebufferAttachmentParameterivEXT != g_glGetFramebufferAttachmentParameterivEXT &&
      g_glGetFramebufferAttachmentParameterivEXT != Debug_glGetFramebufferAttachmentParameterivEXT) {
    g_debug_glGetFramebufferAttachmentParameterivEXT = g_glGetFramebufferAttachmentParameterivEXT;
    g_glGetFramebufferAttachmentParameterivEXT = Debug_glGetFramebufferAttachmentParameterivEXT;
  }
  if (g_debug_glGetRenderbufferParameterivEXT != g_glGetRenderbufferParameterivEXT &&
      g_glGetRenderbufferParameterivEXT != Debug_glGetRenderbufferParameterivEXT) {
    g_debug_glGetRenderbufferParameterivEXT = g_glGetRenderbufferParameterivEXT;
    g_glGetRenderbufferParameterivEXT = Debug_glGetRenderbufferParameterivEXT;
  }
  if (g_debug_glIsFramebufferEXT != g_glIsFramebufferEXT &&
      g_glIsFramebufferEXT != Debug_glIsFramebufferEXT) {
    g_debug_glIsFramebufferEXT = g_glIsFramebufferEXT;
    g_glIsFramebufferEXT = Debug_glIsFramebufferEXT;
  }
  if (g_debug_glIsRenderbufferEXT != g_glIsRenderbufferEXT &&
      g_glIsRenderbufferEXT != Debug_glIsRenderbufferEXT) {
    g_debug_glIsRenderbufferEXT = g_glIsRenderbufferEXT;
    g_glIsRenderbufferEXT = Debug_glIsRenderbufferEXT;
  }
  if (g_debug_glRenderbufferStorageMultisampleEXT != g_glRenderbufferStorageMultisampleEXT &&
      g_glRenderbufferStorageMultisampleEXT != Debug_glRenderbufferStorageMultisampleEXT) {
    g_debug_glRenderbufferStorageMultisampleEXT = g_glRenderbufferStorageMultisampleEXT;
    g_glRenderbufferStorageMultisampleEXT = Debug_glRenderbufferStorageMultisampleEXT;
  }
  if (g_debug_glRenderbufferStorageMultisampleANGLE != g_glRenderbufferStorageMultisampleANGLE &&
      g_glRenderbufferStorageMultisampleANGLE != Debug_glRenderbufferStorageMultisampleANGLE) {
    g_debug_glRenderbufferStorageMultisampleANGLE = g_glRenderbufferStorageMultisampleANGLE;
    g_glRenderbufferStorageMultisampleANGLE = Debug_glRenderbufferStorageMultisampleANGLE;
  }
  if (g_debug_glRenderbufferStorageEXT != g_glRenderbufferStorageEXT &&
      g_glRenderbufferStorageEXT != Debug_glRenderbufferStorageEXT) {
    g_debug_glRenderbufferStorageEXT = g_glRenderbufferStorageEXT;
    g_glRenderbufferStorageEXT = Debug_glRenderbufferStorageEXT;
  }
  if (g_debug_glBeginQueryARB != g_glBeginQueryARB &&
      g_glBeginQueryARB != Debug_glBeginQueryARB) {
    g_debug_glBeginQueryARB = g_glBeginQueryARB;
    g_glBeginQueryARB = Debug_glBeginQueryARB;
  }
  if (g_debug_glDeleteQueriesARB != g_glDeleteQueriesARB &&
      g_glDeleteQueriesARB != Debug_glDeleteQueriesARB) {
    g_debug_glDeleteQueriesARB = g_glDeleteQueriesARB;
    g_glDeleteQueriesARB = Debug_glDeleteQueriesARB;
  }
  if (g_debug_glEndQueryARB != g_glEndQueryARB &&
      g_glEndQueryARB != Debug_glEndQueryARB) {
    g_debug_glEndQueryARB = g_glEndQueryARB;
    g_glEndQueryARB = Debug_glEndQueryARB;
  }
  if (g_debug_glGenQueriesARB != g_glGenQueriesARB &&
      g_glGenQueriesARB != Debug_glGenQueriesARB) {
    g_debug_glGenQueriesARB = g_glGenQueriesARB;
    g_glGenQueriesARB = Debug_glGenQueriesARB;
  }
  if (g_debug_glGetQueryivARB != g_glGetQueryivARB &&
      g_glGetQueryivARB != Debug_glGetQueryivARB) {
    g_debug_glGetQueryivARB = g_glGetQueryivARB;
    g_glGetQueryivARB = Debug_glGetQueryivARB;
  }
  if (g_debug_glGetQueryObjectuivARB != g_glGetQueryObjectuivARB &&
      g_glGetQueryObjectuivARB != Debug_glGetQueryObjectuivARB) {
    g_debug_glGetQueryObjectuivARB = g_glGetQueryObjectuivARB;
    g_glGetQueryObjectuivARB = Debug_glGetQueryObjectuivARB;
  }
  if (g_debug_glIsQueryARB != g_glIsQueryARB &&
      g_glIsQueryARB != Debug_glIsQueryARB) {
    g_debug_glIsQueryARB = g_glIsQueryARB;
    g_glIsQueryARB = Debug_glIsQueryARB;
  }
  if (g_debug_glClearDepthf != g_glClearDepthf &&
      g_glClearDepthf != Debug_glClearDepthf) {
    g_debug_glClearDepthf = g_glClearDepthf;
    g_glClearDepthf = Debug_glClearDepthf;
  }
  if (g_debug_glDepthRangef != g_glDepthRangef &&
      g_glDepthRangef != Debug_glDepthRangef) {
    g_debug_glDepthRangef = g_glDepthRangef;
    g_glDepthRangef = Debug_glDepthRangef;
  }
  if (g_debug_glGetShaderPrecisionFormat != g_glGetShaderPrecisionFormat &&
      g_glGetShaderPrecisionFormat != Debug_glGetShaderPrecisionFormat) {
    g_debug_glGetShaderPrecisionFormat = g_glGetShaderPrecisionFormat;
    g_glGetShaderPrecisionFormat = Debug_glGetShaderPrecisionFormat;
  }
  if (g_debug_glReleaseShaderCompiler != g_glReleaseShaderCompiler &&
      g_glReleaseShaderCompiler != Debug_glReleaseShaderCompiler) {
    g_debug_glReleaseShaderCompiler = g_glReleaseShaderCompiler;
    g_glReleaseShaderCompiler = Debug_glReleaseShaderCompiler;
  }
  if (g_debug_glShaderBinary != g_glShaderBinary &&
      g_glShaderBinary != Debug_glShaderBinary) {
    g_debug_glShaderBinary = g_glShaderBinary;
    g_glShaderBinary = Debug_glShaderBinary;
  }
  if (g_debug_glDrawBuffersARB != g_glDrawBuffersARB &&
      g_glDrawBuffersARB != Debug_glDrawBuffersARB) {
    g_debug_glDrawBuffersARB = g_glDrawBuffersARB;
    g_glDrawBuffersARB = Debug_glDrawBuffersARB;
  }
}

void ClearGLBindingsGL() {
  g_GL_NV_fence = false;
  g_GL_ANGLE_translated_shader_source = false;
  g_GL_ANGLE_framebuffer_blit = false;
  g_GL_ANGLE_framebuffer_multisample = false;
  g_GL_ANGLE_instanced_arrays = false;
  g_GL_EXT_multisampled_render_to_texture = false;
  g_GL_EXT_framebuffer_multisample = false;
  g_GL_EXT_occlusion_query_boolean = false;
  g_GL_EXT_framebuffer_object = false;
  g_GL_EXT_framebuffer_blit = false;
  g_GL_EXT_texture_storage = false;
  g_GL_OES_mapbuffer = false;
  g_GL_OES_EGL_image = false;
  g_GL_ARB_instanced_arrays = false;
  g_GL_ARB_blend_func_extended = false;
  g_GL_ARB_sync = false;
  g_GL_ARB_robustness = false;
  g_GL_ARB_timer_query = false;
  g_GL_ARB_draw_instanced = false;
  g_GL_ARB_vertex_buffer_object = false;
  g_GL_ARB_framebuffer_object = false;
  g_GL_ARB_occlusion_query = false;
  g_GL_ARB_ES2_compatibility = false;
  g_GL_ARB_draw_buffers = false;

  g_glActiveTexture = NULL;
  g_glAttachShader = NULL;
  g_glBeginQuery = NULL;
  g_glBeginQueryARB = NULL;
  g_glBindAttribLocation = NULL;
  g_glBindBuffer = NULL;
  g_glBindFragDataLocation = NULL;
  g_glBindFragDataLocationIndexed = NULL;
  g_glBindFramebufferEXT = NULL;
  g_glBindRenderbufferEXT = NULL;
  g_glBindTexture = NULL;
  g_glBlendColor = NULL;
  g_glBlendEquation = NULL;
  g_glBlendEquationSeparate = NULL;
  g_glBlendFunc = NULL;
  g_glBlendFuncSeparate = NULL;
  g_glBlitFramebufferEXT = NULL;
  g_glBlitFramebufferANGLE = NULL;
  g_glBufferData = NULL;
  g_glBufferSubData = NULL;
  g_glCheckFramebufferStatusEXT = NULL;
  g_glClear = NULL;
  g_glClearColor = NULL;
  g_glClearDepth = NULL;
  g_glClearDepthf = NULL;
  g_glClearStencil = NULL;
  g_glColorMask = NULL;
  g_glCompileShader = NULL;
  g_glCompressedTexImage2D = NULL;
  g_glCompressedTexSubImage2D = NULL;
  g_glCopyTexImage2D = NULL;
  g_glCopyTexSubImage2D = NULL;
  g_glCreateProgram = NULL;
  g_glCreateShader = NULL;
  g_glCullFace = NULL;
  g_glDeleteBuffersARB = NULL;
  g_glDeleteFramebuffersEXT = NULL;
  g_glDeleteProgram = NULL;
  g_glDeleteQueries = NULL;
  g_glDeleteQueriesARB = NULL;
  g_glDeleteRenderbuffersEXT = NULL;
  g_glDeleteShader = NULL;
  g_glDeleteTextures = NULL;
  g_glDepthFunc = NULL;
  g_glDepthMask = NULL;
  g_glDepthRange = NULL;
  g_glDepthRangef = NULL;
  g_glDetachShader = NULL;
  g_glDisable = NULL;
  g_glDisableVertexAttribArray = NULL;
  g_glDrawArrays = NULL;
  g_glDrawBuffer = NULL;
  g_glDrawBuffersARB = NULL;
  g_glDrawElements = NULL;
  g_glEGLImageTargetTexture2DOES = NULL;
  g_glEGLImageTargetRenderbufferStorageOES = NULL;
  g_glEnable = NULL;
  g_glEnableVertexAttribArray = NULL;
  g_glEndQuery = NULL;
  g_glEndQueryARB = NULL;
  g_glFinish = NULL;
  g_glFlush = NULL;
  g_glFramebufferRenderbufferEXT = NULL;
  g_glFramebufferTexture2DEXT = NULL;
  g_glFrontFace = NULL;
  g_glGenBuffersARB = NULL;
  g_glGenQueries = NULL;
  g_glGenQueriesARB = NULL;
  g_glGenerateMipmapEXT = NULL;
  g_glGenFramebuffersEXT = NULL;
  g_glGenRenderbuffersEXT = NULL;
  g_glGenTextures = NULL;
  g_glGetActiveAttrib = NULL;
  g_glGetActiveUniform = NULL;
  g_glGetAttachedShaders = NULL;
  g_glGetAttribLocation = NULL;
  g_glGetBooleanv = NULL;
  g_glGetBufferParameteriv = NULL;
  g_glGetError = NULL;
  g_glGetFloatv = NULL;
  g_glGetFramebufferAttachmentParameterivEXT = NULL;
  g_glGetGraphicsResetStatusARB = NULL;
  g_glGetIntegerv = NULL;
  g_glGetProgramiv = NULL;
  g_glGetProgramInfoLog = NULL;
  g_glGetQueryiv = NULL;
  g_glGetQueryivARB = NULL;
  g_glGetQueryObjecti64v = NULL;
  g_glGetQueryObjectiv = NULL;
  g_glGetQueryObjectui64v = NULL;
  g_glGetQueryObjectuiv = NULL;
  g_glGetQueryObjectuivARB = NULL;
  g_glGetRenderbufferParameterivEXT = NULL;
  g_glGetShaderiv = NULL;
  g_glGetShaderInfoLog = NULL;
  g_glGetShaderPrecisionFormat = NULL;
  g_glGetShaderSource = NULL;
  g_glGetString = NULL;
  g_glGetTexLevelParameterfv = NULL;
  g_glGetTexLevelParameteriv = NULL;
  g_glGetTexParameterfv = NULL;
  g_glGetTexParameteriv = NULL;
  g_glGetTranslatedShaderSourceANGLE = NULL;
  g_glGetUniformfv = NULL;
  g_glGetUniformiv = NULL;
  g_glGetUniformLocation = NULL;
  g_glGetVertexAttribfv = NULL;
  g_glGetVertexAttribiv = NULL;
  g_glGetVertexAttribPointerv = NULL;
  g_glHint = NULL;
  g_glIsBuffer = NULL;
  g_glIsEnabled = NULL;
  g_glIsFramebufferEXT = NULL;
  g_glIsProgram = NULL;
  g_glIsQueryARB = NULL;
  g_glIsRenderbufferEXT = NULL;
  g_glIsShader = NULL;
  g_glIsTexture = NULL;
  g_glLineWidth = NULL;
  g_glLinkProgram = NULL;
  g_glMapBuffer = NULL;
  g_glPixelStorei = NULL;
  g_glPointParameteri = NULL;
  g_glPolygonOffset = NULL;
  g_glQueryCounter = NULL;
  g_glReadBuffer = NULL;
  g_glReadPixels = NULL;
  g_glReleaseShaderCompiler = NULL;
  g_glRenderbufferStorageMultisampleEXT = NULL;
  g_glRenderbufferStorageMultisampleANGLE = NULL;
  g_glRenderbufferStorageEXT = NULL;
  g_glSampleCoverage = NULL;
  g_glScissor = NULL;
  g_glShaderBinary = NULL;
  g_glShaderSource = NULL;
  g_glStencilFunc = NULL;
  g_glStencilFuncSeparate = NULL;
  g_glStencilMask = NULL;
  g_glStencilMaskSeparate = NULL;
  g_glStencilOp = NULL;
  g_glStencilOpSeparate = NULL;
  g_glTexImage2D = NULL;
  g_glTexParameterf = NULL;
  g_glTexParameterfv = NULL;
  g_glTexParameteri = NULL;
  g_glTexParameteriv = NULL;
  g_glTexStorage2DEXT = NULL;
  g_glTexSubImage2D = NULL;
  g_glUniform1f = NULL;
  g_glUniform1fv = NULL;
  g_glUniform1i = NULL;
  g_glUniform1iv = NULL;
  g_glUniform2f = NULL;
  g_glUniform2fv = NULL;
  g_glUniform2i = NULL;
  g_glUniform2iv = NULL;
  g_glUniform3f = NULL;
  g_glUniform3fv = NULL;
  g_glUniform3i = NULL;
  g_glUniform3iv = NULL;
  g_glUniform4f = NULL;
  g_glUniform4fv = NULL;
  g_glUniform4i = NULL;
  g_glUniform4iv = NULL;
  g_glUniformMatrix2fv = NULL;
  g_glUniformMatrix3fv = NULL;
  g_glUniformMatrix4fv = NULL;
  g_glUnmapBuffer = NULL;
  g_glUseProgram = NULL;
  g_glValidateProgram = NULL;
  g_glVertexAttrib1f = NULL;
  g_glVertexAttrib1fv = NULL;
  g_glVertexAttrib2f = NULL;
  g_glVertexAttrib2fv = NULL;
  g_glVertexAttrib3f = NULL;
  g_glVertexAttrib3fv = NULL;
  g_glVertexAttrib4f = NULL;
  g_glVertexAttrib4fv = NULL;
  g_glVertexAttribPointer = NULL;
  g_glViewport = NULL;
  g_glGenFencesNV = NULL;
  g_glDeleteFencesNV = NULL;
  g_glSetFenceNV = NULL;
  g_glTestFenceNV = NULL;
  g_glFinishFenceNV = NULL;
  g_glIsFenceNV = NULL;
  g_glGetFenceivNV = NULL;
  g_glFenceSync = NULL;
  g_glDeleteSync = NULL;
  g_glGetSynciv = NULL;
  g_glDrawArraysInstancedANGLE = NULL;
  g_glDrawElementsInstancedANGLE = NULL;
  g_glVertexAttribDivisorANGLE = NULL;

  g_debug_glActiveTexture = NULL;
  g_debug_glAttachShader = NULL;
  g_debug_glBeginQuery = NULL;
  g_debug_glBeginQueryARB = NULL;
  g_debug_glBindAttribLocation = NULL;
  g_debug_glBindBuffer = NULL;
  g_debug_glBindFragDataLocation = NULL;
  g_debug_glBindFragDataLocationIndexed = NULL;
  g_debug_glBindFramebufferEXT = NULL;
  g_debug_glBindRenderbufferEXT = NULL;
  g_debug_glBindTexture = NULL;
  g_debug_glBlendColor = NULL;
  g_debug_glBlendEquation = NULL;
  g_debug_glBlendEquationSeparate = NULL;
  g_debug_glBlendFunc = NULL;
  g_debug_glBlendFuncSeparate = NULL;
  g_debug_glBlitFramebufferEXT = NULL;
  g_debug_glBlitFramebufferANGLE = NULL;
  g_debug_glBufferData = NULL;
  g_debug_glBufferSubData = NULL;
  g_debug_glCheckFramebufferStatusEXT = NULL;
  g_debug_glClear = NULL;
  g_debug_glClearColor = NULL;
  g_debug_glClearDepth = NULL;
  g_debug_glClearDepthf = NULL;
  g_debug_glClearStencil = NULL;
  g_debug_glColorMask = NULL;
  g_debug_glCompileShader = NULL;
  g_debug_glCompressedTexImage2D = NULL;
  g_debug_glCompressedTexSubImage2D = NULL;
  g_debug_glCopyTexImage2D = NULL;
  g_debug_glCopyTexSubImage2D = NULL;
  g_debug_glCreateProgram = NULL;
  g_debug_glCreateShader = NULL;
  g_debug_glCullFace = NULL;
  g_debug_glDeleteBuffersARB = NULL;
  g_debug_glDeleteFramebuffersEXT = NULL;
  g_debug_glDeleteProgram = NULL;
  g_debug_glDeleteQueries = NULL;
  g_debug_glDeleteQueriesARB = NULL;
  g_debug_glDeleteRenderbuffersEXT = NULL;
  g_debug_glDeleteShader = NULL;
  g_debug_glDeleteTextures = NULL;
  g_debug_glDepthFunc = NULL;
  g_debug_glDepthMask = NULL;
  g_debug_glDepthRange = NULL;
  g_debug_glDepthRangef = NULL;
  g_debug_glDetachShader = NULL;
  g_debug_glDisable = NULL;
  g_debug_glDisableVertexAttribArray = NULL;
  g_debug_glDrawArrays = NULL;
  g_debug_glDrawBuffer = NULL;
  g_debug_glDrawBuffersARB = NULL;
  g_debug_glDrawElements = NULL;
  g_debug_glEGLImageTargetTexture2DOES = NULL;
  g_debug_glEGLImageTargetRenderbufferStorageOES = NULL;
  g_debug_glEnable = NULL;
  g_debug_glEnableVertexAttribArray = NULL;
  g_debug_glEndQuery = NULL;
  g_debug_glEndQueryARB = NULL;
  g_debug_glFinish = NULL;
  g_debug_glFlush = NULL;
  g_debug_glFramebufferRenderbufferEXT = NULL;
  g_debug_glFramebufferTexture2DEXT = NULL;
  g_debug_glFrontFace = NULL;
  g_debug_glGenBuffersARB = NULL;
  g_debug_glGenQueries = NULL;
  g_debug_glGenQueriesARB = NULL;
  g_debug_glGenerateMipmapEXT = NULL;
  g_debug_glGenFramebuffersEXT = NULL;
  g_debug_glGenRenderbuffersEXT = NULL;
  g_debug_glGenTextures = NULL;
  g_debug_glGetActiveAttrib = NULL;
  g_debug_glGetActiveUniform = NULL;
  g_debug_glGetAttachedShaders = NULL;
  g_debug_glGetAttribLocation = NULL;
  g_debug_glGetBooleanv = NULL;
  g_debug_glGetBufferParameteriv = NULL;
  g_debug_glGetError = NULL;
  g_debug_glGetFloatv = NULL;
  g_debug_glGetFramebufferAttachmentParameterivEXT = NULL;
  g_debug_glGetGraphicsResetStatusARB = NULL;
  g_debug_glGetIntegerv = NULL;
  g_debug_glGetProgramiv = NULL;
  g_debug_glGetProgramInfoLog = NULL;
  g_debug_glGetQueryiv = NULL;
  g_debug_glGetQueryivARB = NULL;
  g_debug_glGetQueryObjecti64v = NULL;
  g_debug_glGetQueryObjectiv = NULL;
  g_debug_glGetQueryObjectui64v = NULL;
  g_debug_glGetQueryObjectuiv = NULL;
  g_debug_glGetQueryObjectuivARB = NULL;
  g_debug_glGetRenderbufferParameterivEXT = NULL;
  g_debug_glGetShaderiv = NULL;
  g_debug_glGetShaderInfoLog = NULL;
  g_debug_glGetShaderPrecisionFormat = NULL;
  g_debug_glGetShaderSource = NULL;
  g_debug_glGetString = NULL;
  g_debug_glGetTexLevelParameterfv = NULL;
  g_debug_glGetTexLevelParameteriv = NULL;
  g_debug_glGetTexParameterfv = NULL;
  g_debug_glGetTexParameteriv = NULL;
  g_debug_glGetTranslatedShaderSourceANGLE = NULL;
  g_debug_glGetUniformfv = NULL;
  g_debug_glGetUniformiv = NULL;
  g_debug_glGetUniformLocation = NULL;
  g_debug_glGetVertexAttribfv = NULL;
  g_debug_glGetVertexAttribiv = NULL;
  g_debug_glGetVertexAttribPointerv = NULL;
  g_debug_glHint = NULL;
  g_debug_glIsBuffer = NULL;
  g_debug_glIsEnabled = NULL;
  g_debug_glIsFramebufferEXT = NULL;
  g_debug_glIsProgram = NULL;
  g_debug_glIsQueryARB = NULL;
  g_debug_glIsRenderbufferEXT = NULL;
  g_debug_glIsShader = NULL;
  g_debug_glIsTexture = NULL;
  g_debug_glLineWidth = NULL;
  g_debug_glLinkProgram = NULL;
  g_debug_glMapBuffer = NULL;
  g_debug_glPixelStorei = NULL;
  g_debug_glPointParameteri = NULL;
  g_debug_glPolygonOffset = NULL;
  g_debug_glQueryCounter = NULL;
  g_debug_glReadBuffer = NULL;
  g_debug_glReadPixels = NULL;
  g_debug_glReleaseShaderCompiler = NULL;
  g_debug_glRenderbufferStorageMultisampleEXT = NULL;
  g_debug_glRenderbufferStorageMultisampleANGLE = NULL;
  g_debug_glRenderbufferStorageEXT = NULL;
  g_debug_glSampleCoverage = NULL;
  g_debug_glScissor = NULL;
  g_debug_glShaderBinary = NULL;
  g_debug_glShaderSource = NULL;
  g_debug_glStencilFunc = NULL;
  g_debug_glStencilFuncSeparate = NULL;
  g_debug_glStencilMask = NULL;
  g_debug_glStencilMaskSeparate = NULL;
  g_debug_glStencilOp = NULL;
  g_debug_glStencilOpSeparate = NULL;
  g_debug_glTexImage2D = NULL;
  g_debug_glTexParameterf = NULL;
  g_debug_glTexParameterfv = NULL;
  g_debug_glTexParameteri = NULL;
  g_debug_glTexParameteriv = NULL;
  g_debug_glTexStorage2DEXT = NULL;
  g_debug_glTexSubImage2D = NULL;
  g_debug_glUniform1f = NULL;
  g_debug_glUniform1fv = NULL;
  g_debug_glUniform1i = NULL;
  g_debug_glUniform1iv = NULL;
  g_debug_glUniform2f = NULL;
  g_debug_glUniform2fv = NULL;
  g_debug_glUniform2i = NULL;
  g_debug_glUniform2iv = NULL;
  g_debug_glUniform3f = NULL;
  g_debug_glUniform3fv = NULL;
  g_debug_glUniform3i = NULL;
  g_debug_glUniform3iv = NULL;
  g_debug_glUniform4f = NULL;
  g_debug_glUniform4fv = NULL;
  g_debug_glUniform4i = NULL;
  g_debug_glUniform4iv = NULL;
  g_debug_glUniformMatrix2fv = NULL;
  g_debug_glUniformMatrix3fv = NULL;
  g_debug_glUniformMatrix4fv = NULL;
  g_debug_glUnmapBuffer = NULL;
  g_debug_glUseProgram = NULL;
  g_debug_glValidateProgram = NULL;
  g_debug_glVertexAttrib1f = NULL;
  g_debug_glVertexAttrib1fv = NULL;
  g_debug_glVertexAttrib2f = NULL;
  g_debug_glVertexAttrib2fv = NULL;
  g_debug_glVertexAttrib3f = NULL;
  g_debug_glVertexAttrib3fv = NULL;
  g_debug_glVertexAttrib4f = NULL;
  g_debug_glVertexAttrib4fv = NULL;
  g_debug_glVertexAttribPointer = NULL;
  g_debug_glViewport = NULL;
  g_debug_glGenFencesNV = NULL;
  g_debug_glDeleteFencesNV = NULL;
  g_debug_glSetFenceNV = NULL;
  g_debug_glTestFenceNV = NULL;
  g_debug_glFinishFenceNV = NULL;
  g_debug_glIsFenceNV = NULL;
  g_debug_glGetFenceivNV = NULL;
  g_debug_glFenceSync = NULL;
  g_debug_glDeleteSync = NULL;
  g_debug_glGetSynciv = NULL;
  g_debug_glDrawArraysInstancedANGLE = NULL;
  g_debug_glDrawElementsInstancedANGLE = NULL;
  g_debug_glVertexAttribDivisorANGLE = NULL;
  g_debugBindingsInitialized = false;
}

}  // namespace gfx
